/*
 * Copyright 2024 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/api/auth.proto

// Protobuf Java Version: 3.25.5
package com.couchbase.client.core.deps.com.google.api;

/**
 *
 *
 * <pre>
 * `Authentication` defines the authentication configuration for API methods
 * provided by an API service.
 *
 * Example:
 *
 *     name: calendar.googleapis.com
 *     authentication:
 *       providers:
 *       - id: google_calendar_auth
 *         jwks_uri: https://www.googleapis.com/oauth2/v1/certs
 *         issuer: https://securetoken.google.com
 *       rules:
 *       - selector: "*"
 *         requirements:
 *           provider_id: google_calendar_auth
 *       - selector: google.calendar.Delegate
 *         oauth:
 *           canonical_scopes: https://www.googleapis.com/auth/calendar.read
 * </pre>
 *
 * Protobuf type {@code google.api.Authentication}
 */
public final class Authentication extends com.google.protobuf.GeneratedMessageV3
    implements
    // @@protoc_insertion_point(message_implements:google.api.Authentication)
    AuthenticationOrBuilder {
  private static final long serialVersionUID = 0L;
  // Use Authentication.newBuilder() to construct.
  private Authentication(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }

  private Authentication() {
    rules_ = java.util.Collections.emptyList();
    providers_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
    return new Authentication();
  }

  public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
    return com.google.api.AuthProto.internal_static_google_api_Authentication_descriptor;
  }

  @java.lang.Override
  protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.google.api.AuthProto.internal_static_google_api_Authentication_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.google.api.Authentication.class, com.google.api.Authentication.Builder.class);
  }

  public static final int RULES_FIELD_NUMBER = 3;

  @SuppressWarnings("serial")
  private java.util.List<com.couchbase.client.core.deps.com.google.api.AuthenticationRule> rules_;
  /**
   *
   *
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   *
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  @java.lang.Override
  public java.util.List<com.couchbase.client.core.deps.com.google.api.AuthenticationRule> getRulesList() {
    return rules_;
  }
  /**
   *
   *
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   *
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  @java.lang.Override
  public java.util.List<? extends com.google.api.AuthenticationRuleOrBuilder>
      getRulesOrBuilderList() {
    return rules_;
  }
  /**
   *
   *
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   *
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  @java.lang.Override
  public int getRulesCount() {
    return rules_.size();
  }
  /**
   *
   *
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   *
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.api.AuthenticationRule getRules(int index) {
    return rules_.get(index);
  }
  /**
   *
   *
   * <pre>
   * A list of authentication rules that apply to individual API methods.
   *
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.api.AuthenticationRuleOrBuilder getRulesOrBuilder(int index) {
    return rules_.get(index);
  }

  public static final int PROVIDERS_FIELD_NUMBER = 4;

  @SuppressWarnings("serial")
  private java.util.List<com.couchbase.client.core.deps.com.google.api.AuthProvider> providers_;
  /**
   *
   *
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  @java.lang.Override
  public java.util.List<com.couchbase.client.core.deps.com.google.api.AuthProvider> getProvidersList() {
    return providers_;
  }
  /**
   *
   *
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  @java.lang.Override
  public java.util.List<? extends com.google.api.AuthProviderOrBuilder>
      getProvidersOrBuilderList() {
    return providers_;
  }
  /**
   *
   *
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  @java.lang.Override
  public int getProvidersCount() {
    return providers_.size();
  }
  /**
   *
   *
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.api.AuthProvider getProviders(int index) {
    return providers_.get(index);
  }
  /**
   *
   *
   * <pre>
   * Defines a set of authentication providers that a service supports.
   * </pre>
   *
   * <code>repeated .google.api.AuthProvider providers = 4;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.api.AuthProviderOrBuilder getProvidersOrBuilder(int index) {
    return providers_.get(index);
  }

  private byte memoizedIsInitialized = -1;

  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.couchbase.client.core.deps.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
    for (int i = 0; i < rules_.size(); i++) {
      output.writeMessage(3, rules_.get(i));
    }
    for (int i = 0; i < providers_.size(); i++) {
      output.writeMessage(4, providers_.get(i));
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    for (int i = 0; i < rules_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream.computeMessageSize(3, rules_.get(i));
    }
    for (int i = 0; i < providers_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream.computeMessageSize(4, providers_.get(i));
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
      return true;
    }
    if (!(obj instanceof com.google.api.Authentication)) {
      return super.equals(obj);
    }
    com.google.api.Authentication other = (com.couchbase.client.core.deps.com.google.api.Authentication) obj;

    if (!getRulesList().equals(other.getRulesList())) return false;
    if (!getProvidersList().equals(other.getProvidersList())) return false;
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getRulesCount() > 0) {
      hash = (37 * hash) + RULES_FIELD_NUMBER;
      hash = (53 * hash) + getRulesList().hashCode();
    }
    if (getProvidersCount() > 0) {
      hash = (37 * hash) + PROVIDERS_FIELD_NUMBER;
      hash = (53 * hash) + getProvidersList().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static com.couchbase.client.core.deps.com.google.api.Authentication parseFrom(java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.api.Authentication parseFrom(
      java.nio.ByteBuffer data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.api.Authentication parseFrom(com.couchbase.client.core.deps.com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.api.Authentication parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.api.Authentication parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.api.Authentication parseFrom(
      byte[] data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.api.Authentication parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.api.Authentication parseFrom(
      java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.api.Authentication parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.api.Authentication parseDelimitedFrom(
      java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.api.Authentication parseFrom(com.couchbase.client.core.deps.com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.api.Authentication parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() {
    return newBuilder();
  }

  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }

  public static Builder newBuilder(com.couchbase.client.core.deps.com.google.api.Authentication prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }

  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   *
   *
   * <pre>
   * `Authentication` defines the authentication configuration for API methods
   * provided by an API service.
   *
   * Example:
   *
   *     name: calendar.googleapis.com
   *     authentication:
   *       providers:
   *       - id: google_calendar_auth
   *         jwks_uri: https://www.googleapis.com/oauth2/v1/certs
   *         issuer: https://securetoken.google.com
   *       rules:
   *       - selector: "*"
   *         requirements:
   *           provider_id: google_calendar_auth
   *       - selector: google.calendar.Delegate
   *         oauth:
   *           canonical_scopes: https://www.googleapis.com/auth/calendar.read
   * </pre>
   *
   * Protobuf type {@code google.api.Authentication}
   */
  public static final class Builder extends com.google.protobuf.GeneratedMessageV3.Builder<Builder>
      implements
      // @@protoc_insertion_point(builder_implements:google.api.Authentication)
      com.google.api.AuthenticationOrBuilder {
    public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return com.google.api.AuthProto.internal_static_google_api_Authentication_descriptor;
    }

    @java.lang.Override
    protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.api.AuthProto.internal_static_google_api_Authentication_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.api.Authentication.class, com.google.api.Authentication.Builder.class);
    }

    // Construct using com.google.api.Authentication.newBuilder()
    private Builder() {}

    private Builder(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
    }

    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      if (rulesBuilder_ == null) {
        rules_ = java.util.Collections.emptyList();
      } else {
        rules_ = null;
        rulesBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000001);
      if (providersBuilder_ == null) {
        providers_ = java.util.Collections.emptyList();
      } else {
        providers_ = null;
        providersBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000002);
      return this;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
      return com.google.api.AuthProto.internal_static_google_api_Authentication_descriptor;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.api.Authentication getDefaultInstanceForType() {
      return com.google.api.Authentication.getDefaultInstance();
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.api.Authentication build() {
      com.google.api.Authentication result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.api.Authentication buildPartial() {
      com.google.api.Authentication result = new com.google.api.Authentication(this);
      buildPartialRepeatedFields(result);
      if (bitField0_ != 0) {
        buildPartial0(result);
      }
      onBuilt();
      return result;
    }

    private void buildPartialRepeatedFields(com.couchbase.client.core.deps.com.google.api.Authentication result) {
      if (rulesBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0)) {
          rules_ = java.util.Collections.unmodifiableList(rules_);
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.rules_ = rules_;
      } else {
        result.rules_ = rulesBuilder_.build();
      }
      if (providersBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0)) {
          providers_ = java.util.Collections.unmodifiableList(providers_);
          bitField0_ = (bitField0_ & ~0x00000002);
        }
        result.providers_ = providers_;
      } else {
        result.providers_ = providersBuilder_.build();
      }
    }

    private void buildPartial0(com.couchbase.client.core.deps.com.google.api.Authentication result) {
      int from_bitField0_ = bitField0_;
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }

    @java.lang.Override
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.setField(field, value);
    }

    @java.lang.Override
    public Builder clearField(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }

    @java.lang.Override
    public Builder clearOneof(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }

    @java.lang.Override
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field, int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }

    @java.lang.Override
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }

    @java.lang.Override
    public Builder mergeFrom(com.couchbase.client.core.deps.com.google.protobuf.Message other) {
      if (other instanceof com.google.api.Authentication) {
        return mergeFrom((com.couchbase.client.core.deps.com.google.api.Authentication) other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.couchbase.client.core.deps.com.google.api.Authentication other) {
      if (other == com.google.api.Authentication.getDefaultInstance()) return this;
      if (rulesBuilder_ == null) {
        if (!other.rules_.isEmpty()) {
          if (rules_.isEmpty()) {
            rules_ = other.rules_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureRulesIsMutable();
            rules_.addAll(other.rules_);
          }
          onChanged();
        }
      } else {
        if (!other.rules_.isEmpty()) {
          if (rulesBuilder_.isEmpty()) {
            rulesBuilder_.dispose();
            rulesBuilder_ = null;
            rules_ = other.rules_;
            bitField0_ = (bitField0_ & ~0x00000001);
            rulesBuilder_ =
                com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders
                    ? getRulesFieldBuilder()
                    : null;
          } else {
            rulesBuilder_.addAllMessages(other.rules_);
          }
        }
      }
      if (providersBuilder_ == null) {
        if (!other.providers_.isEmpty()) {
          if (providers_.isEmpty()) {
            providers_ = other.providers_;
            bitField0_ = (bitField0_ & ~0x00000002);
          } else {
            ensureProvidersIsMutable();
            providers_.addAll(other.providers_);
          }
          onChanged();
        }
      } else {
        if (!other.providers_.isEmpty()) {
          if (providersBuilder_.isEmpty()) {
            providersBuilder_.dispose();
            providersBuilder_ = null;
            providers_ = other.providers_;
            bitField0_ = (bitField0_ & ~0x00000002);
            providersBuilder_ =
                com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders
                    ? getProvidersFieldBuilder()
                    : null;
          } else {
            providersBuilder_.addAllMessages(other.providers_);
          }
        }
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 26:
              {
                com.google.api.AuthenticationRule m =
                    input.readMessage(
                        com.google.api.AuthenticationRule.parser(), extensionRegistry);
                if (rulesBuilder_ == null) {
                  ensureRulesIsMutable();
                  rules_.add(m);
                } else {
                  rulesBuilder_.addMessage(m);
                }
                break;
              } // case 26
            case 34:
              {
                com.google.api.AuthProvider m =
                    input.readMessage(com.couchbase.client.core.deps.com.google.api.AuthProvider.parser(), extensionRegistry);
                if (providersBuilder_ == null) {
                  ensureProvidersIsMutable();
                  providers_.add(m);
                } else {
                  providersBuilder_.addMessage(m);
                }
                break;
              } // case 34
            default:
              {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }

    private int bitField0_;

    private java.util.List<com.couchbase.client.core.deps.com.google.api.AuthenticationRule> rules_ =
        java.util.Collections.emptyList();

    private void ensureRulesIsMutable() {
      if (!((bitField0_ & 0x00000001) != 0)) {
        rules_ = new java.util.ArrayList<com.couchbase.client.core.deps.com.google.api.AuthenticationRule>(rules_);
        bitField0_ |= 0x00000001;
      }
    }

    private com.couchbase.client.core.deps.com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.api.AuthenticationRule,
            com.google.api.AuthenticationRule.Builder,
            com.google.api.AuthenticationRuleOrBuilder>
        rulesBuilder_;

    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public java.util.List<com.couchbase.client.core.deps.com.google.api.AuthenticationRule> getRulesList() {
      if (rulesBuilder_ == null) {
        return java.util.Collections.unmodifiableList(rules_);
      } else {
        return rulesBuilder_.getMessageList();
      }
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public int getRulesCount() {
      if (rulesBuilder_ == null) {
        return rules_.size();
      } else {
        return rulesBuilder_.getCount();
      }
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.AuthenticationRule getRules(int index) {
      if (rulesBuilder_ == null) {
        return rules_.get(index);
      } else {
        return rulesBuilder_.getMessage(index);
      }
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder setRules(int index, com.google.api.AuthenticationRule value) {
      if (rulesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRulesIsMutable();
        rules_.set(index, value);
        onChanged();
      } else {
        rulesBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder setRules(int index, com.google.api.AuthenticationRule.Builder builderForValue) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        rules_.set(index, builderForValue.build());
        onChanged();
      } else {
        rulesBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder addRules(com.couchbase.client.core.deps.com.google.api.AuthenticationRule value) {
      if (rulesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRulesIsMutable();
        rules_.add(value);
        onChanged();
      } else {
        rulesBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder addRules(int index, com.google.api.AuthenticationRule value) {
      if (rulesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRulesIsMutable();
        rules_.add(index, value);
        onChanged();
      } else {
        rulesBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder addRules(com.couchbase.client.core.deps.com.google.api.AuthenticationRule.Builder builderForValue) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        rules_.add(builderForValue.build());
        onChanged();
      } else {
        rulesBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder addRules(int index, com.google.api.AuthenticationRule.Builder builderForValue) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        rules_.add(index, builderForValue.build());
        onChanged();
      } else {
        rulesBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder addAllRules(
        java.lang.Iterable<? extends com.google.api.AuthenticationRule> values) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(values, rules_);
        onChanged();
      } else {
        rulesBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder clearRules() {
      if (rulesBuilder_ == null) {
        rules_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
      } else {
        rulesBuilder_.clear();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public Builder removeRules(int index) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        rules_.remove(index);
        onChanged();
      } else {
        rulesBuilder_.remove(index);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.AuthenticationRule.Builder getRulesBuilder(int index) {
      return getRulesFieldBuilder().getBuilder(index);
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.AuthenticationRuleOrBuilder getRulesOrBuilder(int index) {
      if (rulesBuilder_ == null) {
        return rules_.get(index);
      } else {
        return rulesBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public java.util.List<? extends com.google.api.AuthenticationRuleOrBuilder>
        getRulesOrBuilderList() {
      if (rulesBuilder_ != null) {
        return rulesBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(rules_);
      }
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.AuthenticationRule.Builder addRulesBuilder() {
      return getRulesFieldBuilder()
          .addBuilder(com.couchbase.client.core.deps.com.google.api.AuthenticationRule.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.AuthenticationRule.Builder addRulesBuilder(int index) {
      return getRulesFieldBuilder()
          .addBuilder(index, com.google.api.AuthenticationRule.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * A list of authentication rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.AuthenticationRule rules = 3;</code>
     */
    public java.util.List<com.couchbase.client.core.deps.com.google.api.AuthenticationRule.Builder> getRulesBuilderList() {
      return getRulesFieldBuilder().getBuilderList();
    }

    private com.couchbase.client.core.deps.com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.api.AuthenticationRule,
            com.google.api.AuthenticationRule.Builder,
            com.google.api.AuthenticationRuleOrBuilder>
        getRulesFieldBuilder() {
      if (rulesBuilder_ == null) {
        rulesBuilder_ =
            new com.google.protobuf.RepeatedFieldBuilderV3<
                com.google.api.AuthenticationRule,
                com.google.api.AuthenticationRule.Builder,
                com.google.api.AuthenticationRuleOrBuilder>(
                rules_, ((bitField0_ & 0x00000001) != 0), getParentForChildren(), isClean());
        rules_ = null;
      }
      return rulesBuilder_;
    }

    private java.util.List<com.couchbase.client.core.deps.com.google.api.AuthProvider> providers_ =
        java.util.Collections.emptyList();

    private void ensureProvidersIsMutable() {
      if (!((bitField0_ & 0x00000002) != 0)) {
        providers_ = new java.util.ArrayList<com.couchbase.client.core.deps.com.google.api.AuthProvider>(providers_);
        bitField0_ |= 0x00000002;
      }
    }

    private com.couchbase.client.core.deps.com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.api.AuthProvider,
            com.google.api.AuthProvider.Builder,
            com.google.api.AuthProviderOrBuilder>
        providersBuilder_;

    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public java.util.List<com.couchbase.client.core.deps.com.google.api.AuthProvider> getProvidersList() {
      if (providersBuilder_ == null) {
        return java.util.Collections.unmodifiableList(providers_);
      } else {
        return providersBuilder_.getMessageList();
      }
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public int getProvidersCount() {
      if (providersBuilder_ == null) {
        return providers_.size();
      } else {
        return providersBuilder_.getCount();
      }
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.AuthProvider getProviders(int index) {
      if (providersBuilder_ == null) {
        return providers_.get(index);
      } else {
        return providersBuilder_.getMessage(index);
      }
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder setProviders(int index, com.google.api.AuthProvider value) {
      if (providersBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureProvidersIsMutable();
        providers_.set(index, value);
        onChanged();
      } else {
        providersBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder setProviders(int index, com.google.api.AuthProvider.Builder builderForValue) {
      if (providersBuilder_ == null) {
        ensureProvidersIsMutable();
        providers_.set(index, builderForValue.build());
        onChanged();
      } else {
        providersBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder addProviders(com.couchbase.client.core.deps.com.google.api.AuthProvider value) {
      if (providersBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureProvidersIsMutable();
        providers_.add(value);
        onChanged();
      } else {
        providersBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder addProviders(int index, com.google.api.AuthProvider value) {
      if (providersBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureProvidersIsMutable();
        providers_.add(index, value);
        onChanged();
      } else {
        providersBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder addProviders(com.couchbase.client.core.deps.com.google.api.AuthProvider.Builder builderForValue) {
      if (providersBuilder_ == null) {
        ensureProvidersIsMutable();
        providers_.add(builderForValue.build());
        onChanged();
      } else {
        providersBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder addProviders(int index, com.google.api.AuthProvider.Builder builderForValue) {
      if (providersBuilder_ == null) {
        ensureProvidersIsMutable();
        providers_.add(index, builderForValue.build());
        onChanged();
      } else {
        providersBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder addAllProviders(
        java.lang.Iterable<? extends com.google.api.AuthProvider> values) {
      if (providersBuilder_ == null) {
        ensureProvidersIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(values, providers_);
        onChanged();
      } else {
        providersBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder clearProviders() {
      if (providersBuilder_ == null) {
        providers_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
      } else {
        providersBuilder_.clear();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public Builder removeProviders(int index) {
      if (providersBuilder_ == null) {
        ensureProvidersIsMutable();
        providers_.remove(index);
        onChanged();
      } else {
        providersBuilder_.remove(index);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.AuthProvider.Builder getProvidersBuilder(int index) {
      return getProvidersFieldBuilder().getBuilder(index);
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.AuthProviderOrBuilder getProvidersOrBuilder(int index) {
      if (providersBuilder_ == null) {
        return providers_.get(index);
      } else {
        return providersBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public java.util.List<? extends com.google.api.AuthProviderOrBuilder>
        getProvidersOrBuilderList() {
      if (providersBuilder_ != null) {
        return providersBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(providers_);
      }
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.AuthProvider.Builder addProvidersBuilder() {
      return getProvidersFieldBuilder()
          .addBuilder(com.couchbase.client.core.deps.com.google.api.AuthProvider.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.AuthProvider.Builder addProvidersBuilder(int index) {
      return getProvidersFieldBuilder()
          .addBuilder(index, com.google.api.AuthProvider.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * Defines a set of authentication providers that a service supports.
     * </pre>
     *
     * <code>repeated .google.api.AuthProvider providers = 4;</code>
     */
    public java.util.List<com.couchbase.client.core.deps.com.google.api.AuthProvider.Builder> getProvidersBuilderList() {
      return getProvidersFieldBuilder().getBuilderList();
    }

    private com.couchbase.client.core.deps.com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.api.AuthProvider,
            com.google.api.AuthProvider.Builder,
            com.google.api.AuthProviderOrBuilder>
        getProvidersFieldBuilder() {
      if (providersBuilder_ == null) {
        providersBuilder_ =
            new com.google.protobuf.RepeatedFieldBuilderV3<
                com.google.api.AuthProvider,
                com.google.api.AuthProvider.Builder,
                com.google.api.AuthProviderOrBuilder>(
                providers_, ((bitField0_ & 0x00000002) != 0), getParentForChildren(), isClean());
        providers_ = null;
      }
      return providersBuilder_;
    }

    @java.lang.Override
    public final Builder setUnknownFields(final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }

    // @@protoc_insertion_point(builder_scope:google.api.Authentication)
  }

  // @@protoc_insertion_point(class_scope:google.api.Authentication)
  private static final com.couchbase.client.core.deps.com.google.api.Authentication DEFAULT_INSTANCE;

  static {
    DEFAULT_INSTANCE = new com.google.api.Authentication();
  }

  public static com.couchbase.client.core.deps.com.google.api.Authentication getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.couchbase.client.core.deps.com.google.protobuf.Parser<Authentication> PARSER =
      new com.google.protobuf.AbstractParser<Authentication>() {
        @java.lang.Override
        public Authentication parsePartialFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          Builder builder = newBuilder();
          try {
            builder.mergeFrom(input, extensionRegistry);
          } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
            throw e.setUnfinishedMessage(builder.buildPartial());
          } catch (com.couchbase.client.core.deps.com.google.protobuf.UninitializedMessageException e) {
            throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
          } catch (java.io.IOException e) {
            throw new com.google.protobuf.InvalidProtocolBufferException(e)
                .setUnfinishedMessage(builder.buildPartial());
          }
          return builder.buildPartial();
        }
      };

  public static com.couchbase.client.core.deps.com.google.protobuf.Parser<Authentication> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.protobuf.Parser<Authentication> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.api.Authentication getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }
}
