/*
 * Copyright 2024 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/api/client.proto

// Protobuf Java Version: 3.25.5
package com.couchbase.client.core.deps.com.google.api;

/**
 *
 *
 * <pre>
 * The organization for which the client libraries are being published.
 * Affects the url where generated docs are published, etc.
 * </pre>
 *
 * Protobuf enum {@code google.api.ClientLibraryOrganization}
 */
public enum ClientLibraryOrganization implements com.google.protobuf.ProtocolMessageEnum {
  /**
   *
   *
   * <pre>
   * Not useful.
   * </pre>
   *
   * <code>CLIENT_LIBRARY_ORGANIZATION_UNSPECIFIED = 0;</code>
   */
  CLIENT_LIBRARY_ORGANIZATION_UNSPECIFIED(0),
  /**
   *
   *
   * <pre>
   * Google Cloud Platform Org.
   * </pre>
   *
   * <code>CLOUD = 1;</code>
   */
  CLOUD(1),
  /**
   *
   *
   * <pre>
   * Ads (Advertising) Org.
   * </pre>
   *
   * <code>ADS = 2;</code>
   */
  ADS(2),
  /**
   *
   *
   * <pre>
   * Photos Org.
   * </pre>
   *
   * <code>PHOTOS = 3;</code>
   */
  PHOTOS(3),
  /**
   *
   *
   * <pre>
   * Street View Org.
   * </pre>
   *
   * <code>STREET_VIEW = 4;</code>
   */
  STREET_VIEW(4),
  /**
   *
   *
   * <pre>
   * Shopping Org.
   * </pre>
   *
   * <code>SHOPPING = 5;</code>
   */
  SHOPPING(5),
  /**
   *
   *
   * <pre>
   * Geo Org.
   * </pre>
   *
   * <code>GEO = 6;</code>
   */
  GEO(6),
  /**
   *
   *
   * <pre>
   * Generative AI - https://developers.generativeai.google
   * </pre>
   *
   * <code>GENERATIVE_AI = 7;</code>
   */
  GENERATIVE_AI(7),
  UNRECOGNIZED(-1),
  ;

  /**
   *
   *
   * <pre>
   * Not useful.
   * </pre>
   *
   * <code>CLIENT_LIBRARY_ORGANIZATION_UNSPECIFIED = 0;</code>
   */
  public static final int CLIENT_LIBRARY_ORGANIZATION_UNSPECIFIED_VALUE = 0;
  /**
   *
   *
   * <pre>
   * Google Cloud Platform Org.
   * </pre>
   *
   * <code>CLOUD = 1;</code>
   */
  public static final int CLOUD_VALUE = 1;
  /**
   *
   *
   * <pre>
   * Ads (Advertising) Org.
   * </pre>
   *
   * <code>ADS = 2;</code>
   */
  public static final int ADS_VALUE = 2;
  /**
   *
   *
   * <pre>
   * Photos Org.
   * </pre>
   *
   * <code>PHOTOS = 3;</code>
   */
  public static final int PHOTOS_VALUE = 3;
  /**
   *
   *
   * <pre>
   * Street View Org.
   * </pre>
   *
   * <code>STREET_VIEW = 4;</code>
   */
  public static final int STREET_VIEW_VALUE = 4;
  /**
   *
   *
   * <pre>
   * Shopping Org.
   * </pre>
   *
   * <code>SHOPPING = 5;</code>
   */
  public static final int SHOPPING_VALUE = 5;
  /**
   *
   *
   * <pre>
   * Geo Org.
   * </pre>
   *
   * <code>GEO = 6;</code>
   */
  public static final int GEO_VALUE = 6;
  /**
   *
   *
   * <pre>
   * Generative AI - https://developers.generativeai.google
   * </pre>
   *
   * <code>GENERATIVE_AI = 7;</code>
   */
  public static final int GENERATIVE_AI_VALUE = 7;

  public final int getNumber() {
    if (this == UNRECOGNIZED) {
      throw new java.lang.IllegalArgumentException(
          "Can't get the number of an unknown enum value.");
    }
    return value;
  }

  /**
   * @param value The numeric wire value of the corresponding enum entry.
   * @return The enum associated with the given numeric wire value.
   * @deprecated Use {@link #forNumber(int)} instead.
   */
  @java.lang.Deprecated
  public static ClientLibraryOrganization valueOf(int value) {
    return forNumber(value);
  }

  /**
   * @param value The numeric wire value of the corresponding enum entry.
   * @return The enum associated with the given numeric wire value.
   */
  public static ClientLibraryOrganization forNumber(int value) {
    switch (value) {
      case 0:
        return CLIENT_LIBRARY_ORGANIZATION_UNSPECIFIED;
      case 1:
        return CLOUD;
      case 2:
        return ADS;
      case 3:
        return PHOTOS;
      case 4:
        return STREET_VIEW;
      case 5:
        return SHOPPING;
      case 6:
        return GEO;
      case 7:
        return GENERATIVE_AI;
      default:
        return null;
    }
  }

  public static com.couchbase.client.core.deps.com.google.protobuf.Internal.EnumLiteMap<ClientLibraryOrganization>
      internalGetValueMap() {
    return internalValueMap;
  }

  private static final com.couchbase.client.core.deps.com.google.protobuf.Internal.EnumLiteMap<ClientLibraryOrganization>
      internalValueMap =
          new com.google.protobuf.Internal.EnumLiteMap<ClientLibraryOrganization>() {
            public ClientLibraryOrganization findValueByNumber(int number) {
              return ClientLibraryOrganization.forNumber(number);
            }
          };

  public final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.EnumValueDescriptor getValueDescriptor() {
    if (this == UNRECOGNIZED) {
      throw new java.lang.IllegalStateException(
          "Can't get the descriptor of an unrecognized enum value.");
    }
    return getDescriptor().getValues().get(ordinal());
  }

  public final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.EnumDescriptor getDescriptorForType() {
    return getDescriptor();
  }

  public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.EnumDescriptor getDescriptor() {
    return com.google.api.ClientProto.getDescriptor().getEnumTypes().get(0);
  }

  private static final ClientLibraryOrganization[] VALUES = values();

  public static ClientLibraryOrganization valueOf(
      com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
    if (desc.getType() != getDescriptor()) {
      throw new java.lang.IllegalArgumentException("EnumValueDescriptor is not for this type.");
    }
    if (desc.getIndex() == -1) {
      return UNRECOGNIZED;
    }
    return VALUES[desc.getIndex()];
  }

  private final int value;

  private ClientLibraryOrganization(int value) {
    this.value = value;
  }

  // @@protoc_insertion_point(enum_scope:google.api.ClientLibraryOrganization)
}
