/*
 * Copyright 2024 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/api/documentation.proto

// Protobuf Java Version: 3.25.5
package com.couchbase.client.core.deps.com.google.api;

/**
 *
 *
 * <pre>
 * Represents a documentation page. A page can contain subpages to represent
 * nested documentation set structure.
 * </pre>
 *
 * Protobuf type {@code google.api.Page}
 */
public final class Page extends com.google.protobuf.GeneratedMessageV3
    implements
    // @@protoc_insertion_point(message_implements:google.api.Page)
    PageOrBuilder {
  private static final long serialVersionUID = 0L;
  // Use Page.newBuilder() to construct.
  private Page(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }

  private Page() {
    name_ = "";
    content_ = "";
    subpages_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
    return new Page();
  }

  public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
    return com.google.api.DocumentationProto.internal_static_google_api_Page_descriptor;
  }

  @java.lang.Override
  protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.google.api.DocumentationProto.internal_static_google_api_Page_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.google.api.Page.class, com.google.api.Page.Builder.class);
  }

  public static final int NAME_FIELD_NUMBER = 1;

  @SuppressWarnings("serial")
  private volatile java.lang.Object name_ = "";
  /**
   *
   *
   * <pre>
   * The name of the page. It will be used as an identity of the page to
   * generate URI of the page, text of the link to this page in navigation,
   * etc. The full page name (start from the root page name to this page
   * concatenated with `.`) can be used as reference to the page in your
   * documentation. For example:
   * &lt;pre&gt;&lt;code&gt;pages:
   * - name: Tutorial
   *   content: &amp;#40;== include tutorial.md ==&amp;#41;
   *   subpages:
   *   - name: Java
   *     content: &amp;#40;== include tutorial_java.md ==&amp;#41;
   * &lt;/code&gt;&lt;/pre&gt;
   * You can reference `Java` page using Markdown reference link syntax:
   * `[Java][Tutorial.Java]`.
   * </pre>
   *
   * <code>string name = 1;</code>
   *
   * @return The name.
   */
  @java.lang.Override
  public java.lang.String getName() {
    java.lang.Object ref = name_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      name_ = s;
      return s;
    }
  }
  /**
   *
   *
   * <pre>
   * The name of the page. It will be used as an identity of the page to
   * generate URI of the page, text of the link to this page in navigation,
   * etc. The full page name (start from the root page name to this page
   * concatenated with `.`) can be used as reference to the page in your
   * documentation. For example:
   * &lt;pre&gt;&lt;code&gt;pages:
   * - name: Tutorial
   *   content: &amp;#40;== include tutorial.md ==&amp;#41;
   *   subpages:
   *   - name: Java
   *     content: &amp;#40;== include tutorial_java.md ==&amp;#41;
   * &lt;/code&gt;&lt;/pre&gt;
   * You can reference `Java` page using Markdown reference link syntax:
   * `[Java][Tutorial.Java]`.
   * </pre>
   *
   * <code>string name = 1;</code>
   *
   * @return The bytes for name.
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.protobuf.ByteString getNameBytes() {
    java.lang.Object ref = name_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b =
          com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
      name_ = b;
      return b;
    } else {
      return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
    }
  }

  public static final int CONTENT_FIELD_NUMBER = 2;

  @SuppressWarnings("serial")
  private volatile java.lang.Object content_ = "";
  /**
   *
   *
   * <pre>
   * The Markdown content of the page. You can use &lt;code&gt;&amp;#40;== include {path}
   * ==&amp;#41;&lt;/code&gt; to include content from a Markdown file. The content can be
   * used to produce the documentation page such as HTML format page.
   * </pre>
   *
   * <code>string content = 2;</code>
   *
   * @return The content.
   */
  @java.lang.Override
  public java.lang.String getContent() {
    java.lang.Object ref = content_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      content_ = s;
      return s;
    }
  }
  /**
   *
   *
   * <pre>
   * The Markdown content of the page. You can use &lt;code&gt;&amp;#40;== include {path}
   * ==&amp;#41;&lt;/code&gt; to include content from a Markdown file. The content can be
   * used to produce the documentation page such as HTML format page.
   * </pre>
   *
   * <code>string content = 2;</code>
   *
   * @return The bytes for content.
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.protobuf.ByteString getContentBytes() {
    java.lang.Object ref = content_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b =
          com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
      content_ = b;
      return b;
    } else {
      return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
    }
  }

  public static final int SUBPAGES_FIELD_NUMBER = 3;

  @SuppressWarnings("serial")
  private java.util.List<com.couchbase.client.core.deps.com.google.api.Page> subpages_;
  /**
   *
   *
   * <pre>
   * Subpages of this page. The order of subpages specified here will be
   * honored in the generated docset.
   * </pre>
   *
   * <code>repeated .google.api.Page subpages = 3;</code>
   */
  @java.lang.Override
  public java.util.List<com.couchbase.client.core.deps.com.google.api.Page> getSubpagesList() {
    return subpages_;
  }
  /**
   *
   *
   * <pre>
   * Subpages of this page. The order of subpages specified here will be
   * honored in the generated docset.
   * </pre>
   *
   * <code>repeated .google.api.Page subpages = 3;</code>
   */
  @java.lang.Override
  public java.util.List<? extends com.google.api.PageOrBuilder> getSubpagesOrBuilderList() {
    return subpages_;
  }
  /**
   *
   *
   * <pre>
   * Subpages of this page. The order of subpages specified here will be
   * honored in the generated docset.
   * </pre>
   *
   * <code>repeated .google.api.Page subpages = 3;</code>
   */
  @java.lang.Override
  public int getSubpagesCount() {
    return subpages_.size();
  }
  /**
   *
   *
   * <pre>
   * Subpages of this page. The order of subpages specified here will be
   * honored in the generated docset.
   * </pre>
   *
   * <code>repeated .google.api.Page subpages = 3;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.api.Page getSubpages(int index) {
    return subpages_.get(index);
  }
  /**
   *
   *
   * <pre>
   * Subpages of this page. The order of subpages specified here will be
   * honored in the generated docset.
   * </pre>
   *
   * <code>repeated .google.api.Page subpages = 3;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.api.PageOrBuilder getSubpagesOrBuilder(int index) {
    return subpages_.get(index);
  }

  private byte memoizedIsInitialized = -1;

  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.couchbase.client.core.deps.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
    if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(name_)) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 1, name_);
    }
    if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(content_)) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 2, content_);
    }
    for (int i = 0; i < subpages_.size(); i++) {
      output.writeMessage(3, subpages_.get(i));
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(name_)) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, name_);
    }
    if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(content_)) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, content_);
    }
    for (int i = 0; i < subpages_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream.computeMessageSize(3, subpages_.get(i));
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
      return true;
    }
    if (!(obj instanceof com.google.api.Page)) {
      return super.equals(obj);
    }
    com.google.api.Page other = (com.couchbase.client.core.deps.com.google.api.Page) obj;

    if (!getName().equals(other.getName())) return false;
    if (!getContent().equals(other.getContent())) return false;
    if (!getSubpagesList().equals(other.getSubpagesList())) return false;
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + NAME_FIELD_NUMBER;
    hash = (53 * hash) + getName().hashCode();
    hash = (37 * hash) + CONTENT_FIELD_NUMBER;
    hash = (53 * hash) + getContent().hashCode();
    if (getSubpagesCount() > 0) {
      hash = (37 * hash) + SUBPAGES_FIELD_NUMBER;
      hash = (53 * hash) + getSubpagesList().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static com.couchbase.client.core.deps.com.google.api.Page parseFrom(java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.api.Page parseFrom(
      java.nio.ByteBuffer data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.api.Page parseFrom(com.couchbase.client.core.deps.com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.api.Page parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.api.Page parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.api.Page parseFrom(
      byte[] data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.api.Page parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.api.Page parseFrom(
      java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.api.Page parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.api.Page parseDelimitedFrom(
      java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.api.Page parseFrom(com.couchbase.client.core.deps.com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.api.Page parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() {
    return newBuilder();
  }

  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }

  public static Builder newBuilder(com.couchbase.client.core.deps.com.google.api.Page prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }

  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   *
   *
   * <pre>
   * Represents a documentation page. A page can contain subpages to represent
   * nested documentation set structure.
   * </pre>
   *
   * Protobuf type {@code google.api.Page}
   */
  public static final class Builder extends com.google.protobuf.GeneratedMessageV3.Builder<Builder>
      implements
      // @@protoc_insertion_point(builder_implements:google.api.Page)
      com.google.api.PageOrBuilder {
    public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return com.google.api.DocumentationProto.internal_static_google_api_Page_descriptor;
    }

    @java.lang.Override
    protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.api.DocumentationProto.internal_static_google_api_Page_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.api.Page.class, com.google.api.Page.Builder.class);
    }

    // Construct using com.google.api.Page.newBuilder()
    private Builder() {}

    private Builder(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
    }

    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      name_ = "";
      content_ = "";
      if (subpagesBuilder_ == null) {
        subpages_ = java.util.Collections.emptyList();
      } else {
        subpages_ = null;
        subpagesBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000004);
      return this;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
      return com.google.api.DocumentationProto.internal_static_google_api_Page_descriptor;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.api.Page getDefaultInstanceForType() {
      return com.google.api.Page.getDefaultInstance();
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.api.Page build() {
      com.google.api.Page result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.api.Page buildPartial() {
      com.google.api.Page result = new com.google.api.Page(this);
      buildPartialRepeatedFields(result);
      if (bitField0_ != 0) {
        buildPartial0(result);
      }
      onBuilt();
      return result;
    }

    private void buildPartialRepeatedFields(com.couchbase.client.core.deps.com.google.api.Page result) {
      if (subpagesBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0)) {
          subpages_ = java.util.Collections.unmodifiableList(subpages_);
          bitField0_ = (bitField0_ & ~0x00000004);
        }
        result.subpages_ = subpages_;
      } else {
        result.subpages_ = subpagesBuilder_.build();
      }
    }

    private void buildPartial0(com.couchbase.client.core.deps.com.google.api.Page result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.name_ = name_;
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.content_ = content_;
      }
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }

    @java.lang.Override
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.setField(field, value);
    }

    @java.lang.Override
    public Builder clearField(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }

    @java.lang.Override
    public Builder clearOneof(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }

    @java.lang.Override
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field, int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }

    @java.lang.Override
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }

    @java.lang.Override
    public Builder mergeFrom(com.couchbase.client.core.deps.com.google.protobuf.Message other) {
      if (other instanceof com.google.api.Page) {
        return mergeFrom((com.couchbase.client.core.deps.com.google.api.Page) other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.couchbase.client.core.deps.com.google.api.Page other) {
      if (other == com.google.api.Page.getDefaultInstance()) return this;
      if (!other.getName().isEmpty()) {
        name_ = other.name_;
        bitField0_ |= 0x00000001;
        onChanged();
      }
      if (!other.getContent().isEmpty()) {
        content_ = other.content_;
        bitField0_ |= 0x00000002;
        onChanged();
      }
      if (subpagesBuilder_ == null) {
        if (!other.subpages_.isEmpty()) {
          if (subpages_.isEmpty()) {
            subpages_ = other.subpages_;
            bitField0_ = (bitField0_ & ~0x00000004);
          } else {
            ensureSubpagesIsMutable();
            subpages_.addAll(other.subpages_);
          }
          onChanged();
        }
      } else {
        if (!other.subpages_.isEmpty()) {
          if (subpagesBuilder_.isEmpty()) {
            subpagesBuilder_.dispose();
            subpagesBuilder_ = null;
            subpages_ = other.subpages_;
            bitField0_ = (bitField0_ & ~0x00000004);
            subpagesBuilder_ =
                com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders
                    ? getSubpagesFieldBuilder()
                    : null;
          } else {
            subpagesBuilder_.addAllMessages(other.subpages_);
          }
        }
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10:
              {
                name_ = input.readStringRequireUtf8();
                bitField0_ |= 0x00000001;
                break;
              } // case 10
            case 18:
              {
                content_ = input.readStringRequireUtf8();
                bitField0_ |= 0x00000002;
                break;
              } // case 18
            case 26:
              {
                com.google.api.Page m =
                    input.readMessage(com.couchbase.client.core.deps.com.google.api.Page.parser(), extensionRegistry);
                if (subpagesBuilder_ == null) {
                  ensureSubpagesIsMutable();
                  subpages_.add(m);
                } else {
                  subpagesBuilder_.addMessage(m);
                }
                break;
              } // case 26
            default:
              {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }

    private int bitField0_;

    private java.lang.Object name_ = "";
    /**
     *
     *
     * <pre>
     * The name of the page. It will be used as an identity of the page to
     * generate URI of the page, text of the link to this page in navigation,
     * etc. The full page name (start from the root page name to this page
     * concatenated with `.`) can be used as reference to the page in your
     * documentation. For example:
     * &lt;pre&gt;&lt;code&gt;pages:
     * - name: Tutorial
     *   content: &amp;#40;== include tutorial.md ==&amp;#41;
     *   subpages:
     *   - name: Java
     *     content: &amp;#40;== include tutorial_java.md ==&amp;#41;
     * &lt;/code&gt;&lt;/pre&gt;
     * You can reference `Java` page using Markdown reference link syntax:
     * `[Java][Tutorial.Java]`.
     * </pre>
     *
     * <code>string name = 1;</code>
     *
     * @return The name.
     */
    public java.lang.String getName() {
      java.lang.Object ref = name_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        name_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The name of the page. It will be used as an identity of the page to
     * generate URI of the page, text of the link to this page in navigation,
     * etc. The full page name (start from the root page name to this page
     * concatenated with `.`) can be used as reference to the page in your
     * documentation. For example:
     * &lt;pre&gt;&lt;code&gt;pages:
     * - name: Tutorial
     *   content: &amp;#40;== include tutorial.md ==&amp;#41;
     *   subpages:
     *   - name: Java
     *     content: &amp;#40;== include tutorial_java.md ==&amp;#41;
     * &lt;/code&gt;&lt;/pre&gt;
     * You can reference `Java` page using Markdown reference link syntax:
     * `[Java][Tutorial.Java]`.
     * </pre>
     *
     * <code>string name = 1;</code>
     *
     * @return The bytes for name.
     */
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getNameBytes() {
      java.lang.Object ref = name_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        name_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The name of the page. It will be used as an identity of the page to
     * generate URI of the page, text of the link to this page in navigation,
     * etc. The full page name (start from the root page name to this page
     * concatenated with `.`) can be used as reference to the page in your
     * documentation. For example:
     * &lt;pre&gt;&lt;code&gt;pages:
     * - name: Tutorial
     *   content: &amp;#40;== include tutorial.md ==&amp;#41;
     *   subpages:
     *   - name: Java
     *     content: &amp;#40;== include tutorial_java.md ==&amp;#41;
     * &lt;/code&gt;&lt;/pre&gt;
     * You can reference `Java` page using Markdown reference link syntax:
     * `[Java][Tutorial.Java]`.
     * </pre>
     *
     * <code>string name = 1;</code>
     *
     * @param value The name to set.
     * @return This builder for chaining.
     */
    public Builder setName(java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }
      name_ = value;
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The name of the page. It will be used as an identity of the page to
     * generate URI of the page, text of the link to this page in navigation,
     * etc. The full page name (start from the root page name to this page
     * concatenated with `.`) can be used as reference to the page in your
     * documentation. For example:
     * &lt;pre&gt;&lt;code&gt;pages:
     * - name: Tutorial
     *   content: &amp;#40;== include tutorial.md ==&amp;#41;
     *   subpages:
     *   - name: Java
     *     content: &amp;#40;== include tutorial_java.md ==&amp;#41;
     * &lt;/code&gt;&lt;/pre&gt;
     * You can reference `Java` page using Markdown reference link syntax:
     * `[Java][Tutorial.Java]`.
     * </pre>
     *
     * <code>string name = 1;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearName() {
      name_ = getDefaultInstance().getName();
      bitField0_ = (bitField0_ & ~0x00000001);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The name of the page. It will be used as an identity of the page to
     * generate URI of the page, text of the link to this page in navigation,
     * etc. The full page name (start from the root page name to this page
     * concatenated with `.`) can be used as reference to the page in your
     * documentation. For example:
     * &lt;pre&gt;&lt;code&gt;pages:
     * - name: Tutorial
     *   content: &amp;#40;== include tutorial.md ==&amp;#41;
     *   subpages:
     *   - name: Java
     *     content: &amp;#40;== include tutorial_java.md ==&amp;#41;
     * &lt;/code&gt;&lt;/pre&gt;
     * You can reference `Java` page using Markdown reference link syntax:
     * `[Java][Tutorial.Java]`.
     * </pre>
     *
     * <code>string name = 1;</code>
     *
     * @param value The bytes for name to set.
     * @return This builder for chaining.
     */
    public Builder setNameBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
      if (value == null) {
        throw new NullPointerException();
      }
      checkByteStringIsUtf8(value);
      name_ = value;
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }

    private java.lang.Object content_ = "";
    /**
     *
     *
     * <pre>
     * The Markdown content of the page. You can use &lt;code&gt;&amp;#40;== include {path}
     * ==&amp;#41;&lt;/code&gt; to include content from a Markdown file. The content can be
     * used to produce the documentation page such as HTML format page.
     * </pre>
     *
     * <code>string content = 2;</code>
     *
     * @return The content.
     */
    public java.lang.String getContent() {
      java.lang.Object ref = content_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        content_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The Markdown content of the page. You can use &lt;code&gt;&amp;#40;== include {path}
     * ==&amp;#41;&lt;/code&gt; to include content from a Markdown file. The content can be
     * used to produce the documentation page such as HTML format page.
     * </pre>
     *
     * <code>string content = 2;</code>
     *
     * @return The bytes for content.
     */
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getContentBytes() {
      java.lang.Object ref = content_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        content_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The Markdown content of the page. You can use &lt;code&gt;&amp;#40;== include {path}
     * ==&amp;#41;&lt;/code&gt; to include content from a Markdown file. The content can be
     * used to produce the documentation page such as HTML format page.
     * </pre>
     *
     * <code>string content = 2;</code>
     *
     * @param value The content to set.
     * @return This builder for chaining.
     */
    public Builder setContent(java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }
      content_ = value;
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The Markdown content of the page. You can use &lt;code&gt;&amp;#40;== include {path}
     * ==&amp;#41;&lt;/code&gt; to include content from a Markdown file. The content can be
     * used to produce the documentation page such as HTML format page.
     * </pre>
     *
     * <code>string content = 2;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearContent() {
      content_ = getDefaultInstance().getContent();
      bitField0_ = (bitField0_ & ~0x00000002);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The Markdown content of the page. You can use &lt;code&gt;&amp;#40;== include {path}
     * ==&amp;#41;&lt;/code&gt; to include content from a Markdown file. The content can be
     * used to produce the documentation page such as HTML format page.
     * </pre>
     *
     * <code>string content = 2;</code>
     *
     * @param value The bytes for content to set.
     * @return This builder for chaining.
     */
    public Builder setContentBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
      if (value == null) {
        throw new NullPointerException();
      }
      checkByteStringIsUtf8(value);
      content_ = value;
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }

    private java.util.List<com.couchbase.client.core.deps.com.google.api.Page> subpages_ = java.util.Collections.emptyList();

    private void ensureSubpagesIsMutable() {
      if (!((bitField0_ & 0x00000004) != 0)) {
        subpages_ = new java.util.ArrayList<com.couchbase.client.core.deps.com.google.api.Page>(subpages_);
        bitField0_ |= 0x00000004;
      }
    }

    private com.couchbase.client.core.deps.com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.api.Page, com.google.api.Page.Builder, com.google.api.PageOrBuilder>
        subpagesBuilder_;

    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public java.util.List<com.couchbase.client.core.deps.com.google.api.Page> getSubpagesList() {
      if (subpagesBuilder_ == null) {
        return java.util.Collections.unmodifiableList(subpages_);
      } else {
        return subpagesBuilder_.getMessageList();
      }
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public int getSubpagesCount() {
      if (subpagesBuilder_ == null) {
        return subpages_.size();
      } else {
        return subpagesBuilder_.getCount();
      }
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.Page getSubpages(int index) {
      if (subpagesBuilder_ == null) {
        return subpages_.get(index);
      } else {
        return subpagesBuilder_.getMessage(index);
      }
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public Builder setSubpages(int index, com.google.api.Page value) {
      if (subpagesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureSubpagesIsMutable();
        subpages_.set(index, value);
        onChanged();
      } else {
        subpagesBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public Builder setSubpages(int index, com.google.api.Page.Builder builderForValue) {
      if (subpagesBuilder_ == null) {
        ensureSubpagesIsMutable();
        subpages_.set(index, builderForValue.build());
        onChanged();
      } else {
        subpagesBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public Builder addSubpages(com.couchbase.client.core.deps.com.google.api.Page value) {
      if (subpagesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureSubpagesIsMutable();
        subpages_.add(value);
        onChanged();
      } else {
        subpagesBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public Builder addSubpages(int index, com.google.api.Page value) {
      if (subpagesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureSubpagesIsMutable();
        subpages_.add(index, value);
        onChanged();
      } else {
        subpagesBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public Builder addSubpages(com.couchbase.client.core.deps.com.google.api.Page.Builder builderForValue) {
      if (subpagesBuilder_ == null) {
        ensureSubpagesIsMutable();
        subpages_.add(builderForValue.build());
        onChanged();
      } else {
        subpagesBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public Builder addSubpages(int index, com.google.api.Page.Builder builderForValue) {
      if (subpagesBuilder_ == null) {
        ensureSubpagesIsMutable();
        subpages_.add(index, builderForValue.build());
        onChanged();
      } else {
        subpagesBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public Builder addAllSubpages(java.lang.Iterable<? extends com.google.api.Page> values) {
      if (subpagesBuilder_ == null) {
        ensureSubpagesIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(values, subpages_);
        onChanged();
      } else {
        subpagesBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public Builder clearSubpages() {
      if (subpagesBuilder_ == null) {
        subpages_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000004);
        onChanged();
      } else {
        subpagesBuilder_.clear();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public Builder removeSubpages(int index) {
      if (subpagesBuilder_ == null) {
        ensureSubpagesIsMutable();
        subpages_.remove(index);
        onChanged();
      } else {
        subpagesBuilder_.remove(index);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.Page.Builder getSubpagesBuilder(int index) {
      return getSubpagesFieldBuilder().getBuilder(index);
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.PageOrBuilder getSubpagesOrBuilder(int index) {
      if (subpagesBuilder_ == null) {
        return subpages_.get(index);
      } else {
        return subpagesBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public java.util.List<? extends com.google.api.PageOrBuilder> getSubpagesOrBuilderList() {
      if (subpagesBuilder_ != null) {
        return subpagesBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(subpages_);
      }
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.Page.Builder addSubpagesBuilder() {
      return getSubpagesFieldBuilder().addBuilder(com.couchbase.client.core.deps.com.google.api.Page.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.Page.Builder addSubpagesBuilder(int index) {
      return getSubpagesFieldBuilder().addBuilder(index, com.google.api.Page.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * Subpages of this page. The order of subpages specified here will be
     * honored in the generated docset.
     * </pre>
     *
     * <code>repeated .google.api.Page subpages = 3;</code>
     */
    public java.util.List<com.couchbase.client.core.deps.com.google.api.Page.Builder> getSubpagesBuilderList() {
      return getSubpagesFieldBuilder().getBuilderList();
    }

    private com.couchbase.client.core.deps.com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.api.Page, com.google.api.Page.Builder, com.google.api.PageOrBuilder>
        getSubpagesFieldBuilder() {
      if (subpagesBuilder_ == null) {
        subpagesBuilder_ =
            new com.google.protobuf.RepeatedFieldBuilderV3<
                com.google.api.Page, com.google.api.Page.Builder, com.google.api.PageOrBuilder>(
                subpages_, ((bitField0_ & 0x00000004) != 0), getParentForChildren(), isClean());
        subpages_ = null;
      }
      return subpagesBuilder_;
    }

    @java.lang.Override
    public final Builder setUnknownFields(final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }

    // @@protoc_insertion_point(builder_scope:google.api.Page)
  }

  // @@protoc_insertion_point(class_scope:google.api.Page)
  private static final com.couchbase.client.core.deps.com.google.api.Page DEFAULT_INSTANCE;

  static {
    DEFAULT_INSTANCE = new com.google.api.Page();
  }

  public static com.couchbase.client.core.deps.com.google.api.Page getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.couchbase.client.core.deps.com.google.protobuf.Parser<Page> PARSER =
      new com.google.protobuf.AbstractParser<Page>() {
        @java.lang.Override
        public Page parsePartialFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          Builder builder = newBuilder();
          try {
            builder.mergeFrom(input, extensionRegistry);
          } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
            throw e.setUnfinishedMessage(builder.buildPartial());
          } catch (com.couchbase.client.core.deps.com.google.protobuf.UninitializedMessageException e) {
            throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
          } catch (java.io.IOException e) {
            throw new com.google.protobuf.InvalidProtocolBufferException(e)
                .setUnfinishedMessage(builder.buildPartial());
          }
          return builder.buildPartial();
        }
      };

  public static com.couchbase.client.core.deps.com.google.protobuf.Parser<Page> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.protobuf.Parser<Page> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.api.Page getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }
}
