/*
 * Copyright 2024 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/api/usage.proto

// Protobuf Java Version: 3.25.5
package com.couchbase.client.core.deps.com.google.api;

/**
 *
 *
 * <pre>
 * Configuration controlling usage of a service.
 * </pre>
 *
 * Protobuf type {@code google.api.Usage}
 */
public final class Usage extends com.google.protobuf.GeneratedMessageV3
    implements
    // @@protoc_insertion_point(message_implements:google.api.Usage)
    UsageOrBuilder {
  private static final long serialVersionUID = 0L;
  // Use Usage.newBuilder() to construct.
  private Usage(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }

  private Usage() {
    requirements_ = com.google.protobuf.LazyStringArrayList.emptyList();
    rules_ = java.util.Collections.emptyList();
    producerNotificationChannel_ = "";
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
    return new Usage();
  }

  public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
    return com.google.api.UsageProto.internal_static_google_api_Usage_descriptor;
  }

  @java.lang.Override
  protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.google.api.UsageProto.internal_static_google_api_Usage_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.google.api.Usage.class, com.google.api.Usage.Builder.class);
  }

  public static final int REQUIREMENTS_FIELD_NUMBER = 1;

  @SuppressWarnings("serial")
  private com.couchbase.client.core.deps.com.google.protobuf.LazyStringArrayList requirements_ =
      com.google.protobuf.LazyStringArrayList.emptyList();
  /**
   *
   *
   * <pre>
   * Requirements that must be satisfied before a consumer project can use the
   * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
   * for example 'serviceusage.googleapis.com/billing-enabled'.
   *
   * For Google APIs, a Terms of Service requirement must be included here.
   * Google Cloud APIs must include "serviceusage.googleapis.com/tos/cloud".
   * Other Google APIs should include
   * "serviceusage.googleapis.com/tos/universal". Additional ToS can be
   * included based on the business needs.
   * </pre>
   *
   * <code>repeated string requirements = 1;</code>
   *
   * @return A list containing the requirements.
   */
  public com.couchbase.client.core.deps.com.google.protobuf.ProtocolStringList getRequirementsList() {
    return requirements_;
  }
  /**
   *
   *
   * <pre>
   * Requirements that must be satisfied before a consumer project can use the
   * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
   * for example 'serviceusage.googleapis.com/billing-enabled'.
   *
   * For Google APIs, a Terms of Service requirement must be included here.
   * Google Cloud APIs must include "serviceusage.googleapis.com/tos/cloud".
   * Other Google APIs should include
   * "serviceusage.googleapis.com/tos/universal". Additional ToS can be
   * included based on the business needs.
   * </pre>
   *
   * <code>repeated string requirements = 1;</code>
   *
   * @return The count of requirements.
   */
  public int getRequirementsCount() {
    return requirements_.size();
  }
  /**
   *
   *
   * <pre>
   * Requirements that must be satisfied before a consumer project can use the
   * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
   * for example 'serviceusage.googleapis.com/billing-enabled'.
   *
   * For Google APIs, a Terms of Service requirement must be included here.
   * Google Cloud APIs must include "serviceusage.googleapis.com/tos/cloud".
   * Other Google APIs should include
   * "serviceusage.googleapis.com/tos/universal". Additional ToS can be
   * included based on the business needs.
   * </pre>
   *
   * <code>repeated string requirements = 1;</code>
   *
   * @param index The index of the element to return.
   * @return The requirements at the given index.
   */
  public java.lang.String getRequirements(int index) {
    return requirements_.get(index);
  }
  /**
   *
   *
   * <pre>
   * Requirements that must be satisfied before a consumer project can use the
   * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
   * for example 'serviceusage.googleapis.com/billing-enabled'.
   *
   * For Google APIs, a Terms of Service requirement must be included here.
   * Google Cloud APIs must include "serviceusage.googleapis.com/tos/cloud".
   * Other Google APIs should include
   * "serviceusage.googleapis.com/tos/universal". Additional ToS can be
   * included based on the business needs.
   * </pre>
   *
   * <code>repeated string requirements = 1;</code>
   *
   * @param index The index of the value to return.
   * @return The bytes of the requirements at the given index.
   */
  public com.couchbase.client.core.deps.com.google.protobuf.ByteString getRequirementsBytes(int index) {
    return requirements_.getByteString(index);
  }

  public static final int RULES_FIELD_NUMBER = 6;

  @SuppressWarnings("serial")
  private java.util.List<com.couchbase.client.core.deps.com.google.api.UsageRule> rules_;
  /**
   *
   *
   * <pre>
   * A list of usage rules that apply to individual API methods.
   *
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.UsageRule rules = 6;</code>
   */
  @java.lang.Override
  public java.util.List<com.couchbase.client.core.deps.com.google.api.UsageRule> getRulesList() {
    return rules_;
  }
  /**
   *
   *
   * <pre>
   * A list of usage rules that apply to individual API methods.
   *
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.UsageRule rules = 6;</code>
   */
  @java.lang.Override
  public java.util.List<? extends com.google.api.UsageRuleOrBuilder> getRulesOrBuilderList() {
    return rules_;
  }
  /**
   *
   *
   * <pre>
   * A list of usage rules that apply to individual API methods.
   *
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.UsageRule rules = 6;</code>
   */
  @java.lang.Override
  public int getRulesCount() {
    return rules_.size();
  }
  /**
   *
   *
   * <pre>
   * A list of usage rules that apply to individual API methods.
   *
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.UsageRule rules = 6;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.api.UsageRule getRules(int index) {
    return rules_.get(index);
  }
  /**
   *
   *
   * <pre>
   * A list of usage rules that apply to individual API methods.
   *
   * **NOTE:** All service configuration rules follow "last one wins" order.
   * </pre>
   *
   * <code>repeated .google.api.UsageRule rules = 6;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.api.UsageRuleOrBuilder getRulesOrBuilder(int index) {
    return rules_.get(index);
  }

  public static final int PRODUCER_NOTIFICATION_CHANNEL_FIELD_NUMBER = 7;

  @SuppressWarnings("serial")
  private volatile java.lang.Object producerNotificationChannel_ = "";
  /**
   *
   *
   * <pre>
   * The full resource name of a channel used for sending notifications to the
   * service producer.
   *
   * Google Service Management currently only supports
   * [Google Cloud Pub/Sub](https://cloud.google.com/pubsub) as a notification
   * channel. To use Google Cloud Pub/Sub as the channel, this must be the name
   * of a Cloud Pub/Sub topic that uses the Cloud Pub/Sub topic name format
   * documented in https://cloud.google.com/pubsub/docs/overview.
   * </pre>
   *
   * <code>string producer_notification_channel = 7;</code>
   *
   * @return The producerNotificationChannel.
   */
  @java.lang.Override
  public java.lang.String getProducerNotificationChannel() {
    java.lang.Object ref = producerNotificationChannel_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      producerNotificationChannel_ = s;
      return s;
    }
  }
  /**
   *
   *
   * <pre>
   * The full resource name of a channel used for sending notifications to the
   * service producer.
   *
   * Google Service Management currently only supports
   * [Google Cloud Pub/Sub](https://cloud.google.com/pubsub) as a notification
   * channel. To use Google Cloud Pub/Sub as the channel, this must be the name
   * of a Cloud Pub/Sub topic that uses the Cloud Pub/Sub topic name format
   * documented in https://cloud.google.com/pubsub/docs/overview.
   * </pre>
   *
   * <code>string producer_notification_channel = 7;</code>
   *
   * @return The bytes for producerNotificationChannel.
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.protobuf.ByteString getProducerNotificationChannelBytes() {
    java.lang.Object ref = producerNotificationChannel_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b =
          com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
      producerNotificationChannel_ = b;
      return b;
    } else {
      return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
    }
  }

  private byte memoizedIsInitialized = -1;

  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.couchbase.client.core.deps.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
    for (int i = 0; i < requirements_.size(); i++) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 1, requirements_.getRaw(i));
    }
    for (int i = 0; i < rules_.size(); i++) {
      output.writeMessage(6, rules_.get(i));
    }
    if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(producerNotificationChannel_)) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 7, producerNotificationChannel_);
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    {
      int dataSize = 0;
      for (int i = 0; i < requirements_.size(); i++) {
        dataSize += computeStringSizeNoTag(requirements_.getRaw(i));
      }
      size += dataSize;
      size += 1 * getRequirementsList().size();
    }
    for (int i = 0; i < rules_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream.computeMessageSize(6, rules_.get(i));
    }
    if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(producerNotificationChannel_)) {
      size +=
          com.google.protobuf.GeneratedMessageV3.computeStringSize(7, producerNotificationChannel_);
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
      return true;
    }
    if (!(obj instanceof com.google.api.Usage)) {
      return super.equals(obj);
    }
    com.google.api.Usage other = (com.couchbase.client.core.deps.com.google.api.Usage) obj;

    if (!getRequirementsList().equals(other.getRequirementsList())) return false;
    if (!getRulesList().equals(other.getRulesList())) return false;
    if (!getProducerNotificationChannel().equals(other.getProducerNotificationChannel()))
      return false;
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getRequirementsCount() > 0) {
      hash = (37 * hash) + REQUIREMENTS_FIELD_NUMBER;
      hash = (53 * hash) + getRequirementsList().hashCode();
    }
    if (getRulesCount() > 0) {
      hash = (37 * hash) + RULES_FIELD_NUMBER;
      hash = (53 * hash) + getRulesList().hashCode();
    }
    hash = (37 * hash) + PRODUCER_NOTIFICATION_CHANNEL_FIELD_NUMBER;
    hash = (53 * hash) + getProducerNotificationChannel().hashCode();
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static com.couchbase.client.core.deps.com.google.api.Usage parseFrom(java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.api.Usage parseFrom(
      java.nio.ByteBuffer data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.api.Usage parseFrom(com.couchbase.client.core.deps.com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.api.Usage parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.api.Usage parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.api.Usage parseFrom(
      byte[] data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.api.Usage parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.api.Usage parseFrom(
      java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.api.Usage parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.api.Usage parseDelimitedFrom(
      java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.api.Usage parseFrom(com.couchbase.client.core.deps.com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.api.Usage parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() {
    return newBuilder();
  }

  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }

  public static Builder newBuilder(com.couchbase.client.core.deps.com.google.api.Usage prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }

  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   *
   *
   * <pre>
   * Configuration controlling usage of a service.
   * </pre>
   *
   * Protobuf type {@code google.api.Usage}
   */
  public static final class Builder extends com.google.protobuf.GeneratedMessageV3.Builder<Builder>
      implements
      // @@protoc_insertion_point(builder_implements:google.api.Usage)
      com.google.api.UsageOrBuilder {
    public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return com.google.api.UsageProto.internal_static_google_api_Usage_descriptor;
    }

    @java.lang.Override
    protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.api.UsageProto.internal_static_google_api_Usage_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.api.Usage.class, com.google.api.Usage.Builder.class);
    }

    // Construct using com.google.api.Usage.newBuilder()
    private Builder() {}

    private Builder(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
    }

    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      requirements_ = com.google.protobuf.LazyStringArrayList.emptyList();
      if (rulesBuilder_ == null) {
        rules_ = java.util.Collections.emptyList();
      } else {
        rules_ = null;
        rulesBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000002);
      producerNotificationChannel_ = "";
      return this;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
      return com.google.api.UsageProto.internal_static_google_api_Usage_descriptor;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.api.Usage getDefaultInstanceForType() {
      return com.google.api.Usage.getDefaultInstance();
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.api.Usage build() {
      com.google.api.Usage result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.api.Usage buildPartial() {
      com.google.api.Usage result = new com.google.api.Usage(this);
      buildPartialRepeatedFields(result);
      if (bitField0_ != 0) {
        buildPartial0(result);
      }
      onBuilt();
      return result;
    }

    private void buildPartialRepeatedFields(com.couchbase.client.core.deps.com.google.api.Usage result) {
      if (rulesBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0)) {
          rules_ = java.util.Collections.unmodifiableList(rules_);
          bitField0_ = (bitField0_ & ~0x00000002);
        }
        result.rules_ = rules_;
      } else {
        result.rules_ = rulesBuilder_.build();
      }
    }

    private void buildPartial0(com.couchbase.client.core.deps.com.google.api.Usage result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        requirements_.makeImmutable();
        result.requirements_ = requirements_;
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.producerNotificationChannel_ = producerNotificationChannel_;
      }
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }

    @java.lang.Override
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.setField(field, value);
    }

    @java.lang.Override
    public Builder clearField(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }

    @java.lang.Override
    public Builder clearOneof(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }

    @java.lang.Override
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field, int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }

    @java.lang.Override
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }

    @java.lang.Override
    public Builder mergeFrom(com.couchbase.client.core.deps.com.google.protobuf.Message other) {
      if (other instanceof com.google.api.Usage) {
        return mergeFrom((com.couchbase.client.core.deps.com.google.api.Usage) other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.couchbase.client.core.deps.com.google.api.Usage other) {
      if (other == com.google.api.Usage.getDefaultInstance()) return this;
      if (!other.requirements_.isEmpty()) {
        if (requirements_.isEmpty()) {
          requirements_ = other.requirements_;
          bitField0_ |= 0x00000001;
        } else {
          ensureRequirementsIsMutable();
          requirements_.addAll(other.requirements_);
        }
        onChanged();
      }
      if (rulesBuilder_ == null) {
        if (!other.rules_.isEmpty()) {
          if (rules_.isEmpty()) {
            rules_ = other.rules_;
            bitField0_ = (bitField0_ & ~0x00000002);
          } else {
            ensureRulesIsMutable();
            rules_.addAll(other.rules_);
          }
          onChanged();
        }
      } else {
        if (!other.rules_.isEmpty()) {
          if (rulesBuilder_.isEmpty()) {
            rulesBuilder_.dispose();
            rulesBuilder_ = null;
            rules_ = other.rules_;
            bitField0_ = (bitField0_ & ~0x00000002);
            rulesBuilder_ =
                com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders
                    ? getRulesFieldBuilder()
                    : null;
          } else {
            rulesBuilder_.addAllMessages(other.rules_);
          }
        }
      }
      if (!other.getProducerNotificationChannel().isEmpty()) {
        producerNotificationChannel_ = other.producerNotificationChannel_;
        bitField0_ |= 0x00000004;
        onChanged();
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10:
              {
                java.lang.String s = input.readStringRequireUtf8();
                ensureRequirementsIsMutable();
                requirements_.add(s);
                break;
              } // case 10
            case 50:
              {
                com.google.api.UsageRule m =
                    input.readMessage(com.couchbase.client.core.deps.com.google.api.UsageRule.parser(), extensionRegistry);
                if (rulesBuilder_ == null) {
                  ensureRulesIsMutable();
                  rules_.add(m);
                } else {
                  rulesBuilder_.addMessage(m);
                }
                break;
              } // case 50
            case 58:
              {
                producerNotificationChannel_ = input.readStringRequireUtf8();
                bitField0_ |= 0x00000004;
                break;
              } // case 58
            default:
              {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }

    private int bitField0_;

    private com.couchbase.client.core.deps.com.google.protobuf.LazyStringArrayList requirements_ =
        com.google.protobuf.LazyStringArrayList.emptyList();

    private void ensureRequirementsIsMutable() {
      if (!requirements_.isModifiable()) {
        requirements_ = new com.google.protobuf.LazyStringArrayList(requirements_);
      }
      bitField0_ |= 0x00000001;
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     *
     * For Google APIs, a Terms of Service requirement must be included here.
     * Google Cloud APIs must include "serviceusage.googleapis.com/tos/cloud".
     * Other Google APIs should include
     * "serviceusage.googleapis.com/tos/universal". Additional ToS can be
     * included based on the business needs.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @return A list containing the requirements.
     */
    public com.couchbase.client.core.deps.com.google.protobuf.ProtocolStringList getRequirementsList() {
      requirements_.makeImmutable();
      return requirements_;
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     *
     * For Google APIs, a Terms of Service requirement must be included here.
     * Google Cloud APIs must include "serviceusage.googleapis.com/tos/cloud".
     * Other Google APIs should include
     * "serviceusage.googleapis.com/tos/universal". Additional ToS can be
     * included based on the business needs.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @return The count of requirements.
     */
    public int getRequirementsCount() {
      return requirements_.size();
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     *
     * For Google APIs, a Terms of Service requirement must be included here.
     * Google Cloud APIs must include "serviceusage.googleapis.com/tos/cloud".
     * Other Google APIs should include
     * "serviceusage.googleapis.com/tos/universal". Additional ToS can be
     * included based on the business needs.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @param index The index of the element to return.
     * @return The requirements at the given index.
     */
    public java.lang.String getRequirements(int index) {
      return requirements_.get(index);
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     *
     * For Google APIs, a Terms of Service requirement must be included here.
     * Google Cloud APIs must include "serviceusage.googleapis.com/tos/cloud".
     * Other Google APIs should include
     * "serviceusage.googleapis.com/tos/universal". Additional ToS can be
     * included based on the business needs.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @param index The index of the value to return.
     * @return The bytes of the requirements at the given index.
     */
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getRequirementsBytes(int index) {
      return requirements_.getByteString(index);
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     *
     * For Google APIs, a Terms of Service requirement must be included here.
     * Google Cloud APIs must include "serviceusage.googleapis.com/tos/cloud".
     * Other Google APIs should include
     * "serviceusage.googleapis.com/tos/universal". Additional ToS can be
     * included based on the business needs.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @param index The index to set the value at.
     * @param value The requirements to set.
     * @return This builder for chaining.
     */
    public Builder setRequirements(int index, java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }
      ensureRequirementsIsMutable();
      requirements_.set(index, value);
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     *
     * For Google APIs, a Terms of Service requirement must be included here.
     * Google Cloud APIs must include "serviceusage.googleapis.com/tos/cloud".
     * Other Google APIs should include
     * "serviceusage.googleapis.com/tos/universal". Additional ToS can be
     * included based on the business needs.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @param value The requirements to add.
     * @return This builder for chaining.
     */
    public Builder addRequirements(java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }
      ensureRequirementsIsMutable();
      requirements_.add(value);
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     *
     * For Google APIs, a Terms of Service requirement must be included here.
     * Google Cloud APIs must include "serviceusage.googleapis.com/tos/cloud".
     * Other Google APIs should include
     * "serviceusage.googleapis.com/tos/universal". Additional ToS can be
     * included based on the business needs.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @param values The requirements to add.
     * @return This builder for chaining.
     */
    public Builder addAllRequirements(java.lang.Iterable<java.lang.String> values) {
      ensureRequirementsIsMutable();
      com.google.protobuf.AbstractMessageLite.Builder.addAll(values, requirements_);
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     *
     * For Google APIs, a Terms of Service requirement must be included here.
     * Google Cloud APIs must include "serviceusage.googleapis.com/tos/cloud".
     * Other Google APIs should include
     * "serviceusage.googleapis.com/tos/universal". Additional ToS can be
     * included based on the business needs.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearRequirements() {
      requirements_ = com.google.protobuf.LazyStringArrayList.emptyList();
      bitField0_ = (bitField0_ & ~0x00000001);
      ;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Requirements that must be satisfied before a consumer project can use the
     * service. Each requirement is of the form &lt;service.name&gt;/&lt;requirement-id&gt;;
     * for example 'serviceusage.googleapis.com/billing-enabled'.
     *
     * For Google APIs, a Terms of Service requirement must be included here.
     * Google Cloud APIs must include "serviceusage.googleapis.com/tos/cloud".
     * Other Google APIs should include
     * "serviceusage.googleapis.com/tos/universal". Additional ToS can be
     * included based on the business needs.
     * </pre>
     *
     * <code>repeated string requirements = 1;</code>
     *
     * @param value The bytes of the requirements to add.
     * @return This builder for chaining.
     */
    public Builder addRequirementsBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
      if (value == null) {
        throw new NullPointerException();
      }
      checkByteStringIsUtf8(value);
      ensureRequirementsIsMutable();
      requirements_.add(value);
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }

    private java.util.List<com.couchbase.client.core.deps.com.google.api.UsageRule> rules_ = java.util.Collections.emptyList();

    private void ensureRulesIsMutable() {
      if (!((bitField0_ & 0x00000002) != 0)) {
        rules_ = new java.util.ArrayList<com.couchbase.client.core.deps.com.google.api.UsageRule>(rules_);
        bitField0_ |= 0x00000002;
      }
    }

    private com.couchbase.client.core.deps.com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.api.UsageRule,
            com.google.api.UsageRule.Builder,
            com.google.api.UsageRuleOrBuilder>
        rulesBuilder_;

    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public java.util.List<com.couchbase.client.core.deps.com.google.api.UsageRule> getRulesList() {
      if (rulesBuilder_ == null) {
        return java.util.Collections.unmodifiableList(rules_);
      } else {
        return rulesBuilder_.getMessageList();
      }
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public int getRulesCount() {
      if (rulesBuilder_ == null) {
        return rules_.size();
      } else {
        return rulesBuilder_.getCount();
      }
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.UsageRule getRules(int index) {
      if (rulesBuilder_ == null) {
        return rules_.get(index);
      } else {
        return rulesBuilder_.getMessage(index);
      }
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder setRules(int index, com.google.api.UsageRule value) {
      if (rulesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRulesIsMutable();
        rules_.set(index, value);
        onChanged();
      } else {
        rulesBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder setRules(int index, com.google.api.UsageRule.Builder builderForValue) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        rules_.set(index, builderForValue.build());
        onChanged();
      } else {
        rulesBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder addRules(com.couchbase.client.core.deps.com.google.api.UsageRule value) {
      if (rulesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRulesIsMutable();
        rules_.add(value);
        onChanged();
      } else {
        rulesBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder addRules(int index, com.google.api.UsageRule value) {
      if (rulesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureRulesIsMutable();
        rules_.add(index, value);
        onChanged();
      } else {
        rulesBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder addRules(com.couchbase.client.core.deps.com.google.api.UsageRule.Builder builderForValue) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        rules_.add(builderForValue.build());
        onChanged();
      } else {
        rulesBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder addRules(int index, com.google.api.UsageRule.Builder builderForValue) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        rules_.add(index, builderForValue.build());
        onChanged();
      } else {
        rulesBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder addAllRules(java.lang.Iterable<? extends com.google.api.UsageRule> values) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(values, rules_);
        onChanged();
      } else {
        rulesBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder clearRules() {
      if (rulesBuilder_ == null) {
        rules_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
      } else {
        rulesBuilder_.clear();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public Builder removeRules(int index) {
      if (rulesBuilder_ == null) {
        ensureRulesIsMutable();
        rules_.remove(index);
        onChanged();
      } else {
        rulesBuilder_.remove(index);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.UsageRule.Builder getRulesBuilder(int index) {
      return getRulesFieldBuilder().getBuilder(index);
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.UsageRuleOrBuilder getRulesOrBuilder(int index) {
      if (rulesBuilder_ == null) {
        return rules_.get(index);
      } else {
        return rulesBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public java.util.List<? extends com.google.api.UsageRuleOrBuilder> getRulesOrBuilderList() {
      if (rulesBuilder_ != null) {
        return rulesBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(rules_);
      }
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.UsageRule.Builder addRulesBuilder() {
      return getRulesFieldBuilder().addBuilder(com.couchbase.client.core.deps.com.google.api.UsageRule.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public com.couchbase.client.core.deps.com.google.api.UsageRule.Builder addRulesBuilder(int index) {
      return getRulesFieldBuilder()
          .addBuilder(index, com.google.api.UsageRule.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * A list of usage rules that apply to individual API methods.
     *
     * **NOTE:** All service configuration rules follow "last one wins" order.
     * </pre>
     *
     * <code>repeated .google.api.UsageRule rules = 6;</code>
     */
    public java.util.List<com.couchbase.client.core.deps.com.google.api.UsageRule.Builder> getRulesBuilderList() {
      return getRulesFieldBuilder().getBuilderList();
    }

    private com.couchbase.client.core.deps.com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.api.UsageRule,
            com.google.api.UsageRule.Builder,
            com.google.api.UsageRuleOrBuilder>
        getRulesFieldBuilder() {
      if (rulesBuilder_ == null) {
        rulesBuilder_ =
            new com.google.protobuf.RepeatedFieldBuilderV3<
                com.google.api.UsageRule,
                com.google.api.UsageRule.Builder,
                com.google.api.UsageRuleOrBuilder>(
                rules_, ((bitField0_ & 0x00000002) != 0), getParentForChildren(), isClean());
        rules_ = null;
      }
      return rulesBuilder_;
    }

    private java.lang.Object producerNotificationChannel_ = "";
    /**
     *
     *
     * <pre>
     * The full resource name of a channel used for sending notifications to the
     * service producer.
     *
     * Google Service Management currently only supports
     * [Google Cloud Pub/Sub](https://cloud.google.com/pubsub) as a notification
     * channel. To use Google Cloud Pub/Sub as the channel, this must be the name
     * of a Cloud Pub/Sub topic that uses the Cloud Pub/Sub topic name format
     * documented in https://cloud.google.com/pubsub/docs/overview.
     * </pre>
     *
     * <code>string producer_notification_channel = 7;</code>
     *
     * @return The producerNotificationChannel.
     */
    public java.lang.String getProducerNotificationChannel() {
      java.lang.Object ref = producerNotificationChannel_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        producerNotificationChannel_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The full resource name of a channel used for sending notifications to the
     * service producer.
     *
     * Google Service Management currently only supports
     * [Google Cloud Pub/Sub](https://cloud.google.com/pubsub) as a notification
     * channel. To use Google Cloud Pub/Sub as the channel, this must be the name
     * of a Cloud Pub/Sub topic that uses the Cloud Pub/Sub topic name format
     * documented in https://cloud.google.com/pubsub/docs/overview.
     * </pre>
     *
     * <code>string producer_notification_channel = 7;</code>
     *
     * @return The bytes for producerNotificationChannel.
     */
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getProducerNotificationChannelBytes() {
      java.lang.Object ref = producerNotificationChannel_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        producerNotificationChannel_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The full resource name of a channel used for sending notifications to the
     * service producer.
     *
     * Google Service Management currently only supports
     * [Google Cloud Pub/Sub](https://cloud.google.com/pubsub) as a notification
     * channel. To use Google Cloud Pub/Sub as the channel, this must be the name
     * of a Cloud Pub/Sub topic that uses the Cloud Pub/Sub topic name format
     * documented in https://cloud.google.com/pubsub/docs/overview.
     * </pre>
     *
     * <code>string producer_notification_channel = 7;</code>
     *
     * @param value The producerNotificationChannel to set.
     * @return This builder for chaining.
     */
    public Builder setProducerNotificationChannel(java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }
      producerNotificationChannel_ = value;
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The full resource name of a channel used for sending notifications to the
     * service producer.
     *
     * Google Service Management currently only supports
     * [Google Cloud Pub/Sub](https://cloud.google.com/pubsub) as a notification
     * channel. To use Google Cloud Pub/Sub as the channel, this must be the name
     * of a Cloud Pub/Sub topic that uses the Cloud Pub/Sub topic name format
     * documented in https://cloud.google.com/pubsub/docs/overview.
     * </pre>
     *
     * <code>string producer_notification_channel = 7;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearProducerNotificationChannel() {
      producerNotificationChannel_ = getDefaultInstance().getProducerNotificationChannel();
      bitField0_ = (bitField0_ & ~0x00000004);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The full resource name of a channel used for sending notifications to the
     * service producer.
     *
     * Google Service Management currently only supports
     * [Google Cloud Pub/Sub](https://cloud.google.com/pubsub) as a notification
     * channel. To use Google Cloud Pub/Sub as the channel, this must be the name
     * of a Cloud Pub/Sub topic that uses the Cloud Pub/Sub topic name format
     * documented in https://cloud.google.com/pubsub/docs/overview.
     * </pre>
     *
     * <code>string producer_notification_channel = 7;</code>
     *
     * @param value The bytes for producerNotificationChannel to set.
     * @return This builder for chaining.
     */
    public Builder setProducerNotificationChannelBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
      if (value == null) {
        throw new NullPointerException();
      }
      checkByteStringIsUtf8(value);
      producerNotificationChannel_ = value;
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }

    @java.lang.Override
    public final Builder setUnknownFields(final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }

    // @@protoc_insertion_point(builder_scope:google.api.Usage)
  }

  // @@protoc_insertion_point(class_scope:google.api.Usage)
  private static final com.couchbase.client.core.deps.com.google.api.Usage DEFAULT_INSTANCE;

  static {
    DEFAULT_INSTANCE = new com.google.api.Usage();
  }

  public static com.couchbase.client.core.deps.com.google.api.Usage getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.couchbase.client.core.deps.com.google.protobuf.Parser<Usage> PARSER =
      new com.google.protobuf.AbstractParser<Usage>() {
        @java.lang.Override
        public Usage parsePartialFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          Builder builder = newBuilder();
          try {
            builder.mergeFrom(input, extensionRegistry);
          } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
            throw e.setUnfinishedMessage(builder.buildPartial());
          } catch (com.couchbase.client.core.deps.com.google.protobuf.UninitializedMessageException e) {
            throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
          } catch (java.io.IOException e) {
            throw new com.google.protobuf.InvalidProtocolBufferException(e)
                .setUnfinishedMessage(builder.buildPartial());
          }
          return builder.buildPartial();
        }
      };

  public static com.couchbase.client.core.deps.com.google.protobuf.Parser<Usage> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.protobuf.Parser<Usage> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.api.Usage getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }
}
