/*
 * Copyright 2024 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/apps/card/v1/card.proto

// Protobuf Java Version: 3.25.5
package com.couchbase.client.core.deps.com.google.apps.card.v1;

/**
 *
 *
 * <pre>
 * A list of buttons layed out horizontally. For an example in
 * Google Chat apps, see
 * [Add a
 * button](https://developers.google.com/workspace/chat/design-interactive-card-dialog#add_a_button).
 *
 * [Google Workspace Add-ons and Chat
 * apps](https://developers.google.com/workspace/extend):
 * </pre>
 *
 * Protobuf type {@code google.apps.card.v1.ButtonList}
 */
public final class ButtonList extends com.google.protobuf.GeneratedMessageV3
    implements
    // @@protoc_insertion_point(message_implements:google.apps.card.v1.ButtonList)
    ButtonListOrBuilder {
  private static final long serialVersionUID = 0L;
  // Use ButtonList.newBuilder() to construct.
  private ButtonList(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }

  private ButtonList() {
    buttons_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
    return new ButtonList();
  }

  public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
    return com.google.apps.card.v1.CardProto
        .internal_static_google_apps_card_v1_ButtonList_descriptor;
  }

  @java.lang.Override
  protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.google.apps.card.v1.CardProto
        .internal_static_google_apps_card_v1_ButtonList_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.google.apps.card.v1.ButtonList.class,
            com.google.apps.card.v1.ButtonList.Builder.class);
  }

  public static final int BUTTONS_FIELD_NUMBER = 1;

  @SuppressWarnings("serial")
  private java.util.List<com.couchbase.client.core.deps.com.google.apps.card.v1.Button> buttons_;
  /**
   *
   *
   * <pre>
   * An array of buttons.
   * </pre>
   *
   * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
   */
  @java.lang.Override
  public java.util.List<com.couchbase.client.core.deps.com.google.apps.card.v1.Button> getButtonsList() {
    return buttons_;
  }
  /**
   *
   *
   * <pre>
   * An array of buttons.
   * </pre>
   *
   * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
   */
  @java.lang.Override
  public java.util.List<? extends com.google.apps.card.v1.ButtonOrBuilder>
      getButtonsOrBuilderList() {
    return buttons_;
  }
  /**
   *
   *
   * <pre>
   * An array of buttons.
   * </pre>
   *
   * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
   */
  @java.lang.Override
  public int getButtonsCount() {
    return buttons_.size();
  }
  /**
   *
   *
   * <pre>
   * An array of buttons.
   * </pre>
   *
   * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.apps.card.v1.Button getButtons(int index) {
    return buttons_.get(index);
  }
  /**
   *
   *
   * <pre>
   * An array of buttons.
   * </pre>
   *
   * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonOrBuilder getButtonsOrBuilder(int index) {
    return buttons_.get(index);
  }

  private byte memoizedIsInitialized = -1;

  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.couchbase.client.core.deps.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
    for (int i = 0; i < buttons_.size(); i++) {
      output.writeMessage(1, buttons_.get(i));
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    for (int i = 0; i < buttons_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream.computeMessageSize(1, buttons_.get(i));
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
      return true;
    }
    if (!(obj instanceof com.google.apps.card.v1.ButtonList)) {
      return super.equals(obj);
    }
    com.google.apps.card.v1.ButtonList other = (com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList) obj;

    if (!getButtonsList().equals(other.getButtonsList())) return false;
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getButtonsCount() > 0) {
      hash = (37 * hash) + BUTTONS_FIELD_NUMBER;
      hash = (53 * hash) + getButtonsList().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList parseFrom(java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList parseFrom(
      java.nio.ByteBuffer data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList parseFrom(com.couchbase.client.core.deps.com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList parseFrom(
      byte[] data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList parseFrom(
      java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList parseDelimitedFrom(
      java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList parseFrom(
      com.google.protobuf.CodedInputStream input) throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() {
    return newBuilder();
  }

  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }

  public static Builder newBuilder(com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }

  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   *
   *
   * <pre>
   * A list of buttons layed out horizontally. For an example in
   * Google Chat apps, see
   * [Add a
   * button](https://developers.google.com/workspace/chat/design-interactive-card-dialog#add_a_button).
   *
   * [Google Workspace Add-ons and Chat
   * apps](https://developers.google.com/workspace/extend):
   * </pre>
   *
   * Protobuf type {@code google.apps.card.v1.ButtonList}
   */
  public static final class Builder extends com.google.protobuf.GeneratedMessageV3.Builder<Builder>
      implements
      // @@protoc_insertion_point(builder_implements:google.apps.card.v1.ButtonList)
      com.google.apps.card.v1.ButtonListOrBuilder {
    public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return com.google.apps.card.v1.CardProto
          .internal_static_google_apps_card_v1_ButtonList_descriptor;
    }

    @java.lang.Override
    protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.apps.card.v1.CardProto
          .internal_static_google_apps_card_v1_ButtonList_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.apps.card.v1.ButtonList.class,
              com.google.apps.card.v1.ButtonList.Builder.class);
    }

    // Construct using com.google.apps.card.v1.ButtonList.newBuilder()
    private Builder() {}

    private Builder(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
    }

    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      if (buttonsBuilder_ == null) {
        buttons_ = java.util.Collections.emptyList();
      } else {
        buttons_ = null;
        buttonsBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000001);
      return this;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
      return com.google.apps.card.v1.CardProto
          .internal_static_google_apps_card_v1_ButtonList_descriptor;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList getDefaultInstanceForType() {
      return com.google.apps.card.v1.ButtonList.getDefaultInstance();
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList build() {
      com.google.apps.card.v1.ButtonList result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList buildPartial() {
      com.google.apps.card.v1.ButtonList result = new com.google.apps.card.v1.ButtonList(this);
      buildPartialRepeatedFields(result);
      if (bitField0_ != 0) {
        buildPartial0(result);
      }
      onBuilt();
      return result;
    }

    private void buildPartialRepeatedFields(com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList result) {
      if (buttonsBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0)) {
          buttons_ = java.util.Collections.unmodifiableList(buttons_);
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.buttons_ = buttons_;
      } else {
        result.buttons_ = buttonsBuilder_.build();
      }
    }

    private void buildPartial0(com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList result) {
      int from_bitField0_ = bitField0_;
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }

    @java.lang.Override
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.setField(field, value);
    }

    @java.lang.Override
    public Builder clearField(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }

    @java.lang.Override
    public Builder clearOneof(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }

    @java.lang.Override
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field, int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }

    @java.lang.Override
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }

    @java.lang.Override
    public Builder mergeFrom(com.couchbase.client.core.deps.com.google.protobuf.Message other) {
      if (other instanceof com.google.apps.card.v1.ButtonList) {
        return mergeFrom((com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList) other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList other) {
      if (other == com.google.apps.card.v1.ButtonList.getDefaultInstance()) return this;
      if (buttonsBuilder_ == null) {
        if (!other.buttons_.isEmpty()) {
          if (buttons_.isEmpty()) {
            buttons_ = other.buttons_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureButtonsIsMutable();
            buttons_.addAll(other.buttons_);
          }
          onChanged();
        }
      } else {
        if (!other.buttons_.isEmpty()) {
          if (buttonsBuilder_.isEmpty()) {
            buttonsBuilder_.dispose();
            buttonsBuilder_ = null;
            buttons_ = other.buttons_;
            bitField0_ = (bitField0_ & ~0x00000001);
            buttonsBuilder_ =
                com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders
                    ? getButtonsFieldBuilder()
                    : null;
          } else {
            buttonsBuilder_.addAllMessages(other.buttons_);
          }
        }
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10:
              {
                com.google.apps.card.v1.Button m =
                    input.readMessage(com.couchbase.client.core.deps.com.google.apps.card.v1.Button.parser(), extensionRegistry);
                if (buttonsBuilder_ == null) {
                  ensureButtonsIsMutable();
                  buttons_.add(m);
                } else {
                  buttonsBuilder_.addMessage(m);
                }
                break;
              } // case 10
            default:
              {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }

    private int bitField0_;

    private java.util.List<com.couchbase.client.core.deps.com.google.apps.card.v1.Button> buttons_ =
        java.util.Collections.emptyList();

    private void ensureButtonsIsMutable() {
      if (!((bitField0_ & 0x00000001) != 0)) {
        buttons_ = new java.util.ArrayList<com.couchbase.client.core.deps.com.google.apps.card.v1.Button>(buttons_);
        bitField0_ |= 0x00000001;
      }
    }

    private com.couchbase.client.core.deps.com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.apps.card.v1.Button,
            com.google.apps.card.v1.Button.Builder,
            com.google.apps.card.v1.ButtonOrBuilder>
        buttonsBuilder_;

    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public java.util.List<com.couchbase.client.core.deps.com.google.apps.card.v1.Button> getButtonsList() {
      if (buttonsBuilder_ == null) {
        return java.util.Collections.unmodifiableList(buttons_);
      } else {
        return buttonsBuilder_.getMessageList();
      }
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public int getButtonsCount() {
      if (buttonsBuilder_ == null) {
        return buttons_.size();
      } else {
        return buttonsBuilder_.getCount();
      }
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public com.couchbase.client.core.deps.com.google.apps.card.v1.Button getButtons(int index) {
      if (buttonsBuilder_ == null) {
        return buttons_.get(index);
      } else {
        return buttonsBuilder_.getMessage(index);
      }
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public Builder setButtons(int index, com.google.apps.card.v1.Button value) {
      if (buttonsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureButtonsIsMutable();
        buttons_.set(index, value);
        onChanged();
      } else {
        buttonsBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public Builder setButtons(int index, com.google.apps.card.v1.Button.Builder builderForValue) {
      if (buttonsBuilder_ == null) {
        ensureButtonsIsMutable();
        buttons_.set(index, builderForValue.build());
        onChanged();
      } else {
        buttonsBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public Builder addButtons(com.couchbase.client.core.deps.com.google.apps.card.v1.Button value) {
      if (buttonsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureButtonsIsMutable();
        buttons_.add(value);
        onChanged();
      } else {
        buttonsBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public Builder addButtons(int index, com.google.apps.card.v1.Button value) {
      if (buttonsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureButtonsIsMutable();
        buttons_.add(index, value);
        onChanged();
      } else {
        buttonsBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public Builder addButtons(com.couchbase.client.core.deps.com.google.apps.card.v1.Button.Builder builderForValue) {
      if (buttonsBuilder_ == null) {
        ensureButtonsIsMutable();
        buttons_.add(builderForValue.build());
        onChanged();
      } else {
        buttonsBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public Builder addButtons(int index, com.google.apps.card.v1.Button.Builder builderForValue) {
      if (buttonsBuilder_ == null) {
        ensureButtonsIsMutable();
        buttons_.add(index, builderForValue.build());
        onChanged();
      } else {
        buttonsBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public Builder addAllButtons(
        java.lang.Iterable<? extends com.google.apps.card.v1.Button> values) {
      if (buttonsBuilder_ == null) {
        ensureButtonsIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(values, buttons_);
        onChanged();
      } else {
        buttonsBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public Builder clearButtons() {
      if (buttonsBuilder_ == null) {
        buttons_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
      } else {
        buttonsBuilder_.clear();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public Builder removeButtons(int index) {
      if (buttonsBuilder_ == null) {
        ensureButtonsIsMutable();
        buttons_.remove(index);
        onChanged();
      } else {
        buttonsBuilder_.remove(index);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public com.couchbase.client.core.deps.com.google.apps.card.v1.Button.Builder getButtonsBuilder(int index) {
      return getButtonsFieldBuilder().getBuilder(index);
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonOrBuilder getButtonsOrBuilder(int index) {
      if (buttonsBuilder_ == null) {
        return buttons_.get(index);
      } else {
        return buttonsBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public java.util.List<? extends com.google.apps.card.v1.ButtonOrBuilder>
        getButtonsOrBuilderList() {
      if (buttonsBuilder_ != null) {
        return buttonsBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(buttons_);
      }
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public com.couchbase.client.core.deps.com.google.apps.card.v1.Button.Builder addButtonsBuilder() {
      return getButtonsFieldBuilder()
          .addBuilder(com.couchbase.client.core.deps.com.google.apps.card.v1.Button.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public com.couchbase.client.core.deps.com.google.apps.card.v1.Button.Builder addButtonsBuilder(int index) {
      return getButtonsFieldBuilder()
          .addBuilder(index, com.google.apps.card.v1.Button.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * An array of buttons.
     * </pre>
     *
     * <code>repeated .google.apps.card.v1.Button buttons = 1;</code>
     */
    public java.util.List<com.couchbase.client.core.deps.com.google.apps.card.v1.Button.Builder> getButtonsBuilderList() {
      return getButtonsFieldBuilder().getBuilderList();
    }

    private com.couchbase.client.core.deps.com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.apps.card.v1.Button,
            com.google.apps.card.v1.Button.Builder,
            com.google.apps.card.v1.ButtonOrBuilder>
        getButtonsFieldBuilder() {
      if (buttonsBuilder_ == null) {
        buttonsBuilder_ =
            new com.google.protobuf.RepeatedFieldBuilderV3<
                com.google.apps.card.v1.Button,
                com.google.apps.card.v1.Button.Builder,
                com.google.apps.card.v1.ButtonOrBuilder>(
                buttons_, ((bitField0_ & 0x00000001) != 0), getParentForChildren(), isClean());
        buttons_ = null;
      }
      return buttonsBuilder_;
    }

    @java.lang.Override
    public final Builder setUnknownFields(final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }

    // @@protoc_insertion_point(builder_scope:google.apps.card.v1.ButtonList)
  }

  // @@protoc_insertion_point(class_scope:google.apps.card.v1.ButtonList)
  private static final com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList DEFAULT_INSTANCE;

  static {
    DEFAULT_INSTANCE = new com.google.apps.card.v1.ButtonList();
  }

  public static com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.couchbase.client.core.deps.com.google.protobuf.Parser<ButtonList> PARSER =
      new com.google.protobuf.AbstractParser<ButtonList>() {
        @java.lang.Override
        public ButtonList parsePartialFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          Builder builder = newBuilder();
          try {
            builder.mergeFrom(input, extensionRegistry);
          } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
            throw e.setUnfinishedMessage(builder.buildPartial());
          } catch (com.couchbase.client.core.deps.com.google.protobuf.UninitializedMessageException e) {
            throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
          } catch (java.io.IOException e) {
            throw new com.google.protobuf.InvalidProtocolBufferException(e)
                .setUnfinishedMessage(builder.buildPartial());
          }
          return builder.buildPartial();
        }
      };

  public static com.couchbase.client.core.deps.com.google.protobuf.Parser<ButtonList> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.protobuf.Parser<ButtonList> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.apps.card.v1.ButtonList getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }
}
