/*
 * Copyright 2024 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/apps/card/v1/card.proto

// Protobuf Java Version: 3.25.5
package com.couchbase.client.core.deps.com.google.apps.card.v1;

public interface ImageOrBuilder
    extends
    // @@protoc_insertion_point(interface_extends:google.apps.card.v1.Image)
    com.google.protobuf.MessageOrBuilder {

  /**
   *
   *
   * <pre>
   * The HTTPS URL that hosts the image.
   *
   * For example:
   *
   * ```
   * https://developers.google.com/workspace/chat/images/quickstart-app-avatar.png
   * ```
   * </pre>
   *
   * <code>string image_url = 1;</code>
   *
   * @return The imageUrl.
   */
  java.lang.String getImageUrl();
  /**
   *
   *
   * <pre>
   * The HTTPS URL that hosts the image.
   *
   * For example:
   *
   * ```
   * https://developers.google.com/workspace/chat/images/quickstart-app-avatar.png
   * ```
   * </pre>
   *
   * <code>string image_url = 1;</code>
   *
   * @return The bytes for imageUrl.
   */
  com.google.protobuf.ByteString getImageUrlBytes();

  /**
   *
   *
   * <pre>
   * When a user clicks the image, the click triggers this action.
   * </pre>
   *
   * <code>.google.apps.card.v1.OnClick on_click = 2;</code>
   *
   * @return Whether the onClick field is set.
   */
  boolean hasOnClick();
  /**
   *
   *
   * <pre>
   * When a user clicks the image, the click triggers this action.
   * </pre>
   *
   * <code>.google.apps.card.v1.OnClick on_click = 2;</code>
   *
   * @return The onClick.
   */
  com.google.apps.card.v1.OnClick getOnClick();
  /**
   *
   *
   * <pre>
   * When a user clicks the image, the click triggers this action.
   * </pre>
   *
   * <code>.google.apps.card.v1.OnClick on_click = 2;</code>
   */
  com.google.apps.card.v1.OnClickOrBuilder getOnClickOrBuilder();

  /**
   *
   *
   * <pre>
   * The alternative text of this image that's used for accessibility.
   * </pre>
   *
   * <code>string alt_text = 3;</code>
   *
   * @return The altText.
   */
  java.lang.String getAltText();
  /**
   *
   *
   * <pre>
   * The alternative text of this image that's used for accessibility.
   * </pre>
   *
   * <code>string alt_text = 3;</code>
   *
   * @return The bytes for altText.
   */
  com.google.protobuf.ByteString getAltTextBytes();
}
