/*
 * Copyright 2024 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/cloud/audit/audit_log.proto

// Protobuf Java Version: 3.25.5
package com.couchbase.client.core.deps.com.google.cloud.audit;

/**
 *
 *
 * <pre>
 * Authorization information for the operation.
 * </pre>
 *
 * Protobuf type {@code google.cloud.audit.AuthorizationInfo}
 */
public final class AuthorizationInfo extends com.google.protobuf.GeneratedMessageV3
    implements
    // @@protoc_insertion_point(message_implements:google.cloud.audit.AuthorizationInfo)
    AuthorizationInfoOrBuilder {
  private static final long serialVersionUID = 0L;
  // Use AuthorizationInfo.newBuilder() to construct.
  private AuthorizationInfo(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }

  private AuthorizationInfo() {
    resource_ = "";
    permission_ = "";
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
    return new AuthorizationInfo();
  }

  public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
    return com.google.cloud.audit.AuditLogProto
        .internal_static_google_cloud_audit_AuthorizationInfo_descriptor;
  }

  @java.lang.Override
  protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.google.cloud.audit.AuditLogProto
        .internal_static_google_cloud_audit_AuthorizationInfo_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.google.cloud.audit.AuthorizationInfo.class,
            com.google.cloud.audit.AuthorizationInfo.Builder.class);
  }

  private int bitField0_;
  public static final int RESOURCE_FIELD_NUMBER = 1;

  @SuppressWarnings("serial")
  private volatile java.lang.Object resource_ = "";
  /**
   *
   *
   * <pre>
   * The resource being accessed, as a REST-style or cloud resource string.
   * For example:
   *
   *     bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID
   * or
   *     projects/PROJECTID/datasets/DATASETID
   * </pre>
   *
   * <code>string resource = 1;</code>
   *
   * @return The resource.
   */
  @java.lang.Override
  public java.lang.String getResource() {
    java.lang.Object ref = resource_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      resource_ = s;
      return s;
    }
  }
  /**
   *
   *
   * <pre>
   * The resource being accessed, as a REST-style or cloud resource string.
   * For example:
   *
   *     bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID
   * or
   *     projects/PROJECTID/datasets/DATASETID
   * </pre>
   *
   * <code>string resource = 1;</code>
   *
   * @return The bytes for resource.
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.protobuf.ByteString getResourceBytes() {
    java.lang.Object ref = resource_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b =
          com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
      resource_ = b;
      return b;
    } else {
      return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
    }
  }

  public static final int PERMISSION_FIELD_NUMBER = 2;

  @SuppressWarnings("serial")
  private volatile java.lang.Object permission_ = "";
  /**
   *
   *
   * <pre>
   * The required IAM permission.
   * </pre>
   *
   * <code>string permission = 2;</code>
   *
   * @return The permission.
   */
  @java.lang.Override
  public java.lang.String getPermission() {
    java.lang.Object ref = permission_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      permission_ = s;
      return s;
    }
  }
  /**
   *
   *
   * <pre>
   * The required IAM permission.
   * </pre>
   *
   * <code>string permission = 2;</code>
   *
   * @return The bytes for permission.
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.protobuf.ByteString getPermissionBytes() {
    java.lang.Object ref = permission_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b =
          com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
      permission_ = b;
      return b;
    } else {
      return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
    }
  }

  public static final int GRANTED_FIELD_NUMBER = 3;
  private boolean granted_ = false;
  /**
   *
   *
   * <pre>
   * Whether or not authorization for `resource` and `permission`
   * was granted.
   * </pre>
   *
   * <code>bool granted = 3;</code>
   *
   * @return The granted.
   */
  @java.lang.Override
  public boolean getGranted() {
    return granted_;
  }

  public static final int RESOURCE_ATTRIBUTES_FIELD_NUMBER = 5;
  private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource resourceAttributes_;
  /**
   *
   *
   * <pre>
   * Resource attributes used in IAM condition evaluation. This field contains
   * resource attributes like resource type and resource name.
   *
   * To get the whole view of the attributes used in IAM
   * condition evaluation, the user must also look into
   * `AuditLog.request_metadata.request_attributes`.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
   *
   * @return Whether the resourceAttributes field is set.
   */
  @java.lang.Override
  public boolean hasResourceAttributes() {
    return ((bitField0_ & 0x00000001) != 0);
  }
  /**
   *
   *
   * <pre>
   * Resource attributes used in IAM condition evaluation. This field contains
   * resource attributes like resource type and resource name.
   *
   * To get the whole view of the attributes used in IAM
   * condition evaluation, the user must also look into
   * `AuditLog.request_metadata.request_attributes`.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
   *
   * @return The resourceAttributes.
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource getResourceAttributes() {
    return resourceAttributes_ == null
        ? com.google.rpc.context.AttributeContext.Resource.getDefaultInstance()
        : resourceAttributes_;
  }
  /**
   *
   *
   * <pre>
   * Resource attributes used in IAM condition evaluation. This field contains
   * resource attributes like resource type and resource name.
   *
   * To get the whole view of the attributes used in IAM
   * condition evaluation, the user must also look into
   * `AuditLog.request_metadata.request_attributes`.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.ResourceOrBuilder
      getResourceAttributesOrBuilder() {
    return resourceAttributes_ == null
        ? com.google.rpc.context.AttributeContext.Resource.getDefaultInstance()
        : resourceAttributes_;
  }

  private byte memoizedIsInitialized = -1;

  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.couchbase.client.core.deps.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
    if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(resource_)) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 1, resource_);
    }
    if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(permission_)) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 2, permission_);
    }
    if (granted_ != false) {
      output.writeBool(3, granted_);
    }
    if (((bitField0_ & 0x00000001) != 0)) {
      output.writeMessage(5, getResourceAttributes());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(resource_)) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, resource_);
    }
    if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(permission_)) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, permission_);
    }
    if (granted_ != false) {
      size += com.google.protobuf.CodedOutputStream.computeBoolSize(3, granted_);
    }
    if (((bitField0_ & 0x00000001) != 0)) {
      size += com.google.protobuf.CodedOutputStream.computeMessageSize(5, getResourceAttributes());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
      return true;
    }
    if (!(obj instanceof com.google.cloud.audit.AuthorizationInfo)) {
      return super.equals(obj);
    }
    com.google.cloud.audit.AuthorizationInfo other = (com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo) obj;

    if (!getResource().equals(other.getResource())) return false;
    if (!getPermission().equals(other.getPermission())) return false;
    if (getGranted() != other.getGranted()) return false;
    if (hasResourceAttributes() != other.hasResourceAttributes()) return false;
    if (hasResourceAttributes()) {
      if (!getResourceAttributes().equals(other.getResourceAttributes())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    hash = (37 * hash) + RESOURCE_FIELD_NUMBER;
    hash = (53 * hash) + getResource().hashCode();
    hash = (37 * hash) + PERMISSION_FIELD_NUMBER;
    hash = (53 * hash) + getPermission().hashCode();
    hash = (37 * hash) + GRANTED_FIELD_NUMBER;
    hash = (53 * hash) + com.google.protobuf.Internal.hashBoolean(getGranted());
    if (hasResourceAttributes()) {
      hash = (37 * hash) + RESOURCE_ATTRIBUTES_FIELD_NUMBER;
      hash = (53 * hash) + getResourceAttributes().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo parseFrom(java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo parseFrom(
      java.nio.ByteBuffer data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo parseFrom(
      byte[] data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo parseFrom(
      java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo parseDelimitedFrom(
      java.io.InputStream input) throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo parseDelimitedFrom(
      java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo parseFrom(
      com.google.protobuf.CodedInputStream input) throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() {
    return newBuilder();
  }

  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }

  public static Builder newBuilder(com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }

  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   *
   *
   * <pre>
   * Authorization information for the operation.
   * </pre>
   *
   * Protobuf type {@code google.cloud.audit.AuthorizationInfo}
   */
  public static final class Builder extends com.google.protobuf.GeneratedMessageV3.Builder<Builder>
      implements
      // @@protoc_insertion_point(builder_implements:google.cloud.audit.AuthorizationInfo)
      com.google.cloud.audit.AuthorizationInfoOrBuilder {
    public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_AuthorizationInfo_descriptor;
    }

    @java.lang.Override
    protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_AuthorizationInfo_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.cloud.audit.AuthorizationInfo.class,
              com.google.cloud.audit.AuthorizationInfo.Builder.class);
    }

    // Construct using com.google.cloud.audit.AuthorizationInfo.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }

    private void maybeForceBuilderInitialization() {
      if (com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {
        getResourceAttributesFieldBuilder();
      }
    }

    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      resource_ = "";
      permission_ = "";
      granted_ = false;
      resourceAttributes_ = null;
      if (resourceAttributesBuilder_ != null) {
        resourceAttributesBuilder_.dispose();
        resourceAttributesBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
      return com.google.cloud.audit.AuditLogProto
          .internal_static_google_cloud_audit_AuthorizationInfo_descriptor;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo getDefaultInstanceForType() {
      return com.google.cloud.audit.AuthorizationInfo.getDefaultInstance();
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo build() {
      com.google.cloud.audit.AuthorizationInfo result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo buildPartial() {
      com.google.cloud.audit.AuthorizationInfo result =
          new com.google.cloud.audit.AuthorizationInfo(this);
      if (bitField0_ != 0) {
        buildPartial0(result);
      }
      onBuilt();
      return result;
    }

    private void buildPartial0(com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.resource_ = resource_;
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.permission_ = permission_;
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.granted_ = granted_;
      }
      int to_bitField0_ = 0;
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.resourceAttributes_ =
            resourceAttributesBuilder_ == null
                ? resourceAttributes_
                : resourceAttributesBuilder_.build();
        to_bitField0_ |= 0x00000001;
      }
      result.bitField0_ |= to_bitField0_;
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }

    @java.lang.Override
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.setField(field, value);
    }

    @java.lang.Override
    public Builder clearField(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }

    @java.lang.Override
    public Builder clearOneof(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }

    @java.lang.Override
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field, int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }

    @java.lang.Override
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }

    @java.lang.Override
    public Builder mergeFrom(com.couchbase.client.core.deps.com.google.protobuf.Message other) {
      if (other instanceof com.google.cloud.audit.AuthorizationInfo) {
        return mergeFrom((com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo) other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo other) {
      if (other == com.google.cloud.audit.AuthorizationInfo.getDefaultInstance()) return this;
      if (!other.getResource().isEmpty()) {
        resource_ = other.resource_;
        bitField0_ |= 0x00000001;
        onChanged();
      }
      if (!other.getPermission().isEmpty()) {
        permission_ = other.permission_;
        bitField0_ |= 0x00000002;
        onChanged();
      }
      if (other.getGranted() != false) {
        setGranted(other.getGranted());
      }
      if (other.hasResourceAttributes()) {
        mergeResourceAttributes(other.getResourceAttributes());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10:
              {
                resource_ = input.readStringRequireUtf8();
                bitField0_ |= 0x00000001;
                break;
              } // case 10
            case 18:
              {
                permission_ = input.readStringRequireUtf8();
                bitField0_ |= 0x00000002;
                break;
              } // case 18
            case 24:
              {
                granted_ = input.readBool();
                bitField0_ |= 0x00000004;
                break;
              } // case 24
            case 42:
              {
                input.readMessage(
                    getResourceAttributesFieldBuilder().getBuilder(), extensionRegistry);
                bitField0_ |= 0x00000008;
                break;
              } // case 42
            default:
              {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }

    private int bitField0_;

    private java.lang.Object resource_ = "";
    /**
     *
     *
     * <pre>
     * The resource being accessed, as a REST-style or cloud resource string.
     * For example:
     *
     *     bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID
     * or
     *     projects/PROJECTID/datasets/DATASETID
     * </pre>
     *
     * <code>string resource = 1;</code>
     *
     * @return The resource.
     */
    public java.lang.String getResource() {
      java.lang.Object ref = resource_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        resource_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The resource being accessed, as a REST-style or cloud resource string.
     * For example:
     *
     *     bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID
     * or
     *     projects/PROJECTID/datasets/DATASETID
     * </pre>
     *
     * <code>string resource = 1;</code>
     *
     * @return The bytes for resource.
     */
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getResourceBytes() {
      java.lang.Object ref = resource_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        resource_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The resource being accessed, as a REST-style or cloud resource string.
     * For example:
     *
     *     bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID
     * or
     *     projects/PROJECTID/datasets/DATASETID
     * </pre>
     *
     * <code>string resource = 1;</code>
     *
     * @param value The resource to set.
     * @return This builder for chaining.
     */
    public Builder setResource(java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }
      resource_ = value;
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The resource being accessed, as a REST-style or cloud resource string.
     * For example:
     *
     *     bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID
     * or
     *     projects/PROJECTID/datasets/DATASETID
     * </pre>
     *
     * <code>string resource = 1;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearResource() {
      resource_ = getDefaultInstance().getResource();
      bitField0_ = (bitField0_ & ~0x00000001);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The resource being accessed, as a REST-style or cloud resource string.
     * For example:
     *
     *     bigquery.googleapis.com/projects/PROJECTID/datasets/DATASETID
     * or
     *     projects/PROJECTID/datasets/DATASETID
     * </pre>
     *
     * <code>string resource = 1;</code>
     *
     * @param value The bytes for resource to set.
     * @return This builder for chaining.
     */
    public Builder setResourceBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
      if (value == null) {
        throw new NullPointerException();
      }
      checkByteStringIsUtf8(value);
      resource_ = value;
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }

    private java.lang.Object permission_ = "";
    /**
     *
     *
     * <pre>
     * The required IAM permission.
     * </pre>
     *
     * <code>string permission = 2;</code>
     *
     * @return The permission.
     */
    public java.lang.String getPermission() {
      java.lang.Object ref = permission_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        permission_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The required IAM permission.
     * </pre>
     *
     * <code>string permission = 2;</code>
     *
     * @return The bytes for permission.
     */
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getPermissionBytes() {
      java.lang.Object ref = permission_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        permission_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }
    /**
     *
     *
     * <pre>
     * The required IAM permission.
     * </pre>
     *
     * <code>string permission = 2;</code>
     *
     * @param value The permission to set.
     * @return This builder for chaining.
     */
    public Builder setPermission(java.lang.String value) {
      if (value == null) {
        throw new NullPointerException();
      }
      permission_ = value;
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The required IAM permission.
     * </pre>
     *
     * <code>string permission = 2;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearPermission() {
      permission_ = getDefaultInstance().getPermission();
      bitField0_ = (bitField0_ & ~0x00000002);
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The required IAM permission.
     * </pre>
     *
     * <code>string permission = 2;</code>
     *
     * @param value The bytes for permission to set.
     * @return This builder for chaining.
     */
    public Builder setPermissionBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
      if (value == null) {
        throw new NullPointerException();
      }
      checkByteStringIsUtf8(value);
      permission_ = value;
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }

    private boolean granted_;
    /**
     *
     *
     * <pre>
     * Whether or not authorization for `resource` and `permission`
     * was granted.
     * </pre>
     *
     * <code>bool granted = 3;</code>
     *
     * @return The granted.
     */
    @java.lang.Override
    public boolean getGranted() {
      return granted_;
    }
    /**
     *
     *
     * <pre>
     * Whether or not authorization for `resource` and `permission`
     * was granted.
     * </pre>
     *
     * <code>bool granted = 3;</code>
     *
     * @param value The granted to set.
     * @return This builder for chaining.
     */
    public Builder setGranted(boolean value) {

      granted_ = value;
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Whether or not authorization for `resource` and `permission`
     * was granted.
     * </pre>
     *
     * <code>bool granted = 3;</code>
     *
     * @return This builder for chaining.
     */
    public Builder clearGranted() {
      bitField0_ = (bitField0_ & ~0x00000004);
      granted_ = false;
      onChanged();
      return this;
    }

    private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource resourceAttributes_;
    private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
            com.google.rpc.context.AttributeContext.Resource,
            com.google.rpc.context.AttributeContext.Resource.Builder,
            com.google.rpc.context.AttributeContext.ResourceOrBuilder>
        resourceAttributesBuilder_;
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     *
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     *
     * @return Whether the resourceAttributes field is set.
     */
    public boolean hasResourceAttributes() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     *
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     *
     * @return The resourceAttributes.
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource getResourceAttributes() {
      if (resourceAttributesBuilder_ == null) {
        return resourceAttributes_ == null
            ? com.google.rpc.context.AttributeContext.Resource.getDefaultInstance()
            : resourceAttributes_;
      } else {
        return resourceAttributesBuilder_.getMessage();
      }
    }
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     *
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     */
    public Builder setResourceAttributes(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource value) {
      if (resourceAttributesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        resourceAttributes_ = value;
      } else {
        resourceAttributesBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     *
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     */
    public Builder setResourceAttributes(
        com.google.rpc.context.AttributeContext.Resource.Builder builderForValue) {
      if (resourceAttributesBuilder_ == null) {
        resourceAttributes_ = builderForValue.build();
      } else {
        resourceAttributesBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     *
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     */
    public Builder mergeResourceAttributes(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource value) {
      if (resourceAttributesBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0)
            && resourceAttributes_ != null
            && resourceAttributes_
                != com.google.rpc.context.AttributeContext.Resource.getDefaultInstance()) {
          getResourceAttributesBuilder().mergeFrom(value);
        } else {
          resourceAttributes_ = value;
        }
      } else {
        resourceAttributesBuilder_.mergeFrom(value);
      }
      if (resourceAttributes_ != null) {
        bitField0_ |= 0x00000008;
        onChanged();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     *
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     */
    public Builder clearResourceAttributes() {
      bitField0_ = (bitField0_ & ~0x00000008);
      resourceAttributes_ = null;
      if (resourceAttributesBuilder_ != null) {
        resourceAttributesBuilder_.dispose();
        resourceAttributesBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     *
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource.Builder getResourceAttributesBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getResourceAttributesFieldBuilder().getBuilder();
    }
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     *
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.ResourceOrBuilder
        getResourceAttributesOrBuilder() {
      if (resourceAttributesBuilder_ != null) {
        return resourceAttributesBuilder_.getMessageOrBuilder();
      } else {
        return resourceAttributes_ == null
            ? com.google.rpc.context.AttributeContext.Resource.getDefaultInstance()
            : resourceAttributes_;
      }
    }
    /**
     *
     *
     * <pre>
     * Resource attributes used in IAM condition evaluation. This field contains
     * resource attributes like resource type and resource name.
     *
     * To get the whole view of the attributes used in IAM
     * condition evaluation, the user must also look into
     * `AuditLog.request_metadata.request_attributes`.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource_attributes = 5;</code>
     */
    private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
            com.google.rpc.context.AttributeContext.Resource,
            com.google.rpc.context.AttributeContext.Resource.Builder,
            com.google.rpc.context.AttributeContext.ResourceOrBuilder>
        getResourceAttributesFieldBuilder() {
      if (resourceAttributesBuilder_ == null) {
        resourceAttributesBuilder_ =
            new com.google.protobuf.SingleFieldBuilderV3<
                com.google.rpc.context.AttributeContext.Resource,
                com.google.rpc.context.AttributeContext.Resource.Builder,
                com.google.rpc.context.AttributeContext.ResourceOrBuilder>(
                getResourceAttributes(), getParentForChildren(), isClean());
        resourceAttributes_ = null;
      }
      return resourceAttributesBuilder_;
    }

    @java.lang.Override
    public final Builder setUnknownFields(final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }

    // @@protoc_insertion_point(builder_scope:google.cloud.audit.AuthorizationInfo)
  }

  // @@protoc_insertion_point(class_scope:google.cloud.audit.AuthorizationInfo)
  private static final com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo DEFAULT_INSTANCE;

  static {
    DEFAULT_INSTANCE = new com.google.cloud.audit.AuthorizationInfo();
  }

  public static com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.couchbase.client.core.deps.com.google.protobuf.Parser<AuthorizationInfo> PARSER =
      new com.google.protobuf.AbstractParser<AuthorizationInfo>() {
        @java.lang.Override
        public AuthorizationInfo parsePartialFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          Builder builder = newBuilder();
          try {
            builder.mergeFrom(input, extensionRegistry);
          } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
            throw e.setUnfinishedMessage(builder.buildPartial());
          } catch (com.couchbase.client.core.deps.com.google.protobuf.UninitializedMessageException e) {
            throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
          } catch (java.io.IOException e) {
            throw new com.google.protobuf.InvalidProtocolBufferException(e)
                .setUnfinishedMessage(builder.buildPartial());
          }
          return builder.buildPartial();
        }
      };

  public static com.couchbase.client.core.deps.com.google.protobuf.Parser<AuthorizationInfo> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.protobuf.Parser<AuthorizationInfo> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.cloud.audit.AuthorizationInfo getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }
}
