/*
 * Copyright 2024 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/shopping/type/types.proto

// Protobuf Java Version: 3.25.5
package com.couchbase.client.core.deps.com.google.shopping.type;

public interface WeightOrBuilder
    extends
    // @@protoc_insertion_point(interface_extends:google.shopping.type.Weight)
    com.google.protobuf.MessageOrBuilder {

  /**
   *
   *
   * <pre>
   * Required. The weight represented as a number in micros (1 million micros is
   * an equivalent to one's currency standard unit, for example, 1 kg = 1000000
   * micros).
   * This field can also be set as infinity by setting to -1.
   * This field only support -1 and positive value.
   * </pre>
   *
   * <code>optional int64 amount_micros = 1;</code>
   *
   * @return Whether the amountMicros field is set.
   */
  boolean hasAmountMicros();
  /**
   *
   *
   * <pre>
   * Required. The weight represented as a number in micros (1 million micros is
   * an equivalent to one's currency standard unit, for example, 1 kg = 1000000
   * micros).
   * This field can also be set as infinity by setting to -1.
   * This field only support -1 and positive value.
   * </pre>
   *
   * <code>optional int64 amount_micros = 1;</code>
   *
   * @return The amountMicros.
   */
  long getAmountMicros();

  /**
   *
   *
   * <pre>
   * Required. The weight unit.
   * Acceptable values are: kg and lb
   * </pre>
   *
   * <code>.google.shopping.type.Weight.WeightUnit unit = 2;</code>
   *
   * @return The enum numeric value on the wire for unit.
   */
  int getUnitValue();
  /**
   *
   *
   * <pre>
   * Required. The weight unit.
   * Acceptable values are: kg and lb
   * </pre>
   *
   * <code>.google.shopping.type.Weight.WeightUnit unit = 2;</code>
   *
   * @return The unit.
   */
  com.google.shopping.type.Weight.WeightUnit getUnit();
}
