/*
 * Copyright 2014 The Netty Project
 *
 * The Netty Project licenses this file to you under the Apache License,
 * version 2.0 (the "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at:
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 */

package com.couchbase.client.core.deps.io.netty.handler.codec.socksx.v4;

import com.couchbase.client.core.deps.io.netty.handler.codec.socksx.AbstractSocksMessage;
import com.couchbase.client.core.deps.io.netty.handler.codec.socksx.SocksVersion;

/**
 * An abstract {@link Socks4Message}.
 */
public abstract class AbstractSocks4Message extends AbstractSocksMessage implements Socks4Message {
    @Override
    public final SocksVersion version() {
        return SocksVersion.SOCKS4a;
    }
}
