/*
 * Copyright (c) 2019 Couchbase, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.couchbase.client.core.error;

import com.couchbase.client.core.error.context.CancellationErrorContext;

/**
 * This is a special case of the timeout exception, signaling that the timeout happened with an ambiguous cause.
 */
public class AmbiguousTimeoutException extends TimeoutException {

  public AmbiguousTimeoutException(final String message, final CancellationErrorContext ctx) {
    super(message, null, true, false, ctx);
  }

}
