/*
 * Copyright (c) 2016 Couchbase, Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.couchbase.client.core.error;

import com.couchbase.client.core.error.context.ErrorContext;

/**
 * Raised when provided content could not be successfully decoded.
 *
 * @author Graham Pople
 * @since 2.0
 */
public class DecodingFailureException extends CouchbaseException {

  public DecodingFailureException() {
    super();
  }

  public DecodingFailureException(String message) {
    super(message);
  }

  public DecodingFailureException(String message, Throwable cause) {
    super(message, cause);
  }

  public DecodingFailureException(Throwable cause) {
    super(cause);
  }

  public DecodingFailureException(String message, Throwable cause, ErrorContext ctx) {
    super(message, cause, ctx);
  }

}
