/*
 * Copyright 2024 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: google/rpc/context/attribute_context.proto

// Protobuf Java Version: 3.25.5
package com.couchbase.client.core.deps.com.google.rpc.context;

/**
 *
 *
 * <pre>
 * This message defines the standard attribute vocabulary for Google APIs.
 *
 * An attribute is a piece of metadata that describes an activity on a network
 * service. For example, the size of an HTTP request, or the status code of
 * an HTTP response.
 *
 * Each attribute has a type and a name, which is logically defined as
 * a proto message field in `AttributeContext`. The field type becomes the
 * attribute type, and the field path becomes the attribute name. For example,
 * the attribute `source.ip` maps to field `AttributeContext.source.ip`.
 *
 * This message definition is guaranteed not to have any wire breaking change.
 * So you can use it directly for passing attributes across different systems.
 *
 * NOTE: Different system may generate different subset of attributes. Please
 * verify the system specification before relying on an attribute generated
 * a system.
 * </pre>
 *
 * Protobuf type {@code google.rpc.context.AttributeContext}
 */
public final class AttributeContext extends com.google.protobuf.GeneratedMessageV3
    implements
    // @@protoc_insertion_point(message_implements:google.rpc.context.AttributeContext)
    AttributeContextOrBuilder {
  private static final long serialVersionUID = 0L;
  // Use AttributeContext.newBuilder() to construct.
  private AttributeContext(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }

  private AttributeContext() {
    extensions_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
    return new AttributeContext();
  }

  public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
    return com.google.rpc.context.AttributeContextProto
        .internal_static_google_rpc_context_AttributeContext_descriptor;
  }

  @java.lang.Override
  protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.google.rpc.context.AttributeContextProto
        .internal_static_google_rpc_context_AttributeContext_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.google.rpc.context.AttributeContext.class,
            com.google.rpc.context.AttributeContext.Builder.class);
  }

  public interface PeerOrBuilder
      extends
      // @@protoc_insertion_point(interface_extends:google.rpc.context.AttributeContext.Peer)
      com.google.protobuf.MessageOrBuilder {

    /**
     *
     *
     * <pre>
     * The IP address of the peer.
     * </pre>
     *
     * <code>string ip = 1;</code>
     *
     * @return The ip.
     */
    java.lang.String getIp();
    /**
     *
     *
     * <pre>
     * The IP address of the peer.
     * </pre>
     *
     * <code>string ip = 1;</code>
     *
     * @return The bytes for ip.
     */
    com.google.protobuf.ByteString getIpBytes();

    /**
     *
     *
     * <pre>
     * The network port of the peer.
     * </pre>
     *
     * <code>int64 port = 2;</code>
     *
     * @return The port.
     */
    long getPort();

    /**
     *
     *
     * <pre>
     * The labels associated with the peer.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 6;</code>
     */
    int getLabelsCount();
    /**
     *
     *
     * <pre>
     * The labels associated with the peer.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 6;</code>
     */
    boolean containsLabels(java.lang.String key);
    /** Use {@link #getLabelsMap()} instead. */
    @java.lang.Deprecated
    java.util.Map<java.lang.String, java.lang.String> getLabels();
    /**
     *
     *
     * <pre>
     * The labels associated with the peer.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 6;</code>
     */
    java.util.Map<java.lang.String, java.lang.String> getLabelsMap();
    /**
     *
     *
     * <pre>
     * The labels associated with the peer.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 6;</code>
     */
    /* nullable */
    java.lang.String getLabelsOrDefault(
        java.lang.String key,
        /* nullable */
        java.lang.String defaultValue);
    /**
     *
     *
     * <pre>
     * The labels associated with the peer.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 6;</code>
     */
    java.lang.String getLabelsOrThrow(java.lang.String key);

    /**
     *
     *
     * <pre>
     * The identity of this peer. Similar to `Request.auth.principal`, but
     * relative to the peer instead of the request. For example, the
     * identity associated with a load balancer that forwarded the request.
     * </pre>
     *
     * <code>string principal = 7;</code>
     *
     * @return The principal.
     */
    java.lang.String getPrincipal();
    /**
     *
     *
     * <pre>
     * The identity of this peer. Similar to `Request.auth.principal`, but
     * relative to the peer instead of the request. For example, the
     * identity associated with a load balancer that forwarded the request.
     * </pre>
     *
     * <code>string principal = 7;</code>
     *
     * @return The bytes for principal.
     */
    com.google.protobuf.ByteString getPrincipalBytes();

    /**
     *
     *
     * <pre>
     * The CLDR country/region code associated with the above IP address.
     * If the IP address is private, the `region_code` should reflect the
     * physical location where this peer is running.
     * </pre>
     *
     * <code>string region_code = 8;</code>
     *
     * @return The regionCode.
     */
    java.lang.String getRegionCode();
    /**
     *
     *
     * <pre>
     * The CLDR country/region code associated with the above IP address.
     * If the IP address is private, the `region_code` should reflect the
     * physical location where this peer is running.
     * </pre>
     *
     * <code>string region_code = 8;</code>
     *
     * @return The bytes for regionCode.
     */
    com.google.protobuf.ByteString getRegionCodeBytes();
  }
  /**
   *
   *
   * <pre>
   * This message defines attributes for a node that handles a network request.
   * The node can be either a service or an application that sends, forwards,
   * or receives the request. Service peers should fill in
   * `principal` and `labels` as appropriate.
   * </pre>
   *
   * Protobuf type {@code google.rpc.context.AttributeContext.Peer}
   */
  public static final class Peer extends com.google.protobuf.GeneratedMessageV3
      implements
      // @@protoc_insertion_point(message_implements:google.rpc.context.AttributeContext.Peer)
      PeerOrBuilder {
    private static final long serialVersionUID = 0L;
    // Use Peer.newBuilder() to construct.
    private Peer(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }

    private Peer() {
      ip_ = "";
      principal_ = "";
      regionCode_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
      return new Peer();
    }

    public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return com.google.rpc.context.AttributeContextProto
          .internal_static_google_rpc_context_AttributeContext_Peer_descriptor;
    }

    @SuppressWarnings({"rawtypes"})
    @java.lang.Override
    protected com.couchbase.client.core.deps.com.google.protobuf.MapFieldReflectionAccessor internalGetMapFieldReflection(
        int number) {
      switch (number) {
        case 6:
          return internalGetLabels();
        default:
          throw new RuntimeException("Invalid map field number: " + number);
      }
    }

    @java.lang.Override
    protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.rpc.context.AttributeContextProto
          .internal_static_google_rpc_context_AttributeContext_Peer_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.rpc.context.AttributeContext.Peer.class,
              com.google.rpc.context.AttributeContext.Peer.Builder.class);
    }

    public static final int IP_FIELD_NUMBER = 1;

    @SuppressWarnings("serial")
    private volatile java.lang.Object ip_ = "";
    /**
     *
     *
     * <pre>
     * The IP address of the peer.
     * </pre>
     *
     * <code>string ip = 1;</code>
     *
     * @return The ip.
     */
    @java.lang.Override
    public java.lang.String getIp() {
      java.lang.Object ref = ip_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        ip_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The IP address of the peer.
     * </pre>
     *
     * <code>string ip = 1;</code>
     *
     * @return The bytes for ip.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getIpBytes() {
      java.lang.Object ref = ip_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        ip_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int PORT_FIELD_NUMBER = 2;
    private long port_ = 0L;
    /**
     *
     *
     * <pre>
     * The network port of the peer.
     * </pre>
     *
     * <code>int64 port = 2;</code>
     *
     * @return The port.
     */
    @java.lang.Override
    public long getPort() {
      return port_;
    }

    public static final int LABELS_FIELD_NUMBER = 6;

    private static final class LabelsDefaultEntryHolder {
      static final com.couchbase.client.core.deps.com.google.protobuf.MapEntry<java.lang.String, java.lang.String> defaultEntry =
          com.google.protobuf.MapEntry.<java.lang.String, java.lang.String>newDefaultInstance(
              com.google.rpc.context.AttributeContextProto
                  .internal_static_google_rpc_context_AttributeContext_Peer_LabelsEntry_descriptor,
              com.google.protobuf.WireFormat.FieldType.STRING,
              "",
              com.google.protobuf.WireFormat.FieldType.STRING,
              "");
    }

    @SuppressWarnings("serial")
    private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String> labels_;

    private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String> internalGetLabels() {
      if (labels_ == null) {
        return com.google.protobuf.MapField.emptyMapField(LabelsDefaultEntryHolder.defaultEntry);
      }
      return labels_;
    }

    public int getLabelsCount() {
      return internalGetLabels().getMap().size();
    }
    /**
     *
     *
     * <pre>
     * The labels associated with the peer.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 6;</code>
     */
    @java.lang.Override
    public boolean containsLabels(java.lang.String key) {
      if (key == null) {
        throw new NullPointerException("map key");
      }
      return internalGetLabels().getMap().containsKey(key);
    }
    /** Use {@link #getLabelsMap()} instead. */
    @java.lang.Override
    @java.lang.Deprecated
    public java.util.Map<java.lang.String, java.lang.String> getLabels() {
      return getLabelsMap();
    }
    /**
     *
     *
     * <pre>
     * The labels associated with the peer.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 6;</code>
     */
    @java.lang.Override
    public java.util.Map<java.lang.String, java.lang.String> getLabelsMap() {
      return internalGetLabels().getMap();
    }
    /**
     *
     *
     * <pre>
     * The labels associated with the peer.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 6;</code>
     */
    @java.lang.Override
    public /* nullable */ java.lang.String getLabelsOrDefault(
        java.lang.String key,
        /* nullable */
        java.lang.String defaultValue) {
      if (key == null) {
        throw new NullPointerException("map key");
      }
      java.util.Map<java.lang.String, java.lang.String> map = internalGetLabels().getMap();
      return map.containsKey(key) ? map.get(key) : defaultValue;
    }
    /**
     *
     *
     * <pre>
     * The labels associated with the peer.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 6;</code>
     */
    @java.lang.Override
    public java.lang.String getLabelsOrThrow(java.lang.String key) {
      if (key == null) {
        throw new NullPointerException("map key");
      }
      java.util.Map<java.lang.String, java.lang.String> map = internalGetLabels().getMap();
      if (!map.containsKey(key)) {
        throw new java.lang.IllegalArgumentException();
      }
      return map.get(key);
    }

    public static final int PRINCIPAL_FIELD_NUMBER = 7;

    @SuppressWarnings("serial")
    private volatile java.lang.Object principal_ = "";
    /**
     *
     *
     * <pre>
     * The identity of this peer. Similar to `Request.auth.principal`, but
     * relative to the peer instead of the request. For example, the
     * identity associated with a load balancer that forwarded the request.
     * </pre>
     *
     * <code>string principal = 7;</code>
     *
     * @return The principal.
     */
    @java.lang.Override
    public java.lang.String getPrincipal() {
      java.lang.Object ref = principal_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        principal_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The identity of this peer. Similar to `Request.auth.principal`, but
     * relative to the peer instead of the request. For example, the
     * identity associated with a load balancer that forwarded the request.
     * </pre>
     *
     * <code>string principal = 7;</code>
     *
     * @return The bytes for principal.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getPrincipalBytes() {
      java.lang.Object ref = principal_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        principal_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int REGION_CODE_FIELD_NUMBER = 8;

    @SuppressWarnings("serial")
    private volatile java.lang.Object regionCode_ = "";
    /**
     *
     *
     * <pre>
     * The CLDR country/region code associated with the above IP address.
     * If the IP address is private, the `region_code` should reflect the
     * physical location where this peer is running.
     * </pre>
     *
     * <code>string region_code = 8;</code>
     *
     * @return The regionCode.
     */
    @java.lang.Override
    public java.lang.String getRegionCode() {
      java.lang.Object ref = regionCode_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        regionCode_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The CLDR country/region code associated with the above IP address.
     * If the IP address is private, the `region_code` should reflect the
     * physical location where this peer is running.
     * </pre>
     *
     * <code>string region_code = 8;</code>
     *
     * @return The bytes for regionCode.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getRegionCodeBytes() {
      java.lang.Object ref = regionCode_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        regionCode_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    private byte memoizedIsInitialized = -1;

    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.couchbase.client.core.deps.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(ip_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 1, ip_);
      }
      if (port_ != 0L) {
        output.writeInt64(2, port_);
      }
      com.google.protobuf.GeneratedMessageV3.serializeStringMapTo(
          output, internalGetLabels(), LabelsDefaultEntryHolder.defaultEntry, 6);
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(principal_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 7, principal_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(regionCode_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 8, regionCode_);
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(ip_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, ip_);
      }
      if (port_ != 0L) {
        size += com.google.protobuf.CodedOutputStream.computeInt64Size(2, port_);
      }
      for (java.util.Map.Entry<java.lang.String, java.lang.String> entry :
          internalGetLabels().getMap().entrySet()) {
        com.google.protobuf.MapEntry<java.lang.String, java.lang.String> labels__ =
            LabelsDefaultEntryHolder.defaultEntry
                .newBuilderForType()
                .setKey(entry.getKey())
                .setValue(entry.getValue())
                .build();
        size += com.google.protobuf.CodedOutputStream.computeMessageSize(6, labels__);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(principal_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(7, principal_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(regionCode_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(8, regionCode_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
        return true;
      }
      if (!(obj instanceof com.google.rpc.context.AttributeContext.Peer)) {
        return super.equals(obj);
      }
      com.google.rpc.context.AttributeContext.Peer other =
          (com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer) obj;

      if (!getIp().equals(other.getIp())) return false;
      if (getPort() != other.getPort()) return false;
      if (!internalGetLabels().equals(other.internalGetLabels())) return false;
      if (!getPrincipal().equals(other.getPrincipal())) return false;
      if (!getRegionCode().equals(other.getRegionCode())) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + IP_FIELD_NUMBER;
      hash = (53 * hash) + getIp().hashCode();
      hash = (37 * hash) + PORT_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(getPort());
      if (!internalGetLabels().getMap().isEmpty()) {
        hash = (37 * hash) + LABELS_FIELD_NUMBER;
        hash = (53 * hash) + internalGetLabels().hashCode();
      }
      hash = (37 * hash) + PRINCIPAL_FIELD_NUMBER;
      hash = (53 * hash) + getPrincipal().hashCode();
      hash = (37 * hash) + REGION_CODE_FIELD_NUMBER;
      hash = (53 * hash) + getRegionCode().hashCode();
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer parseFrom(java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer parseFrom(
        java.nio.ByteBuffer data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer parseFrom(
        byte[] data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer parseFrom(
        java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer parseDelimitedFrom(
        java.io.InputStream input) throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer parseDelimitedFrom(
        java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer parseFrom(
        com.google.protobuf.CodedInputStream input) throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() {
      return newBuilder();
    }

    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }

    public static Builder newBuilder(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }

    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     *
     *
     * <pre>
     * This message defines attributes for a node that handles a network request.
     * The node can be either a service or an application that sends, forwards,
     * or receives the request. Service peers should fill in
     * `principal` and `labels` as appropriate.
     * </pre>
     *
     * Protobuf type {@code google.rpc.context.AttributeContext.Peer}
     */
    public static final class Builder
        extends com.google.protobuf.GeneratedMessageV3.Builder<Builder>
        implements
        // @@protoc_insertion_point(builder_implements:google.rpc.context.AttributeContext.Peer)
        com.google.rpc.context.AttributeContext.PeerOrBuilder {
      public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Peer_descriptor;
      }

      @SuppressWarnings({"rawtypes"})
      protected com.couchbase.client.core.deps.com.google.protobuf.MapFieldReflectionAccessor internalGetMapFieldReflection(
          int number) {
        switch (number) {
          case 6:
            return internalGetLabels();
          default:
            throw new RuntimeException("Invalid map field number: " + number);
        }
      }

      @SuppressWarnings({"rawtypes"})
      protected com.couchbase.client.core.deps.com.google.protobuf.MapFieldReflectionAccessor internalGetMutableMapFieldReflection(
          int number) {
        switch (number) {
          case 6:
            return internalGetMutableLabels();
          default:
            throw new RuntimeException("Invalid map field number: " + number);
        }
      }

      @java.lang.Override
      protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Peer_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.rpc.context.AttributeContext.Peer.class,
                com.google.rpc.context.AttributeContext.Peer.Builder.class);
      }

      // Construct using com.google.rpc.context.AttributeContext.Peer.newBuilder()
      private Builder() {}

      private Builder(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
      }

      @java.lang.Override
      public Builder clear() {
        super.clear();
        bitField0_ = 0;
        ip_ = "";
        port_ = 0L;
        internalGetMutableLabels().clear();
        principal_ = "";
        regionCode_ = "";
        return this;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Peer_descriptor;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer getDefaultInstanceForType() {
        return com.google.rpc.context.AttributeContext.Peer.getDefaultInstance();
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer build() {
        com.google.rpc.context.AttributeContext.Peer result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer buildPartial() {
        com.google.rpc.context.AttributeContext.Peer result =
            new com.google.rpc.context.AttributeContext.Peer(this);
        if (bitField0_ != 0) {
          buildPartial0(result);
        }
        onBuilt();
        return result;
      }

      private void buildPartial0(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer result) {
        int from_bitField0_ = bitField0_;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          result.ip_ = ip_;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          result.port_ = port_;
        }
        if (((from_bitField0_ & 0x00000004) != 0)) {
          result.labels_ = internalGetLabels();
          result.labels_.makeImmutable();
        }
        if (((from_bitField0_ & 0x00000008) != 0)) {
          result.principal_ = principal_;
        }
        if (((from_bitField0_ & 0x00000010) != 0)) {
          result.regionCode_ = regionCode_;
        }
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }

      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.setField(field, value);
      }

      @java.lang.Override
      public Builder clearField(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }

      @java.lang.Override
      public Builder clearOneof(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }

      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index,
          java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }

      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }

      @java.lang.Override
      public Builder mergeFrom(com.couchbase.client.core.deps.com.google.protobuf.Message other) {
        if (other instanceof com.google.rpc.context.AttributeContext.Peer) {
          return mergeFrom((com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer) other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer other) {
        if (other == com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()) return this;
        if (!other.getIp().isEmpty()) {
          ip_ = other.ip_;
          bitField0_ |= 0x00000001;
          onChanged();
        }
        if (other.getPort() != 0L) {
          setPort(other.getPort());
        }
        internalGetMutableLabels().mergeFrom(other.internalGetLabels());
        bitField0_ |= 0x00000004;
        if (!other.getPrincipal().isEmpty()) {
          principal_ = other.principal_;
          bitField0_ |= 0x00000008;
          onChanged();
        }
        if (!other.getRegionCode().isEmpty()) {
          regionCode_ = other.regionCode_;
          bitField0_ |= 0x00000010;
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 10:
                {
                  ip_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000001;
                  break;
                } // case 10
              case 16:
                {
                  port_ = input.readInt64();
                  bitField0_ |= 0x00000002;
                  break;
                } // case 16
              case 50:
                {
                  com.google.protobuf.MapEntry<java.lang.String, java.lang.String> labels__ =
                      input.readMessage(
                          LabelsDefaultEntryHolder.defaultEntry.getParserForType(),
                          extensionRegistry);
                  internalGetMutableLabels()
                      .getMutableMap()
                      .put(labels__.getKey(), labels__.getValue());
                  bitField0_ |= 0x00000004;
                  break;
                } // case 50
              case 58:
                {
                  principal_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000008;
                  break;
                } // case 58
              case 66:
                {
                  regionCode_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000010;
                  break;
                } // case 66
              default:
                {
                  if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                    done = true; // was an endgroup tag
                  }
                  break;
                } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private int bitField0_;

      private java.lang.Object ip_ = "";
      /**
       *
       *
       * <pre>
       * The IP address of the peer.
       * </pre>
       *
       * <code>string ip = 1;</code>
       *
       * @return The ip.
       */
      public java.lang.String getIp() {
        java.lang.Object ref = ip_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          ip_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The IP address of the peer.
       * </pre>
       *
       * <code>string ip = 1;</code>
       *
       * @return The bytes for ip.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getIpBytes() {
        java.lang.Object ref = ip_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          ip_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The IP address of the peer.
       * </pre>
       *
       * <code>string ip = 1;</code>
       *
       * @param value The ip to set.
       * @return This builder for chaining.
       */
      public Builder setIp(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        ip_ = value;
        bitField0_ |= 0x00000001;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The IP address of the peer.
       * </pre>
       *
       * <code>string ip = 1;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearIp() {
        ip_ = getDefaultInstance().getIp();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The IP address of the peer.
       * </pre>
       *
       * <code>string ip = 1;</code>
       *
       * @param value The bytes for ip to set.
       * @return This builder for chaining.
       */
      public Builder setIpBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        ip_ = value;
        bitField0_ |= 0x00000001;
        onChanged();
        return this;
      }

      private long port_;
      /**
       *
       *
       * <pre>
       * The network port of the peer.
       * </pre>
       *
       * <code>int64 port = 2;</code>
       *
       * @return The port.
       */
      @java.lang.Override
      public long getPort() {
        return port_;
      }
      /**
       *
       *
       * <pre>
       * The network port of the peer.
       * </pre>
       *
       * <code>int64 port = 2;</code>
       *
       * @param value The port to set.
       * @return This builder for chaining.
       */
      public Builder setPort(long value) {

        port_ = value;
        bitField0_ |= 0x00000002;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The network port of the peer.
       * </pre>
       *
       * <code>int64 port = 2;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearPort() {
        bitField0_ = (bitField0_ & ~0x00000002);
        port_ = 0L;
        onChanged();
        return this;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String> labels_;

      private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String> internalGetLabels() {
        if (labels_ == null) {
          return com.google.protobuf.MapField.emptyMapField(LabelsDefaultEntryHolder.defaultEntry);
        }
        return labels_;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String>
          internalGetMutableLabels() {
        if (labels_ == null) {
          labels_ = com.google.protobuf.MapField.newMapField(LabelsDefaultEntryHolder.defaultEntry);
        }
        if (!labels_.isMutable()) {
          labels_ = labels_.copy();
        }
        bitField0_ |= 0x00000004;
        onChanged();
        return labels_;
      }

      public int getLabelsCount() {
        return internalGetLabels().getMap().size();
      }
      /**
       *
       *
       * <pre>
       * The labels associated with the peer.
       * </pre>
       *
       * <code>map&lt;string, string&gt; labels = 6;</code>
       */
      @java.lang.Override
      public boolean containsLabels(java.lang.String key) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        return internalGetLabels().getMap().containsKey(key);
      }
      /** Use {@link #getLabelsMap()} instead. */
      @java.lang.Override
      @java.lang.Deprecated
      public java.util.Map<java.lang.String, java.lang.String> getLabels() {
        return getLabelsMap();
      }
      /**
       *
       *
       * <pre>
       * The labels associated with the peer.
       * </pre>
       *
       * <code>map&lt;string, string&gt; labels = 6;</code>
       */
      @java.lang.Override
      public java.util.Map<java.lang.String, java.lang.String> getLabelsMap() {
        return internalGetLabels().getMap();
      }
      /**
       *
       *
       * <pre>
       * The labels associated with the peer.
       * </pre>
       *
       * <code>map&lt;string, string&gt; labels = 6;</code>
       */
      @java.lang.Override
      public /* nullable */ java.lang.String getLabelsOrDefault(
          java.lang.String key,
          /* nullable */
          java.lang.String defaultValue) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        java.util.Map<java.lang.String, java.lang.String> map = internalGetLabels().getMap();
        return map.containsKey(key) ? map.get(key) : defaultValue;
      }
      /**
       *
       *
       * <pre>
       * The labels associated with the peer.
       * </pre>
       *
       * <code>map&lt;string, string&gt; labels = 6;</code>
       */
      @java.lang.Override
      public java.lang.String getLabelsOrThrow(java.lang.String key) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        java.util.Map<java.lang.String, java.lang.String> map = internalGetLabels().getMap();
        if (!map.containsKey(key)) {
          throw new java.lang.IllegalArgumentException();
        }
        return map.get(key);
      }

      public Builder clearLabels() {
        bitField0_ = (bitField0_ & ~0x00000004);
        internalGetMutableLabels().getMutableMap().clear();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The labels associated with the peer.
       * </pre>
       *
       * <code>map&lt;string, string&gt; labels = 6;</code>
       */
      public Builder removeLabels(java.lang.String key) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        internalGetMutableLabels().getMutableMap().remove(key);
        return this;
      }
      /** Use alternate mutation accessors instead. */
      @java.lang.Deprecated
      public java.util.Map<java.lang.String, java.lang.String> getMutableLabels() {
        bitField0_ |= 0x00000004;
        return internalGetMutableLabels().getMutableMap();
      }
      /**
       *
       *
       * <pre>
       * The labels associated with the peer.
       * </pre>
       *
       * <code>map&lt;string, string&gt; labels = 6;</code>
       */
      public Builder putLabels(java.lang.String key, java.lang.String value) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        if (value == null) {
          throw new NullPointerException("map value");
        }
        internalGetMutableLabels().getMutableMap().put(key, value);
        bitField0_ |= 0x00000004;
        return this;
      }
      /**
       *
       *
       * <pre>
       * The labels associated with the peer.
       * </pre>
       *
       * <code>map&lt;string, string&gt; labels = 6;</code>
       */
      public Builder putAllLabels(java.util.Map<java.lang.String, java.lang.String> values) {
        internalGetMutableLabels().getMutableMap().putAll(values);
        bitField0_ |= 0x00000004;
        return this;
      }

      private java.lang.Object principal_ = "";
      /**
       *
       *
       * <pre>
       * The identity of this peer. Similar to `Request.auth.principal`, but
       * relative to the peer instead of the request. For example, the
       * identity associated with a load balancer that forwarded the request.
       * </pre>
       *
       * <code>string principal = 7;</code>
       *
       * @return The principal.
       */
      public java.lang.String getPrincipal() {
        java.lang.Object ref = principal_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          principal_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The identity of this peer. Similar to `Request.auth.principal`, but
       * relative to the peer instead of the request. For example, the
       * identity associated with a load balancer that forwarded the request.
       * </pre>
       *
       * <code>string principal = 7;</code>
       *
       * @return The bytes for principal.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getPrincipalBytes() {
        java.lang.Object ref = principal_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          principal_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The identity of this peer. Similar to `Request.auth.principal`, but
       * relative to the peer instead of the request. For example, the
       * identity associated with a load balancer that forwarded the request.
       * </pre>
       *
       * <code>string principal = 7;</code>
       *
       * @param value The principal to set.
       * @return This builder for chaining.
       */
      public Builder setPrincipal(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        principal_ = value;
        bitField0_ |= 0x00000008;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The identity of this peer. Similar to `Request.auth.principal`, but
       * relative to the peer instead of the request. For example, the
       * identity associated with a load balancer that forwarded the request.
       * </pre>
       *
       * <code>string principal = 7;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearPrincipal() {
        principal_ = getDefaultInstance().getPrincipal();
        bitField0_ = (bitField0_ & ~0x00000008);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The identity of this peer. Similar to `Request.auth.principal`, but
       * relative to the peer instead of the request. For example, the
       * identity associated with a load balancer that forwarded the request.
       * </pre>
       *
       * <code>string principal = 7;</code>
       *
       * @param value The bytes for principal to set.
       * @return This builder for chaining.
       */
      public Builder setPrincipalBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        principal_ = value;
        bitField0_ |= 0x00000008;
        onChanged();
        return this;
      }

      private java.lang.Object regionCode_ = "";
      /**
       *
       *
       * <pre>
       * The CLDR country/region code associated with the above IP address.
       * If the IP address is private, the `region_code` should reflect the
       * physical location where this peer is running.
       * </pre>
       *
       * <code>string region_code = 8;</code>
       *
       * @return The regionCode.
       */
      public java.lang.String getRegionCode() {
        java.lang.Object ref = regionCode_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          regionCode_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The CLDR country/region code associated with the above IP address.
       * If the IP address is private, the `region_code` should reflect the
       * physical location where this peer is running.
       * </pre>
       *
       * <code>string region_code = 8;</code>
       *
       * @return The bytes for regionCode.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getRegionCodeBytes() {
        java.lang.Object ref = regionCode_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          regionCode_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The CLDR country/region code associated with the above IP address.
       * If the IP address is private, the `region_code` should reflect the
       * physical location where this peer is running.
       * </pre>
       *
       * <code>string region_code = 8;</code>
       *
       * @param value The regionCode to set.
       * @return This builder for chaining.
       */
      public Builder setRegionCode(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        regionCode_ = value;
        bitField0_ |= 0x00000010;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The CLDR country/region code associated with the above IP address.
       * If the IP address is private, the `region_code` should reflect the
       * physical location where this peer is running.
       * </pre>
       *
       * <code>string region_code = 8;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearRegionCode() {
        regionCode_ = getDefaultInstance().getRegionCode();
        bitField0_ = (bitField0_ & ~0x00000010);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The CLDR country/region code associated with the above IP address.
       * If the IP address is private, the `region_code` should reflect the
       * physical location where this peer is running.
       * </pre>
       *
       * <code>string region_code = 8;</code>
       *
       * @param value The bytes for regionCode to set.
       * @return This builder for chaining.
       */
      public Builder setRegionCodeBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        regionCode_ = value;
        bitField0_ |= 0x00000010;
        onChanged();
        return this;
      }

      @java.lang.Override
      public final Builder setUnknownFields(
          final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }

      // @@protoc_insertion_point(builder_scope:google.rpc.context.AttributeContext.Peer)
    }

    // @@protoc_insertion_point(class_scope:google.rpc.context.AttributeContext.Peer)
    private static final com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer DEFAULT_INSTANCE;

    static {
      DEFAULT_INSTANCE = new com.google.rpc.context.AttributeContext.Peer();
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.couchbase.client.core.deps.com.google.protobuf.Parser<Peer> PARSER =
        new com.google.protobuf.AbstractParser<Peer>() {
          @java.lang.Override
          public Peer parsePartialFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws com.google.protobuf.InvalidProtocolBufferException {
            Builder builder = newBuilder();
            try {
              builder.mergeFrom(input, extensionRegistry);
            } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
              throw e.setUnfinishedMessage(builder.buildPartial());
            } catch (com.couchbase.client.core.deps.com.google.protobuf.UninitializedMessageException e) {
              throw e.asInvalidProtocolBufferException()
                  .setUnfinishedMessage(builder.buildPartial());
            } catch (java.io.IOException e) {
              throw new com.google.protobuf.InvalidProtocolBufferException(e)
                  .setUnfinishedMessage(builder.buildPartial());
            }
            return builder.buildPartial();
          }
        };

    public static com.couchbase.client.core.deps.com.google.protobuf.Parser<Peer> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Parser<Peer> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }
  }

  public interface ApiOrBuilder
      extends
      // @@protoc_insertion_point(interface_extends:google.rpc.context.AttributeContext.Api)
      com.google.protobuf.MessageOrBuilder {

    /**
     *
     *
     * <pre>
     * The API service name. It is a logical identifier for a networked API,
     * such as "pubsub.googleapis.com". The naming syntax depends on the
     * API management system being used for handling the request.
     * </pre>
     *
     * <code>string service = 1;</code>
     *
     * @return The service.
     */
    java.lang.String getService();
    /**
     *
     *
     * <pre>
     * The API service name. It is a logical identifier for a networked API,
     * such as "pubsub.googleapis.com". The naming syntax depends on the
     * API management system being used for handling the request.
     * </pre>
     *
     * <code>string service = 1;</code>
     *
     * @return The bytes for service.
     */
    com.google.protobuf.ByteString getServiceBytes();

    /**
     *
     *
     * <pre>
     * The API operation name. For gRPC requests, it is the fully qualified API
     * method name, such as "google.pubsub.v1.Publisher.Publish". For OpenAPI
     * requests, it is the `operationId`, such as "getPet".
     * </pre>
     *
     * <code>string operation = 2;</code>
     *
     * @return The operation.
     */
    java.lang.String getOperation();
    /**
     *
     *
     * <pre>
     * The API operation name. For gRPC requests, it is the fully qualified API
     * method name, such as "google.pubsub.v1.Publisher.Publish". For OpenAPI
     * requests, it is the `operationId`, such as "getPet".
     * </pre>
     *
     * <code>string operation = 2;</code>
     *
     * @return The bytes for operation.
     */
    com.google.protobuf.ByteString getOperationBytes();

    /**
     *
     *
     * <pre>
     * The API protocol used for sending the request, such as "http", "https",
     * "grpc", or "internal".
     * </pre>
     *
     * <code>string protocol = 3;</code>
     *
     * @return The protocol.
     */
    java.lang.String getProtocol();
    /**
     *
     *
     * <pre>
     * The API protocol used for sending the request, such as "http", "https",
     * "grpc", or "internal".
     * </pre>
     *
     * <code>string protocol = 3;</code>
     *
     * @return The bytes for protocol.
     */
    com.google.protobuf.ByteString getProtocolBytes();

    /**
     *
     *
     * <pre>
     * The API version associated with the API operation above, such as "v1" or
     * "v1alpha1".
     * </pre>
     *
     * <code>string version = 4;</code>
     *
     * @return The version.
     */
    java.lang.String getVersion();
    /**
     *
     *
     * <pre>
     * The API version associated with the API operation above, such as "v1" or
     * "v1alpha1".
     * </pre>
     *
     * <code>string version = 4;</code>
     *
     * @return The bytes for version.
     */
    com.google.protobuf.ByteString getVersionBytes();
  }
  /**
   *
   *
   * <pre>
   * This message defines attributes associated with API operations, such as
   * a network API request. The terminology is based on the conventions used
   * by Google APIs, Istio, and OpenAPI.
   * </pre>
   *
   * Protobuf type {@code google.rpc.context.AttributeContext.Api}
   */
  public static final class Api extends com.google.protobuf.GeneratedMessageV3
      implements
      // @@protoc_insertion_point(message_implements:google.rpc.context.AttributeContext.Api)
      ApiOrBuilder {
    private static final long serialVersionUID = 0L;
    // Use Api.newBuilder() to construct.
    private Api(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }

    private Api() {
      service_ = "";
      operation_ = "";
      protocol_ = "";
      version_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
      return new Api();
    }

    public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return com.google.rpc.context.AttributeContextProto
          .internal_static_google_rpc_context_AttributeContext_Api_descriptor;
    }

    @java.lang.Override
    protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.rpc.context.AttributeContextProto
          .internal_static_google_rpc_context_AttributeContext_Api_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.rpc.context.AttributeContext.Api.class,
              com.google.rpc.context.AttributeContext.Api.Builder.class);
    }

    public static final int SERVICE_FIELD_NUMBER = 1;

    @SuppressWarnings("serial")
    private volatile java.lang.Object service_ = "";
    /**
     *
     *
     * <pre>
     * The API service name. It is a logical identifier for a networked API,
     * such as "pubsub.googleapis.com". The naming syntax depends on the
     * API management system being used for handling the request.
     * </pre>
     *
     * <code>string service = 1;</code>
     *
     * @return The service.
     */
    @java.lang.Override
    public java.lang.String getService() {
      java.lang.Object ref = service_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        service_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The API service name. It is a logical identifier for a networked API,
     * such as "pubsub.googleapis.com". The naming syntax depends on the
     * API management system being used for handling the request.
     * </pre>
     *
     * <code>string service = 1;</code>
     *
     * @return The bytes for service.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getServiceBytes() {
      java.lang.Object ref = service_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        service_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int OPERATION_FIELD_NUMBER = 2;

    @SuppressWarnings("serial")
    private volatile java.lang.Object operation_ = "";
    /**
     *
     *
     * <pre>
     * The API operation name. For gRPC requests, it is the fully qualified API
     * method name, such as "google.pubsub.v1.Publisher.Publish". For OpenAPI
     * requests, it is the `operationId`, such as "getPet".
     * </pre>
     *
     * <code>string operation = 2;</code>
     *
     * @return The operation.
     */
    @java.lang.Override
    public java.lang.String getOperation() {
      java.lang.Object ref = operation_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        operation_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The API operation name. For gRPC requests, it is the fully qualified API
     * method name, such as "google.pubsub.v1.Publisher.Publish". For OpenAPI
     * requests, it is the `operationId`, such as "getPet".
     * </pre>
     *
     * <code>string operation = 2;</code>
     *
     * @return The bytes for operation.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getOperationBytes() {
      java.lang.Object ref = operation_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        operation_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int PROTOCOL_FIELD_NUMBER = 3;

    @SuppressWarnings("serial")
    private volatile java.lang.Object protocol_ = "";
    /**
     *
     *
     * <pre>
     * The API protocol used for sending the request, such as "http", "https",
     * "grpc", or "internal".
     * </pre>
     *
     * <code>string protocol = 3;</code>
     *
     * @return The protocol.
     */
    @java.lang.Override
    public java.lang.String getProtocol() {
      java.lang.Object ref = protocol_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        protocol_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The API protocol used for sending the request, such as "http", "https",
     * "grpc", or "internal".
     * </pre>
     *
     * <code>string protocol = 3;</code>
     *
     * @return The bytes for protocol.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getProtocolBytes() {
      java.lang.Object ref = protocol_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        protocol_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int VERSION_FIELD_NUMBER = 4;

    @SuppressWarnings("serial")
    private volatile java.lang.Object version_ = "";
    /**
     *
     *
     * <pre>
     * The API version associated with the API operation above, such as "v1" or
     * "v1alpha1".
     * </pre>
     *
     * <code>string version = 4;</code>
     *
     * @return The version.
     */
    @java.lang.Override
    public java.lang.String getVersion() {
      java.lang.Object ref = version_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        version_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The API version associated with the API operation above, such as "v1" or
     * "v1alpha1".
     * </pre>
     *
     * <code>string version = 4;</code>
     *
     * @return The bytes for version.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getVersionBytes() {
      java.lang.Object ref = version_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        version_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    private byte memoizedIsInitialized = -1;

    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.couchbase.client.core.deps.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(service_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 1, service_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(operation_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 2, operation_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(protocol_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 3, protocol_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(version_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 4, version_);
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(service_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, service_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(operation_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, operation_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(protocol_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(3, protocol_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(version_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(4, version_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
        return true;
      }
      if (!(obj instanceof com.google.rpc.context.AttributeContext.Api)) {
        return super.equals(obj);
      }
      com.google.rpc.context.AttributeContext.Api other =
          (com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api) obj;

      if (!getService().equals(other.getService())) return false;
      if (!getOperation().equals(other.getOperation())) return false;
      if (!getProtocol().equals(other.getProtocol())) return false;
      if (!getVersion().equals(other.getVersion())) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + SERVICE_FIELD_NUMBER;
      hash = (53 * hash) + getService().hashCode();
      hash = (37 * hash) + OPERATION_FIELD_NUMBER;
      hash = (53 * hash) + getOperation().hashCode();
      hash = (37 * hash) + PROTOCOL_FIELD_NUMBER;
      hash = (53 * hash) + getProtocol().hashCode();
      hash = (37 * hash) + VERSION_FIELD_NUMBER;
      hash = (53 * hash) + getVersion().hashCode();
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api parseFrom(java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api parseFrom(
        java.nio.ByteBuffer data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api parseFrom(
        byte[] data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api parseFrom(
        java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api parseDelimitedFrom(
        java.io.InputStream input) throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api parseDelimitedFrom(
        java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api parseFrom(
        com.google.protobuf.CodedInputStream input) throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() {
      return newBuilder();
    }

    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }

    public static Builder newBuilder(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }

    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     *
     *
     * <pre>
     * This message defines attributes associated with API operations, such as
     * a network API request. The terminology is based on the conventions used
     * by Google APIs, Istio, and OpenAPI.
     * </pre>
     *
     * Protobuf type {@code google.rpc.context.AttributeContext.Api}
     */
    public static final class Builder
        extends com.google.protobuf.GeneratedMessageV3.Builder<Builder>
        implements
        // @@protoc_insertion_point(builder_implements:google.rpc.context.AttributeContext.Api)
        com.google.rpc.context.AttributeContext.ApiOrBuilder {
      public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Api_descriptor;
      }

      @java.lang.Override
      protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Api_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.rpc.context.AttributeContext.Api.class,
                com.google.rpc.context.AttributeContext.Api.Builder.class);
      }

      // Construct using com.google.rpc.context.AttributeContext.Api.newBuilder()
      private Builder() {}

      private Builder(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
      }

      @java.lang.Override
      public Builder clear() {
        super.clear();
        bitField0_ = 0;
        service_ = "";
        operation_ = "";
        protocol_ = "";
        version_ = "";
        return this;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Api_descriptor;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api getDefaultInstanceForType() {
        return com.google.rpc.context.AttributeContext.Api.getDefaultInstance();
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api build() {
        com.google.rpc.context.AttributeContext.Api result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api buildPartial() {
        com.google.rpc.context.AttributeContext.Api result =
            new com.google.rpc.context.AttributeContext.Api(this);
        if (bitField0_ != 0) {
          buildPartial0(result);
        }
        onBuilt();
        return result;
      }

      private void buildPartial0(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api result) {
        int from_bitField0_ = bitField0_;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          result.service_ = service_;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          result.operation_ = operation_;
        }
        if (((from_bitField0_ & 0x00000004) != 0)) {
          result.protocol_ = protocol_;
        }
        if (((from_bitField0_ & 0x00000008) != 0)) {
          result.version_ = version_;
        }
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }

      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.setField(field, value);
      }

      @java.lang.Override
      public Builder clearField(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }

      @java.lang.Override
      public Builder clearOneof(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }

      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index,
          java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }

      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }

      @java.lang.Override
      public Builder mergeFrom(com.couchbase.client.core.deps.com.google.protobuf.Message other) {
        if (other instanceof com.google.rpc.context.AttributeContext.Api) {
          return mergeFrom((com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api) other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api other) {
        if (other == com.google.rpc.context.AttributeContext.Api.getDefaultInstance()) return this;
        if (!other.getService().isEmpty()) {
          service_ = other.service_;
          bitField0_ |= 0x00000001;
          onChanged();
        }
        if (!other.getOperation().isEmpty()) {
          operation_ = other.operation_;
          bitField0_ |= 0x00000002;
          onChanged();
        }
        if (!other.getProtocol().isEmpty()) {
          protocol_ = other.protocol_;
          bitField0_ |= 0x00000004;
          onChanged();
        }
        if (!other.getVersion().isEmpty()) {
          version_ = other.version_;
          bitField0_ |= 0x00000008;
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 10:
                {
                  service_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000001;
                  break;
                } // case 10
              case 18:
                {
                  operation_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000002;
                  break;
                } // case 18
              case 26:
                {
                  protocol_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000004;
                  break;
                } // case 26
              case 34:
                {
                  version_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000008;
                  break;
                } // case 34
              default:
                {
                  if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                    done = true; // was an endgroup tag
                  }
                  break;
                } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private int bitField0_;

      private java.lang.Object service_ = "";
      /**
       *
       *
       * <pre>
       * The API service name. It is a logical identifier for a networked API,
       * such as "pubsub.googleapis.com". The naming syntax depends on the
       * API management system being used for handling the request.
       * </pre>
       *
       * <code>string service = 1;</code>
       *
       * @return The service.
       */
      public java.lang.String getService() {
        java.lang.Object ref = service_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          service_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The API service name. It is a logical identifier for a networked API,
       * such as "pubsub.googleapis.com". The naming syntax depends on the
       * API management system being used for handling the request.
       * </pre>
       *
       * <code>string service = 1;</code>
       *
       * @return The bytes for service.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getServiceBytes() {
        java.lang.Object ref = service_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          service_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The API service name. It is a logical identifier for a networked API,
       * such as "pubsub.googleapis.com". The naming syntax depends on the
       * API management system being used for handling the request.
       * </pre>
       *
       * <code>string service = 1;</code>
       *
       * @param value The service to set.
       * @return This builder for chaining.
       */
      public Builder setService(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        service_ = value;
        bitField0_ |= 0x00000001;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The API service name. It is a logical identifier for a networked API,
       * such as "pubsub.googleapis.com". The naming syntax depends on the
       * API management system being used for handling the request.
       * </pre>
       *
       * <code>string service = 1;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearService() {
        service_ = getDefaultInstance().getService();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The API service name. It is a logical identifier for a networked API,
       * such as "pubsub.googleapis.com". The naming syntax depends on the
       * API management system being used for handling the request.
       * </pre>
       *
       * <code>string service = 1;</code>
       *
       * @param value The bytes for service to set.
       * @return This builder for chaining.
       */
      public Builder setServiceBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        service_ = value;
        bitField0_ |= 0x00000001;
        onChanged();
        return this;
      }

      private java.lang.Object operation_ = "";
      /**
       *
       *
       * <pre>
       * The API operation name. For gRPC requests, it is the fully qualified API
       * method name, such as "google.pubsub.v1.Publisher.Publish". For OpenAPI
       * requests, it is the `operationId`, such as "getPet".
       * </pre>
       *
       * <code>string operation = 2;</code>
       *
       * @return The operation.
       */
      public java.lang.String getOperation() {
        java.lang.Object ref = operation_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          operation_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The API operation name. For gRPC requests, it is the fully qualified API
       * method name, such as "google.pubsub.v1.Publisher.Publish". For OpenAPI
       * requests, it is the `operationId`, such as "getPet".
       * </pre>
       *
       * <code>string operation = 2;</code>
       *
       * @return The bytes for operation.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getOperationBytes() {
        java.lang.Object ref = operation_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          operation_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The API operation name. For gRPC requests, it is the fully qualified API
       * method name, such as "google.pubsub.v1.Publisher.Publish". For OpenAPI
       * requests, it is the `operationId`, such as "getPet".
       * </pre>
       *
       * <code>string operation = 2;</code>
       *
       * @param value The operation to set.
       * @return This builder for chaining.
       */
      public Builder setOperation(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        operation_ = value;
        bitField0_ |= 0x00000002;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The API operation name. For gRPC requests, it is the fully qualified API
       * method name, such as "google.pubsub.v1.Publisher.Publish". For OpenAPI
       * requests, it is the `operationId`, such as "getPet".
       * </pre>
       *
       * <code>string operation = 2;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearOperation() {
        operation_ = getDefaultInstance().getOperation();
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The API operation name. For gRPC requests, it is the fully qualified API
       * method name, such as "google.pubsub.v1.Publisher.Publish". For OpenAPI
       * requests, it is the `operationId`, such as "getPet".
       * </pre>
       *
       * <code>string operation = 2;</code>
       *
       * @param value The bytes for operation to set.
       * @return This builder for chaining.
       */
      public Builder setOperationBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        operation_ = value;
        bitField0_ |= 0x00000002;
        onChanged();
        return this;
      }

      private java.lang.Object protocol_ = "";
      /**
       *
       *
       * <pre>
       * The API protocol used for sending the request, such as "http", "https",
       * "grpc", or "internal".
       * </pre>
       *
       * <code>string protocol = 3;</code>
       *
       * @return The protocol.
       */
      public java.lang.String getProtocol() {
        java.lang.Object ref = protocol_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          protocol_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The API protocol used for sending the request, such as "http", "https",
       * "grpc", or "internal".
       * </pre>
       *
       * <code>string protocol = 3;</code>
       *
       * @return The bytes for protocol.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getProtocolBytes() {
        java.lang.Object ref = protocol_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          protocol_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The API protocol used for sending the request, such as "http", "https",
       * "grpc", or "internal".
       * </pre>
       *
       * <code>string protocol = 3;</code>
       *
       * @param value The protocol to set.
       * @return This builder for chaining.
       */
      public Builder setProtocol(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        protocol_ = value;
        bitField0_ |= 0x00000004;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The API protocol used for sending the request, such as "http", "https",
       * "grpc", or "internal".
       * </pre>
       *
       * <code>string protocol = 3;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearProtocol() {
        protocol_ = getDefaultInstance().getProtocol();
        bitField0_ = (bitField0_ & ~0x00000004);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The API protocol used for sending the request, such as "http", "https",
       * "grpc", or "internal".
       * </pre>
       *
       * <code>string protocol = 3;</code>
       *
       * @param value The bytes for protocol to set.
       * @return This builder for chaining.
       */
      public Builder setProtocolBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        protocol_ = value;
        bitField0_ |= 0x00000004;
        onChanged();
        return this;
      }

      private java.lang.Object version_ = "";
      /**
       *
       *
       * <pre>
       * The API version associated with the API operation above, such as "v1" or
       * "v1alpha1".
       * </pre>
       *
       * <code>string version = 4;</code>
       *
       * @return The version.
       */
      public java.lang.String getVersion() {
        java.lang.Object ref = version_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          version_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The API version associated with the API operation above, such as "v1" or
       * "v1alpha1".
       * </pre>
       *
       * <code>string version = 4;</code>
       *
       * @return The bytes for version.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getVersionBytes() {
        java.lang.Object ref = version_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          version_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The API version associated with the API operation above, such as "v1" or
       * "v1alpha1".
       * </pre>
       *
       * <code>string version = 4;</code>
       *
       * @param value The version to set.
       * @return This builder for chaining.
       */
      public Builder setVersion(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        version_ = value;
        bitField0_ |= 0x00000008;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The API version associated with the API operation above, such as "v1" or
       * "v1alpha1".
       * </pre>
       *
       * <code>string version = 4;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearVersion() {
        version_ = getDefaultInstance().getVersion();
        bitField0_ = (bitField0_ & ~0x00000008);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The API version associated with the API operation above, such as "v1" or
       * "v1alpha1".
       * </pre>
       *
       * <code>string version = 4;</code>
       *
       * @param value The bytes for version to set.
       * @return This builder for chaining.
       */
      public Builder setVersionBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        version_ = value;
        bitField0_ |= 0x00000008;
        onChanged();
        return this;
      }

      @java.lang.Override
      public final Builder setUnknownFields(
          final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }

      // @@protoc_insertion_point(builder_scope:google.rpc.context.AttributeContext.Api)
    }

    // @@protoc_insertion_point(class_scope:google.rpc.context.AttributeContext.Api)
    private static final com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api DEFAULT_INSTANCE;

    static {
      DEFAULT_INSTANCE = new com.google.rpc.context.AttributeContext.Api();
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.couchbase.client.core.deps.com.google.protobuf.Parser<Api> PARSER =
        new com.google.protobuf.AbstractParser<Api>() {
          @java.lang.Override
          public Api parsePartialFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws com.google.protobuf.InvalidProtocolBufferException {
            Builder builder = newBuilder();
            try {
              builder.mergeFrom(input, extensionRegistry);
            } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
              throw e.setUnfinishedMessage(builder.buildPartial());
            } catch (com.couchbase.client.core.deps.com.google.protobuf.UninitializedMessageException e) {
              throw e.asInvalidProtocolBufferException()
                  .setUnfinishedMessage(builder.buildPartial());
            } catch (java.io.IOException e) {
              throw new com.google.protobuf.InvalidProtocolBufferException(e)
                  .setUnfinishedMessage(builder.buildPartial());
            }
            return builder.buildPartial();
          }
        };

    public static com.couchbase.client.core.deps.com.google.protobuf.Parser<Api> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Parser<Api> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }
  }

  public interface AuthOrBuilder
      extends
      // @@protoc_insertion_point(interface_extends:google.rpc.context.AttributeContext.Auth)
      com.google.protobuf.MessageOrBuilder {

    /**
     *
     *
     * <pre>
     * The authenticated principal. Reflects the issuer (`iss`) and subject
     * (`sub`) claims within a JWT. The issuer and subject should be `/`
     * delimited, with `/` percent-encoded within the subject fragment. For
     * Google accounts, the principal format is:
     * "https://accounts.google.com/{id}"
     * </pre>
     *
     * <code>string principal = 1;</code>
     *
     * @return The principal.
     */
    java.lang.String getPrincipal();
    /**
     *
     *
     * <pre>
     * The authenticated principal. Reflects the issuer (`iss`) and subject
     * (`sub`) claims within a JWT. The issuer and subject should be `/`
     * delimited, with `/` percent-encoded within the subject fragment. For
     * Google accounts, the principal format is:
     * "https://accounts.google.com/{id}"
     * </pre>
     *
     * <code>string principal = 1;</code>
     *
     * @return The bytes for principal.
     */
    com.google.protobuf.ByteString getPrincipalBytes();

    /**
     *
     *
     * <pre>
     * The intended audience(s) for this authentication information. Reflects
     * the audience (`aud`) claim within a JWT. The audience
     * value(s) depends on the `issuer`, but typically include one or more of
     * the following pieces of information:
     *
     * *  The services intended to receive the credential. For example,
     *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
     * *  A set of service-based scopes. For example,
     *    ["https://www.googleapis.com/auth/cloud-platform"].
     * *  The client id of an app, such as the Firebase project id for JWTs
     *    from Firebase Auth.
     *
     * Consult the documentation for the credential issuer to determine the
     * information provided.
     * </pre>
     *
     * <code>repeated string audiences = 2;</code>
     *
     * @return A list containing the audiences.
     */
    java.util.List<java.lang.String> getAudiencesList();
    /**
     *
     *
     * <pre>
     * The intended audience(s) for this authentication information. Reflects
     * the audience (`aud`) claim within a JWT. The audience
     * value(s) depends on the `issuer`, but typically include one or more of
     * the following pieces of information:
     *
     * *  The services intended to receive the credential. For example,
     *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
     * *  A set of service-based scopes. For example,
     *    ["https://www.googleapis.com/auth/cloud-platform"].
     * *  The client id of an app, such as the Firebase project id for JWTs
     *    from Firebase Auth.
     *
     * Consult the documentation for the credential issuer to determine the
     * information provided.
     * </pre>
     *
     * <code>repeated string audiences = 2;</code>
     *
     * @return The count of audiences.
     */
    int getAudiencesCount();
    /**
     *
     *
     * <pre>
     * The intended audience(s) for this authentication information. Reflects
     * the audience (`aud`) claim within a JWT. The audience
     * value(s) depends on the `issuer`, but typically include one or more of
     * the following pieces of information:
     *
     * *  The services intended to receive the credential. For example,
     *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
     * *  A set of service-based scopes. For example,
     *    ["https://www.googleapis.com/auth/cloud-platform"].
     * *  The client id of an app, such as the Firebase project id for JWTs
     *    from Firebase Auth.
     *
     * Consult the documentation for the credential issuer to determine the
     * information provided.
     * </pre>
     *
     * <code>repeated string audiences = 2;</code>
     *
     * @param index The index of the element to return.
     * @return The audiences at the given index.
     */
    java.lang.String getAudiences(int index);
    /**
     *
     *
     * <pre>
     * The intended audience(s) for this authentication information. Reflects
     * the audience (`aud`) claim within a JWT. The audience
     * value(s) depends on the `issuer`, but typically include one or more of
     * the following pieces of information:
     *
     * *  The services intended to receive the credential. For example,
     *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
     * *  A set of service-based scopes. For example,
     *    ["https://www.googleapis.com/auth/cloud-platform"].
     * *  The client id of an app, such as the Firebase project id for JWTs
     *    from Firebase Auth.
     *
     * Consult the documentation for the credential issuer to determine the
     * information provided.
     * </pre>
     *
     * <code>repeated string audiences = 2;</code>
     *
     * @param index The index of the value to return.
     * @return The bytes of the audiences at the given index.
     */
    com.google.protobuf.ByteString getAudiencesBytes(int index);

    /**
     *
     *
     * <pre>
     * The authorized presenter of the credential. Reflects the optional
     * Authorized Presenter (`azp`) claim within a JWT or the
     * OAuth client id. For example, a Google Cloud Platform client id looks
     * as follows: "123456789012.apps.googleusercontent.com".
     * </pre>
     *
     * <code>string presenter = 3;</code>
     *
     * @return The presenter.
     */
    java.lang.String getPresenter();
    /**
     *
     *
     * <pre>
     * The authorized presenter of the credential. Reflects the optional
     * Authorized Presenter (`azp`) claim within a JWT or the
     * OAuth client id. For example, a Google Cloud Platform client id looks
     * as follows: "123456789012.apps.googleusercontent.com".
     * </pre>
     *
     * <code>string presenter = 3;</code>
     *
     * @return The bytes for presenter.
     */
    com.google.protobuf.ByteString getPresenterBytes();

    /**
     *
     *
     * <pre>
     * Structured claims presented with the credential. JWTs include
     * `{key: value}` pairs for standard and private claims. The following
     * is a subset of the standard required and optional claims that would
     * typically be presented for a Google-based JWT:
     *
     *    {'iss': 'accounts.google.com',
     *     'sub': '113289723416554971153',
     *     'aud': ['123456789012', 'pubsub.googleapis.com'],
     *     'azp': '123456789012.apps.googleusercontent.com',
     *     'email': 'jsmith&#64;example.com',
     *     'iat': 1353601026,
     *     'exp': 1353604926}
     *
     * SAML assertions are similarly specified, but with an identity provider
     * dependent structure.
     * </pre>
     *
     * <code>.google.protobuf.Struct claims = 4;</code>
     *
     * @return Whether the claims field is set.
     */
    boolean hasClaims();
    /**
     *
     *
     * <pre>
     * Structured claims presented with the credential. JWTs include
     * `{key: value}` pairs for standard and private claims. The following
     * is a subset of the standard required and optional claims that would
     * typically be presented for a Google-based JWT:
     *
     *    {'iss': 'accounts.google.com',
     *     'sub': '113289723416554971153',
     *     'aud': ['123456789012', 'pubsub.googleapis.com'],
     *     'azp': '123456789012.apps.googleusercontent.com',
     *     'email': 'jsmith&#64;example.com',
     *     'iat': 1353601026,
     *     'exp': 1353604926}
     *
     * SAML assertions are similarly specified, but with an identity provider
     * dependent structure.
     * </pre>
     *
     * <code>.google.protobuf.Struct claims = 4;</code>
     *
     * @return The claims.
     */
    com.google.protobuf.Struct getClaims();
    /**
     *
     *
     * <pre>
     * Structured claims presented with the credential. JWTs include
     * `{key: value}` pairs for standard and private claims. The following
     * is a subset of the standard required and optional claims that would
     * typically be presented for a Google-based JWT:
     *
     *    {'iss': 'accounts.google.com',
     *     'sub': '113289723416554971153',
     *     'aud': ['123456789012', 'pubsub.googleapis.com'],
     *     'azp': '123456789012.apps.googleusercontent.com',
     *     'email': 'jsmith&#64;example.com',
     *     'iat': 1353601026,
     *     'exp': 1353604926}
     *
     * SAML assertions are similarly specified, but with an identity provider
     * dependent structure.
     * </pre>
     *
     * <code>.google.protobuf.Struct claims = 4;</code>
     */
    com.google.protobuf.StructOrBuilder getClaimsOrBuilder();

    /**
     *
     *
     * <pre>
     * A list of access level resource names that allow resources to be
     * accessed by authenticated requester. It is part of Secure GCP processing
     * for the incoming request. An access level string has the format:
     * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
     *
     * Example:
     * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
     * </pre>
     *
     * <code>repeated string access_levels = 5;</code>
     *
     * @return A list containing the accessLevels.
     */
    java.util.List<java.lang.String> getAccessLevelsList();
    /**
     *
     *
     * <pre>
     * A list of access level resource names that allow resources to be
     * accessed by authenticated requester. It is part of Secure GCP processing
     * for the incoming request. An access level string has the format:
     * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
     *
     * Example:
     * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
     * </pre>
     *
     * <code>repeated string access_levels = 5;</code>
     *
     * @return The count of accessLevels.
     */
    int getAccessLevelsCount();
    /**
     *
     *
     * <pre>
     * A list of access level resource names that allow resources to be
     * accessed by authenticated requester. It is part of Secure GCP processing
     * for the incoming request. An access level string has the format:
     * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
     *
     * Example:
     * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
     * </pre>
     *
     * <code>repeated string access_levels = 5;</code>
     *
     * @param index The index of the element to return.
     * @return The accessLevels at the given index.
     */
    java.lang.String getAccessLevels(int index);
    /**
     *
     *
     * <pre>
     * A list of access level resource names that allow resources to be
     * accessed by authenticated requester. It is part of Secure GCP processing
     * for the incoming request. An access level string has the format:
     * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
     *
     * Example:
     * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
     * </pre>
     *
     * <code>repeated string access_levels = 5;</code>
     *
     * @param index The index of the value to return.
     * @return The bytes of the accessLevels at the given index.
     */
    com.google.protobuf.ByteString getAccessLevelsBytes(int index);
  }
  /**
   *
   *
   * <pre>
   * This message defines request authentication attributes. Terminology is
   * based on the JSON Web Token (JWT) standard, but the terms also
   * correlate to concepts in other standards.
   * </pre>
   *
   * Protobuf type {@code google.rpc.context.AttributeContext.Auth}
   */
  public static final class Auth extends com.google.protobuf.GeneratedMessageV3
      implements
      // @@protoc_insertion_point(message_implements:google.rpc.context.AttributeContext.Auth)
      AuthOrBuilder {
    private static final long serialVersionUID = 0L;
    // Use Auth.newBuilder() to construct.
    private Auth(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }

    private Auth() {
      principal_ = "";
      audiences_ = com.google.protobuf.LazyStringArrayList.emptyList();
      presenter_ = "";
      accessLevels_ = com.google.protobuf.LazyStringArrayList.emptyList();
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
      return new Auth();
    }

    public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return com.google.rpc.context.AttributeContextProto
          .internal_static_google_rpc_context_AttributeContext_Auth_descriptor;
    }

    @java.lang.Override
    protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.rpc.context.AttributeContextProto
          .internal_static_google_rpc_context_AttributeContext_Auth_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.rpc.context.AttributeContext.Auth.class,
              com.google.rpc.context.AttributeContext.Auth.Builder.class);
    }

    private int bitField0_;
    public static final int PRINCIPAL_FIELD_NUMBER = 1;

    @SuppressWarnings("serial")
    private volatile java.lang.Object principal_ = "";
    /**
     *
     *
     * <pre>
     * The authenticated principal. Reflects the issuer (`iss`) and subject
     * (`sub`) claims within a JWT. The issuer and subject should be `/`
     * delimited, with `/` percent-encoded within the subject fragment. For
     * Google accounts, the principal format is:
     * "https://accounts.google.com/{id}"
     * </pre>
     *
     * <code>string principal = 1;</code>
     *
     * @return The principal.
     */
    @java.lang.Override
    public java.lang.String getPrincipal() {
      java.lang.Object ref = principal_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        principal_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The authenticated principal. Reflects the issuer (`iss`) and subject
     * (`sub`) claims within a JWT. The issuer and subject should be `/`
     * delimited, with `/` percent-encoded within the subject fragment. For
     * Google accounts, the principal format is:
     * "https://accounts.google.com/{id}"
     * </pre>
     *
     * <code>string principal = 1;</code>
     *
     * @return The bytes for principal.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getPrincipalBytes() {
      java.lang.Object ref = principal_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        principal_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int AUDIENCES_FIELD_NUMBER = 2;

    @SuppressWarnings("serial")
    private com.couchbase.client.core.deps.com.google.protobuf.LazyStringArrayList audiences_ =
        com.google.protobuf.LazyStringArrayList.emptyList();
    /**
     *
     *
     * <pre>
     * The intended audience(s) for this authentication information. Reflects
     * the audience (`aud`) claim within a JWT. The audience
     * value(s) depends on the `issuer`, but typically include one or more of
     * the following pieces of information:
     *
     * *  The services intended to receive the credential. For example,
     *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
     * *  A set of service-based scopes. For example,
     *    ["https://www.googleapis.com/auth/cloud-platform"].
     * *  The client id of an app, such as the Firebase project id for JWTs
     *    from Firebase Auth.
     *
     * Consult the documentation for the credential issuer to determine the
     * information provided.
     * </pre>
     *
     * <code>repeated string audiences = 2;</code>
     *
     * @return A list containing the audiences.
     */
    public com.couchbase.client.core.deps.com.google.protobuf.ProtocolStringList getAudiencesList() {
      return audiences_;
    }
    /**
     *
     *
     * <pre>
     * The intended audience(s) for this authentication information. Reflects
     * the audience (`aud`) claim within a JWT. The audience
     * value(s) depends on the `issuer`, but typically include one or more of
     * the following pieces of information:
     *
     * *  The services intended to receive the credential. For example,
     *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
     * *  A set of service-based scopes. For example,
     *    ["https://www.googleapis.com/auth/cloud-platform"].
     * *  The client id of an app, such as the Firebase project id for JWTs
     *    from Firebase Auth.
     *
     * Consult the documentation for the credential issuer to determine the
     * information provided.
     * </pre>
     *
     * <code>repeated string audiences = 2;</code>
     *
     * @return The count of audiences.
     */
    public int getAudiencesCount() {
      return audiences_.size();
    }
    /**
     *
     *
     * <pre>
     * The intended audience(s) for this authentication information. Reflects
     * the audience (`aud`) claim within a JWT. The audience
     * value(s) depends on the `issuer`, but typically include one or more of
     * the following pieces of information:
     *
     * *  The services intended to receive the credential. For example,
     *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
     * *  A set of service-based scopes. For example,
     *    ["https://www.googleapis.com/auth/cloud-platform"].
     * *  The client id of an app, such as the Firebase project id for JWTs
     *    from Firebase Auth.
     *
     * Consult the documentation for the credential issuer to determine the
     * information provided.
     * </pre>
     *
     * <code>repeated string audiences = 2;</code>
     *
     * @param index The index of the element to return.
     * @return The audiences at the given index.
     */
    public java.lang.String getAudiences(int index) {
      return audiences_.get(index);
    }
    /**
     *
     *
     * <pre>
     * The intended audience(s) for this authentication information. Reflects
     * the audience (`aud`) claim within a JWT. The audience
     * value(s) depends on the `issuer`, but typically include one or more of
     * the following pieces of information:
     *
     * *  The services intended to receive the credential. For example,
     *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
     * *  A set of service-based scopes. For example,
     *    ["https://www.googleapis.com/auth/cloud-platform"].
     * *  The client id of an app, such as the Firebase project id for JWTs
     *    from Firebase Auth.
     *
     * Consult the documentation for the credential issuer to determine the
     * information provided.
     * </pre>
     *
     * <code>repeated string audiences = 2;</code>
     *
     * @param index The index of the value to return.
     * @return The bytes of the audiences at the given index.
     */
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getAudiencesBytes(int index) {
      return audiences_.getByteString(index);
    }

    public static final int PRESENTER_FIELD_NUMBER = 3;

    @SuppressWarnings("serial")
    private volatile java.lang.Object presenter_ = "";
    /**
     *
     *
     * <pre>
     * The authorized presenter of the credential. Reflects the optional
     * Authorized Presenter (`azp`) claim within a JWT or the
     * OAuth client id. For example, a Google Cloud Platform client id looks
     * as follows: "123456789012.apps.googleusercontent.com".
     * </pre>
     *
     * <code>string presenter = 3;</code>
     *
     * @return The presenter.
     */
    @java.lang.Override
    public java.lang.String getPresenter() {
      java.lang.Object ref = presenter_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        presenter_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The authorized presenter of the credential. Reflects the optional
     * Authorized Presenter (`azp`) claim within a JWT or the
     * OAuth client id. For example, a Google Cloud Platform client id looks
     * as follows: "123456789012.apps.googleusercontent.com".
     * </pre>
     *
     * <code>string presenter = 3;</code>
     *
     * @return The bytes for presenter.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getPresenterBytes() {
      java.lang.Object ref = presenter_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        presenter_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int CLAIMS_FIELD_NUMBER = 4;
    private com.couchbase.client.core.deps.com.google.protobuf.Struct claims_;
    /**
     *
     *
     * <pre>
     * Structured claims presented with the credential. JWTs include
     * `{key: value}` pairs for standard and private claims. The following
     * is a subset of the standard required and optional claims that would
     * typically be presented for a Google-based JWT:
     *
     *    {'iss': 'accounts.google.com',
     *     'sub': '113289723416554971153',
     *     'aud': ['123456789012', 'pubsub.googleapis.com'],
     *     'azp': '123456789012.apps.googleusercontent.com',
     *     'email': 'jsmith&#64;example.com',
     *     'iat': 1353601026,
     *     'exp': 1353604926}
     *
     * SAML assertions are similarly specified, but with an identity provider
     * dependent structure.
     * </pre>
     *
     * <code>.google.protobuf.Struct claims = 4;</code>
     *
     * @return Whether the claims field is set.
     */
    @java.lang.Override
    public boolean hasClaims() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     *
     *
     * <pre>
     * Structured claims presented with the credential. JWTs include
     * `{key: value}` pairs for standard and private claims. The following
     * is a subset of the standard required and optional claims that would
     * typically be presented for a Google-based JWT:
     *
     *    {'iss': 'accounts.google.com',
     *     'sub': '113289723416554971153',
     *     'aud': ['123456789012', 'pubsub.googleapis.com'],
     *     'azp': '123456789012.apps.googleusercontent.com',
     *     'email': 'jsmith&#64;example.com',
     *     'iat': 1353601026,
     *     'exp': 1353604926}
     *
     * SAML assertions are similarly specified, but with an identity provider
     * dependent structure.
     * </pre>
     *
     * <code>.google.protobuf.Struct claims = 4;</code>
     *
     * @return The claims.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Struct getClaims() {
      return claims_ == null ? com.google.protobuf.Struct.getDefaultInstance() : claims_;
    }
    /**
     *
     *
     * <pre>
     * Structured claims presented with the credential. JWTs include
     * `{key: value}` pairs for standard and private claims. The following
     * is a subset of the standard required and optional claims that would
     * typically be presented for a Google-based JWT:
     *
     *    {'iss': 'accounts.google.com',
     *     'sub': '113289723416554971153',
     *     'aud': ['123456789012', 'pubsub.googleapis.com'],
     *     'azp': '123456789012.apps.googleusercontent.com',
     *     'email': 'jsmith&#64;example.com',
     *     'iat': 1353601026,
     *     'exp': 1353604926}
     *
     * SAML assertions are similarly specified, but with an identity provider
     * dependent structure.
     * </pre>
     *
     * <code>.google.protobuf.Struct claims = 4;</code>
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.StructOrBuilder getClaimsOrBuilder() {
      return claims_ == null ? com.google.protobuf.Struct.getDefaultInstance() : claims_;
    }

    public static final int ACCESS_LEVELS_FIELD_NUMBER = 5;

    @SuppressWarnings("serial")
    private com.couchbase.client.core.deps.com.google.protobuf.LazyStringArrayList accessLevels_ =
        com.google.protobuf.LazyStringArrayList.emptyList();
    /**
     *
     *
     * <pre>
     * A list of access level resource names that allow resources to be
     * accessed by authenticated requester. It is part of Secure GCP processing
     * for the incoming request. An access level string has the format:
     * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
     *
     * Example:
     * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
     * </pre>
     *
     * <code>repeated string access_levels = 5;</code>
     *
     * @return A list containing the accessLevels.
     */
    public com.couchbase.client.core.deps.com.google.protobuf.ProtocolStringList getAccessLevelsList() {
      return accessLevels_;
    }
    /**
     *
     *
     * <pre>
     * A list of access level resource names that allow resources to be
     * accessed by authenticated requester. It is part of Secure GCP processing
     * for the incoming request. An access level string has the format:
     * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
     *
     * Example:
     * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
     * </pre>
     *
     * <code>repeated string access_levels = 5;</code>
     *
     * @return The count of accessLevels.
     */
    public int getAccessLevelsCount() {
      return accessLevels_.size();
    }
    /**
     *
     *
     * <pre>
     * A list of access level resource names that allow resources to be
     * accessed by authenticated requester. It is part of Secure GCP processing
     * for the incoming request. An access level string has the format:
     * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
     *
     * Example:
     * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
     * </pre>
     *
     * <code>repeated string access_levels = 5;</code>
     *
     * @param index The index of the element to return.
     * @return The accessLevels at the given index.
     */
    public java.lang.String getAccessLevels(int index) {
      return accessLevels_.get(index);
    }
    /**
     *
     *
     * <pre>
     * A list of access level resource names that allow resources to be
     * accessed by authenticated requester. It is part of Secure GCP processing
     * for the incoming request. An access level string has the format:
     * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
     *
     * Example:
     * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
     * </pre>
     *
     * <code>repeated string access_levels = 5;</code>
     *
     * @param index The index of the value to return.
     * @return The bytes of the accessLevels at the given index.
     */
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getAccessLevelsBytes(int index) {
      return accessLevels_.getByteString(index);
    }

    private byte memoizedIsInitialized = -1;

    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.couchbase.client.core.deps.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(principal_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 1, principal_);
      }
      for (int i = 0; i < audiences_.size(); i++) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 2, audiences_.getRaw(i));
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(presenter_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 3, presenter_);
      }
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeMessage(4, getClaims());
      }
      for (int i = 0; i < accessLevels_.size(); i++) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 5, accessLevels_.getRaw(i));
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(principal_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, principal_);
      }
      {
        int dataSize = 0;
        for (int i = 0; i < audiences_.size(); i++) {
          dataSize += computeStringSizeNoTag(audiences_.getRaw(i));
        }
        size += dataSize;
        size += 1 * getAudiencesList().size();
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(presenter_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(3, presenter_);
      }
      if (((bitField0_ & 0x00000001) != 0)) {
        size += com.google.protobuf.CodedOutputStream.computeMessageSize(4, getClaims());
      }
      {
        int dataSize = 0;
        for (int i = 0; i < accessLevels_.size(); i++) {
          dataSize += computeStringSizeNoTag(accessLevels_.getRaw(i));
        }
        size += dataSize;
        size += 1 * getAccessLevelsList().size();
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
        return true;
      }
      if (!(obj instanceof com.google.rpc.context.AttributeContext.Auth)) {
        return super.equals(obj);
      }
      com.google.rpc.context.AttributeContext.Auth other =
          (com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth) obj;

      if (!getPrincipal().equals(other.getPrincipal())) return false;
      if (!getAudiencesList().equals(other.getAudiencesList())) return false;
      if (!getPresenter().equals(other.getPresenter())) return false;
      if (hasClaims() != other.hasClaims()) return false;
      if (hasClaims()) {
        if (!getClaims().equals(other.getClaims())) return false;
      }
      if (!getAccessLevelsList().equals(other.getAccessLevelsList())) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + PRINCIPAL_FIELD_NUMBER;
      hash = (53 * hash) + getPrincipal().hashCode();
      if (getAudiencesCount() > 0) {
        hash = (37 * hash) + AUDIENCES_FIELD_NUMBER;
        hash = (53 * hash) + getAudiencesList().hashCode();
      }
      hash = (37 * hash) + PRESENTER_FIELD_NUMBER;
      hash = (53 * hash) + getPresenter().hashCode();
      if (hasClaims()) {
        hash = (37 * hash) + CLAIMS_FIELD_NUMBER;
        hash = (53 * hash) + getClaims().hashCode();
      }
      if (getAccessLevelsCount() > 0) {
        hash = (37 * hash) + ACCESS_LEVELS_FIELD_NUMBER;
        hash = (53 * hash) + getAccessLevelsList().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth parseFrom(java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth parseFrom(
        java.nio.ByteBuffer data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth parseFrom(
        byte[] data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth parseFrom(
        java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth parseDelimitedFrom(
        java.io.InputStream input) throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth parseDelimitedFrom(
        java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth parseFrom(
        com.google.protobuf.CodedInputStream input) throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() {
      return newBuilder();
    }

    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }

    public static Builder newBuilder(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }

    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     *
     *
     * <pre>
     * This message defines request authentication attributes. Terminology is
     * based on the JSON Web Token (JWT) standard, but the terms also
     * correlate to concepts in other standards.
     * </pre>
     *
     * Protobuf type {@code google.rpc.context.AttributeContext.Auth}
     */
    public static final class Builder
        extends com.google.protobuf.GeneratedMessageV3.Builder<Builder>
        implements
        // @@protoc_insertion_point(builder_implements:google.rpc.context.AttributeContext.Auth)
        com.google.rpc.context.AttributeContext.AuthOrBuilder {
      public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Auth_descriptor;
      }

      @java.lang.Override
      protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Auth_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.rpc.context.AttributeContext.Auth.class,
                com.google.rpc.context.AttributeContext.Auth.Builder.class);
      }

      // Construct using com.google.rpc.context.AttributeContext.Auth.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }

      private void maybeForceBuilderInitialization() {
        if (com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {
          getClaimsFieldBuilder();
        }
      }

      @java.lang.Override
      public Builder clear() {
        super.clear();
        bitField0_ = 0;
        principal_ = "";
        audiences_ = com.google.protobuf.LazyStringArrayList.emptyList();
        presenter_ = "";
        claims_ = null;
        if (claimsBuilder_ != null) {
          claimsBuilder_.dispose();
          claimsBuilder_ = null;
        }
        accessLevels_ = com.google.protobuf.LazyStringArrayList.emptyList();
        return this;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Auth_descriptor;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth getDefaultInstanceForType() {
        return com.google.rpc.context.AttributeContext.Auth.getDefaultInstance();
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth build() {
        com.google.rpc.context.AttributeContext.Auth result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth buildPartial() {
        com.google.rpc.context.AttributeContext.Auth result =
            new com.google.rpc.context.AttributeContext.Auth(this);
        if (bitField0_ != 0) {
          buildPartial0(result);
        }
        onBuilt();
        return result;
      }

      private void buildPartial0(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth result) {
        int from_bitField0_ = bitField0_;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          result.principal_ = principal_;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          audiences_.makeImmutable();
          result.audiences_ = audiences_;
        }
        if (((from_bitField0_ & 0x00000004) != 0)) {
          result.presenter_ = presenter_;
        }
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000008) != 0)) {
          result.claims_ = claimsBuilder_ == null ? claims_ : claimsBuilder_.build();
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000010) != 0)) {
          accessLevels_.makeImmutable();
          result.accessLevels_ = accessLevels_;
        }
        result.bitField0_ |= to_bitField0_;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }

      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.setField(field, value);
      }

      @java.lang.Override
      public Builder clearField(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }

      @java.lang.Override
      public Builder clearOneof(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }

      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index,
          java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }

      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }

      @java.lang.Override
      public Builder mergeFrom(com.couchbase.client.core.deps.com.google.protobuf.Message other) {
        if (other instanceof com.google.rpc.context.AttributeContext.Auth) {
          return mergeFrom((com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth) other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth other) {
        if (other == com.google.rpc.context.AttributeContext.Auth.getDefaultInstance()) return this;
        if (!other.getPrincipal().isEmpty()) {
          principal_ = other.principal_;
          bitField0_ |= 0x00000001;
          onChanged();
        }
        if (!other.audiences_.isEmpty()) {
          if (audiences_.isEmpty()) {
            audiences_ = other.audiences_;
            bitField0_ |= 0x00000002;
          } else {
            ensureAudiencesIsMutable();
            audiences_.addAll(other.audiences_);
          }
          onChanged();
        }
        if (!other.getPresenter().isEmpty()) {
          presenter_ = other.presenter_;
          bitField0_ |= 0x00000004;
          onChanged();
        }
        if (other.hasClaims()) {
          mergeClaims(other.getClaims());
        }
        if (!other.accessLevels_.isEmpty()) {
          if (accessLevels_.isEmpty()) {
            accessLevels_ = other.accessLevels_;
            bitField0_ |= 0x00000010;
          } else {
            ensureAccessLevelsIsMutable();
            accessLevels_.addAll(other.accessLevels_);
          }
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 10:
                {
                  principal_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000001;
                  break;
                } // case 10
              case 18:
                {
                  java.lang.String s = input.readStringRequireUtf8();
                  ensureAudiencesIsMutable();
                  audiences_.add(s);
                  break;
                } // case 18
              case 26:
                {
                  presenter_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000004;
                  break;
                } // case 26
              case 34:
                {
                  input.readMessage(getClaimsFieldBuilder().getBuilder(), extensionRegistry);
                  bitField0_ |= 0x00000008;
                  break;
                } // case 34
              case 42:
                {
                  java.lang.String s = input.readStringRequireUtf8();
                  ensureAccessLevelsIsMutable();
                  accessLevels_.add(s);
                  break;
                } // case 42
              default:
                {
                  if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                    done = true; // was an endgroup tag
                  }
                  break;
                } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private int bitField0_;

      private java.lang.Object principal_ = "";
      /**
       *
       *
       * <pre>
       * The authenticated principal. Reflects the issuer (`iss`) and subject
       * (`sub`) claims within a JWT. The issuer and subject should be `/`
       * delimited, with `/` percent-encoded within the subject fragment. For
       * Google accounts, the principal format is:
       * "https://accounts.google.com/{id}"
       * </pre>
       *
       * <code>string principal = 1;</code>
       *
       * @return The principal.
       */
      public java.lang.String getPrincipal() {
        java.lang.Object ref = principal_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          principal_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The authenticated principal. Reflects the issuer (`iss`) and subject
       * (`sub`) claims within a JWT. The issuer and subject should be `/`
       * delimited, with `/` percent-encoded within the subject fragment. For
       * Google accounts, the principal format is:
       * "https://accounts.google.com/{id}"
       * </pre>
       *
       * <code>string principal = 1;</code>
       *
       * @return The bytes for principal.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getPrincipalBytes() {
        java.lang.Object ref = principal_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          principal_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The authenticated principal. Reflects the issuer (`iss`) and subject
       * (`sub`) claims within a JWT. The issuer and subject should be `/`
       * delimited, with `/` percent-encoded within the subject fragment. For
       * Google accounts, the principal format is:
       * "https://accounts.google.com/{id}"
       * </pre>
       *
       * <code>string principal = 1;</code>
       *
       * @param value The principal to set.
       * @return This builder for chaining.
       */
      public Builder setPrincipal(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        principal_ = value;
        bitField0_ |= 0x00000001;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The authenticated principal. Reflects the issuer (`iss`) and subject
       * (`sub`) claims within a JWT. The issuer and subject should be `/`
       * delimited, with `/` percent-encoded within the subject fragment. For
       * Google accounts, the principal format is:
       * "https://accounts.google.com/{id}"
       * </pre>
       *
       * <code>string principal = 1;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearPrincipal() {
        principal_ = getDefaultInstance().getPrincipal();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The authenticated principal. Reflects the issuer (`iss`) and subject
       * (`sub`) claims within a JWT. The issuer and subject should be `/`
       * delimited, with `/` percent-encoded within the subject fragment. For
       * Google accounts, the principal format is:
       * "https://accounts.google.com/{id}"
       * </pre>
       *
       * <code>string principal = 1;</code>
       *
       * @param value The bytes for principal to set.
       * @return This builder for chaining.
       */
      public Builder setPrincipalBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        principal_ = value;
        bitField0_ |= 0x00000001;
        onChanged();
        return this;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.LazyStringArrayList audiences_ =
          com.google.protobuf.LazyStringArrayList.emptyList();

      private void ensureAudiencesIsMutable() {
        if (!audiences_.isModifiable()) {
          audiences_ = new com.google.protobuf.LazyStringArrayList(audiences_);
        }
        bitField0_ |= 0x00000002;
      }
      /**
       *
       *
       * <pre>
       * The intended audience(s) for this authentication information. Reflects
       * the audience (`aud`) claim within a JWT. The audience
       * value(s) depends on the `issuer`, but typically include one or more of
       * the following pieces of information:
       *
       * *  The services intended to receive the credential. For example,
       *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
       * *  A set of service-based scopes. For example,
       *    ["https://www.googleapis.com/auth/cloud-platform"].
       * *  The client id of an app, such as the Firebase project id for JWTs
       *    from Firebase Auth.
       *
       * Consult the documentation for the credential issuer to determine the
       * information provided.
       * </pre>
       *
       * <code>repeated string audiences = 2;</code>
       *
       * @return A list containing the audiences.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ProtocolStringList getAudiencesList() {
        audiences_.makeImmutable();
        return audiences_;
      }
      /**
       *
       *
       * <pre>
       * The intended audience(s) for this authentication information. Reflects
       * the audience (`aud`) claim within a JWT. The audience
       * value(s) depends on the `issuer`, but typically include one or more of
       * the following pieces of information:
       *
       * *  The services intended to receive the credential. For example,
       *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
       * *  A set of service-based scopes. For example,
       *    ["https://www.googleapis.com/auth/cloud-platform"].
       * *  The client id of an app, such as the Firebase project id for JWTs
       *    from Firebase Auth.
       *
       * Consult the documentation for the credential issuer to determine the
       * information provided.
       * </pre>
       *
       * <code>repeated string audiences = 2;</code>
       *
       * @return The count of audiences.
       */
      public int getAudiencesCount() {
        return audiences_.size();
      }
      /**
       *
       *
       * <pre>
       * The intended audience(s) for this authentication information. Reflects
       * the audience (`aud`) claim within a JWT. The audience
       * value(s) depends on the `issuer`, but typically include one or more of
       * the following pieces of information:
       *
       * *  The services intended to receive the credential. For example,
       *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
       * *  A set of service-based scopes. For example,
       *    ["https://www.googleapis.com/auth/cloud-platform"].
       * *  The client id of an app, such as the Firebase project id for JWTs
       *    from Firebase Auth.
       *
       * Consult the documentation for the credential issuer to determine the
       * information provided.
       * </pre>
       *
       * <code>repeated string audiences = 2;</code>
       *
       * @param index The index of the element to return.
       * @return The audiences at the given index.
       */
      public java.lang.String getAudiences(int index) {
        return audiences_.get(index);
      }
      /**
       *
       *
       * <pre>
       * The intended audience(s) for this authentication information. Reflects
       * the audience (`aud`) claim within a JWT. The audience
       * value(s) depends on the `issuer`, but typically include one or more of
       * the following pieces of information:
       *
       * *  The services intended to receive the credential. For example,
       *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
       * *  A set of service-based scopes. For example,
       *    ["https://www.googleapis.com/auth/cloud-platform"].
       * *  The client id of an app, such as the Firebase project id for JWTs
       *    from Firebase Auth.
       *
       * Consult the documentation for the credential issuer to determine the
       * information provided.
       * </pre>
       *
       * <code>repeated string audiences = 2;</code>
       *
       * @param index The index of the value to return.
       * @return The bytes of the audiences at the given index.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getAudiencesBytes(int index) {
        return audiences_.getByteString(index);
      }
      /**
       *
       *
       * <pre>
       * The intended audience(s) for this authentication information. Reflects
       * the audience (`aud`) claim within a JWT. The audience
       * value(s) depends on the `issuer`, but typically include one or more of
       * the following pieces of information:
       *
       * *  The services intended to receive the credential. For example,
       *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
       * *  A set of service-based scopes. For example,
       *    ["https://www.googleapis.com/auth/cloud-platform"].
       * *  The client id of an app, such as the Firebase project id for JWTs
       *    from Firebase Auth.
       *
       * Consult the documentation for the credential issuer to determine the
       * information provided.
       * </pre>
       *
       * <code>repeated string audiences = 2;</code>
       *
       * @param index The index to set the value at.
       * @param value The audiences to set.
       * @return This builder for chaining.
       */
      public Builder setAudiences(int index, java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureAudiencesIsMutable();
        audiences_.set(index, value);
        bitField0_ |= 0x00000002;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The intended audience(s) for this authentication information. Reflects
       * the audience (`aud`) claim within a JWT. The audience
       * value(s) depends on the `issuer`, but typically include one or more of
       * the following pieces of information:
       *
       * *  The services intended to receive the credential. For example,
       *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
       * *  A set of service-based scopes. For example,
       *    ["https://www.googleapis.com/auth/cloud-platform"].
       * *  The client id of an app, such as the Firebase project id for JWTs
       *    from Firebase Auth.
       *
       * Consult the documentation for the credential issuer to determine the
       * information provided.
       * </pre>
       *
       * <code>repeated string audiences = 2;</code>
       *
       * @param value The audiences to add.
       * @return This builder for chaining.
       */
      public Builder addAudiences(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureAudiencesIsMutable();
        audiences_.add(value);
        bitField0_ |= 0x00000002;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The intended audience(s) for this authentication information. Reflects
       * the audience (`aud`) claim within a JWT. The audience
       * value(s) depends on the `issuer`, but typically include one or more of
       * the following pieces of information:
       *
       * *  The services intended to receive the credential. For example,
       *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
       * *  A set of service-based scopes. For example,
       *    ["https://www.googleapis.com/auth/cloud-platform"].
       * *  The client id of an app, such as the Firebase project id for JWTs
       *    from Firebase Auth.
       *
       * Consult the documentation for the credential issuer to determine the
       * information provided.
       * </pre>
       *
       * <code>repeated string audiences = 2;</code>
       *
       * @param values The audiences to add.
       * @return This builder for chaining.
       */
      public Builder addAllAudiences(java.lang.Iterable<java.lang.String> values) {
        ensureAudiencesIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(values, audiences_);
        bitField0_ |= 0x00000002;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The intended audience(s) for this authentication information. Reflects
       * the audience (`aud`) claim within a JWT. The audience
       * value(s) depends on the `issuer`, but typically include one or more of
       * the following pieces of information:
       *
       * *  The services intended to receive the credential. For example,
       *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
       * *  A set of service-based scopes. For example,
       *    ["https://www.googleapis.com/auth/cloud-platform"].
       * *  The client id of an app, such as the Firebase project id for JWTs
       *    from Firebase Auth.
       *
       * Consult the documentation for the credential issuer to determine the
       * information provided.
       * </pre>
       *
       * <code>repeated string audiences = 2;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearAudiences() {
        audiences_ = com.google.protobuf.LazyStringArrayList.emptyList();
        bitField0_ = (bitField0_ & ~0x00000002);
        ;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The intended audience(s) for this authentication information. Reflects
       * the audience (`aud`) claim within a JWT. The audience
       * value(s) depends on the `issuer`, but typically include one or more of
       * the following pieces of information:
       *
       * *  The services intended to receive the credential. For example,
       *    ["https://pubsub.googleapis.com/", "https://storage.googleapis.com/"].
       * *  A set of service-based scopes. For example,
       *    ["https://www.googleapis.com/auth/cloud-platform"].
       * *  The client id of an app, such as the Firebase project id for JWTs
       *    from Firebase Auth.
       *
       * Consult the documentation for the credential issuer to determine the
       * information provided.
       * </pre>
       *
       * <code>repeated string audiences = 2;</code>
       *
       * @param value The bytes of the audiences to add.
       * @return This builder for chaining.
       */
      public Builder addAudiencesBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        ensureAudiencesIsMutable();
        audiences_.add(value);
        bitField0_ |= 0x00000002;
        onChanged();
        return this;
      }

      private java.lang.Object presenter_ = "";
      /**
       *
       *
       * <pre>
       * The authorized presenter of the credential. Reflects the optional
       * Authorized Presenter (`azp`) claim within a JWT or the
       * OAuth client id. For example, a Google Cloud Platform client id looks
       * as follows: "123456789012.apps.googleusercontent.com".
       * </pre>
       *
       * <code>string presenter = 3;</code>
       *
       * @return The presenter.
       */
      public java.lang.String getPresenter() {
        java.lang.Object ref = presenter_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          presenter_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The authorized presenter of the credential. Reflects the optional
       * Authorized Presenter (`azp`) claim within a JWT or the
       * OAuth client id. For example, a Google Cloud Platform client id looks
       * as follows: "123456789012.apps.googleusercontent.com".
       * </pre>
       *
       * <code>string presenter = 3;</code>
       *
       * @return The bytes for presenter.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getPresenterBytes() {
        java.lang.Object ref = presenter_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          presenter_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The authorized presenter of the credential. Reflects the optional
       * Authorized Presenter (`azp`) claim within a JWT or the
       * OAuth client id. For example, a Google Cloud Platform client id looks
       * as follows: "123456789012.apps.googleusercontent.com".
       * </pre>
       *
       * <code>string presenter = 3;</code>
       *
       * @param value The presenter to set.
       * @return This builder for chaining.
       */
      public Builder setPresenter(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        presenter_ = value;
        bitField0_ |= 0x00000004;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The authorized presenter of the credential. Reflects the optional
       * Authorized Presenter (`azp`) claim within a JWT or the
       * OAuth client id. For example, a Google Cloud Platform client id looks
       * as follows: "123456789012.apps.googleusercontent.com".
       * </pre>
       *
       * <code>string presenter = 3;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearPresenter() {
        presenter_ = getDefaultInstance().getPresenter();
        bitField0_ = (bitField0_ & ~0x00000004);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The authorized presenter of the credential. Reflects the optional
       * Authorized Presenter (`azp`) claim within a JWT or the
       * OAuth client id. For example, a Google Cloud Platform client id looks
       * as follows: "123456789012.apps.googleusercontent.com".
       * </pre>
       *
       * <code>string presenter = 3;</code>
       *
       * @param value The bytes for presenter to set.
       * @return This builder for chaining.
       */
      public Builder setPresenterBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        presenter_ = value;
        bitField0_ |= 0x00000004;
        onChanged();
        return this;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.Struct claims_;
      private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
              com.google.protobuf.Struct,
              com.google.protobuf.Struct.Builder,
              com.google.protobuf.StructOrBuilder>
          claimsBuilder_;
      /**
       *
       *
       * <pre>
       * Structured claims presented with the credential. JWTs include
       * `{key: value}` pairs for standard and private claims. The following
       * is a subset of the standard required and optional claims that would
       * typically be presented for a Google-based JWT:
       *
       *    {'iss': 'accounts.google.com',
       *     'sub': '113289723416554971153',
       *     'aud': ['123456789012', 'pubsub.googleapis.com'],
       *     'azp': '123456789012.apps.googleusercontent.com',
       *     'email': 'jsmith&#64;example.com',
       *     'iat': 1353601026,
       *     'exp': 1353604926}
       *
       * SAML assertions are similarly specified, but with an identity provider
       * dependent structure.
       * </pre>
       *
       * <code>.google.protobuf.Struct claims = 4;</code>
       *
       * @return Whether the claims field is set.
       */
      public boolean hasClaims() {
        return ((bitField0_ & 0x00000008) != 0);
      }
      /**
       *
       *
       * <pre>
       * Structured claims presented with the credential. JWTs include
       * `{key: value}` pairs for standard and private claims. The following
       * is a subset of the standard required and optional claims that would
       * typically be presented for a Google-based JWT:
       *
       *    {'iss': 'accounts.google.com',
       *     'sub': '113289723416554971153',
       *     'aud': ['123456789012', 'pubsub.googleapis.com'],
       *     'azp': '123456789012.apps.googleusercontent.com',
       *     'email': 'jsmith&#64;example.com',
       *     'iat': 1353601026,
       *     'exp': 1353604926}
       *
       * SAML assertions are similarly specified, but with an identity provider
       * dependent structure.
       * </pre>
       *
       * <code>.google.protobuf.Struct claims = 4;</code>
       *
       * @return The claims.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.Struct getClaims() {
        if (claimsBuilder_ == null) {
          return claims_ == null ? com.google.protobuf.Struct.getDefaultInstance() : claims_;
        } else {
          return claimsBuilder_.getMessage();
        }
      }
      /**
       *
       *
       * <pre>
       * Structured claims presented with the credential. JWTs include
       * `{key: value}` pairs for standard and private claims. The following
       * is a subset of the standard required and optional claims that would
       * typically be presented for a Google-based JWT:
       *
       *    {'iss': 'accounts.google.com',
       *     'sub': '113289723416554971153',
       *     'aud': ['123456789012', 'pubsub.googleapis.com'],
       *     'azp': '123456789012.apps.googleusercontent.com',
       *     'email': 'jsmith&#64;example.com',
       *     'iat': 1353601026,
       *     'exp': 1353604926}
       *
       * SAML assertions are similarly specified, but with an identity provider
       * dependent structure.
       * </pre>
       *
       * <code>.google.protobuf.Struct claims = 4;</code>
       */
      public Builder setClaims(com.couchbase.client.core.deps.com.google.protobuf.Struct value) {
        if (claimsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          claims_ = value;
        } else {
          claimsBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000008;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Structured claims presented with the credential. JWTs include
       * `{key: value}` pairs for standard and private claims. The following
       * is a subset of the standard required and optional claims that would
       * typically be presented for a Google-based JWT:
       *
       *    {'iss': 'accounts.google.com',
       *     'sub': '113289723416554971153',
       *     'aud': ['123456789012', 'pubsub.googleapis.com'],
       *     'azp': '123456789012.apps.googleusercontent.com',
       *     'email': 'jsmith&#64;example.com',
       *     'iat': 1353601026,
       *     'exp': 1353604926}
       *
       * SAML assertions are similarly specified, but with an identity provider
       * dependent structure.
       * </pre>
       *
       * <code>.google.protobuf.Struct claims = 4;</code>
       */
      public Builder setClaims(com.couchbase.client.core.deps.com.google.protobuf.Struct.Builder builderForValue) {
        if (claimsBuilder_ == null) {
          claims_ = builderForValue.build();
        } else {
          claimsBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000008;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Structured claims presented with the credential. JWTs include
       * `{key: value}` pairs for standard and private claims. The following
       * is a subset of the standard required and optional claims that would
       * typically be presented for a Google-based JWT:
       *
       *    {'iss': 'accounts.google.com',
       *     'sub': '113289723416554971153',
       *     'aud': ['123456789012', 'pubsub.googleapis.com'],
       *     'azp': '123456789012.apps.googleusercontent.com',
       *     'email': 'jsmith&#64;example.com',
       *     'iat': 1353601026,
       *     'exp': 1353604926}
       *
       * SAML assertions are similarly specified, but with an identity provider
       * dependent structure.
       * </pre>
       *
       * <code>.google.protobuf.Struct claims = 4;</code>
       */
      public Builder mergeClaims(com.couchbase.client.core.deps.com.google.protobuf.Struct value) {
        if (claimsBuilder_ == null) {
          if (((bitField0_ & 0x00000008) != 0)
              && claims_ != null
              && claims_ != com.google.protobuf.Struct.getDefaultInstance()) {
            getClaimsBuilder().mergeFrom(value);
          } else {
            claims_ = value;
          }
        } else {
          claimsBuilder_.mergeFrom(value);
        }
        if (claims_ != null) {
          bitField0_ |= 0x00000008;
          onChanged();
        }
        return this;
      }
      /**
       *
       *
       * <pre>
       * Structured claims presented with the credential. JWTs include
       * `{key: value}` pairs for standard and private claims. The following
       * is a subset of the standard required and optional claims that would
       * typically be presented for a Google-based JWT:
       *
       *    {'iss': 'accounts.google.com',
       *     'sub': '113289723416554971153',
       *     'aud': ['123456789012', 'pubsub.googleapis.com'],
       *     'azp': '123456789012.apps.googleusercontent.com',
       *     'email': 'jsmith&#64;example.com',
       *     'iat': 1353601026,
       *     'exp': 1353604926}
       *
       * SAML assertions are similarly specified, but with an identity provider
       * dependent structure.
       * </pre>
       *
       * <code>.google.protobuf.Struct claims = 4;</code>
       */
      public Builder clearClaims() {
        bitField0_ = (bitField0_ & ~0x00000008);
        claims_ = null;
        if (claimsBuilder_ != null) {
          claimsBuilder_.dispose();
          claimsBuilder_ = null;
        }
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Structured claims presented with the credential. JWTs include
       * `{key: value}` pairs for standard and private claims. The following
       * is a subset of the standard required and optional claims that would
       * typically be presented for a Google-based JWT:
       *
       *    {'iss': 'accounts.google.com',
       *     'sub': '113289723416554971153',
       *     'aud': ['123456789012', 'pubsub.googleapis.com'],
       *     'azp': '123456789012.apps.googleusercontent.com',
       *     'email': 'jsmith&#64;example.com',
       *     'iat': 1353601026,
       *     'exp': 1353604926}
       *
       * SAML assertions are similarly specified, but with an identity provider
       * dependent structure.
       * </pre>
       *
       * <code>.google.protobuf.Struct claims = 4;</code>
       */
      public com.couchbase.client.core.deps.com.google.protobuf.Struct.Builder getClaimsBuilder() {
        bitField0_ |= 0x00000008;
        onChanged();
        return getClaimsFieldBuilder().getBuilder();
      }
      /**
       *
       *
       * <pre>
       * Structured claims presented with the credential. JWTs include
       * `{key: value}` pairs for standard and private claims. The following
       * is a subset of the standard required and optional claims that would
       * typically be presented for a Google-based JWT:
       *
       *    {'iss': 'accounts.google.com',
       *     'sub': '113289723416554971153',
       *     'aud': ['123456789012', 'pubsub.googleapis.com'],
       *     'azp': '123456789012.apps.googleusercontent.com',
       *     'email': 'jsmith&#64;example.com',
       *     'iat': 1353601026,
       *     'exp': 1353604926}
       *
       * SAML assertions are similarly specified, but with an identity provider
       * dependent structure.
       * </pre>
       *
       * <code>.google.protobuf.Struct claims = 4;</code>
       */
      public com.couchbase.client.core.deps.com.google.protobuf.StructOrBuilder getClaimsOrBuilder() {
        if (claimsBuilder_ != null) {
          return claimsBuilder_.getMessageOrBuilder();
        } else {
          return claims_ == null ? com.google.protobuf.Struct.getDefaultInstance() : claims_;
        }
      }
      /**
       *
       *
       * <pre>
       * Structured claims presented with the credential. JWTs include
       * `{key: value}` pairs for standard and private claims. The following
       * is a subset of the standard required and optional claims that would
       * typically be presented for a Google-based JWT:
       *
       *    {'iss': 'accounts.google.com',
       *     'sub': '113289723416554971153',
       *     'aud': ['123456789012', 'pubsub.googleapis.com'],
       *     'azp': '123456789012.apps.googleusercontent.com',
       *     'email': 'jsmith&#64;example.com',
       *     'iat': 1353601026,
       *     'exp': 1353604926}
       *
       * SAML assertions are similarly specified, but with an identity provider
       * dependent structure.
       * </pre>
       *
       * <code>.google.protobuf.Struct claims = 4;</code>
       */
      private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
              com.google.protobuf.Struct,
              com.google.protobuf.Struct.Builder,
              com.google.protobuf.StructOrBuilder>
          getClaimsFieldBuilder() {
        if (claimsBuilder_ == null) {
          claimsBuilder_ =
              new com.google.protobuf.SingleFieldBuilderV3<
                  com.google.protobuf.Struct,
                  com.google.protobuf.Struct.Builder,
                  com.google.protobuf.StructOrBuilder>(
                  getClaims(), getParentForChildren(), isClean());
          claims_ = null;
        }
        return claimsBuilder_;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.LazyStringArrayList accessLevels_ =
          com.google.protobuf.LazyStringArrayList.emptyList();

      private void ensureAccessLevelsIsMutable() {
        if (!accessLevels_.isModifiable()) {
          accessLevels_ = new com.google.protobuf.LazyStringArrayList(accessLevels_);
        }
        bitField0_ |= 0x00000010;
      }
      /**
       *
       *
       * <pre>
       * A list of access level resource names that allow resources to be
       * accessed by authenticated requester. It is part of Secure GCP processing
       * for the incoming request. An access level string has the format:
       * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
       *
       * Example:
       * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
       * </pre>
       *
       * <code>repeated string access_levels = 5;</code>
       *
       * @return A list containing the accessLevels.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ProtocolStringList getAccessLevelsList() {
        accessLevels_.makeImmutable();
        return accessLevels_;
      }
      /**
       *
       *
       * <pre>
       * A list of access level resource names that allow resources to be
       * accessed by authenticated requester. It is part of Secure GCP processing
       * for the incoming request. An access level string has the format:
       * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
       *
       * Example:
       * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
       * </pre>
       *
       * <code>repeated string access_levels = 5;</code>
       *
       * @return The count of accessLevels.
       */
      public int getAccessLevelsCount() {
        return accessLevels_.size();
      }
      /**
       *
       *
       * <pre>
       * A list of access level resource names that allow resources to be
       * accessed by authenticated requester. It is part of Secure GCP processing
       * for the incoming request. An access level string has the format:
       * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
       *
       * Example:
       * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
       * </pre>
       *
       * <code>repeated string access_levels = 5;</code>
       *
       * @param index The index of the element to return.
       * @return The accessLevels at the given index.
       */
      public java.lang.String getAccessLevels(int index) {
        return accessLevels_.get(index);
      }
      /**
       *
       *
       * <pre>
       * A list of access level resource names that allow resources to be
       * accessed by authenticated requester. It is part of Secure GCP processing
       * for the incoming request. An access level string has the format:
       * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
       *
       * Example:
       * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
       * </pre>
       *
       * <code>repeated string access_levels = 5;</code>
       *
       * @param index The index of the value to return.
       * @return The bytes of the accessLevels at the given index.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getAccessLevelsBytes(int index) {
        return accessLevels_.getByteString(index);
      }
      /**
       *
       *
       * <pre>
       * A list of access level resource names that allow resources to be
       * accessed by authenticated requester. It is part of Secure GCP processing
       * for the incoming request. An access level string has the format:
       * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
       *
       * Example:
       * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
       * </pre>
       *
       * <code>repeated string access_levels = 5;</code>
       *
       * @param index The index to set the value at.
       * @param value The accessLevels to set.
       * @return This builder for chaining.
       */
      public Builder setAccessLevels(int index, java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureAccessLevelsIsMutable();
        accessLevels_.set(index, value);
        bitField0_ |= 0x00000010;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * A list of access level resource names that allow resources to be
       * accessed by authenticated requester. It is part of Secure GCP processing
       * for the incoming request. An access level string has the format:
       * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
       *
       * Example:
       * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
       * </pre>
       *
       * <code>repeated string access_levels = 5;</code>
       *
       * @param value The accessLevels to add.
       * @return This builder for chaining.
       */
      public Builder addAccessLevels(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureAccessLevelsIsMutable();
        accessLevels_.add(value);
        bitField0_ |= 0x00000010;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * A list of access level resource names that allow resources to be
       * accessed by authenticated requester. It is part of Secure GCP processing
       * for the incoming request. An access level string has the format:
       * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
       *
       * Example:
       * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
       * </pre>
       *
       * <code>repeated string access_levels = 5;</code>
       *
       * @param values The accessLevels to add.
       * @return This builder for chaining.
       */
      public Builder addAllAccessLevels(java.lang.Iterable<java.lang.String> values) {
        ensureAccessLevelsIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(values, accessLevels_);
        bitField0_ |= 0x00000010;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * A list of access level resource names that allow resources to be
       * accessed by authenticated requester. It is part of Secure GCP processing
       * for the incoming request. An access level string has the format:
       * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
       *
       * Example:
       * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
       * </pre>
       *
       * <code>repeated string access_levels = 5;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearAccessLevels() {
        accessLevels_ = com.google.protobuf.LazyStringArrayList.emptyList();
        bitField0_ = (bitField0_ & ~0x00000010);
        ;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * A list of access level resource names that allow resources to be
       * accessed by authenticated requester. It is part of Secure GCP processing
       * for the incoming request. An access level string has the format:
       * "//{api_service_name}/accessPolicies/{policy_id}/accessLevels/{short_name}"
       *
       * Example:
       * "//accesscontextmanager.googleapis.com/accessPolicies/MY_POLICY_ID/accessLevels/MY_LEVEL"
       * </pre>
       *
       * <code>repeated string access_levels = 5;</code>
       *
       * @param value The bytes of the accessLevels to add.
       * @return This builder for chaining.
       */
      public Builder addAccessLevelsBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        ensureAccessLevelsIsMutable();
        accessLevels_.add(value);
        bitField0_ |= 0x00000010;
        onChanged();
        return this;
      }

      @java.lang.Override
      public final Builder setUnknownFields(
          final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }

      // @@protoc_insertion_point(builder_scope:google.rpc.context.AttributeContext.Auth)
    }

    // @@protoc_insertion_point(class_scope:google.rpc.context.AttributeContext.Auth)
    private static final com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth DEFAULT_INSTANCE;

    static {
      DEFAULT_INSTANCE = new com.google.rpc.context.AttributeContext.Auth();
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.couchbase.client.core.deps.com.google.protobuf.Parser<Auth> PARSER =
        new com.google.protobuf.AbstractParser<Auth>() {
          @java.lang.Override
          public Auth parsePartialFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws com.google.protobuf.InvalidProtocolBufferException {
            Builder builder = newBuilder();
            try {
              builder.mergeFrom(input, extensionRegistry);
            } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
              throw e.setUnfinishedMessage(builder.buildPartial());
            } catch (com.couchbase.client.core.deps.com.google.protobuf.UninitializedMessageException e) {
              throw e.asInvalidProtocolBufferException()
                  .setUnfinishedMessage(builder.buildPartial());
            } catch (java.io.IOException e) {
              throw new com.google.protobuf.InvalidProtocolBufferException(e)
                  .setUnfinishedMessage(builder.buildPartial());
            }
            return builder.buildPartial();
          }
        };

    public static com.couchbase.client.core.deps.com.google.protobuf.Parser<Auth> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Parser<Auth> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }
  }

  public interface RequestOrBuilder
      extends
      // @@protoc_insertion_point(interface_extends:google.rpc.context.AttributeContext.Request)
      com.google.protobuf.MessageOrBuilder {

    /**
     *
     *
     * <pre>
     * The unique ID for a request, which can be propagated to downstream
     * systems. The ID should have low probability of collision
     * within a single day for a specific service.
     * </pre>
     *
     * <code>string id = 1;</code>
     *
     * @return The id.
     */
    java.lang.String getId();
    /**
     *
     *
     * <pre>
     * The unique ID for a request, which can be propagated to downstream
     * systems. The ID should have low probability of collision
     * within a single day for a specific service.
     * </pre>
     *
     * <code>string id = 1;</code>
     *
     * @return The bytes for id.
     */
    com.google.protobuf.ByteString getIdBytes();

    /**
     *
     *
     * <pre>
     * The HTTP request method, such as `GET`, `POST`.
     * </pre>
     *
     * <code>string method = 2;</code>
     *
     * @return The method.
     */
    java.lang.String getMethod();
    /**
     *
     *
     * <pre>
     * The HTTP request method, such as `GET`, `POST`.
     * </pre>
     *
     * <code>string method = 2;</code>
     *
     * @return The bytes for method.
     */
    com.google.protobuf.ByteString getMethodBytes();

    /**
     *
     *
     * <pre>
     * The HTTP request headers. If multiple headers share the same key, they
     * must be merged according to the HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    int getHeadersCount();
    /**
     *
     *
     * <pre>
     * The HTTP request headers. If multiple headers share the same key, they
     * must be merged according to the HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    boolean containsHeaders(java.lang.String key);
    /** Use {@link #getHeadersMap()} instead. */
    @java.lang.Deprecated
    java.util.Map<java.lang.String, java.lang.String> getHeaders();
    /**
     *
     *
     * <pre>
     * The HTTP request headers. If multiple headers share the same key, they
     * must be merged according to the HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    java.util.Map<java.lang.String, java.lang.String> getHeadersMap();
    /**
     *
     *
     * <pre>
     * The HTTP request headers. If multiple headers share the same key, they
     * must be merged according to the HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    /* nullable */
    java.lang.String getHeadersOrDefault(
        java.lang.String key,
        /* nullable */
        java.lang.String defaultValue);
    /**
     *
     *
     * <pre>
     * The HTTP request headers. If multiple headers share the same key, they
     * must be merged according to the HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    java.lang.String getHeadersOrThrow(java.lang.String key);

    /**
     *
     *
     * <pre>
     * The HTTP URL path, excluding the query parameters.
     * </pre>
     *
     * <code>string path = 4;</code>
     *
     * @return The path.
     */
    java.lang.String getPath();
    /**
     *
     *
     * <pre>
     * The HTTP URL path, excluding the query parameters.
     * </pre>
     *
     * <code>string path = 4;</code>
     *
     * @return The bytes for path.
     */
    com.google.protobuf.ByteString getPathBytes();

    /**
     *
     *
     * <pre>
     * The HTTP request `Host` header value.
     * </pre>
     *
     * <code>string host = 5;</code>
     *
     * @return The host.
     */
    java.lang.String getHost();
    /**
     *
     *
     * <pre>
     * The HTTP request `Host` header value.
     * </pre>
     *
     * <code>string host = 5;</code>
     *
     * @return The bytes for host.
     */
    com.google.protobuf.ByteString getHostBytes();

    /**
     *
     *
     * <pre>
     * The HTTP URL scheme, such as `http` and `https`.
     * </pre>
     *
     * <code>string scheme = 6;</code>
     *
     * @return The scheme.
     */
    java.lang.String getScheme();
    /**
     *
     *
     * <pre>
     * The HTTP URL scheme, such as `http` and `https`.
     * </pre>
     *
     * <code>string scheme = 6;</code>
     *
     * @return The bytes for scheme.
     */
    com.google.protobuf.ByteString getSchemeBytes();

    /**
     *
     *
     * <pre>
     * The HTTP URL query in the format of `name1=value1&amp;name2=value2`, as it
     * appears in the first line of the HTTP request. No decoding is performed.
     * </pre>
     *
     * <code>string query = 7;</code>
     *
     * @return The query.
     */
    java.lang.String getQuery();
    /**
     *
     *
     * <pre>
     * The HTTP URL query in the format of `name1=value1&amp;name2=value2`, as it
     * appears in the first line of the HTTP request. No decoding is performed.
     * </pre>
     *
     * <code>string query = 7;</code>
     *
     * @return The bytes for query.
     */
    com.google.protobuf.ByteString getQueryBytes();

    /**
     *
     *
     * <pre>
     * The timestamp when the `destination` service receives the last byte of
     * the request.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 9;</code>
     *
     * @return Whether the time field is set.
     */
    boolean hasTime();
    /**
     *
     *
     * <pre>
     * The timestamp when the `destination` service receives the last byte of
     * the request.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 9;</code>
     *
     * @return The time.
     */
    com.google.protobuf.Timestamp getTime();
    /**
     *
     *
     * <pre>
     * The timestamp when the `destination` service receives the last byte of
     * the request.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 9;</code>
     */
    com.google.protobuf.TimestampOrBuilder getTimeOrBuilder();

    /**
     *
     *
     * <pre>
     * The HTTP request size in bytes. If unknown, it must be -1.
     * </pre>
     *
     * <code>int64 size = 10;</code>
     *
     * @return The size.
     */
    long getSize();

    /**
     *
     *
     * <pre>
     * The network protocol used with the request, such as "http/1.1",
     * "spdy/3", "h2", "h2c", "webrtc", "tcp", "udp", "quic". See
     * https://www.iana.org/assignments/tls-extensiontype-values/tls-extensiontype-values.xhtml#alpn-protocol-ids
     * for details.
     * </pre>
     *
     * <code>string protocol = 11;</code>
     *
     * @return The protocol.
     */
    java.lang.String getProtocol();
    /**
     *
     *
     * <pre>
     * The network protocol used with the request, such as "http/1.1",
     * "spdy/3", "h2", "h2c", "webrtc", "tcp", "udp", "quic". See
     * https://www.iana.org/assignments/tls-extensiontype-values/tls-extensiontype-values.xhtml#alpn-protocol-ids
     * for details.
     * </pre>
     *
     * <code>string protocol = 11;</code>
     *
     * @return The bytes for protocol.
     */
    com.google.protobuf.ByteString getProtocolBytes();

    /**
     *
     *
     * <pre>
     * A special parameter for request reason. It is used by security systems
     * to associate auditing information with a request.
     * </pre>
     *
     * <code>string reason = 12;</code>
     *
     * @return The reason.
     */
    java.lang.String getReason();
    /**
     *
     *
     * <pre>
     * A special parameter for request reason. It is used by security systems
     * to associate auditing information with a request.
     * </pre>
     *
     * <code>string reason = 12;</code>
     *
     * @return The bytes for reason.
     */
    com.google.protobuf.ByteString getReasonBytes();

    /**
     *
     *
     * <pre>
     * The request authentication. May be absent for unauthenticated requests.
     * Derived from the HTTP request `Authorization` header or equivalent.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Auth auth = 13;</code>
     *
     * @return Whether the auth field is set.
     */
    boolean hasAuth();
    /**
     *
     *
     * <pre>
     * The request authentication. May be absent for unauthenticated requests.
     * Derived from the HTTP request `Authorization` header or equivalent.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Auth auth = 13;</code>
     *
     * @return The auth.
     */
    com.google.rpc.context.AttributeContext.Auth getAuth();
    /**
     *
     *
     * <pre>
     * The request authentication. May be absent for unauthenticated requests.
     * Derived from the HTTP request `Authorization` header or equivalent.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Auth auth = 13;</code>
     */
    com.google.rpc.context.AttributeContext.AuthOrBuilder getAuthOrBuilder();
  }
  /**
   *
   *
   * <pre>
   * This message defines attributes for an HTTP request. If the actual
   * request is not an HTTP request, the runtime system should try to map
   * the actual request to an equivalent HTTP request.
   * </pre>
   *
   * Protobuf type {@code google.rpc.context.AttributeContext.Request}
   */
  public static final class Request extends com.google.protobuf.GeneratedMessageV3
      implements
      // @@protoc_insertion_point(message_implements:google.rpc.context.AttributeContext.Request)
      RequestOrBuilder {
    private static final long serialVersionUID = 0L;
    // Use Request.newBuilder() to construct.
    private Request(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }

    private Request() {
      id_ = "";
      method_ = "";
      path_ = "";
      host_ = "";
      scheme_ = "";
      query_ = "";
      protocol_ = "";
      reason_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
      return new Request();
    }

    public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return com.google.rpc.context.AttributeContextProto
          .internal_static_google_rpc_context_AttributeContext_Request_descriptor;
    }

    @SuppressWarnings({"rawtypes"})
    @java.lang.Override
    protected com.couchbase.client.core.deps.com.google.protobuf.MapFieldReflectionAccessor internalGetMapFieldReflection(
        int number) {
      switch (number) {
        case 3:
          return internalGetHeaders();
        default:
          throw new RuntimeException("Invalid map field number: " + number);
      }
    }

    @java.lang.Override
    protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.rpc.context.AttributeContextProto
          .internal_static_google_rpc_context_AttributeContext_Request_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.rpc.context.AttributeContext.Request.class,
              com.google.rpc.context.AttributeContext.Request.Builder.class);
    }

    private int bitField0_;
    public static final int ID_FIELD_NUMBER = 1;

    @SuppressWarnings("serial")
    private volatile java.lang.Object id_ = "";
    /**
     *
     *
     * <pre>
     * The unique ID for a request, which can be propagated to downstream
     * systems. The ID should have low probability of collision
     * within a single day for a specific service.
     * </pre>
     *
     * <code>string id = 1;</code>
     *
     * @return The id.
     */
    @java.lang.Override
    public java.lang.String getId() {
      java.lang.Object ref = id_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        id_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The unique ID for a request, which can be propagated to downstream
     * systems. The ID should have low probability of collision
     * within a single day for a specific service.
     * </pre>
     *
     * <code>string id = 1;</code>
     *
     * @return The bytes for id.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getIdBytes() {
      java.lang.Object ref = id_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        id_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int METHOD_FIELD_NUMBER = 2;

    @SuppressWarnings("serial")
    private volatile java.lang.Object method_ = "";
    /**
     *
     *
     * <pre>
     * The HTTP request method, such as `GET`, `POST`.
     * </pre>
     *
     * <code>string method = 2;</code>
     *
     * @return The method.
     */
    @java.lang.Override
    public java.lang.String getMethod() {
      java.lang.Object ref = method_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        method_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The HTTP request method, such as `GET`, `POST`.
     * </pre>
     *
     * <code>string method = 2;</code>
     *
     * @return The bytes for method.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getMethodBytes() {
      java.lang.Object ref = method_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        method_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int HEADERS_FIELD_NUMBER = 3;

    private static final class HeadersDefaultEntryHolder {
      static final com.couchbase.client.core.deps.com.google.protobuf.MapEntry<java.lang.String, java.lang.String> defaultEntry =
          com.google.protobuf.MapEntry.<java.lang.String, java.lang.String>newDefaultInstance(
              com.google.rpc.context.AttributeContextProto
                  .internal_static_google_rpc_context_AttributeContext_Request_HeadersEntry_descriptor,
              com.google.protobuf.WireFormat.FieldType.STRING,
              "",
              com.google.protobuf.WireFormat.FieldType.STRING,
              "");
    }

    @SuppressWarnings("serial")
    private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String> headers_;

    private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String> internalGetHeaders() {
      if (headers_ == null) {
        return com.google.protobuf.MapField.emptyMapField(HeadersDefaultEntryHolder.defaultEntry);
      }
      return headers_;
    }

    public int getHeadersCount() {
      return internalGetHeaders().getMap().size();
    }
    /**
     *
     *
     * <pre>
     * The HTTP request headers. If multiple headers share the same key, they
     * must be merged according to the HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    @java.lang.Override
    public boolean containsHeaders(java.lang.String key) {
      if (key == null) {
        throw new NullPointerException("map key");
      }
      return internalGetHeaders().getMap().containsKey(key);
    }
    /** Use {@link #getHeadersMap()} instead. */
    @java.lang.Override
    @java.lang.Deprecated
    public java.util.Map<java.lang.String, java.lang.String> getHeaders() {
      return getHeadersMap();
    }
    /**
     *
     *
     * <pre>
     * The HTTP request headers. If multiple headers share the same key, they
     * must be merged according to the HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    @java.lang.Override
    public java.util.Map<java.lang.String, java.lang.String> getHeadersMap() {
      return internalGetHeaders().getMap();
    }
    /**
     *
     *
     * <pre>
     * The HTTP request headers. If multiple headers share the same key, they
     * must be merged according to the HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    @java.lang.Override
    public /* nullable */ java.lang.String getHeadersOrDefault(
        java.lang.String key,
        /* nullable */
        java.lang.String defaultValue) {
      if (key == null) {
        throw new NullPointerException("map key");
      }
      java.util.Map<java.lang.String, java.lang.String> map = internalGetHeaders().getMap();
      return map.containsKey(key) ? map.get(key) : defaultValue;
    }
    /**
     *
     *
     * <pre>
     * The HTTP request headers. If multiple headers share the same key, they
     * must be merged according to the HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    @java.lang.Override
    public java.lang.String getHeadersOrThrow(java.lang.String key) {
      if (key == null) {
        throw new NullPointerException("map key");
      }
      java.util.Map<java.lang.String, java.lang.String> map = internalGetHeaders().getMap();
      if (!map.containsKey(key)) {
        throw new java.lang.IllegalArgumentException();
      }
      return map.get(key);
    }

    public static final int PATH_FIELD_NUMBER = 4;

    @SuppressWarnings("serial")
    private volatile java.lang.Object path_ = "";
    /**
     *
     *
     * <pre>
     * The HTTP URL path, excluding the query parameters.
     * </pre>
     *
     * <code>string path = 4;</code>
     *
     * @return The path.
     */
    @java.lang.Override
    public java.lang.String getPath() {
      java.lang.Object ref = path_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        path_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The HTTP URL path, excluding the query parameters.
     * </pre>
     *
     * <code>string path = 4;</code>
     *
     * @return The bytes for path.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getPathBytes() {
      java.lang.Object ref = path_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        path_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int HOST_FIELD_NUMBER = 5;

    @SuppressWarnings("serial")
    private volatile java.lang.Object host_ = "";
    /**
     *
     *
     * <pre>
     * The HTTP request `Host` header value.
     * </pre>
     *
     * <code>string host = 5;</code>
     *
     * @return The host.
     */
    @java.lang.Override
    public java.lang.String getHost() {
      java.lang.Object ref = host_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        host_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The HTTP request `Host` header value.
     * </pre>
     *
     * <code>string host = 5;</code>
     *
     * @return The bytes for host.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getHostBytes() {
      java.lang.Object ref = host_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        host_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int SCHEME_FIELD_NUMBER = 6;

    @SuppressWarnings("serial")
    private volatile java.lang.Object scheme_ = "";
    /**
     *
     *
     * <pre>
     * The HTTP URL scheme, such as `http` and `https`.
     * </pre>
     *
     * <code>string scheme = 6;</code>
     *
     * @return The scheme.
     */
    @java.lang.Override
    public java.lang.String getScheme() {
      java.lang.Object ref = scheme_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        scheme_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The HTTP URL scheme, such as `http` and `https`.
     * </pre>
     *
     * <code>string scheme = 6;</code>
     *
     * @return The bytes for scheme.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getSchemeBytes() {
      java.lang.Object ref = scheme_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        scheme_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int QUERY_FIELD_NUMBER = 7;

    @SuppressWarnings("serial")
    private volatile java.lang.Object query_ = "";
    /**
     *
     *
     * <pre>
     * The HTTP URL query in the format of `name1=value1&amp;name2=value2`, as it
     * appears in the first line of the HTTP request. No decoding is performed.
     * </pre>
     *
     * <code>string query = 7;</code>
     *
     * @return The query.
     */
    @java.lang.Override
    public java.lang.String getQuery() {
      java.lang.Object ref = query_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        query_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The HTTP URL query in the format of `name1=value1&amp;name2=value2`, as it
     * appears in the first line of the HTTP request. No decoding is performed.
     * </pre>
     *
     * <code>string query = 7;</code>
     *
     * @return The bytes for query.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getQueryBytes() {
      java.lang.Object ref = query_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        query_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int TIME_FIELD_NUMBER = 9;
    private com.couchbase.client.core.deps.com.google.protobuf.Timestamp time_;
    /**
     *
     *
     * <pre>
     * The timestamp when the `destination` service receives the last byte of
     * the request.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 9;</code>
     *
     * @return Whether the time field is set.
     */
    @java.lang.Override
    public boolean hasTime() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     *
     *
     * <pre>
     * The timestamp when the `destination` service receives the last byte of
     * the request.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 9;</code>
     *
     * @return The time.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Timestamp getTime() {
      return time_ == null ? com.google.protobuf.Timestamp.getDefaultInstance() : time_;
    }
    /**
     *
     *
     * <pre>
     * The timestamp when the `destination` service receives the last byte of
     * the request.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 9;</code>
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.TimestampOrBuilder getTimeOrBuilder() {
      return time_ == null ? com.google.protobuf.Timestamp.getDefaultInstance() : time_;
    }

    public static final int SIZE_FIELD_NUMBER = 10;
    private long size_ = 0L;
    /**
     *
     *
     * <pre>
     * The HTTP request size in bytes. If unknown, it must be -1.
     * </pre>
     *
     * <code>int64 size = 10;</code>
     *
     * @return The size.
     */
    @java.lang.Override
    public long getSize() {
      return size_;
    }

    public static final int PROTOCOL_FIELD_NUMBER = 11;

    @SuppressWarnings("serial")
    private volatile java.lang.Object protocol_ = "";
    /**
     *
     *
     * <pre>
     * The network protocol used with the request, such as "http/1.1",
     * "spdy/3", "h2", "h2c", "webrtc", "tcp", "udp", "quic". See
     * https://www.iana.org/assignments/tls-extensiontype-values/tls-extensiontype-values.xhtml#alpn-protocol-ids
     * for details.
     * </pre>
     *
     * <code>string protocol = 11;</code>
     *
     * @return The protocol.
     */
    @java.lang.Override
    public java.lang.String getProtocol() {
      java.lang.Object ref = protocol_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        protocol_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The network protocol used with the request, such as "http/1.1",
     * "spdy/3", "h2", "h2c", "webrtc", "tcp", "udp", "quic". See
     * https://www.iana.org/assignments/tls-extensiontype-values/tls-extensiontype-values.xhtml#alpn-protocol-ids
     * for details.
     * </pre>
     *
     * <code>string protocol = 11;</code>
     *
     * @return The bytes for protocol.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getProtocolBytes() {
      java.lang.Object ref = protocol_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        protocol_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int REASON_FIELD_NUMBER = 12;

    @SuppressWarnings("serial")
    private volatile java.lang.Object reason_ = "";
    /**
     *
     *
     * <pre>
     * A special parameter for request reason. It is used by security systems
     * to associate auditing information with a request.
     * </pre>
     *
     * <code>string reason = 12;</code>
     *
     * @return The reason.
     */
    @java.lang.Override
    public java.lang.String getReason() {
      java.lang.Object ref = reason_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        reason_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * A special parameter for request reason. It is used by security systems
     * to associate auditing information with a request.
     * </pre>
     *
     * <code>string reason = 12;</code>
     *
     * @return The bytes for reason.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getReasonBytes() {
      java.lang.Object ref = reason_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        reason_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int AUTH_FIELD_NUMBER = 13;
    private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth auth_;
    /**
     *
     *
     * <pre>
     * The request authentication. May be absent for unauthenticated requests.
     * Derived from the HTTP request `Authorization` header or equivalent.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Auth auth = 13;</code>
     *
     * @return Whether the auth field is set.
     */
    @java.lang.Override
    public boolean hasAuth() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     *
     *
     * <pre>
     * The request authentication. May be absent for unauthenticated requests.
     * Derived from the HTTP request `Authorization` header or equivalent.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Auth auth = 13;</code>
     *
     * @return The auth.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth getAuth() {
      return auth_ == null
          ? com.google.rpc.context.AttributeContext.Auth.getDefaultInstance()
          : auth_;
    }
    /**
     *
     *
     * <pre>
     * The request authentication. May be absent for unauthenticated requests.
     * Derived from the HTTP request `Authorization` header or equivalent.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Auth auth = 13;</code>
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.AuthOrBuilder getAuthOrBuilder() {
      return auth_ == null
          ? com.google.rpc.context.AttributeContext.Auth.getDefaultInstance()
          : auth_;
    }

    private byte memoizedIsInitialized = -1;

    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.couchbase.client.core.deps.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(id_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 1, id_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(method_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 2, method_);
      }
      com.google.protobuf.GeneratedMessageV3.serializeStringMapTo(
          output, internalGetHeaders(), HeadersDefaultEntryHolder.defaultEntry, 3);
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(path_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 4, path_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(host_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 5, host_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(scheme_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 6, scheme_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(query_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 7, query_);
      }
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeMessage(9, getTime());
      }
      if (size_ != 0L) {
        output.writeInt64(10, size_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(protocol_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 11, protocol_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(reason_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 12, reason_);
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeMessage(13, getAuth());
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(id_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, id_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(method_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, method_);
      }
      for (java.util.Map.Entry<java.lang.String, java.lang.String> entry :
          internalGetHeaders().getMap().entrySet()) {
        com.google.protobuf.MapEntry<java.lang.String, java.lang.String> headers__ =
            HeadersDefaultEntryHolder.defaultEntry
                .newBuilderForType()
                .setKey(entry.getKey())
                .setValue(entry.getValue())
                .build();
        size += com.google.protobuf.CodedOutputStream.computeMessageSize(3, headers__);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(path_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(4, path_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(host_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(5, host_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(scheme_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(6, scheme_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(query_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(7, query_);
      }
      if (((bitField0_ & 0x00000001) != 0)) {
        size += com.google.protobuf.CodedOutputStream.computeMessageSize(9, getTime());
      }
      if (size_ != 0L) {
        size += com.google.protobuf.CodedOutputStream.computeInt64Size(10, size_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(protocol_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(11, protocol_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(reason_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(12, reason_);
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += com.google.protobuf.CodedOutputStream.computeMessageSize(13, getAuth());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
        return true;
      }
      if (!(obj instanceof com.google.rpc.context.AttributeContext.Request)) {
        return super.equals(obj);
      }
      com.google.rpc.context.AttributeContext.Request other =
          (com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request) obj;

      if (!getId().equals(other.getId())) return false;
      if (!getMethod().equals(other.getMethod())) return false;
      if (!internalGetHeaders().equals(other.internalGetHeaders())) return false;
      if (!getPath().equals(other.getPath())) return false;
      if (!getHost().equals(other.getHost())) return false;
      if (!getScheme().equals(other.getScheme())) return false;
      if (!getQuery().equals(other.getQuery())) return false;
      if (hasTime() != other.hasTime()) return false;
      if (hasTime()) {
        if (!getTime().equals(other.getTime())) return false;
      }
      if (getSize() != other.getSize()) return false;
      if (!getProtocol().equals(other.getProtocol())) return false;
      if (!getReason().equals(other.getReason())) return false;
      if (hasAuth() != other.hasAuth()) return false;
      if (hasAuth()) {
        if (!getAuth().equals(other.getAuth())) return false;
      }
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + ID_FIELD_NUMBER;
      hash = (53 * hash) + getId().hashCode();
      hash = (37 * hash) + METHOD_FIELD_NUMBER;
      hash = (53 * hash) + getMethod().hashCode();
      if (!internalGetHeaders().getMap().isEmpty()) {
        hash = (37 * hash) + HEADERS_FIELD_NUMBER;
        hash = (53 * hash) + internalGetHeaders().hashCode();
      }
      hash = (37 * hash) + PATH_FIELD_NUMBER;
      hash = (53 * hash) + getPath().hashCode();
      hash = (37 * hash) + HOST_FIELD_NUMBER;
      hash = (53 * hash) + getHost().hashCode();
      hash = (37 * hash) + SCHEME_FIELD_NUMBER;
      hash = (53 * hash) + getScheme().hashCode();
      hash = (37 * hash) + QUERY_FIELD_NUMBER;
      hash = (53 * hash) + getQuery().hashCode();
      if (hasTime()) {
        hash = (37 * hash) + TIME_FIELD_NUMBER;
        hash = (53 * hash) + getTime().hashCode();
      }
      hash = (37 * hash) + SIZE_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(getSize());
      hash = (37 * hash) + PROTOCOL_FIELD_NUMBER;
      hash = (53 * hash) + getProtocol().hashCode();
      hash = (37 * hash) + REASON_FIELD_NUMBER;
      hash = (53 * hash) + getReason().hashCode();
      if (hasAuth()) {
        hash = (37 * hash) + AUTH_FIELD_NUMBER;
        hash = (53 * hash) + getAuth().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request parseFrom(
        java.nio.ByteBuffer data) throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request parseFrom(
        java.nio.ByteBuffer data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request parseFrom(
        byte[] data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request parseFrom(
        java.io.InputStream input) throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request parseFrom(
        java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request parseDelimitedFrom(
        java.io.InputStream input) throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request parseDelimitedFrom(
        java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request parseFrom(
        com.google.protobuf.CodedInputStream input) throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() {
      return newBuilder();
    }

    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }

    public static Builder newBuilder(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }

    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     *
     *
     * <pre>
     * This message defines attributes for an HTTP request. If the actual
     * request is not an HTTP request, the runtime system should try to map
     * the actual request to an equivalent HTTP request.
     * </pre>
     *
     * Protobuf type {@code google.rpc.context.AttributeContext.Request}
     */
    public static final class Builder
        extends com.google.protobuf.GeneratedMessageV3.Builder<Builder>
        implements
        // @@protoc_insertion_point(builder_implements:google.rpc.context.AttributeContext.Request)
        com.google.rpc.context.AttributeContext.RequestOrBuilder {
      public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Request_descriptor;
      }

      @SuppressWarnings({"rawtypes"})
      protected com.couchbase.client.core.deps.com.google.protobuf.MapFieldReflectionAccessor internalGetMapFieldReflection(
          int number) {
        switch (number) {
          case 3:
            return internalGetHeaders();
          default:
            throw new RuntimeException("Invalid map field number: " + number);
        }
      }

      @SuppressWarnings({"rawtypes"})
      protected com.couchbase.client.core.deps.com.google.protobuf.MapFieldReflectionAccessor internalGetMutableMapFieldReflection(
          int number) {
        switch (number) {
          case 3:
            return internalGetMutableHeaders();
          default:
            throw new RuntimeException("Invalid map field number: " + number);
        }
      }

      @java.lang.Override
      protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Request_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.rpc.context.AttributeContext.Request.class,
                com.google.rpc.context.AttributeContext.Request.Builder.class);
      }

      // Construct using com.google.rpc.context.AttributeContext.Request.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }

      private void maybeForceBuilderInitialization() {
        if (com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {
          getTimeFieldBuilder();
          getAuthFieldBuilder();
        }
      }

      @java.lang.Override
      public Builder clear() {
        super.clear();
        bitField0_ = 0;
        id_ = "";
        method_ = "";
        internalGetMutableHeaders().clear();
        path_ = "";
        host_ = "";
        scheme_ = "";
        query_ = "";
        time_ = null;
        if (timeBuilder_ != null) {
          timeBuilder_.dispose();
          timeBuilder_ = null;
        }
        size_ = 0L;
        protocol_ = "";
        reason_ = "";
        auth_ = null;
        if (authBuilder_ != null) {
          authBuilder_.dispose();
          authBuilder_ = null;
        }
        return this;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Request_descriptor;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request getDefaultInstanceForType() {
        return com.google.rpc.context.AttributeContext.Request.getDefaultInstance();
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request build() {
        com.google.rpc.context.AttributeContext.Request result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request buildPartial() {
        com.google.rpc.context.AttributeContext.Request result =
            new com.google.rpc.context.AttributeContext.Request(this);
        if (bitField0_ != 0) {
          buildPartial0(result);
        }
        onBuilt();
        return result;
      }

      private void buildPartial0(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request result) {
        int from_bitField0_ = bitField0_;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          result.id_ = id_;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          result.method_ = method_;
        }
        if (((from_bitField0_ & 0x00000004) != 0)) {
          result.headers_ = internalGetHeaders();
          result.headers_.makeImmutable();
        }
        if (((from_bitField0_ & 0x00000008) != 0)) {
          result.path_ = path_;
        }
        if (((from_bitField0_ & 0x00000010) != 0)) {
          result.host_ = host_;
        }
        if (((from_bitField0_ & 0x00000020) != 0)) {
          result.scheme_ = scheme_;
        }
        if (((from_bitField0_ & 0x00000040) != 0)) {
          result.query_ = query_;
        }
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000080) != 0)) {
          result.time_ = timeBuilder_ == null ? time_ : timeBuilder_.build();
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000100) != 0)) {
          result.size_ = size_;
        }
        if (((from_bitField0_ & 0x00000200) != 0)) {
          result.protocol_ = protocol_;
        }
        if (((from_bitField0_ & 0x00000400) != 0)) {
          result.reason_ = reason_;
        }
        if (((from_bitField0_ & 0x00000800) != 0)) {
          result.auth_ = authBuilder_ == null ? auth_ : authBuilder_.build();
          to_bitField0_ |= 0x00000002;
        }
        result.bitField0_ |= to_bitField0_;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }

      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.setField(field, value);
      }

      @java.lang.Override
      public Builder clearField(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }

      @java.lang.Override
      public Builder clearOneof(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }

      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index,
          java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }

      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }

      @java.lang.Override
      public Builder mergeFrom(com.couchbase.client.core.deps.com.google.protobuf.Message other) {
        if (other instanceof com.google.rpc.context.AttributeContext.Request) {
          return mergeFrom((com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request) other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request other) {
        if (other == com.google.rpc.context.AttributeContext.Request.getDefaultInstance())
          return this;
        if (!other.getId().isEmpty()) {
          id_ = other.id_;
          bitField0_ |= 0x00000001;
          onChanged();
        }
        if (!other.getMethod().isEmpty()) {
          method_ = other.method_;
          bitField0_ |= 0x00000002;
          onChanged();
        }
        internalGetMutableHeaders().mergeFrom(other.internalGetHeaders());
        bitField0_ |= 0x00000004;
        if (!other.getPath().isEmpty()) {
          path_ = other.path_;
          bitField0_ |= 0x00000008;
          onChanged();
        }
        if (!other.getHost().isEmpty()) {
          host_ = other.host_;
          bitField0_ |= 0x00000010;
          onChanged();
        }
        if (!other.getScheme().isEmpty()) {
          scheme_ = other.scheme_;
          bitField0_ |= 0x00000020;
          onChanged();
        }
        if (!other.getQuery().isEmpty()) {
          query_ = other.query_;
          bitField0_ |= 0x00000040;
          onChanged();
        }
        if (other.hasTime()) {
          mergeTime(other.getTime());
        }
        if (other.getSize() != 0L) {
          setSize(other.getSize());
        }
        if (!other.getProtocol().isEmpty()) {
          protocol_ = other.protocol_;
          bitField0_ |= 0x00000200;
          onChanged();
        }
        if (!other.getReason().isEmpty()) {
          reason_ = other.reason_;
          bitField0_ |= 0x00000400;
          onChanged();
        }
        if (other.hasAuth()) {
          mergeAuth(other.getAuth());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 10:
                {
                  id_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000001;
                  break;
                } // case 10
              case 18:
                {
                  method_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000002;
                  break;
                } // case 18
              case 26:
                {
                  com.google.protobuf.MapEntry<java.lang.String, java.lang.String> headers__ =
                      input.readMessage(
                          HeadersDefaultEntryHolder.defaultEntry.getParserForType(),
                          extensionRegistry);
                  internalGetMutableHeaders()
                      .getMutableMap()
                      .put(headers__.getKey(), headers__.getValue());
                  bitField0_ |= 0x00000004;
                  break;
                } // case 26
              case 34:
                {
                  path_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000008;
                  break;
                } // case 34
              case 42:
                {
                  host_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000010;
                  break;
                } // case 42
              case 50:
                {
                  scheme_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000020;
                  break;
                } // case 50
              case 58:
                {
                  query_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000040;
                  break;
                } // case 58
              case 74:
                {
                  input.readMessage(getTimeFieldBuilder().getBuilder(), extensionRegistry);
                  bitField0_ |= 0x00000080;
                  break;
                } // case 74
              case 80:
                {
                  size_ = input.readInt64();
                  bitField0_ |= 0x00000100;
                  break;
                } // case 80
              case 90:
                {
                  protocol_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000200;
                  break;
                } // case 90
              case 98:
                {
                  reason_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000400;
                  break;
                } // case 98
              case 106:
                {
                  input.readMessage(getAuthFieldBuilder().getBuilder(), extensionRegistry);
                  bitField0_ |= 0x00000800;
                  break;
                } // case 106
              default:
                {
                  if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                    done = true; // was an endgroup tag
                  }
                  break;
                } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private int bitField0_;

      private java.lang.Object id_ = "";
      /**
       *
       *
       * <pre>
       * The unique ID for a request, which can be propagated to downstream
       * systems. The ID should have low probability of collision
       * within a single day for a specific service.
       * </pre>
       *
       * <code>string id = 1;</code>
       *
       * @return The id.
       */
      public java.lang.String getId() {
        java.lang.Object ref = id_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          id_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The unique ID for a request, which can be propagated to downstream
       * systems. The ID should have low probability of collision
       * within a single day for a specific service.
       * </pre>
       *
       * <code>string id = 1;</code>
       *
       * @return The bytes for id.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getIdBytes() {
        java.lang.Object ref = id_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          id_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The unique ID for a request, which can be propagated to downstream
       * systems. The ID should have low probability of collision
       * within a single day for a specific service.
       * </pre>
       *
       * <code>string id = 1;</code>
       *
       * @param value The id to set.
       * @return This builder for chaining.
       */
      public Builder setId(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        id_ = value;
        bitField0_ |= 0x00000001;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The unique ID for a request, which can be propagated to downstream
       * systems. The ID should have low probability of collision
       * within a single day for a specific service.
       * </pre>
       *
       * <code>string id = 1;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearId() {
        id_ = getDefaultInstance().getId();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The unique ID for a request, which can be propagated to downstream
       * systems. The ID should have low probability of collision
       * within a single day for a specific service.
       * </pre>
       *
       * <code>string id = 1;</code>
       *
       * @param value The bytes for id to set.
       * @return This builder for chaining.
       */
      public Builder setIdBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        id_ = value;
        bitField0_ |= 0x00000001;
        onChanged();
        return this;
      }

      private java.lang.Object method_ = "";
      /**
       *
       *
       * <pre>
       * The HTTP request method, such as `GET`, `POST`.
       * </pre>
       *
       * <code>string method = 2;</code>
       *
       * @return The method.
       */
      public java.lang.String getMethod() {
        java.lang.Object ref = method_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          method_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The HTTP request method, such as `GET`, `POST`.
       * </pre>
       *
       * <code>string method = 2;</code>
       *
       * @return The bytes for method.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getMethodBytes() {
        java.lang.Object ref = method_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          method_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The HTTP request method, such as `GET`, `POST`.
       * </pre>
       *
       * <code>string method = 2;</code>
       *
       * @param value The method to set.
       * @return This builder for chaining.
       */
      public Builder setMethod(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        method_ = value;
        bitField0_ |= 0x00000002;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP request method, such as `GET`, `POST`.
       * </pre>
       *
       * <code>string method = 2;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearMethod() {
        method_ = getDefaultInstance().getMethod();
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP request method, such as `GET`, `POST`.
       * </pre>
       *
       * <code>string method = 2;</code>
       *
       * @param value The bytes for method to set.
       * @return This builder for chaining.
       */
      public Builder setMethodBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        method_ = value;
        bitField0_ |= 0x00000002;
        onChanged();
        return this;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String> headers_;

      private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String>
          internalGetHeaders() {
        if (headers_ == null) {
          return com.google.protobuf.MapField.emptyMapField(HeadersDefaultEntryHolder.defaultEntry);
        }
        return headers_;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String>
          internalGetMutableHeaders() {
        if (headers_ == null) {
          headers_ =
              com.google.protobuf.MapField.newMapField(HeadersDefaultEntryHolder.defaultEntry);
        }
        if (!headers_.isMutable()) {
          headers_ = headers_.copy();
        }
        bitField0_ |= 0x00000004;
        onChanged();
        return headers_;
      }

      public int getHeadersCount() {
        return internalGetHeaders().getMap().size();
      }
      /**
       *
       *
       * <pre>
       * The HTTP request headers. If multiple headers share the same key, they
       * must be merged according to the HTTP spec. All header keys must be
       * lowercased, because HTTP header keys are case-insensitive.
       * </pre>
       *
       * <code>map&lt;string, string&gt; headers = 3;</code>
       */
      @java.lang.Override
      public boolean containsHeaders(java.lang.String key) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        return internalGetHeaders().getMap().containsKey(key);
      }
      /** Use {@link #getHeadersMap()} instead. */
      @java.lang.Override
      @java.lang.Deprecated
      public java.util.Map<java.lang.String, java.lang.String> getHeaders() {
        return getHeadersMap();
      }
      /**
       *
       *
       * <pre>
       * The HTTP request headers. If multiple headers share the same key, they
       * must be merged according to the HTTP spec. All header keys must be
       * lowercased, because HTTP header keys are case-insensitive.
       * </pre>
       *
       * <code>map&lt;string, string&gt; headers = 3;</code>
       */
      @java.lang.Override
      public java.util.Map<java.lang.String, java.lang.String> getHeadersMap() {
        return internalGetHeaders().getMap();
      }
      /**
       *
       *
       * <pre>
       * The HTTP request headers. If multiple headers share the same key, they
       * must be merged according to the HTTP spec. All header keys must be
       * lowercased, because HTTP header keys are case-insensitive.
       * </pre>
       *
       * <code>map&lt;string, string&gt; headers = 3;</code>
       */
      @java.lang.Override
      public /* nullable */ java.lang.String getHeadersOrDefault(
          java.lang.String key,
          /* nullable */
          java.lang.String defaultValue) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        java.util.Map<java.lang.String, java.lang.String> map = internalGetHeaders().getMap();
        return map.containsKey(key) ? map.get(key) : defaultValue;
      }
      /**
       *
       *
       * <pre>
       * The HTTP request headers. If multiple headers share the same key, they
       * must be merged according to the HTTP spec. All header keys must be
       * lowercased, because HTTP header keys are case-insensitive.
       * </pre>
       *
       * <code>map&lt;string, string&gt; headers = 3;</code>
       */
      @java.lang.Override
      public java.lang.String getHeadersOrThrow(java.lang.String key) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        java.util.Map<java.lang.String, java.lang.String> map = internalGetHeaders().getMap();
        if (!map.containsKey(key)) {
          throw new java.lang.IllegalArgumentException();
        }
        return map.get(key);
      }

      public Builder clearHeaders() {
        bitField0_ = (bitField0_ & ~0x00000004);
        internalGetMutableHeaders().getMutableMap().clear();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP request headers. If multiple headers share the same key, they
       * must be merged according to the HTTP spec. All header keys must be
       * lowercased, because HTTP header keys are case-insensitive.
       * </pre>
       *
       * <code>map&lt;string, string&gt; headers = 3;</code>
       */
      public Builder removeHeaders(java.lang.String key) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        internalGetMutableHeaders().getMutableMap().remove(key);
        return this;
      }
      /** Use alternate mutation accessors instead. */
      @java.lang.Deprecated
      public java.util.Map<java.lang.String, java.lang.String> getMutableHeaders() {
        bitField0_ |= 0x00000004;
        return internalGetMutableHeaders().getMutableMap();
      }
      /**
       *
       *
       * <pre>
       * The HTTP request headers. If multiple headers share the same key, they
       * must be merged according to the HTTP spec. All header keys must be
       * lowercased, because HTTP header keys are case-insensitive.
       * </pre>
       *
       * <code>map&lt;string, string&gt; headers = 3;</code>
       */
      public Builder putHeaders(java.lang.String key, java.lang.String value) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        if (value == null) {
          throw new NullPointerException("map value");
        }
        internalGetMutableHeaders().getMutableMap().put(key, value);
        bitField0_ |= 0x00000004;
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP request headers. If multiple headers share the same key, they
       * must be merged according to the HTTP spec. All header keys must be
       * lowercased, because HTTP header keys are case-insensitive.
       * </pre>
       *
       * <code>map&lt;string, string&gt; headers = 3;</code>
       */
      public Builder putAllHeaders(java.util.Map<java.lang.String, java.lang.String> values) {
        internalGetMutableHeaders().getMutableMap().putAll(values);
        bitField0_ |= 0x00000004;
        return this;
      }

      private java.lang.Object path_ = "";
      /**
       *
       *
       * <pre>
       * The HTTP URL path, excluding the query parameters.
       * </pre>
       *
       * <code>string path = 4;</code>
       *
       * @return The path.
       */
      public java.lang.String getPath() {
        java.lang.Object ref = path_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          path_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The HTTP URL path, excluding the query parameters.
       * </pre>
       *
       * <code>string path = 4;</code>
       *
       * @return The bytes for path.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getPathBytes() {
        java.lang.Object ref = path_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          path_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The HTTP URL path, excluding the query parameters.
       * </pre>
       *
       * <code>string path = 4;</code>
       *
       * @param value The path to set.
       * @return This builder for chaining.
       */
      public Builder setPath(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        path_ = value;
        bitField0_ |= 0x00000008;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP URL path, excluding the query parameters.
       * </pre>
       *
       * <code>string path = 4;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearPath() {
        path_ = getDefaultInstance().getPath();
        bitField0_ = (bitField0_ & ~0x00000008);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP URL path, excluding the query parameters.
       * </pre>
       *
       * <code>string path = 4;</code>
       *
       * @param value The bytes for path to set.
       * @return This builder for chaining.
       */
      public Builder setPathBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        path_ = value;
        bitField0_ |= 0x00000008;
        onChanged();
        return this;
      }

      private java.lang.Object host_ = "";
      /**
       *
       *
       * <pre>
       * The HTTP request `Host` header value.
       * </pre>
       *
       * <code>string host = 5;</code>
       *
       * @return The host.
       */
      public java.lang.String getHost() {
        java.lang.Object ref = host_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          host_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The HTTP request `Host` header value.
       * </pre>
       *
       * <code>string host = 5;</code>
       *
       * @return The bytes for host.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getHostBytes() {
        java.lang.Object ref = host_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          host_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The HTTP request `Host` header value.
       * </pre>
       *
       * <code>string host = 5;</code>
       *
       * @param value The host to set.
       * @return This builder for chaining.
       */
      public Builder setHost(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        host_ = value;
        bitField0_ |= 0x00000010;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP request `Host` header value.
       * </pre>
       *
       * <code>string host = 5;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearHost() {
        host_ = getDefaultInstance().getHost();
        bitField0_ = (bitField0_ & ~0x00000010);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP request `Host` header value.
       * </pre>
       *
       * <code>string host = 5;</code>
       *
       * @param value The bytes for host to set.
       * @return This builder for chaining.
       */
      public Builder setHostBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        host_ = value;
        bitField0_ |= 0x00000010;
        onChanged();
        return this;
      }

      private java.lang.Object scheme_ = "";
      /**
       *
       *
       * <pre>
       * The HTTP URL scheme, such as `http` and `https`.
       * </pre>
       *
       * <code>string scheme = 6;</code>
       *
       * @return The scheme.
       */
      public java.lang.String getScheme() {
        java.lang.Object ref = scheme_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          scheme_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The HTTP URL scheme, such as `http` and `https`.
       * </pre>
       *
       * <code>string scheme = 6;</code>
       *
       * @return The bytes for scheme.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getSchemeBytes() {
        java.lang.Object ref = scheme_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          scheme_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The HTTP URL scheme, such as `http` and `https`.
       * </pre>
       *
       * <code>string scheme = 6;</code>
       *
       * @param value The scheme to set.
       * @return This builder for chaining.
       */
      public Builder setScheme(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        scheme_ = value;
        bitField0_ |= 0x00000020;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP URL scheme, such as `http` and `https`.
       * </pre>
       *
       * <code>string scheme = 6;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearScheme() {
        scheme_ = getDefaultInstance().getScheme();
        bitField0_ = (bitField0_ & ~0x00000020);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP URL scheme, such as `http` and `https`.
       * </pre>
       *
       * <code>string scheme = 6;</code>
       *
       * @param value The bytes for scheme to set.
       * @return This builder for chaining.
       */
      public Builder setSchemeBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        scheme_ = value;
        bitField0_ |= 0x00000020;
        onChanged();
        return this;
      }

      private java.lang.Object query_ = "";
      /**
       *
       *
       * <pre>
       * The HTTP URL query in the format of `name1=value1&amp;name2=value2`, as it
       * appears in the first line of the HTTP request. No decoding is performed.
       * </pre>
       *
       * <code>string query = 7;</code>
       *
       * @return The query.
       */
      public java.lang.String getQuery() {
        java.lang.Object ref = query_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          query_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The HTTP URL query in the format of `name1=value1&amp;name2=value2`, as it
       * appears in the first line of the HTTP request. No decoding is performed.
       * </pre>
       *
       * <code>string query = 7;</code>
       *
       * @return The bytes for query.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getQueryBytes() {
        java.lang.Object ref = query_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          query_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The HTTP URL query in the format of `name1=value1&amp;name2=value2`, as it
       * appears in the first line of the HTTP request. No decoding is performed.
       * </pre>
       *
       * <code>string query = 7;</code>
       *
       * @param value The query to set.
       * @return This builder for chaining.
       */
      public Builder setQuery(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        query_ = value;
        bitField0_ |= 0x00000040;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP URL query in the format of `name1=value1&amp;name2=value2`, as it
       * appears in the first line of the HTTP request. No decoding is performed.
       * </pre>
       *
       * <code>string query = 7;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearQuery() {
        query_ = getDefaultInstance().getQuery();
        bitField0_ = (bitField0_ & ~0x00000040);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP URL query in the format of `name1=value1&amp;name2=value2`, as it
       * appears in the first line of the HTTP request. No decoding is performed.
       * </pre>
       *
       * <code>string query = 7;</code>
       *
       * @param value The bytes for query to set.
       * @return This builder for chaining.
       */
      public Builder setQueryBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        query_ = value;
        bitField0_ |= 0x00000040;
        onChanged();
        return this;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.Timestamp time_;
      private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
              com.google.protobuf.Timestamp,
              com.google.protobuf.Timestamp.Builder,
              com.google.protobuf.TimestampOrBuilder>
          timeBuilder_;
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service receives the last byte of
       * the request.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 9;</code>
       *
       * @return Whether the time field is set.
       */
      public boolean hasTime() {
        return ((bitField0_ & 0x00000080) != 0);
      }
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service receives the last byte of
       * the request.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 9;</code>
       *
       * @return The time.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.Timestamp getTime() {
        if (timeBuilder_ == null) {
          return time_ == null ? com.google.protobuf.Timestamp.getDefaultInstance() : time_;
        } else {
          return timeBuilder_.getMessage();
        }
      }
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service receives the last byte of
       * the request.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 9;</code>
       */
      public Builder setTime(com.couchbase.client.core.deps.com.google.protobuf.Timestamp value) {
        if (timeBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          time_ = value;
        } else {
          timeBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000080;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service receives the last byte of
       * the request.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 9;</code>
       */
      public Builder setTime(com.couchbase.client.core.deps.com.google.protobuf.Timestamp.Builder builderForValue) {
        if (timeBuilder_ == null) {
          time_ = builderForValue.build();
        } else {
          timeBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000080;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service receives the last byte of
       * the request.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 9;</code>
       */
      public Builder mergeTime(com.couchbase.client.core.deps.com.google.protobuf.Timestamp value) {
        if (timeBuilder_ == null) {
          if (((bitField0_ & 0x00000080) != 0)
              && time_ != null
              && time_ != com.google.protobuf.Timestamp.getDefaultInstance()) {
            getTimeBuilder().mergeFrom(value);
          } else {
            time_ = value;
          }
        } else {
          timeBuilder_.mergeFrom(value);
        }
        if (time_ != null) {
          bitField0_ |= 0x00000080;
          onChanged();
        }
        return this;
      }
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service receives the last byte of
       * the request.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 9;</code>
       */
      public Builder clearTime() {
        bitField0_ = (bitField0_ & ~0x00000080);
        time_ = null;
        if (timeBuilder_ != null) {
          timeBuilder_.dispose();
          timeBuilder_ = null;
        }
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service receives the last byte of
       * the request.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 9;</code>
       */
      public com.couchbase.client.core.deps.com.google.protobuf.Timestamp.Builder getTimeBuilder() {
        bitField0_ |= 0x00000080;
        onChanged();
        return getTimeFieldBuilder().getBuilder();
      }
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service receives the last byte of
       * the request.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 9;</code>
       */
      public com.couchbase.client.core.deps.com.google.protobuf.TimestampOrBuilder getTimeOrBuilder() {
        if (timeBuilder_ != null) {
          return timeBuilder_.getMessageOrBuilder();
        } else {
          return time_ == null ? com.google.protobuf.Timestamp.getDefaultInstance() : time_;
        }
      }
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service receives the last byte of
       * the request.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 9;</code>
       */
      private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
              com.google.protobuf.Timestamp,
              com.google.protobuf.Timestamp.Builder,
              com.google.protobuf.TimestampOrBuilder>
          getTimeFieldBuilder() {
        if (timeBuilder_ == null) {
          timeBuilder_ =
              new com.google.protobuf.SingleFieldBuilderV3<
                  com.google.protobuf.Timestamp,
                  com.google.protobuf.Timestamp.Builder,
                  com.google.protobuf.TimestampOrBuilder>(
                  getTime(), getParentForChildren(), isClean());
          time_ = null;
        }
        return timeBuilder_;
      }

      private long size_;
      /**
       *
       *
       * <pre>
       * The HTTP request size in bytes. If unknown, it must be -1.
       * </pre>
       *
       * <code>int64 size = 10;</code>
       *
       * @return The size.
       */
      @java.lang.Override
      public long getSize() {
        return size_;
      }
      /**
       *
       *
       * <pre>
       * The HTTP request size in bytes. If unknown, it must be -1.
       * </pre>
       *
       * <code>int64 size = 10;</code>
       *
       * @param value The size to set.
       * @return This builder for chaining.
       */
      public Builder setSize(long value) {

        size_ = value;
        bitField0_ |= 0x00000100;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP request size in bytes. If unknown, it must be -1.
       * </pre>
       *
       * <code>int64 size = 10;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearSize() {
        bitField0_ = (bitField0_ & ~0x00000100);
        size_ = 0L;
        onChanged();
        return this;
      }

      private java.lang.Object protocol_ = "";
      /**
       *
       *
       * <pre>
       * The network protocol used with the request, such as "http/1.1",
       * "spdy/3", "h2", "h2c", "webrtc", "tcp", "udp", "quic". See
       * https://www.iana.org/assignments/tls-extensiontype-values/tls-extensiontype-values.xhtml#alpn-protocol-ids
       * for details.
       * </pre>
       *
       * <code>string protocol = 11;</code>
       *
       * @return The protocol.
       */
      public java.lang.String getProtocol() {
        java.lang.Object ref = protocol_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          protocol_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The network protocol used with the request, such as "http/1.1",
       * "spdy/3", "h2", "h2c", "webrtc", "tcp", "udp", "quic". See
       * https://www.iana.org/assignments/tls-extensiontype-values/tls-extensiontype-values.xhtml#alpn-protocol-ids
       * for details.
       * </pre>
       *
       * <code>string protocol = 11;</code>
       *
       * @return The bytes for protocol.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getProtocolBytes() {
        java.lang.Object ref = protocol_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          protocol_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The network protocol used with the request, such as "http/1.1",
       * "spdy/3", "h2", "h2c", "webrtc", "tcp", "udp", "quic". See
       * https://www.iana.org/assignments/tls-extensiontype-values/tls-extensiontype-values.xhtml#alpn-protocol-ids
       * for details.
       * </pre>
       *
       * <code>string protocol = 11;</code>
       *
       * @param value The protocol to set.
       * @return This builder for chaining.
       */
      public Builder setProtocol(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        protocol_ = value;
        bitField0_ |= 0x00000200;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The network protocol used with the request, such as "http/1.1",
       * "spdy/3", "h2", "h2c", "webrtc", "tcp", "udp", "quic". See
       * https://www.iana.org/assignments/tls-extensiontype-values/tls-extensiontype-values.xhtml#alpn-protocol-ids
       * for details.
       * </pre>
       *
       * <code>string protocol = 11;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearProtocol() {
        protocol_ = getDefaultInstance().getProtocol();
        bitField0_ = (bitField0_ & ~0x00000200);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The network protocol used with the request, such as "http/1.1",
       * "spdy/3", "h2", "h2c", "webrtc", "tcp", "udp", "quic". See
       * https://www.iana.org/assignments/tls-extensiontype-values/tls-extensiontype-values.xhtml#alpn-protocol-ids
       * for details.
       * </pre>
       *
       * <code>string protocol = 11;</code>
       *
       * @param value The bytes for protocol to set.
       * @return This builder for chaining.
       */
      public Builder setProtocolBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        protocol_ = value;
        bitField0_ |= 0x00000200;
        onChanged();
        return this;
      }

      private java.lang.Object reason_ = "";
      /**
       *
       *
       * <pre>
       * A special parameter for request reason. It is used by security systems
       * to associate auditing information with a request.
       * </pre>
       *
       * <code>string reason = 12;</code>
       *
       * @return The reason.
       */
      public java.lang.String getReason() {
        java.lang.Object ref = reason_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          reason_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * A special parameter for request reason. It is used by security systems
       * to associate auditing information with a request.
       * </pre>
       *
       * <code>string reason = 12;</code>
       *
       * @return The bytes for reason.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getReasonBytes() {
        java.lang.Object ref = reason_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          reason_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * A special parameter for request reason. It is used by security systems
       * to associate auditing information with a request.
       * </pre>
       *
       * <code>string reason = 12;</code>
       *
       * @param value The reason to set.
       * @return This builder for chaining.
       */
      public Builder setReason(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        reason_ = value;
        bitField0_ |= 0x00000400;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * A special parameter for request reason. It is used by security systems
       * to associate auditing information with a request.
       * </pre>
       *
       * <code>string reason = 12;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearReason() {
        reason_ = getDefaultInstance().getReason();
        bitField0_ = (bitField0_ & ~0x00000400);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * A special parameter for request reason. It is used by security systems
       * to associate auditing information with a request.
       * </pre>
       *
       * <code>string reason = 12;</code>
       *
       * @param value The bytes for reason to set.
       * @return This builder for chaining.
       */
      public Builder setReasonBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        reason_ = value;
        bitField0_ |= 0x00000400;
        onChanged();
        return this;
      }

      private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth auth_;
      private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
              com.google.rpc.context.AttributeContext.Auth,
              com.google.rpc.context.AttributeContext.Auth.Builder,
              com.google.rpc.context.AttributeContext.AuthOrBuilder>
          authBuilder_;
      /**
       *
       *
       * <pre>
       * The request authentication. May be absent for unauthenticated requests.
       * Derived from the HTTP request `Authorization` header or equivalent.
       * </pre>
       *
       * <code>.google.rpc.context.AttributeContext.Auth auth = 13;</code>
       *
       * @return Whether the auth field is set.
       */
      public boolean hasAuth() {
        return ((bitField0_ & 0x00000800) != 0);
      }
      /**
       *
       *
       * <pre>
       * The request authentication. May be absent for unauthenticated requests.
       * Derived from the HTTP request `Authorization` header or equivalent.
       * </pre>
       *
       * <code>.google.rpc.context.AttributeContext.Auth auth = 13;</code>
       *
       * @return The auth.
       */
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth getAuth() {
        if (authBuilder_ == null) {
          return auth_ == null
              ? com.google.rpc.context.AttributeContext.Auth.getDefaultInstance()
              : auth_;
        } else {
          return authBuilder_.getMessage();
        }
      }
      /**
       *
       *
       * <pre>
       * The request authentication. May be absent for unauthenticated requests.
       * Derived from the HTTP request `Authorization` header or equivalent.
       * </pre>
       *
       * <code>.google.rpc.context.AttributeContext.Auth auth = 13;</code>
       */
      public Builder setAuth(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth value) {
        if (authBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          auth_ = value;
        } else {
          authBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000800;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The request authentication. May be absent for unauthenticated requests.
       * Derived from the HTTP request `Authorization` header or equivalent.
       * </pre>
       *
       * <code>.google.rpc.context.AttributeContext.Auth auth = 13;</code>
       */
      public Builder setAuth(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth.Builder builderForValue) {
        if (authBuilder_ == null) {
          auth_ = builderForValue.build();
        } else {
          authBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000800;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The request authentication. May be absent for unauthenticated requests.
       * Derived from the HTTP request `Authorization` header or equivalent.
       * </pre>
       *
       * <code>.google.rpc.context.AttributeContext.Auth auth = 13;</code>
       */
      public Builder mergeAuth(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth value) {
        if (authBuilder_ == null) {
          if (((bitField0_ & 0x00000800) != 0)
              && auth_ != null
              && auth_ != com.google.rpc.context.AttributeContext.Auth.getDefaultInstance()) {
            getAuthBuilder().mergeFrom(value);
          } else {
            auth_ = value;
          }
        } else {
          authBuilder_.mergeFrom(value);
        }
        if (auth_ != null) {
          bitField0_ |= 0x00000800;
          onChanged();
        }
        return this;
      }
      /**
       *
       *
       * <pre>
       * The request authentication. May be absent for unauthenticated requests.
       * Derived from the HTTP request `Authorization` header or equivalent.
       * </pre>
       *
       * <code>.google.rpc.context.AttributeContext.Auth auth = 13;</code>
       */
      public Builder clearAuth() {
        bitField0_ = (bitField0_ & ~0x00000800);
        auth_ = null;
        if (authBuilder_ != null) {
          authBuilder_.dispose();
          authBuilder_ = null;
        }
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The request authentication. May be absent for unauthenticated requests.
       * Derived from the HTTP request `Authorization` header or equivalent.
       * </pre>
       *
       * <code>.google.rpc.context.AttributeContext.Auth auth = 13;</code>
       */
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Auth.Builder getAuthBuilder() {
        bitField0_ |= 0x00000800;
        onChanged();
        return getAuthFieldBuilder().getBuilder();
      }
      /**
       *
       *
       * <pre>
       * The request authentication. May be absent for unauthenticated requests.
       * Derived from the HTTP request `Authorization` header or equivalent.
       * </pre>
       *
       * <code>.google.rpc.context.AttributeContext.Auth auth = 13;</code>
       */
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.AuthOrBuilder getAuthOrBuilder() {
        if (authBuilder_ != null) {
          return authBuilder_.getMessageOrBuilder();
        } else {
          return auth_ == null
              ? com.google.rpc.context.AttributeContext.Auth.getDefaultInstance()
              : auth_;
        }
      }
      /**
       *
       *
       * <pre>
       * The request authentication. May be absent for unauthenticated requests.
       * Derived from the HTTP request `Authorization` header or equivalent.
       * </pre>
       *
       * <code>.google.rpc.context.AttributeContext.Auth auth = 13;</code>
       */
      private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
              com.google.rpc.context.AttributeContext.Auth,
              com.google.rpc.context.AttributeContext.Auth.Builder,
              com.google.rpc.context.AttributeContext.AuthOrBuilder>
          getAuthFieldBuilder() {
        if (authBuilder_ == null) {
          authBuilder_ =
              new com.google.protobuf.SingleFieldBuilderV3<
                  com.google.rpc.context.AttributeContext.Auth,
                  com.google.rpc.context.AttributeContext.Auth.Builder,
                  com.google.rpc.context.AttributeContext.AuthOrBuilder>(
                  getAuth(), getParentForChildren(), isClean());
          auth_ = null;
        }
        return authBuilder_;
      }

      @java.lang.Override
      public final Builder setUnknownFields(
          final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }

      // @@protoc_insertion_point(builder_scope:google.rpc.context.AttributeContext.Request)
    }

    // @@protoc_insertion_point(class_scope:google.rpc.context.AttributeContext.Request)
    private static final com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request DEFAULT_INSTANCE;

    static {
      DEFAULT_INSTANCE = new com.google.rpc.context.AttributeContext.Request();
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.couchbase.client.core.deps.com.google.protobuf.Parser<Request> PARSER =
        new com.google.protobuf.AbstractParser<Request>() {
          @java.lang.Override
          public Request parsePartialFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws com.google.protobuf.InvalidProtocolBufferException {
            Builder builder = newBuilder();
            try {
              builder.mergeFrom(input, extensionRegistry);
            } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
              throw e.setUnfinishedMessage(builder.buildPartial());
            } catch (com.couchbase.client.core.deps.com.google.protobuf.UninitializedMessageException e) {
              throw e.asInvalidProtocolBufferException()
                  .setUnfinishedMessage(builder.buildPartial());
            } catch (java.io.IOException e) {
              throw new com.google.protobuf.InvalidProtocolBufferException(e)
                  .setUnfinishedMessage(builder.buildPartial());
            }
            return builder.buildPartial();
          }
        };

    public static com.couchbase.client.core.deps.com.google.protobuf.Parser<Request> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Parser<Request> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }
  }

  public interface ResponseOrBuilder
      extends
      // @@protoc_insertion_point(interface_extends:google.rpc.context.AttributeContext.Response)
      com.google.protobuf.MessageOrBuilder {

    /**
     *
     *
     * <pre>
     * The HTTP response status code, such as `200` and `404`.
     * </pre>
     *
     * <code>int64 code = 1;</code>
     *
     * @return The code.
     */
    long getCode();

    /**
     *
     *
     * <pre>
     * The HTTP response size in bytes. If unknown, it must be -1.
     * </pre>
     *
     * <code>int64 size = 2;</code>
     *
     * @return The size.
     */
    long getSize();

    /**
     *
     *
     * <pre>
     * The HTTP response headers. If multiple headers share the same key, they
     * must be merged according to HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    int getHeadersCount();
    /**
     *
     *
     * <pre>
     * The HTTP response headers. If multiple headers share the same key, they
     * must be merged according to HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    boolean containsHeaders(java.lang.String key);
    /** Use {@link #getHeadersMap()} instead. */
    @java.lang.Deprecated
    java.util.Map<java.lang.String, java.lang.String> getHeaders();
    /**
     *
     *
     * <pre>
     * The HTTP response headers. If multiple headers share the same key, they
     * must be merged according to HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    java.util.Map<java.lang.String, java.lang.String> getHeadersMap();
    /**
     *
     *
     * <pre>
     * The HTTP response headers. If multiple headers share the same key, they
     * must be merged according to HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    /* nullable */
    java.lang.String getHeadersOrDefault(
        java.lang.String key,
        /* nullable */
        java.lang.String defaultValue);
    /**
     *
     *
     * <pre>
     * The HTTP response headers. If multiple headers share the same key, they
     * must be merged according to HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    java.lang.String getHeadersOrThrow(java.lang.String key);

    /**
     *
     *
     * <pre>
     * The timestamp when the `destination` service sends the last byte of
     * the response.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 4;</code>
     *
     * @return Whether the time field is set.
     */
    boolean hasTime();
    /**
     *
     *
     * <pre>
     * The timestamp when the `destination` service sends the last byte of
     * the response.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 4;</code>
     *
     * @return The time.
     */
    com.google.protobuf.Timestamp getTime();
    /**
     *
     *
     * <pre>
     * The timestamp when the `destination` service sends the last byte of
     * the response.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 4;</code>
     */
    com.google.protobuf.TimestampOrBuilder getTimeOrBuilder();

    /**
     *
     *
     * <pre>
     * The amount of time it takes the backend service to fully respond to a
     * request. Measured from when the destination service starts to send the
     * request to the backend until when the destination service receives the
     * complete response from the backend.
     * </pre>
     *
     * <code>.google.protobuf.Duration backend_latency = 5;</code>
     *
     * @return Whether the backendLatency field is set.
     */
    boolean hasBackendLatency();
    /**
     *
     *
     * <pre>
     * The amount of time it takes the backend service to fully respond to a
     * request. Measured from when the destination service starts to send the
     * request to the backend until when the destination service receives the
     * complete response from the backend.
     * </pre>
     *
     * <code>.google.protobuf.Duration backend_latency = 5;</code>
     *
     * @return The backendLatency.
     */
    com.google.protobuf.Duration getBackendLatency();
    /**
     *
     *
     * <pre>
     * The amount of time it takes the backend service to fully respond to a
     * request. Measured from when the destination service starts to send the
     * request to the backend until when the destination service receives the
     * complete response from the backend.
     * </pre>
     *
     * <code>.google.protobuf.Duration backend_latency = 5;</code>
     */
    com.google.protobuf.DurationOrBuilder getBackendLatencyOrBuilder();
  }
  /**
   *
   *
   * <pre>
   * This message defines attributes for a typical network response. It
   * generally models semantics of an HTTP response.
   * </pre>
   *
   * Protobuf type {@code google.rpc.context.AttributeContext.Response}
   */
  public static final class Response extends com.google.protobuf.GeneratedMessageV3
      implements
      // @@protoc_insertion_point(message_implements:google.rpc.context.AttributeContext.Response)
      ResponseOrBuilder {
    private static final long serialVersionUID = 0L;
    // Use Response.newBuilder() to construct.
    private Response(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }

    private Response() {}

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
      return new Response();
    }

    public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return com.google.rpc.context.AttributeContextProto
          .internal_static_google_rpc_context_AttributeContext_Response_descriptor;
    }

    @SuppressWarnings({"rawtypes"})
    @java.lang.Override
    protected com.couchbase.client.core.deps.com.google.protobuf.MapFieldReflectionAccessor internalGetMapFieldReflection(
        int number) {
      switch (number) {
        case 3:
          return internalGetHeaders();
        default:
          throw new RuntimeException("Invalid map field number: " + number);
      }
    }

    @java.lang.Override
    protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.rpc.context.AttributeContextProto
          .internal_static_google_rpc_context_AttributeContext_Response_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.rpc.context.AttributeContext.Response.class,
              com.google.rpc.context.AttributeContext.Response.Builder.class);
    }

    private int bitField0_;
    public static final int CODE_FIELD_NUMBER = 1;
    private long code_ = 0L;
    /**
     *
     *
     * <pre>
     * The HTTP response status code, such as `200` and `404`.
     * </pre>
     *
     * <code>int64 code = 1;</code>
     *
     * @return The code.
     */
    @java.lang.Override
    public long getCode() {
      return code_;
    }

    public static final int SIZE_FIELD_NUMBER = 2;
    private long size_ = 0L;
    /**
     *
     *
     * <pre>
     * The HTTP response size in bytes. If unknown, it must be -1.
     * </pre>
     *
     * <code>int64 size = 2;</code>
     *
     * @return The size.
     */
    @java.lang.Override
    public long getSize() {
      return size_;
    }

    public static final int HEADERS_FIELD_NUMBER = 3;

    private static final class HeadersDefaultEntryHolder {
      static final com.couchbase.client.core.deps.com.google.protobuf.MapEntry<java.lang.String, java.lang.String> defaultEntry =
          com.google.protobuf.MapEntry.<java.lang.String, java.lang.String>newDefaultInstance(
              com.google.rpc.context.AttributeContextProto
                  .internal_static_google_rpc_context_AttributeContext_Response_HeadersEntry_descriptor,
              com.google.protobuf.WireFormat.FieldType.STRING,
              "",
              com.google.protobuf.WireFormat.FieldType.STRING,
              "");
    }

    @SuppressWarnings("serial")
    private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String> headers_;

    private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String> internalGetHeaders() {
      if (headers_ == null) {
        return com.google.protobuf.MapField.emptyMapField(HeadersDefaultEntryHolder.defaultEntry);
      }
      return headers_;
    }

    public int getHeadersCount() {
      return internalGetHeaders().getMap().size();
    }
    /**
     *
     *
     * <pre>
     * The HTTP response headers. If multiple headers share the same key, they
     * must be merged according to HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    @java.lang.Override
    public boolean containsHeaders(java.lang.String key) {
      if (key == null) {
        throw new NullPointerException("map key");
      }
      return internalGetHeaders().getMap().containsKey(key);
    }
    /** Use {@link #getHeadersMap()} instead. */
    @java.lang.Override
    @java.lang.Deprecated
    public java.util.Map<java.lang.String, java.lang.String> getHeaders() {
      return getHeadersMap();
    }
    /**
     *
     *
     * <pre>
     * The HTTP response headers. If multiple headers share the same key, they
     * must be merged according to HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    @java.lang.Override
    public java.util.Map<java.lang.String, java.lang.String> getHeadersMap() {
      return internalGetHeaders().getMap();
    }
    /**
     *
     *
     * <pre>
     * The HTTP response headers. If multiple headers share the same key, they
     * must be merged according to HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    @java.lang.Override
    public /* nullable */ java.lang.String getHeadersOrDefault(
        java.lang.String key,
        /* nullable */
        java.lang.String defaultValue) {
      if (key == null) {
        throw new NullPointerException("map key");
      }
      java.util.Map<java.lang.String, java.lang.String> map = internalGetHeaders().getMap();
      return map.containsKey(key) ? map.get(key) : defaultValue;
    }
    /**
     *
     *
     * <pre>
     * The HTTP response headers. If multiple headers share the same key, they
     * must be merged according to HTTP spec. All header keys must be
     * lowercased, because HTTP header keys are case-insensitive.
     * </pre>
     *
     * <code>map&lt;string, string&gt; headers = 3;</code>
     */
    @java.lang.Override
    public java.lang.String getHeadersOrThrow(java.lang.String key) {
      if (key == null) {
        throw new NullPointerException("map key");
      }
      java.util.Map<java.lang.String, java.lang.String> map = internalGetHeaders().getMap();
      if (!map.containsKey(key)) {
        throw new java.lang.IllegalArgumentException();
      }
      return map.get(key);
    }

    public static final int TIME_FIELD_NUMBER = 4;
    private com.couchbase.client.core.deps.com.google.protobuf.Timestamp time_;
    /**
     *
     *
     * <pre>
     * The timestamp when the `destination` service sends the last byte of
     * the response.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 4;</code>
     *
     * @return Whether the time field is set.
     */
    @java.lang.Override
    public boolean hasTime() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     *
     *
     * <pre>
     * The timestamp when the `destination` service sends the last byte of
     * the response.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 4;</code>
     *
     * @return The time.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Timestamp getTime() {
      return time_ == null ? com.google.protobuf.Timestamp.getDefaultInstance() : time_;
    }
    /**
     *
     *
     * <pre>
     * The timestamp when the `destination` service sends the last byte of
     * the response.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp time = 4;</code>
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.TimestampOrBuilder getTimeOrBuilder() {
      return time_ == null ? com.google.protobuf.Timestamp.getDefaultInstance() : time_;
    }

    public static final int BACKEND_LATENCY_FIELD_NUMBER = 5;
    private com.couchbase.client.core.deps.com.google.protobuf.Duration backendLatency_;
    /**
     *
     *
     * <pre>
     * The amount of time it takes the backend service to fully respond to a
     * request. Measured from when the destination service starts to send the
     * request to the backend until when the destination service receives the
     * complete response from the backend.
     * </pre>
     *
     * <code>.google.protobuf.Duration backend_latency = 5;</code>
     *
     * @return Whether the backendLatency field is set.
     */
    @java.lang.Override
    public boolean hasBackendLatency() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     *
     *
     * <pre>
     * The amount of time it takes the backend service to fully respond to a
     * request. Measured from when the destination service starts to send the
     * request to the backend until when the destination service receives the
     * complete response from the backend.
     * </pre>
     *
     * <code>.google.protobuf.Duration backend_latency = 5;</code>
     *
     * @return The backendLatency.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Duration getBackendLatency() {
      return backendLatency_ == null
          ? com.google.protobuf.Duration.getDefaultInstance()
          : backendLatency_;
    }
    /**
     *
     *
     * <pre>
     * The amount of time it takes the backend service to fully respond to a
     * request. Measured from when the destination service starts to send the
     * request to the backend until when the destination service receives the
     * complete response from the backend.
     * </pre>
     *
     * <code>.google.protobuf.Duration backend_latency = 5;</code>
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.DurationOrBuilder getBackendLatencyOrBuilder() {
      return backendLatency_ == null
          ? com.google.protobuf.Duration.getDefaultInstance()
          : backendLatency_;
    }

    private byte memoizedIsInitialized = -1;

    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.couchbase.client.core.deps.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
      if (code_ != 0L) {
        output.writeInt64(1, code_);
      }
      if (size_ != 0L) {
        output.writeInt64(2, size_);
      }
      com.google.protobuf.GeneratedMessageV3.serializeStringMapTo(
          output, internalGetHeaders(), HeadersDefaultEntryHolder.defaultEntry, 3);
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeMessage(4, getTime());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeMessage(5, getBackendLatency());
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (code_ != 0L) {
        size += com.google.protobuf.CodedOutputStream.computeInt64Size(1, code_);
      }
      if (size_ != 0L) {
        size += com.google.protobuf.CodedOutputStream.computeInt64Size(2, size_);
      }
      for (java.util.Map.Entry<java.lang.String, java.lang.String> entry :
          internalGetHeaders().getMap().entrySet()) {
        com.google.protobuf.MapEntry<java.lang.String, java.lang.String> headers__ =
            HeadersDefaultEntryHolder.defaultEntry
                .newBuilderForType()
                .setKey(entry.getKey())
                .setValue(entry.getValue())
                .build();
        size += com.google.protobuf.CodedOutputStream.computeMessageSize(3, headers__);
      }
      if (((bitField0_ & 0x00000001) != 0)) {
        size += com.google.protobuf.CodedOutputStream.computeMessageSize(4, getTime());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += com.google.protobuf.CodedOutputStream.computeMessageSize(5, getBackendLatency());
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
        return true;
      }
      if (!(obj instanceof com.google.rpc.context.AttributeContext.Response)) {
        return super.equals(obj);
      }
      com.google.rpc.context.AttributeContext.Response other =
          (com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response) obj;

      if (getCode() != other.getCode()) return false;
      if (getSize() != other.getSize()) return false;
      if (!internalGetHeaders().equals(other.internalGetHeaders())) return false;
      if (hasTime() != other.hasTime()) return false;
      if (hasTime()) {
        if (!getTime().equals(other.getTime())) return false;
      }
      if (hasBackendLatency() != other.hasBackendLatency()) return false;
      if (hasBackendLatency()) {
        if (!getBackendLatency().equals(other.getBackendLatency())) return false;
      }
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + CODE_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(getCode());
      hash = (37 * hash) + SIZE_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(getSize());
      if (!internalGetHeaders().getMap().isEmpty()) {
        hash = (37 * hash) + HEADERS_FIELD_NUMBER;
        hash = (53 * hash) + internalGetHeaders().hashCode();
      }
      if (hasTime()) {
        hash = (37 * hash) + TIME_FIELD_NUMBER;
        hash = (53 * hash) + getTime().hashCode();
      }
      if (hasBackendLatency()) {
        hash = (37 * hash) + BACKEND_LATENCY_FIELD_NUMBER;
        hash = (53 * hash) + getBackendLatency().hashCode();
      }
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response parseFrom(
        java.nio.ByteBuffer data) throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response parseFrom(
        java.nio.ByteBuffer data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response parseFrom(
        byte[] data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response parseFrom(
        java.io.InputStream input) throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response parseFrom(
        java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response parseDelimitedFrom(
        java.io.InputStream input) throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response parseDelimitedFrom(
        java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response parseFrom(
        com.google.protobuf.CodedInputStream input) throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() {
      return newBuilder();
    }

    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }

    public static Builder newBuilder(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }

    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     *
     *
     * <pre>
     * This message defines attributes for a typical network response. It
     * generally models semantics of an HTTP response.
     * </pre>
     *
     * Protobuf type {@code google.rpc.context.AttributeContext.Response}
     */
    public static final class Builder
        extends com.google.protobuf.GeneratedMessageV3.Builder<Builder>
        implements
        // @@protoc_insertion_point(builder_implements:google.rpc.context.AttributeContext.Response)
        com.google.rpc.context.AttributeContext.ResponseOrBuilder {
      public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Response_descriptor;
      }

      @SuppressWarnings({"rawtypes"})
      protected com.couchbase.client.core.deps.com.google.protobuf.MapFieldReflectionAccessor internalGetMapFieldReflection(
          int number) {
        switch (number) {
          case 3:
            return internalGetHeaders();
          default:
            throw new RuntimeException("Invalid map field number: " + number);
        }
      }

      @SuppressWarnings({"rawtypes"})
      protected com.couchbase.client.core.deps.com.google.protobuf.MapFieldReflectionAccessor internalGetMutableMapFieldReflection(
          int number) {
        switch (number) {
          case 3:
            return internalGetMutableHeaders();
          default:
            throw new RuntimeException("Invalid map field number: " + number);
        }
      }

      @java.lang.Override
      protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Response_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.rpc.context.AttributeContext.Response.class,
                com.google.rpc.context.AttributeContext.Response.Builder.class);
      }

      // Construct using com.google.rpc.context.AttributeContext.Response.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }

      private void maybeForceBuilderInitialization() {
        if (com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {
          getTimeFieldBuilder();
          getBackendLatencyFieldBuilder();
        }
      }

      @java.lang.Override
      public Builder clear() {
        super.clear();
        bitField0_ = 0;
        code_ = 0L;
        size_ = 0L;
        internalGetMutableHeaders().clear();
        time_ = null;
        if (timeBuilder_ != null) {
          timeBuilder_.dispose();
          timeBuilder_ = null;
        }
        backendLatency_ = null;
        if (backendLatencyBuilder_ != null) {
          backendLatencyBuilder_.dispose();
          backendLatencyBuilder_ = null;
        }
        return this;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Response_descriptor;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response getDefaultInstanceForType() {
        return com.google.rpc.context.AttributeContext.Response.getDefaultInstance();
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response build() {
        com.google.rpc.context.AttributeContext.Response result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response buildPartial() {
        com.google.rpc.context.AttributeContext.Response result =
            new com.google.rpc.context.AttributeContext.Response(this);
        if (bitField0_ != 0) {
          buildPartial0(result);
        }
        onBuilt();
        return result;
      }

      private void buildPartial0(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response result) {
        int from_bitField0_ = bitField0_;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          result.code_ = code_;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          result.size_ = size_;
        }
        if (((from_bitField0_ & 0x00000004) != 0)) {
          result.headers_ = internalGetHeaders();
          result.headers_.makeImmutable();
        }
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000008) != 0)) {
          result.time_ = timeBuilder_ == null ? time_ : timeBuilder_.build();
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000010) != 0)) {
          result.backendLatency_ =
              backendLatencyBuilder_ == null ? backendLatency_ : backendLatencyBuilder_.build();
          to_bitField0_ |= 0x00000002;
        }
        result.bitField0_ |= to_bitField0_;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }

      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.setField(field, value);
      }

      @java.lang.Override
      public Builder clearField(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }

      @java.lang.Override
      public Builder clearOneof(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }

      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index,
          java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }

      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }

      @java.lang.Override
      public Builder mergeFrom(com.couchbase.client.core.deps.com.google.protobuf.Message other) {
        if (other instanceof com.google.rpc.context.AttributeContext.Response) {
          return mergeFrom((com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response) other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response other) {
        if (other == com.google.rpc.context.AttributeContext.Response.getDefaultInstance())
          return this;
        if (other.getCode() != 0L) {
          setCode(other.getCode());
        }
        if (other.getSize() != 0L) {
          setSize(other.getSize());
        }
        internalGetMutableHeaders().mergeFrom(other.internalGetHeaders());
        bitField0_ |= 0x00000004;
        if (other.hasTime()) {
          mergeTime(other.getTime());
        }
        if (other.hasBackendLatency()) {
          mergeBackendLatency(other.getBackendLatency());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 8:
                {
                  code_ = input.readInt64();
                  bitField0_ |= 0x00000001;
                  break;
                } // case 8
              case 16:
                {
                  size_ = input.readInt64();
                  bitField0_ |= 0x00000002;
                  break;
                } // case 16
              case 26:
                {
                  com.google.protobuf.MapEntry<java.lang.String, java.lang.String> headers__ =
                      input.readMessage(
                          HeadersDefaultEntryHolder.defaultEntry.getParserForType(),
                          extensionRegistry);
                  internalGetMutableHeaders()
                      .getMutableMap()
                      .put(headers__.getKey(), headers__.getValue());
                  bitField0_ |= 0x00000004;
                  break;
                } // case 26
              case 34:
                {
                  input.readMessage(getTimeFieldBuilder().getBuilder(), extensionRegistry);
                  bitField0_ |= 0x00000008;
                  break;
                } // case 34
              case 42:
                {
                  input.readMessage(
                      getBackendLatencyFieldBuilder().getBuilder(), extensionRegistry);
                  bitField0_ |= 0x00000010;
                  break;
                } // case 42
              default:
                {
                  if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                    done = true; // was an endgroup tag
                  }
                  break;
                } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private int bitField0_;

      private long code_;
      /**
       *
       *
       * <pre>
       * The HTTP response status code, such as `200` and `404`.
       * </pre>
       *
       * <code>int64 code = 1;</code>
       *
       * @return The code.
       */
      @java.lang.Override
      public long getCode() {
        return code_;
      }
      /**
       *
       *
       * <pre>
       * The HTTP response status code, such as `200` and `404`.
       * </pre>
       *
       * <code>int64 code = 1;</code>
       *
       * @param value The code to set.
       * @return This builder for chaining.
       */
      public Builder setCode(long value) {

        code_ = value;
        bitField0_ |= 0x00000001;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP response status code, such as `200` and `404`.
       * </pre>
       *
       * <code>int64 code = 1;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearCode() {
        bitField0_ = (bitField0_ & ~0x00000001);
        code_ = 0L;
        onChanged();
        return this;
      }

      private long size_;
      /**
       *
       *
       * <pre>
       * The HTTP response size in bytes. If unknown, it must be -1.
       * </pre>
       *
       * <code>int64 size = 2;</code>
       *
       * @return The size.
       */
      @java.lang.Override
      public long getSize() {
        return size_;
      }
      /**
       *
       *
       * <pre>
       * The HTTP response size in bytes. If unknown, it must be -1.
       * </pre>
       *
       * <code>int64 size = 2;</code>
       *
       * @param value The size to set.
       * @return This builder for chaining.
       */
      public Builder setSize(long value) {

        size_ = value;
        bitField0_ |= 0x00000002;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP response size in bytes. If unknown, it must be -1.
       * </pre>
       *
       * <code>int64 size = 2;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearSize() {
        bitField0_ = (bitField0_ & ~0x00000002);
        size_ = 0L;
        onChanged();
        return this;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String> headers_;

      private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String>
          internalGetHeaders() {
        if (headers_ == null) {
          return com.google.protobuf.MapField.emptyMapField(HeadersDefaultEntryHolder.defaultEntry);
        }
        return headers_;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String>
          internalGetMutableHeaders() {
        if (headers_ == null) {
          headers_ =
              com.google.protobuf.MapField.newMapField(HeadersDefaultEntryHolder.defaultEntry);
        }
        if (!headers_.isMutable()) {
          headers_ = headers_.copy();
        }
        bitField0_ |= 0x00000004;
        onChanged();
        return headers_;
      }

      public int getHeadersCount() {
        return internalGetHeaders().getMap().size();
      }
      /**
       *
       *
       * <pre>
       * The HTTP response headers. If multiple headers share the same key, they
       * must be merged according to HTTP spec. All header keys must be
       * lowercased, because HTTP header keys are case-insensitive.
       * </pre>
       *
       * <code>map&lt;string, string&gt; headers = 3;</code>
       */
      @java.lang.Override
      public boolean containsHeaders(java.lang.String key) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        return internalGetHeaders().getMap().containsKey(key);
      }
      /** Use {@link #getHeadersMap()} instead. */
      @java.lang.Override
      @java.lang.Deprecated
      public java.util.Map<java.lang.String, java.lang.String> getHeaders() {
        return getHeadersMap();
      }
      /**
       *
       *
       * <pre>
       * The HTTP response headers. If multiple headers share the same key, they
       * must be merged according to HTTP spec. All header keys must be
       * lowercased, because HTTP header keys are case-insensitive.
       * </pre>
       *
       * <code>map&lt;string, string&gt; headers = 3;</code>
       */
      @java.lang.Override
      public java.util.Map<java.lang.String, java.lang.String> getHeadersMap() {
        return internalGetHeaders().getMap();
      }
      /**
       *
       *
       * <pre>
       * The HTTP response headers. If multiple headers share the same key, they
       * must be merged according to HTTP spec. All header keys must be
       * lowercased, because HTTP header keys are case-insensitive.
       * </pre>
       *
       * <code>map&lt;string, string&gt; headers = 3;</code>
       */
      @java.lang.Override
      public /* nullable */ java.lang.String getHeadersOrDefault(
          java.lang.String key,
          /* nullable */
          java.lang.String defaultValue) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        java.util.Map<java.lang.String, java.lang.String> map = internalGetHeaders().getMap();
        return map.containsKey(key) ? map.get(key) : defaultValue;
      }
      /**
       *
       *
       * <pre>
       * The HTTP response headers. If multiple headers share the same key, they
       * must be merged according to HTTP spec. All header keys must be
       * lowercased, because HTTP header keys are case-insensitive.
       * </pre>
       *
       * <code>map&lt;string, string&gt; headers = 3;</code>
       */
      @java.lang.Override
      public java.lang.String getHeadersOrThrow(java.lang.String key) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        java.util.Map<java.lang.String, java.lang.String> map = internalGetHeaders().getMap();
        if (!map.containsKey(key)) {
          throw new java.lang.IllegalArgumentException();
        }
        return map.get(key);
      }

      public Builder clearHeaders() {
        bitField0_ = (bitField0_ & ~0x00000004);
        internalGetMutableHeaders().getMutableMap().clear();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP response headers. If multiple headers share the same key, they
       * must be merged according to HTTP spec. All header keys must be
       * lowercased, because HTTP header keys are case-insensitive.
       * </pre>
       *
       * <code>map&lt;string, string&gt; headers = 3;</code>
       */
      public Builder removeHeaders(java.lang.String key) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        internalGetMutableHeaders().getMutableMap().remove(key);
        return this;
      }
      /** Use alternate mutation accessors instead. */
      @java.lang.Deprecated
      public java.util.Map<java.lang.String, java.lang.String> getMutableHeaders() {
        bitField0_ |= 0x00000004;
        return internalGetMutableHeaders().getMutableMap();
      }
      /**
       *
       *
       * <pre>
       * The HTTP response headers. If multiple headers share the same key, they
       * must be merged according to HTTP spec. All header keys must be
       * lowercased, because HTTP header keys are case-insensitive.
       * </pre>
       *
       * <code>map&lt;string, string&gt; headers = 3;</code>
       */
      public Builder putHeaders(java.lang.String key, java.lang.String value) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        if (value == null) {
          throw new NullPointerException("map value");
        }
        internalGetMutableHeaders().getMutableMap().put(key, value);
        bitField0_ |= 0x00000004;
        return this;
      }
      /**
       *
       *
       * <pre>
       * The HTTP response headers. If multiple headers share the same key, they
       * must be merged according to HTTP spec. All header keys must be
       * lowercased, because HTTP header keys are case-insensitive.
       * </pre>
       *
       * <code>map&lt;string, string&gt; headers = 3;</code>
       */
      public Builder putAllHeaders(java.util.Map<java.lang.String, java.lang.String> values) {
        internalGetMutableHeaders().getMutableMap().putAll(values);
        bitField0_ |= 0x00000004;
        return this;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.Timestamp time_;
      private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
              com.google.protobuf.Timestamp,
              com.google.protobuf.Timestamp.Builder,
              com.google.protobuf.TimestampOrBuilder>
          timeBuilder_;
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service sends the last byte of
       * the response.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 4;</code>
       *
       * @return Whether the time field is set.
       */
      public boolean hasTime() {
        return ((bitField0_ & 0x00000008) != 0);
      }
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service sends the last byte of
       * the response.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 4;</code>
       *
       * @return The time.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.Timestamp getTime() {
        if (timeBuilder_ == null) {
          return time_ == null ? com.google.protobuf.Timestamp.getDefaultInstance() : time_;
        } else {
          return timeBuilder_.getMessage();
        }
      }
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service sends the last byte of
       * the response.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 4;</code>
       */
      public Builder setTime(com.couchbase.client.core.deps.com.google.protobuf.Timestamp value) {
        if (timeBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          time_ = value;
        } else {
          timeBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000008;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service sends the last byte of
       * the response.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 4;</code>
       */
      public Builder setTime(com.couchbase.client.core.deps.com.google.protobuf.Timestamp.Builder builderForValue) {
        if (timeBuilder_ == null) {
          time_ = builderForValue.build();
        } else {
          timeBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000008;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service sends the last byte of
       * the response.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 4;</code>
       */
      public Builder mergeTime(com.couchbase.client.core.deps.com.google.protobuf.Timestamp value) {
        if (timeBuilder_ == null) {
          if (((bitField0_ & 0x00000008) != 0)
              && time_ != null
              && time_ != com.google.protobuf.Timestamp.getDefaultInstance()) {
            getTimeBuilder().mergeFrom(value);
          } else {
            time_ = value;
          }
        } else {
          timeBuilder_.mergeFrom(value);
        }
        if (time_ != null) {
          bitField0_ |= 0x00000008;
          onChanged();
        }
        return this;
      }
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service sends the last byte of
       * the response.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 4;</code>
       */
      public Builder clearTime() {
        bitField0_ = (bitField0_ & ~0x00000008);
        time_ = null;
        if (timeBuilder_ != null) {
          timeBuilder_.dispose();
          timeBuilder_ = null;
        }
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service sends the last byte of
       * the response.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 4;</code>
       */
      public com.couchbase.client.core.deps.com.google.protobuf.Timestamp.Builder getTimeBuilder() {
        bitField0_ |= 0x00000008;
        onChanged();
        return getTimeFieldBuilder().getBuilder();
      }
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service sends the last byte of
       * the response.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 4;</code>
       */
      public com.couchbase.client.core.deps.com.google.protobuf.TimestampOrBuilder getTimeOrBuilder() {
        if (timeBuilder_ != null) {
          return timeBuilder_.getMessageOrBuilder();
        } else {
          return time_ == null ? com.google.protobuf.Timestamp.getDefaultInstance() : time_;
        }
      }
      /**
       *
       *
       * <pre>
       * The timestamp when the `destination` service sends the last byte of
       * the response.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp time = 4;</code>
       */
      private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
              com.google.protobuf.Timestamp,
              com.google.protobuf.Timestamp.Builder,
              com.google.protobuf.TimestampOrBuilder>
          getTimeFieldBuilder() {
        if (timeBuilder_ == null) {
          timeBuilder_ =
              new com.google.protobuf.SingleFieldBuilderV3<
                  com.google.protobuf.Timestamp,
                  com.google.protobuf.Timestamp.Builder,
                  com.google.protobuf.TimestampOrBuilder>(
                  getTime(), getParentForChildren(), isClean());
          time_ = null;
        }
        return timeBuilder_;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.Duration backendLatency_;
      private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
              com.google.protobuf.Duration,
              com.google.protobuf.Duration.Builder,
              com.google.protobuf.DurationOrBuilder>
          backendLatencyBuilder_;
      /**
       *
       *
       * <pre>
       * The amount of time it takes the backend service to fully respond to a
       * request. Measured from when the destination service starts to send the
       * request to the backend until when the destination service receives the
       * complete response from the backend.
       * </pre>
       *
       * <code>.google.protobuf.Duration backend_latency = 5;</code>
       *
       * @return Whether the backendLatency field is set.
       */
      public boolean hasBackendLatency() {
        return ((bitField0_ & 0x00000010) != 0);
      }
      /**
       *
       *
       * <pre>
       * The amount of time it takes the backend service to fully respond to a
       * request. Measured from when the destination service starts to send the
       * request to the backend until when the destination service receives the
       * complete response from the backend.
       * </pre>
       *
       * <code>.google.protobuf.Duration backend_latency = 5;</code>
       *
       * @return The backendLatency.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.Duration getBackendLatency() {
        if (backendLatencyBuilder_ == null) {
          return backendLatency_ == null
              ? com.google.protobuf.Duration.getDefaultInstance()
              : backendLatency_;
        } else {
          return backendLatencyBuilder_.getMessage();
        }
      }
      /**
       *
       *
       * <pre>
       * The amount of time it takes the backend service to fully respond to a
       * request. Measured from when the destination service starts to send the
       * request to the backend until when the destination service receives the
       * complete response from the backend.
       * </pre>
       *
       * <code>.google.protobuf.Duration backend_latency = 5;</code>
       */
      public Builder setBackendLatency(com.couchbase.client.core.deps.com.google.protobuf.Duration value) {
        if (backendLatencyBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          backendLatency_ = value;
        } else {
          backendLatencyBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000010;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The amount of time it takes the backend service to fully respond to a
       * request. Measured from when the destination service starts to send the
       * request to the backend until when the destination service receives the
       * complete response from the backend.
       * </pre>
       *
       * <code>.google.protobuf.Duration backend_latency = 5;</code>
       */
      public Builder setBackendLatency(com.couchbase.client.core.deps.com.google.protobuf.Duration.Builder builderForValue) {
        if (backendLatencyBuilder_ == null) {
          backendLatency_ = builderForValue.build();
        } else {
          backendLatencyBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000010;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The amount of time it takes the backend service to fully respond to a
       * request. Measured from when the destination service starts to send the
       * request to the backend until when the destination service receives the
       * complete response from the backend.
       * </pre>
       *
       * <code>.google.protobuf.Duration backend_latency = 5;</code>
       */
      public Builder mergeBackendLatency(com.couchbase.client.core.deps.com.google.protobuf.Duration value) {
        if (backendLatencyBuilder_ == null) {
          if (((bitField0_ & 0x00000010) != 0)
              && backendLatency_ != null
              && backendLatency_ != com.google.protobuf.Duration.getDefaultInstance()) {
            getBackendLatencyBuilder().mergeFrom(value);
          } else {
            backendLatency_ = value;
          }
        } else {
          backendLatencyBuilder_.mergeFrom(value);
        }
        if (backendLatency_ != null) {
          bitField0_ |= 0x00000010;
          onChanged();
        }
        return this;
      }
      /**
       *
       *
       * <pre>
       * The amount of time it takes the backend service to fully respond to a
       * request. Measured from when the destination service starts to send the
       * request to the backend until when the destination service receives the
       * complete response from the backend.
       * </pre>
       *
       * <code>.google.protobuf.Duration backend_latency = 5;</code>
       */
      public Builder clearBackendLatency() {
        bitField0_ = (bitField0_ & ~0x00000010);
        backendLatency_ = null;
        if (backendLatencyBuilder_ != null) {
          backendLatencyBuilder_.dispose();
          backendLatencyBuilder_ = null;
        }
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The amount of time it takes the backend service to fully respond to a
       * request. Measured from when the destination service starts to send the
       * request to the backend until when the destination service receives the
       * complete response from the backend.
       * </pre>
       *
       * <code>.google.protobuf.Duration backend_latency = 5;</code>
       */
      public com.couchbase.client.core.deps.com.google.protobuf.Duration.Builder getBackendLatencyBuilder() {
        bitField0_ |= 0x00000010;
        onChanged();
        return getBackendLatencyFieldBuilder().getBuilder();
      }
      /**
       *
       *
       * <pre>
       * The amount of time it takes the backend service to fully respond to a
       * request. Measured from when the destination service starts to send the
       * request to the backend until when the destination service receives the
       * complete response from the backend.
       * </pre>
       *
       * <code>.google.protobuf.Duration backend_latency = 5;</code>
       */
      public com.couchbase.client.core.deps.com.google.protobuf.DurationOrBuilder getBackendLatencyOrBuilder() {
        if (backendLatencyBuilder_ != null) {
          return backendLatencyBuilder_.getMessageOrBuilder();
        } else {
          return backendLatency_ == null
              ? com.google.protobuf.Duration.getDefaultInstance()
              : backendLatency_;
        }
      }
      /**
       *
       *
       * <pre>
       * The amount of time it takes the backend service to fully respond to a
       * request. Measured from when the destination service starts to send the
       * request to the backend until when the destination service receives the
       * complete response from the backend.
       * </pre>
       *
       * <code>.google.protobuf.Duration backend_latency = 5;</code>
       */
      private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
              com.google.protobuf.Duration,
              com.google.protobuf.Duration.Builder,
              com.google.protobuf.DurationOrBuilder>
          getBackendLatencyFieldBuilder() {
        if (backendLatencyBuilder_ == null) {
          backendLatencyBuilder_ =
              new com.google.protobuf.SingleFieldBuilderV3<
                  com.google.protobuf.Duration,
                  com.google.protobuf.Duration.Builder,
                  com.google.protobuf.DurationOrBuilder>(
                  getBackendLatency(), getParentForChildren(), isClean());
          backendLatency_ = null;
        }
        return backendLatencyBuilder_;
      }

      @java.lang.Override
      public final Builder setUnknownFields(
          final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }

      // @@protoc_insertion_point(builder_scope:google.rpc.context.AttributeContext.Response)
    }

    // @@protoc_insertion_point(class_scope:google.rpc.context.AttributeContext.Response)
    private static final com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response DEFAULT_INSTANCE;

    static {
      DEFAULT_INSTANCE = new com.google.rpc.context.AttributeContext.Response();
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.couchbase.client.core.deps.com.google.protobuf.Parser<Response> PARSER =
        new com.google.protobuf.AbstractParser<Response>() {
          @java.lang.Override
          public Response parsePartialFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws com.google.protobuf.InvalidProtocolBufferException {
            Builder builder = newBuilder();
            try {
              builder.mergeFrom(input, extensionRegistry);
            } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
              throw e.setUnfinishedMessage(builder.buildPartial());
            } catch (com.couchbase.client.core.deps.com.google.protobuf.UninitializedMessageException e) {
              throw e.asInvalidProtocolBufferException()
                  .setUnfinishedMessage(builder.buildPartial());
            } catch (java.io.IOException e) {
              throw new com.google.protobuf.InvalidProtocolBufferException(e)
                  .setUnfinishedMessage(builder.buildPartial());
            }
            return builder.buildPartial();
          }
        };

    public static com.couchbase.client.core.deps.com.google.protobuf.Parser<Response> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Parser<Response> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }
  }

  public interface ResourceOrBuilder
      extends
      // @@protoc_insertion_point(interface_extends:google.rpc.context.AttributeContext.Resource)
      com.google.protobuf.MessageOrBuilder {

    /**
     *
     *
     * <pre>
     * The name of the service that this resource belongs to, such as
     * `pubsub.googleapis.com`. The service may be different from the DNS
     * hostname that actually serves the request.
     * </pre>
     *
     * <code>string service = 1;</code>
     *
     * @return The service.
     */
    java.lang.String getService();
    /**
     *
     *
     * <pre>
     * The name of the service that this resource belongs to, such as
     * `pubsub.googleapis.com`. The service may be different from the DNS
     * hostname that actually serves the request.
     * </pre>
     *
     * <code>string service = 1;</code>
     *
     * @return The bytes for service.
     */
    com.google.protobuf.ByteString getServiceBytes();

    /**
     *
     *
     * <pre>
     * The stable identifier (name) of a resource on the `service`. A resource
     * can be logically identified as "//{resource.service}/{resource.name}".
     * The differences between a resource name and a URI are:
     *
     * *   Resource name is a logical identifier, independent of network
     *     protocol and API version. For example,
     *     `//pubsub.googleapis.com/projects/123/topics/news-feed`.
     * *   URI often includes protocol and version information, so it can
     *     be used directly by applications. For example,
     *     `https://pubsub.googleapis.com/v1/projects/123/topics/news-feed`.
     *
     * See https://cloud.google.com/apis/design/resource_names for details.
     * </pre>
     *
     * <code>string name = 2;</code>
     *
     * @return The name.
     */
    java.lang.String getName();
    /**
     *
     *
     * <pre>
     * The stable identifier (name) of a resource on the `service`. A resource
     * can be logically identified as "//{resource.service}/{resource.name}".
     * The differences between a resource name and a URI are:
     *
     * *   Resource name is a logical identifier, independent of network
     *     protocol and API version. For example,
     *     `//pubsub.googleapis.com/projects/123/topics/news-feed`.
     * *   URI often includes protocol and version information, so it can
     *     be used directly by applications. For example,
     *     `https://pubsub.googleapis.com/v1/projects/123/topics/news-feed`.
     *
     * See https://cloud.google.com/apis/design/resource_names for details.
     * </pre>
     *
     * <code>string name = 2;</code>
     *
     * @return The bytes for name.
     */
    com.google.protobuf.ByteString getNameBytes();

    /**
     *
     *
     * <pre>
     * The type of the resource. The syntax is platform-specific because
     * different platforms define their resources differently.
     *
     * For Google APIs, the type format must be "{service}/{kind}", such as
     * "pubsub.googleapis.com/Topic".
     * </pre>
     *
     * <code>string type = 3;</code>
     *
     * @return The type.
     */
    java.lang.String getType();
    /**
     *
     *
     * <pre>
     * The type of the resource. The syntax is platform-specific because
     * different platforms define their resources differently.
     *
     * For Google APIs, the type format must be "{service}/{kind}", such as
     * "pubsub.googleapis.com/Topic".
     * </pre>
     *
     * <code>string type = 3;</code>
     *
     * @return The bytes for type.
     */
    com.google.protobuf.ByteString getTypeBytes();

    /**
     *
     *
     * <pre>
     * The labels or tags on the resource, such as AWS resource tags and
     * Kubernetes resource labels.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 4;</code>
     */
    int getLabelsCount();
    /**
     *
     *
     * <pre>
     * The labels or tags on the resource, such as AWS resource tags and
     * Kubernetes resource labels.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 4;</code>
     */
    boolean containsLabels(java.lang.String key);
    /** Use {@link #getLabelsMap()} instead. */
    @java.lang.Deprecated
    java.util.Map<java.lang.String, java.lang.String> getLabels();
    /**
     *
     *
     * <pre>
     * The labels or tags on the resource, such as AWS resource tags and
     * Kubernetes resource labels.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 4;</code>
     */
    java.util.Map<java.lang.String, java.lang.String> getLabelsMap();
    /**
     *
     *
     * <pre>
     * The labels or tags on the resource, such as AWS resource tags and
     * Kubernetes resource labels.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 4;</code>
     */
    /* nullable */
    java.lang.String getLabelsOrDefault(
        java.lang.String key,
        /* nullable */
        java.lang.String defaultValue);
    /**
     *
     *
     * <pre>
     * The labels or tags on the resource, such as AWS resource tags and
     * Kubernetes resource labels.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 4;</code>
     */
    java.lang.String getLabelsOrThrow(java.lang.String key);

    /**
     *
     *
     * <pre>
     * The unique identifier of the resource. UID is unique in the time
     * and space for this resource within the scope of the service. It is
     * typically generated by the server on successful creation of a resource
     * and must not be changed. UID is used to uniquely identify resources
     * with resource name reuses. This should be a UUID4.
     * </pre>
     *
     * <code>string uid = 5;</code>
     *
     * @return The uid.
     */
    java.lang.String getUid();
    /**
     *
     *
     * <pre>
     * The unique identifier of the resource. UID is unique in the time
     * and space for this resource within the scope of the service. It is
     * typically generated by the server on successful creation of a resource
     * and must not be changed. UID is used to uniquely identify resources
     * with resource name reuses. This should be a UUID4.
     * </pre>
     *
     * <code>string uid = 5;</code>
     *
     * @return The bytes for uid.
     */
    com.google.protobuf.ByteString getUidBytes();

    /**
     *
     *
     * <pre>
     * Annotations is an unstructured key-value map stored with a resource that
     * may be set by external tools to store and retrieve arbitrary metadata.
     * They are not queryable and should be preserved when modifying objects.
     *
     * More info: https://kubernetes.io/docs/user-guide/annotations
     * </pre>
     *
     * <code>map&lt;string, string&gt; annotations = 6;</code>
     */
    int getAnnotationsCount();
    /**
     *
     *
     * <pre>
     * Annotations is an unstructured key-value map stored with a resource that
     * may be set by external tools to store and retrieve arbitrary metadata.
     * They are not queryable and should be preserved when modifying objects.
     *
     * More info: https://kubernetes.io/docs/user-guide/annotations
     * </pre>
     *
     * <code>map&lt;string, string&gt; annotations = 6;</code>
     */
    boolean containsAnnotations(java.lang.String key);
    /** Use {@link #getAnnotationsMap()} instead. */
    @java.lang.Deprecated
    java.util.Map<java.lang.String, java.lang.String> getAnnotations();
    /**
     *
     *
     * <pre>
     * Annotations is an unstructured key-value map stored with a resource that
     * may be set by external tools to store and retrieve arbitrary metadata.
     * They are not queryable and should be preserved when modifying objects.
     *
     * More info: https://kubernetes.io/docs/user-guide/annotations
     * </pre>
     *
     * <code>map&lt;string, string&gt; annotations = 6;</code>
     */
    java.util.Map<java.lang.String, java.lang.String> getAnnotationsMap();
    /**
     *
     *
     * <pre>
     * Annotations is an unstructured key-value map stored with a resource that
     * may be set by external tools to store and retrieve arbitrary metadata.
     * They are not queryable and should be preserved when modifying objects.
     *
     * More info: https://kubernetes.io/docs/user-guide/annotations
     * </pre>
     *
     * <code>map&lt;string, string&gt; annotations = 6;</code>
     */
    /* nullable */
    java.lang.String getAnnotationsOrDefault(
        java.lang.String key,
        /* nullable */
        java.lang.String defaultValue);
    /**
     *
     *
     * <pre>
     * Annotations is an unstructured key-value map stored with a resource that
     * may be set by external tools to store and retrieve arbitrary metadata.
     * They are not queryable and should be preserved when modifying objects.
     *
     * More info: https://kubernetes.io/docs/user-guide/annotations
     * </pre>
     *
     * <code>map&lt;string, string&gt; annotations = 6;</code>
     */
    java.lang.String getAnnotationsOrThrow(java.lang.String key);

    /**
     *
     *
     * <pre>
     * Mutable. The display name set by clients. Must be &lt;= 63 characters.
     * </pre>
     *
     * <code>string display_name = 7;</code>
     *
     * @return The displayName.
     */
    java.lang.String getDisplayName();
    /**
     *
     *
     * <pre>
     * Mutable. The display name set by clients. Must be &lt;= 63 characters.
     * </pre>
     *
     * <code>string display_name = 7;</code>
     *
     * @return The bytes for displayName.
     */
    com.google.protobuf.ByteString getDisplayNameBytes();

    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was created. This may
     * be either the time creation was initiated or when it was completed.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp create_time = 8;</code>
     *
     * @return Whether the createTime field is set.
     */
    boolean hasCreateTime();
    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was created. This may
     * be either the time creation was initiated or when it was completed.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp create_time = 8;</code>
     *
     * @return The createTime.
     */
    com.google.protobuf.Timestamp getCreateTime();
    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was created. This may
     * be either the time creation was initiated or when it was completed.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp create_time = 8;</code>
     */
    com.google.protobuf.TimestampOrBuilder getCreateTimeOrBuilder();

    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was last updated. Any
     * change to the resource made by users must refresh this value.
     * Changes to a resource made by the service should refresh this value.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp update_time = 9;</code>
     *
     * @return Whether the updateTime field is set.
     */
    boolean hasUpdateTime();
    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was last updated. Any
     * change to the resource made by users must refresh this value.
     * Changes to a resource made by the service should refresh this value.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp update_time = 9;</code>
     *
     * @return The updateTime.
     */
    com.google.protobuf.Timestamp getUpdateTime();
    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was last updated. Any
     * change to the resource made by users must refresh this value.
     * Changes to a resource made by the service should refresh this value.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp update_time = 9;</code>
     */
    com.google.protobuf.TimestampOrBuilder getUpdateTimeOrBuilder();

    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was deleted.
     * If the resource is not deleted, this must be empty.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp delete_time = 10;</code>
     *
     * @return Whether the deleteTime field is set.
     */
    boolean hasDeleteTime();
    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was deleted.
     * If the resource is not deleted, this must be empty.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp delete_time = 10;</code>
     *
     * @return The deleteTime.
     */
    com.google.protobuf.Timestamp getDeleteTime();
    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was deleted.
     * If the resource is not deleted, this must be empty.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp delete_time = 10;</code>
     */
    com.google.protobuf.TimestampOrBuilder getDeleteTimeOrBuilder();

    /**
     *
     *
     * <pre>
     * Output only. An opaque value that uniquely identifies a version or
     * generation of a resource. It can be used to confirm that the client
     * and server agree on the ordering of a resource being written.
     * </pre>
     *
     * <code>string etag = 11;</code>
     *
     * @return The etag.
     */
    java.lang.String getEtag();
    /**
     *
     *
     * <pre>
     * Output only. An opaque value that uniquely identifies a version or
     * generation of a resource. It can be used to confirm that the client
     * and server agree on the ordering of a resource being written.
     * </pre>
     *
     * <code>string etag = 11;</code>
     *
     * @return The bytes for etag.
     */
    com.google.protobuf.ByteString getEtagBytes();

    /**
     *
     *
     * <pre>
     * Immutable. The location of the resource. The location encoding is
     * specific to the service provider, and new encoding may be introduced
     * as the service evolves.
     *
     * For Google Cloud products, the encoding is what is used by Google Cloud
     * APIs, such as `us-east1`, `aws-us-east-1`, and `azure-eastus2`. The
     * semantics of `location` is identical to the
     * `cloud.googleapis.com/location` label used by some Google Cloud APIs.
     * </pre>
     *
     * <code>string location = 12;</code>
     *
     * @return The location.
     */
    java.lang.String getLocation();
    /**
     *
     *
     * <pre>
     * Immutable. The location of the resource. The location encoding is
     * specific to the service provider, and new encoding may be introduced
     * as the service evolves.
     *
     * For Google Cloud products, the encoding is what is used by Google Cloud
     * APIs, such as `us-east1`, `aws-us-east-1`, and `azure-eastus2`. The
     * semantics of `location` is identical to the
     * `cloud.googleapis.com/location` label used by some Google Cloud APIs.
     * </pre>
     *
     * <code>string location = 12;</code>
     *
     * @return The bytes for location.
     */
    com.google.protobuf.ByteString getLocationBytes();
  }
  /**
   *
   *
   * <pre>
   * This message defines core attributes for a resource. A resource is an
   * addressable (named) entity provided by the destination service. For
   * example, a file stored on a network storage service.
   * </pre>
   *
   * Protobuf type {@code google.rpc.context.AttributeContext.Resource}
   */
  public static final class Resource extends com.google.protobuf.GeneratedMessageV3
      implements
      // @@protoc_insertion_point(message_implements:google.rpc.context.AttributeContext.Resource)
      ResourceOrBuilder {
    private static final long serialVersionUID = 0L;
    // Use Resource.newBuilder() to construct.
    private Resource(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }

    private Resource() {
      service_ = "";
      name_ = "";
      type_ = "";
      uid_ = "";
      displayName_ = "";
      etag_ = "";
      location_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(UnusedPrivateParameter unused) {
      return new Resource();
    }

    public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return com.google.rpc.context.AttributeContextProto
          .internal_static_google_rpc_context_AttributeContext_Resource_descriptor;
    }

    @SuppressWarnings({"rawtypes"})
    @java.lang.Override
    protected com.couchbase.client.core.deps.com.google.protobuf.MapFieldReflectionAccessor internalGetMapFieldReflection(
        int number) {
      switch (number) {
        case 4:
          return internalGetLabels();
        case 6:
          return internalGetAnnotations();
        default:
          throw new RuntimeException("Invalid map field number: " + number);
      }
    }

    @java.lang.Override
    protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.rpc.context.AttributeContextProto
          .internal_static_google_rpc_context_AttributeContext_Resource_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.rpc.context.AttributeContext.Resource.class,
              com.google.rpc.context.AttributeContext.Resource.Builder.class);
    }

    private int bitField0_;
    public static final int SERVICE_FIELD_NUMBER = 1;

    @SuppressWarnings("serial")
    private volatile java.lang.Object service_ = "";
    /**
     *
     *
     * <pre>
     * The name of the service that this resource belongs to, such as
     * `pubsub.googleapis.com`. The service may be different from the DNS
     * hostname that actually serves the request.
     * </pre>
     *
     * <code>string service = 1;</code>
     *
     * @return The service.
     */
    @java.lang.Override
    public java.lang.String getService() {
      java.lang.Object ref = service_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        service_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The name of the service that this resource belongs to, such as
     * `pubsub.googleapis.com`. The service may be different from the DNS
     * hostname that actually serves the request.
     * </pre>
     *
     * <code>string service = 1;</code>
     *
     * @return The bytes for service.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getServiceBytes() {
      java.lang.Object ref = service_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        service_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int NAME_FIELD_NUMBER = 2;

    @SuppressWarnings("serial")
    private volatile java.lang.Object name_ = "";
    /**
     *
     *
     * <pre>
     * The stable identifier (name) of a resource on the `service`. A resource
     * can be logically identified as "//{resource.service}/{resource.name}".
     * The differences between a resource name and a URI are:
     *
     * *   Resource name is a logical identifier, independent of network
     *     protocol and API version. For example,
     *     `//pubsub.googleapis.com/projects/123/topics/news-feed`.
     * *   URI often includes protocol and version information, so it can
     *     be used directly by applications. For example,
     *     `https://pubsub.googleapis.com/v1/projects/123/topics/news-feed`.
     *
     * See https://cloud.google.com/apis/design/resource_names for details.
     * </pre>
     *
     * <code>string name = 2;</code>
     *
     * @return The name.
     */
    @java.lang.Override
    public java.lang.String getName() {
      java.lang.Object ref = name_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        name_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The stable identifier (name) of a resource on the `service`. A resource
     * can be logically identified as "//{resource.service}/{resource.name}".
     * The differences between a resource name and a URI are:
     *
     * *   Resource name is a logical identifier, independent of network
     *     protocol and API version. For example,
     *     `//pubsub.googleapis.com/projects/123/topics/news-feed`.
     * *   URI often includes protocol and version information, so it can
     *     be used directly by applications. For example,
     *     `https://pubsub.googleapis.com/v1/projects/123/topics/news-feed`.
     *
     * See https://cloud.google.com/apis/design/resource_names for details.
     * </pre>
     *
     * <code>string name = 2;</code>
     *
     * @return The bytes for name.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getNameBytes() {
      java.lang.Object ref = name_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        name_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int TYPE_FIELD_NUMBER = 3;

    @SuppressWarnings("serial")
    private volatile java.lang.Object type_ = "";
    /**
     *
     *
     * <pre>
     * The type of the resource. The syntax is platform-specific because
     * different platforms define their resources differently.
     *
     * For Google APIs, the type format must be "{service}/{kind}", such as
     * "pubsub.googleapis.com/Topic".
     * </pre>
     *
     * <code>string type = 3;</code>
     *
     * @return The type.
     */
    @java.lang.Override
    public java.lang.String getType() {
      java.lang.Object ref = type_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        type_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The type of the resource. The syntax is platform-specific because
     * different platforms define their resources differently.
     *
     * For Google APIs, the type format must be "{service}/{kind}", such as
     * "pubsub.googleapis.com/Topic".
     * </pre>
     *
     * <code>string type = 3;</code>
     *
     * @return The bytes for type.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getTypeBytes() {
      java.lang.Object ref = type_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        type_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int LABELS_FIELD_NUMBER = 4;

    private static final class LabelsDefaultEntryHolder {
      static final com.couchbase.client.core.deps.com.google.protobuf.MapEntry<java.lang.String, java.lang.String> defaultEntry =
          com.google.protobuf.MapEntry.<java.lang.String, java.lang.String>newDefaultInstance(
              com.google.rpc.context.AttributeContextProto
                  .internal_static_google_rpc_context_AttributeContext_Resource_LabelsEntry_descriptor,
              com.google.protobuf.WireFormat.FieldType.STRING,
              "",
              com.google.protobuf.WireFormat.FieldType.STRING,
              "");
    }

    @SuppressWarnings("serial")
    private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String> labels_;

    private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String> internalGetLabels() {
      if (labels_ == null) {
        return com.google.protobuf.MapField.emptyMapField(LabelsDefaultEntryHolder.defaultEntry);
      }
      return labels_;
    }

    public int getLabelsCount() {
      return internalGetLabels().getMap().size();
    }
    /**
     *
     *
     * <pre>
     * The labels or tags on the resource, such as AWS resource tags and
     * Kubernetes resource labels.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 4;</code>
     */
    @java.lang.Override
    public boolean containsLabels(java.lang.String key) {
      if (key == null) {
        throw new NullPointerException("map key");
      }
      return internalGetLabels().getMap().containsKey(key);
    }
    /** Use {@link #getLabelsMap()} instead. */
    @java.lang.Override
    @java.lang.Deprecated
    public java.util.Map<java.lang.String, java.lang.String> getLabels() {
      return getLabelsMap();
    }
    /**
     *
     *
     * <pre>
     * The labels or tags on the resource, such as AWS resource tags and
     * Kubernetes resource labels.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 4;</code>
     */
    @java.lang.Override
    public java.util.Map<java.lang.String, java.lang.String> getLabelsMap() {
      return internalGetLabels().getMap();
    }
    /**
     *
     *
     * <pre>
     * The labels or tags on the resource, such as AWS resource tags and
     * Kubernetes resource labels.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 4;</code>
     */
    @java.lang.Override
    public /* nullable */ java.lang.String getLabelsOrDefault(
        java.lang.String key,
        /* nullable */
        java.lang.String defaultValue) {
      if (key == null) {
        throw new NullPointerException("map key");
      }
      java.util.Map<java.lang.String, java.lang.String> map = internalGetLabels().getMap();
      return map.containsKey(key) ? map.get(key) : defaultValue;
    }
    /**
     *
     *
     * <pre>
     * The labels or tags on the resource, such as AWS resource tags and
     * Kubernetes resource labels.
     * </pre>
     *
     * <code>map&lt;string, string&gt; labels = 4;</code>
     */
    @java.lang.Override
    public java.lang.String getLabelsOrThrow(java.lang.String key) {
      if (key == null) {
        throw new NullPointerException("map key");
      }
      java.util.Map<java.lang.String, java.lang.String> map = internalGetLabels().getMap();
      if (!map.containsKey(key)) {
        throw new java.lang.IllegalArgumentException();
      }
      return map.get(key);
    }

    public static final int UID_FIELD_NUMBER = 5;

    @SuppressWarnings("serial")
    private volatile java.lang.Object uid_ = "";
    /**
     *
     *
     * <pre>
     * The unique identifier of the resource. UID is unique in the time
     * and space for this resource within the scope of the service. It is
     * typically generated by the server on successful creation of a resource
     * and must not be changed. UID is used to uniquely identify resources
     * with resource name reuses. This should be a UUID4.
     * </pre>
     *
     * <code>string uid = 5;</code>
     *
     * @return The uid.
     */
    @java.lang.Override
    public java.lang.String getUid() {
      java.lang.Object ref = uid_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        uid_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * The unique identifier of the resource. UID is unique in the time
     * and space for this resource within the scope of the service. It is
     * typically generated by the server on successful creation of a resource
     * and must not be changed. UID is used to uniquely identify resources
     * with resource name reuses. This should be a UUID4.
     * </pre>
     *
     * <code>string uid = 5;</code>
     *
     * @return The bytes for uid.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getUidBytes() {
      java.lang.Object ref = uid_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        uid_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int ANNOTATIONS_FIELD_NUMBER = 6;

    private static final class AnnotationsDefaultEntryHolder {
      static final com.couchbase.client.core.deps.com.google.protobuf.MapEntry<java.lang.String, java.lang.String> defaultEntry =
          com.google.protobuf.MapEntry.<java.lang.String, java.lang.String>newDefaultInstance(
              com.google.rpc.context.AttributeContextProto
                  .internal_static_google_rpc_context_AttributeContext_Resource_AnnotationsEntry_descriptor,
              com.google.protobuf.WireFormat.FieldType.STRING,
              "",
              com.google.protobuf.WireFormat.FieldType.STRING,
              "");
    }

    @SuppressWarnings("serial")
    private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String> annotations_;

    private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String>
        internalGetAnnotations() {
      if (annotations_ == null) {
        return com.google.protobuf.MapField.emptyMapField(
            AnnotationsDefaultEntryHolder.defaultEntry);
      }
      return annotations_;
    }

    public int getAnnotationsCount() {
      return internalGetAnnotations().getMap().size();
    }
    /**
     *
     *
     * <pre>
     * Annotations is an unstructured key-value map stored with a resource that
     * may be set by external tools to store and retrieve arbitrary metadata.
     * They are not queryable and should be preserved when modifying objects.
     *
     * More info: https://kubernetes.io/docs/user-guide/annotations
     * </pre>
     *
     * <code>map&lt;string, string&gt; annotations = 6;</code>
     */
    @java.lang.Override
    public boolean containsAnnotations(java.lang.String key) {
      if (key == null) {
        throw new NullPointerException("map key");
      }
      return internalGetAnnotations().getMap().containsKey(key);
    }
    /** Use {@link #getAnnotationsMap()} instead. */
    @java.lang.Override
    @java.lang.Deprecated
    public java.util.Map<java.lang.String, java.lang.String> getAnnotations() {
      return getAnnotationsMap();
    }
    /**
     *
     *
     * <pre>
     * Annotations is an unstructured key-value map stored with a resource that
     * may be set by external tools to store and retrieve arbitrary metadata.
     * They are not queryable and should be preserved when modifying objects.
     *
     * More info: https://kubernetes.io/docs/user-guide/annotations
     * </pre>
     *
     * <code>map&lt;string, string&gt; annotations = 6;</code>
     */
    @java.lang.Override
    public java.util.Map<java.lang.String, java.lang.String> getAnnotationsMap() {
      return internalGetAnnotations().getMap();
    }
    /**
     *
     *
     * <pre>
     * Annotations is an unstructured key-value map stored with a resource that
     * may be set by external tools to store and retrieve arbitrary metadata.
     * They are not queryable and should be preserved when modifying objects.
     *
     * More info: https://kubernetes.io/docs/user-guide/annotations
     * </pre>
     *
     * <code>map&lt;string, string&gt; annotations = 6;</code>
     */
    @java.lang.Override
    public /* nullable */ java.lang.String getAnnotationsOrDefault(
        java.lang.String key,
        /* nullable */
        java.lang.String defaultValue) {
      if (key == null) {
        throw new NullPointerException("map key");
      }
      java.util.Map<java.lang.String, java.lang.String> map = internalGetAnnotations().getMap();
      return map.containsKey(key) ? map.get(key) : defaultValue;
    }
    /**
     *
     *
     * <pre>
     * Annotations is an unstructured key-value map stored with a resource that
     * may be set by external tools to store and retrieve arbitrary metadata.
     * They are not queryable and should be preserved when modifying objects.
     *
     * More info: https://kubernetes.io/docs/user-guide/annotations
     * </pre>
     *
     * <code>map&lt;string, string&gt; annotations = 6;</code>
     */
    @java.lang.Override
    public java.lang.String getAnnotationsOrThrow(java.lang.String key) {
      if (key == null) {
        throw new NullPointerException("map key");
      }
      java.util.Map<java.lang.String, java.lang.String> map = internalGetAnnotations().getMap();
      if (!map.containsKey(key)) {
        throw new java.lang.IllegalArgumentException();
      }
      return map.get(key);
    }

    public static final int DISPLAY_NAME_FIELD_NUMBER = 7;

    @SuppressWarnings("serial")
    private volatile java.lang.Object displayName_ = "";
    /**
     *
     *
     * <pre>
     * Mutable. The display name set by clients. Must be &lt;= 63 characters.
     * </pre>
     *
     * <code>string display_name = 7;</code>
     *
     * @return The displayName.
     */
    @java.lang.Override
    public java.lang.String getDisplayName() {
      java.lang.Object ref = displayName_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        displayName_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * Mutable. The display name set by clients. Must be &lt;= 63 characters.
     * </pre>
     *
     * <code>string display_name = 7;</code>
     *
     * @return The bytes for displayName.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getDisplayNameBytes() {
      java.lang.Object ref = displayName_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        displayName_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int CREATE_TIME_FIELD_NUMBER = 8;
    private com.couchbase.client.core.deps.com.google.protobuf.Timestamp createTime_;
    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was created. This may
     * be either the time creation was initiated or when it was completed.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp create_time = 8;</code>
     *
     * @return Whether the createTime field is set.
     */
    @java.lang.Override
    public boolean hasCreateTime() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was created. This may
     * be either the time creation was initiated or when it was completed.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp create_time = 8;</code>
     *
     * @return The createTime.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Timestamp getCreateTime() {
      return createTime_ == null ? com.google.protobuf.Timestamp.getDefaultInstance() : createTime_;
    }
    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was created. This may
     * be either the time creation was initiated or when it was completed.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp create_time = 8;</code>
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.TimestampOrBuilder getCreateTimeOrBuilder() {
      return createTime_ == null ? com.google.protobuf.Timestamp.getDefaultInstance() : createTime_;
    }

    public static final int UPDATE_TIME_FIELD_NUMBER = 9;
    private com.couchbase.client.core.deps.com.google.protobuf.Timestamp updateTime_;
    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was last updated. Any
     * change to the resource made by users must refresh this value.
     * Changes to a resource made by the service should refresh this value.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp update_time = 9;</code>
     *
     * @return Whether the updateTime field is set.
     */
    @java.lang.Override
    public boolean hasUpdateTime() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was last updated. Any
     * change to the resource made by users must refresh this value.
     * Changes to a resource made by the service should refresh this value.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp update_time = 9;</code>
     *
     * @return The updateTime.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Timestamp getUpdateTime() {
      return updateTime_ == null ? com.google.protobuf.Timestamp.getDefaultInstance() : updateTime_;
    }
    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was last updated. Any
     * change to the resource made by users must refresh this value.
     * Changes to a resource made by the service should refresh this value.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp update_time = 9;</code>
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.TimestampOrBuilder getUpdateTimeOrBuilder() {
      return updateTime_ == null ? com.google.protobuf.Timestamp.getDefaultInstance() : updateTime_;
    }

    public static final int DELETE_TIME_FIELD_NUMBER = 10;
    private com.couchbase.client.core.deps.com.google.protobuf.Timestamp deleteTime_;
    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was deleted.
     * If the resource is not deleted, this must be empty.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp delete_time = 10;</code>
     *
     * @return Whether the deleteTime field is set.
     */
    @java.lang.Override
    public boolean hasDeleteTime() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was deleted.
     * If the resource is not deleted, this must be empty.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp delete_time = 10;</code>
     *
     * @return The deleteTime.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Timestamp getDeleteTime() {
      return deleteTime_ == null ? com.google.protobuf.Timestamp.getDefaultInstance() : deleteTime_;
    }
    /**
     *
     *
     * <pre>
     * Output only. The timestamp when the resource was deleted.
     * If the resource is not deleted, this must be empty.
     * </pre>
     *
     * <code>.google.protobuf.Timestamp delete_time = 10;</code>
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.TimestampOrBuilder getDeleteTimeOrBuilder() {
      return deleteTime_ == null ? com.google.protobuf.Timestamp.getDefaultInstance() : deleteTime_;
    }

    public static final int ETAG_FIELD_NUMBER = 11;

    @SuppressWarnings("serial")
    private volatile java.lang.Object etag_ = "";
    /**
     *
     *
     * <pre>
     * Output only. An opaque value that uniquely identifies a version or
     * generation of a resource. It can be used to confirm that the client
     * and server agree on the ordering of a resource being written.
     * </pre>
     *
     * <code>string etag = 11;</code>
     *
     * @return The etag.
     */
    @java.lang.Override
    public java.lang.String getEtag() {
      java.lang.Object ref = etag_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        etag_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * Output only. An opaque value that uniquely identifies a version or
     * generation of a resource. It can be used to confirm that the client
     * and server agree on the ordering of a resource being written.
     * </pre>
     *
     * <code>string etag = 11;</code>
     *
     * @return The bytes for etag.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getEtagBytes() {
      java.lang.Object ref = etag_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        etag_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    public static final int LOCATION_FIELD_NUMBER = 12;

    @SuppressWarnings("serial")
    private volatile java.lang.Object location_ = "";
    /**
     *
     *
     * <pre>
     * Immutable. The location of the resource. The location encoding is
     * specific to the service provider, and new encoding may be introduced
     * as the service evolves.
     *
     * For Google Cloud products, the encoding is what is used by Google Cloud
     * APIs, such as `us-east1`, `aws-us-east-1`, and `azure-eastus2`. The
     * semantics of `location` is identical to the
     * `cloud.googleapis.com/location` label used by some Google Cloud APIs.
     * </pre>
     *
     * <code>string location = 12;</code>
     *
     * @return The location.
     */
    @java.lang.Override
    public java.lang.String getLocation() {
      java.lang.Object ref = location_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        location_ = s;
        return s;
      }
    }
    /**
     *
     *
     * <pre>
     * Immutable. The location of the resource. The location encoding is
     * specific to the service provider, and new encoding may be introduced
     * as the service evolves.
     *
     * For Google Cloud products, the encoding is what is used by Google Cloud
     * APIs, such as `us-east1`, `aws-us-east-1`, and `azure-eastus2`. The
     * semantics of `location` is identical to the
     * `cloud.googleapis.com/location` label used by some Google Cloud APIs.
     * </pre>
     *
     * <code>string location = 12;</code>
     *
     * @return The bytes for location.
     */
    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.ByteString getLocationBytes() {
      java.lang.Object ref = location_;
      if (ref instanceof java.lang.String) {
        com.google.protobuf.ByteString b =
            com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
        location_ = b;
        return b;
      } else {
        return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
      }
    }

    private byte memoizedIsInitialized = -1;

    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.couchbase.client.core.deps.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(service_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 1, service_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(name_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 2, name_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(type_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 3, type_);
      }
      com.google.protobuf.GeneratedMessageV3.serializeStringMapTo(
          output, internalGetLabels(), LabelsDefaultEntryHolder.defaultEntry, 4);
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(uid_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 5, uid_);
      }
      com.google.protobuf.GeneratedMessageV3.serializeStringMapTo(
          output, internalGetAnnotations(), AnnotationsDefaultEntryHolder.defaultEntry, 6);
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(displayName_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 7, displayName_);
      }
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeMessage(8, getCreateTime());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeMessage(9, getUpdateTime());
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        output.writeMessage(10, getDeleteTime());
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(etag_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 11, etag_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(location_)) {
        com.google.protobuf.GeneratedMessageV3.writeString(output, 12, location_);
      }
      getUnknownFields().writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(service_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(1, service_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(name_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, name_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(type_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(3, type_);
      }
      for (java.util.Map.Entry<java.lang.String, java.lang.String> entry :
          internalGetLabels().getMap().entrySet()) {
        com.google.protobuf.MapEntry<java.lang.String, java.lang.String> labels__ =
            LabelsDefaultEntryHolder.defaultEntry
                .newBuilderForType()
                .setKey(entry.getKey())
                .setValue(entry.getValue())
                .build();
        size += com.google.protobuf.CodedOutputStream.computeMessageSize(4, labels__);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(uid_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(5, uid_);
      }
      for (java.util.Map.Entry<java.lang.String, java.lang.String> entry :
          internalGetAnnotations().getMap().entrySet()) {
        com.google.protobuf.MapEntry<java.lang.String, java.lang.String> annotations__ =
            AnnotationsDefaultEntryHolder.defaultEntry
                .newBuilderForType()
                .setKey(entry.getKey())
                .setValue(entry.getValue())
                .build();
        size += com.google.protobuf.CodedOutputStream.computeMessageSize(6, annotations__);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(displayName_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(7, displayName_);
      }
      if (((bitField0_ & 0x00000001) != 0)) {
        size += com.google.protobuf.CodedOutputStream.computeMessageSize(8, getCreateTime());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += com.google.protobuf.CodedOutputStream.computeMessageSize(9, getUpdateTime());
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        size += com.google.protobuf.CodedOutputStream.computeMessageSize(10, getDeleteTime());
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(etag_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(11, etag_);
      }
      if (!com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.isStringEmpty(location_)) {
        size += com.google.protobuf.GeneratedMessageV3.computeStringSize(12, location_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
        return true;
      }
      if (!(obj instanceof com.google.rpc.context.AttributeContext.Resource)) {
        return super.equals(obj);
      }
      com.google.rpc.context.AttributeContext.Resource other =
          (com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource) obj;

      if (!getService().equals(other.getService())) return false;
      if (!getName().equals(other.getName())) return false;
      if (!getType().equals(other.getType())) return false;
      if (!internalGetLabels().equals(other.internalGetLabels())) return false;
      if (!getUid().equals(other.getUid())) return false;
      if (!internalGetAnnotations().equals(other.internalGetAnnotations())) return false;
      if (!getDisplayName().equals(other.getDisplayName())) return false;
      if (hasCreateTime() != other.hasCreateTime()) return false;
      if (hasCreateTime()) {
        if (!getCreateTime().equals(other.getCreateTime())) return false;
      }
      if (hasUpdateTime() != other.hasUpdateTime()) return false;
      if (hasUpdateTime()) {
        if (!getUpdateTime().equals(other.getUpdateTime())) return false;
      }
      if (hasDeleteTime() != other.hasDeleteTime()) return false;
      if (hasDeleteTime()) {
        if (!getDeleteTime().equals(other.getDeleteTime())) return false;
      }
      if (!getEtag().equals(other.getEtag())) return false;
      if (!getLocation().equals(other.getLocation())) return false;
      if (!getUnknownFields().equals(other.getUnknownFields())) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + SERVICE_FIELD_NUMBER;
      hash = (53 * hash) + getService().hashCode();
      hash = (37 * hash) + NAME_FIELD_NUMBER;
      hash = (53 * hash) + getName().hashCode();
      hash = (37 * hash) + TYPE_FIELD_NUMBER;
      hash = (53 * hash) + getType().hashCode();
      if (!internalGetLabels().getMap().isEmpty()) {
        hash = (37 * hash) + LABELS_FIELD_NUMBER;
        hash = (53 * hash) + internalGetLabels().hashCode();
      }
      hash = (37 * hash) + UID_FIELD_NUMBER;
      hash = (53 * hash) + getUid().hashCode();
      if (!internalGetAnnotations().getMap().isEmpty()) {
        hash = (37 * hash) + ANNOTATIONS_FIELD_NUMBER;
        hash = (53 * hash) + internalGetAnnotations().hashCode();
      }
      hash = (37 * hash) + DISPLAY_NAME_FIELD_NUMBER;
      hash = (53 * hash) + getDisplayName().hashCode();
      if (hasCreateTime()) {
        hash = (37 * hash) + CREATE_TIME_FIELD_NUMBER;
        hash = (53 * hash) + getCreateTime().hashCode();
      }
      if (hasUpdateTime()) {
        hash = (37 * hash) + UPDATE_TIME_FIELD_NUMBER;
        hash = (53 * hash) + getUpdateTime().hashCode();
      }
      if (hasDeleteTime()) {
        hash = (37 * hash) + DELETE_TIME_FIELD_NUMBER;
        hash = (53 * hash) + getDeleteTime().hashCode();
      }
      hash = (37 * hash) + ETAG_FIELD_NUMBER;
      hash = (53 * hash) + getEtag().hashCode();
      hash = (37 * hash) + LOCATION_FIELD_NUMBER;
      hash = (53 * hash) + getLocation().hashCode();
      hash = (29 * hash) + getUnknownFields().hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource parseFrom(
        java.nio.ByteBuffer data) throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource parseFrom(
        java.nio.ByteBuffer data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource parseFrom(
        byte[] data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource parseFrom(
        java.io.InputStream input) throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource parseFrom(
        java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource parseDelimitedFrom(
        java.io.InputStream input) throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource parseDelimitedFrom(
        java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
          PARSER, input, extensionRegistry);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource parseFrom(
        com.google.protobuf.CodedInputStream input) throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
          PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() {
      return newBuilder();
    }

    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }

    public static Builder newBuilder(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }

    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     *
     *
     * <pre>
     * This message defines core attributes for a resource. A resource is an
     * addressable (named) entity provided by the destination service. For
     * example, a file stored on a network storage service.
     * </pre>
     *
     * Protobuf type {@code google.rpc.context.AttributeContext.Resource}
     */
    public static final class Builder
        extends com.google.protobuf.GeneratedMessageV3.Builder<Builder>
        implements
        // @@protoc_insertion_point(builder_implements:google.rpc.context.AttributeContext.Resource)
        com.google.rpc.context.AttributeContext.ResourceOrBuilder {
      public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Resource_descriptor;
      }

      @SuppressWarnings({"rawtypes"})
      protected com.couchbase.client.core.deps.com.google.protobuf.MapFieldReflectionAccessor internalGetMapFieldReflection(
          int number) {
        switch (number) {
          case 4:
            return internalGetLabels();
          case 6:
            return internalGetAnnotations();
          default:
            throw new RuntimeException("Invalid map field number: " + number);
        }
      }

      @SuppressWarnings({"rawtypes"})
      protected com.couchbase.client.core.deps.com.google.protobuf.MapFieldReflectionAccessor internalGetMutableMapFieldReflection(
          int number) {
        switch (number) {
          case 4:
            return internalGetMutableLabels();
          case 6:
            return internalGetMutableAnnotations();
          default:
            throw new RuntimeException("Invalid map field number: " + number);
        }
      }

      @java.lang.Override
      protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Resource_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                com.google.rpc.context.AttributeContext.Resource.class,
                com.google.rpc.context.AttributeContext.Resource.Builder.class);
      }

      // Construct using com.google.rpc.context.AttributeContext.Resource.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }

      private void maybeForceBuilderInitialization() {
        if (com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {
          getCreateTimeFieldBuilder();
          getUpdateTimeFieldBuilder();
          getDeleteTimeFieldBuilder();
        }
      }

      @java.lang.Override
      public Builder clear() {
        super.clear();
        bitField0_ = 0;
        service_ = "";
        name_ = "";
        type_ = "";
        internalGetMutableLabels().clear();
        uid_ = "";
        internalGetMutableAnnotations().clear();
        displayName_ = "";
        createTime_ = null;
        if (createTimeBuilder_ != null) {
          createTimeBuilder_.dispose();
          createTimeBuilder_ = null;
        }
        updateTime_ = null;
        if (updateTimeBuilder_ != null) {
          updateTimeBuilder_.dispose();
          updateTimeBuilder_ = null;
        }
        deleteTime_ = null;
        if (deleteTimeBuilder_ != null) {
          deleteTimeBuilder_.dispose();
          deleteTimeBuilder_ = null;
        }
        etag_ = "";
        location_ = "";
        return this;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
        return com.google.rpc.context.AttributeContextProto
            .internal_static_google_rpc_context_AttributeContext_Resource_descriptor;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource getDefaultInstanceForType() {
        return com.google.rpc.context.AttributeContext.Resource.getDefaultInstance();
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource build() {
        com.google.rpc.context.AttributeContext.Resource result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource buildPartial() {
        com.google.rpc.context.AttributeContext.Resource result =
            new com.google.rpc.context.AttributeContext.Resource(this);
        if (bitField0_ != 0) {
          buildPartial0(result);
        }
        onBuilt();
        return result;
      }

      private void buildPartial0(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource result) {
        int from_bitField0_ = bitField0_;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          result.service_ = service_;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          result.name_ = name_;
        }
        if (((from_bitField0_ & 0x00000004) != 0)) {
          result.type_ = type_;
        }
        if (((from_bitField0_ & 0x00000008) != 0)) {
          result.labels_ = internalGetLabels();
          result.labels_.makeImmutable();
        }
        if (((from_bitField0_ & 0x00000010) != 0)) {
          result.uid_ = uid_;
        }
        if (((from_bitField0_ & 0x00000020) != 0)) {
          result.annotations_ = internalGetAnnotations();
          result.annotations_.makeImmutable();
        }
        if (((from_bitField0_ & 0x00000040) != 0)) {
          result.displayName_ = displayName_;
        }
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000080) != 0)) {
          result.createTime_ =
              createTimeBuilder_ == null ? createTime_ : createTimeBuilder_.build();
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000100) != 0)) {
          result.updateTime_ =
              updateTimeBuilder_ == null ? updateTime_ : updateTimeBuilder_.build();
          to_bitField0_ |= 0x00000002;
        }
        if (((from_bitField0_ & 0x00000200) != 0)) {
          result.deleteTime_ =
              deleteTimeBuilder_ == null ? deleteTime_ : deleteTimeBuilder_.build();
          to_bitField0_ |= 0x00000004;
        }
        if (((from_bitField0_ & 0x00000400) != 0)) {
          result.etag_ = etag_;
        }
        if (((from_bitField0_ & 0x00000800) != 0)) {
          result.location_ = location_;
        }
        result.bitField0_ |= to_bitField0_;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }

      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.setField(field, value);
      }

      @java.lang.Override
      public Builder clearField(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }

      @java.lang.Override
      public Builder clearOneof(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }

      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index,
          java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }

      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }

      @java.lang.Override
      public Builder mergeFrom(com.couchbase.client.core.deps.com.google.protobuf.Message other) {
        if (other instanceof com.google.rpc.context.AttributeContext.Resource) {
          return mergeFrom((com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource) other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource other) {
        if (other == com.google.rpc.context.AttributeContext.Resource.getDefaultInstance())
          return this;
        if (!other.getService().isEmpty()) {
          service_ = other.service_;
          bitField0_ |= 0x00000001;
          onChanged();
        }
        if (!other.getName().isEmpty()) {
          name_ = other.name_;
          bitField0_ |= 0x00000002;
          onChanged();
        }
        if (!other.getType().isEmpty()) {
          type_ = other.type_;
          bitField0_ |= 0x00000004;
          onChanged();
        }
        internalGetMutableLabels().mergeFrom(other.internalGetLabels());
        bitField0_ |= 0x00000008;
        if (!other.getUid().isEmpty()) {
          uid_ = other.uid_;
          bitField0_ |= 0x00000010;
          onChanged();
        }
        internalGetMutableAnnotations().mergeFrom(other.internalGetAnnotations());
        bitField0_ |= 0x00000020;
        if (!other.getDisplayName().isEmpty()) {
          displayName_ = other.displayName_;
          bitField0_ |= 0x00000040;
          onChanged();
        }
        if (other.hasCreateTime()) {
          mergeCreateTime(other.getCreateTime());
        }
        if (other.hasUpdateTime()) {
          mergeUpdateTime(other.getUpdateTime());
        }
        if (other.hasDeleteTime()) {
          mergeDeleteTime(other.getDeleteTime());
        }
        if (!other.getEtag().isEmpty()) {
          etag_ = other.etag_;
          bitField0_ |= 0x00000400;
          onChanged();
        }
        if (!other.getLocation().isEmpty()) {
          location_ = other.location_;
          bitField0_ |= 0x00000800;
          onChanged();
        }
        this.mergeUnknownFields(other.getUnknownFields());
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 10:
                {
                  service_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000001;
                  break;
                } // case 10
              case 18:
                {
                  name_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000002;
                  break;
                } // case 18
              case 26:
                {
                  type_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000004;
                  break;
                } // case 26
              case 34:
                {
                  com.google.protobuf.MapEntry<java.lang.String, java.lang.String> labels__ =
                      input.readMessage(
                          LabelsDefaultEntryHolder.defaultEntry.getParserForType(),
                          extensionRegistry);
                  internalGetMutableLabels()
                      .getMutableMap()
                      .put(labels__.getKey(), labels__.getValue());
                  bitField0_ |= 0x00000008;
                  break;
                } // case 34
              case 42:
                {
                  uid_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000010;
                  break;
                } // case 42
              case 50:
                {
                  com.google.protobuf.MapEntry<java.lang.String, java.lang.String> annotations__ =
                      input.readMessage(
                          AnnotationsDefaultEntryHolder.defaultEntry.getParserForType(),
                          extensionRegistry);
                  internalGetMutableAnnotations()
                      .getMutableMap()
                      .put(annotations__.getKey(), annotations__.getValue());
                  bitField0_ |= 0x00000020;
                  break;
                } // case 50
              case 58:
                {
                  displayName_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000040;
                  break;
                } // case 58
              case 66:
                {
                  input.readMessage(getCreateTimeFieldBuilder().getBuilder(), extensionRegistry);
                  bitField0_ |= 0x00000080;
                  break;
                } // case 66
              case 74:
                {
                  input.readMessage(getUpdateTimeFieldBuilder().getBuilder(), extensionRegistry);
                  bitField0_ |= 0x00000100;
                  break;
                } // case 74
              case 82:
                {
                  input.readMessage(getDeleteTimeFieldBuilder().getBuilder(), extensionRegistry);
                  bitField0_ |= 0x00000200;
                  break;
                } // case 82
              case 90:
                {
                  etag_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000400;
                  break;
                } // case 90
              case 98:
                {
                  location_ = input.readStringRequireUtf8();
                  bitField0_ |= 0x00000800;
                  break;
                } // case 98
              default:
                {
                  if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                    done = true; // was an endgroup tag
                  }
                  break;
                } // default:
            } // switch (tag)
          } // while (!done)
        } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
          throw e.unwrapIOException();
        } finally {
          onChanged();
        } // finally
        return this;
      }

      private int bitField0_;

      private java.lang.Object service_ = "";
      /**
       *
       *
       * <pre>
       * The name of the service that this resource belongs to, such as
       * `pubsub.googleapis.com`. The service may be different from the DNS
       * hostname that actually serves the request.
       * </pre>
       *
       * <code>string service = 1;</code>
       *
       * @return The service.
       */
      public java.lang.String getService() {
        java.lang.Object ref = service_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          service_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The name of the service that this resource belongs to, such as
       * `pubsub.googleapis.com`. The service may be different from the DNS
       * hostname that actually serves the request.
       * </pre>
       *
       * <code>string service = 1;</code>
       *
       * @return The bytes for service.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getServiceBytes() {
        java.lang.Object ref = service_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          service_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The name of the service that this resource belongs to, such as
       * `pubsub.googleapis.com`. The service may be different from the DNS
       * hostname that actually serves the request.
       * </pre>
       *
       * <code>string service = 1;</code>
       *
       * @param value The service to set.
       * @return This builder for chaining.
       */
      public Builder setService(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        service_ = value;
        bitField0_ |= 0x00000001;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The name of the service that this resource belongs to, such as
       * `pubsub.googleapis.com`. The service may be different from the DNS
       * hostname that actually serves the request.
       * </pre>
       *
       * <code>string service = 1;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearService() {
        service_ = getDefaultInstance().getService();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The name of the service that this resource belongs to, such as
       * `pubsub.googleapis.com`. The service may be different from the DNS
       * hostname that actually serves the request.
       * </pre>
       *
       * <code>string service = 1;</code>
       *
       * @param value The bytes for service to set.
       * @return This builder for chaining.
       */
      public Builder setServiceBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        service_ = value;
        bitField0_ |= 0x00000001;
        onChanged();
        return this;
      }

      private java.lang.Object name_ = "";
      /**
       *
       *
       * <pre>
       * The stable identifier (name) of a resource on the `service`. A resource
       * can be logically identified as "//{resource.service}/{resource.name}".
       * The differences between a resource name and a URI are:
       *
       * *   Resource name is a logical identifier, independent of network
       *     protocol and API version. For example,
       *     `//pubsub.googleapis.com/projects/123/topics/news-feed`.
       * *   URI often includes protocol and version information, so it can
       *     be used directly by applications. For example,
       *     `https://pubsub.googleapis.com/v1/projects/123/topics/news-feed`.
       *
       * See https://cloud.google.com/apis/design/resource_names for details.
       * </pre>
       *
       * <code>string name = 2;</code>
       *
       * @return The name.
       */
      public java.lang.String getName() {
        java.lang.Object ref = name_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          name_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The stable identifier (name) of a resource on the `service`. A resource
       * can be logically identified as "//{resource.service}/{resource.name}".
       * The differences between a resource name and a URI are:
       *
       * *   Resource name is a logical identifier, independent of network
       *     protocol and API version. For example,
       *     `//pubsub.googleapis.com/projects/123/topics/news-feed`.
       * *   URI often includes protocol and version information, so it can
       *     be used directly by applications. For example,
       *     `https://pubsub.googleapis.com/v1/projects/123/topics/news-feed`.
       *
       * See https://cloud.google.com/apis/design/resource_names for details.
       * </pre>
       *
       * <code>string name = 2;</code>
       *
       * @return The bytes for name.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getNameBytes() {
        java.lang.Object ref = name_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          name_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The stable identifier (name) of a resource on the `service`. A resource
       * can be logically identified as "//{resource.service}/{resource.name}".
       * The differences between a resource name and a URI are:
       *
       * *   Resource name is a logical identifier, independent of network
       *     protocol and API version. For example,
       *     `//pubsub.googleapis.com/projects/123/topics/news-feed`.
       * *   URI often includes protocol and version information, so it can
       *     be used directly by applications. For example,
       *     `https://pubsub.googleapis.com/v1/projects/123/topics/news-feed`.
       *
       * See https://cloud.google.com/apis/design/resource_names for details.
       * </pre>
       *
       * <code>string name = 2;</code>
       *
       * @param value The name to set.
       * @return This builder for chaining.
       */
      public Builder setName(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        name_ = value;
        bitField0_ |= 0x00000002;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The stable identifier (name) of a resource on the `service`. A resource
       * can be logically identified as "//{resource.service}/{resource.name}".
       * The differences between a resource name and a URI are:
       *
       * *   Resource name is a logical identifier, independent of network
       *     protocol and API version. For example,
       *     `//pubsub.googleapis.com/projects/123/topics/news-feed`.
       * *   URI often includes protocol and version information, so it can
       *     be used directly by applications. For example,
       *     `https://pubsub.googleapis.com/v1/projects/123/topics/news-feed`.
       *
       * See https://cloud.google.com/apis/design/resource_names for details.
       * </pre>
       *
       * <code>string name = 2;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearName() {
        name_ = getDefaultInstance().getName();
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The stable identifier (name) of a resource on the `service`. A resource
       * can be logically identified as "//{resource.service}/{resource.name}".
       * The differences between a resource name and a URI are:
       *
       * *   Resource name is a logical identifier, independent of network
       *     protocol and API version. For example,
       *     `//pubsub.googleapis.com/projects/123/topics/news-feed`.
       * *   URI often includes protocol and version information, so it can
       *     be used directly by applications. For example,
       *     `https://pubsub.googleapis.com/v1/projects/123/topics/news-feed`.
       *
       * See https://cloud.google.com/apis/design/resource_names for details.
       * </pre>
       *
       * <code>string name = 2;</code>
       *
       * @param value The bytes for name to set.
       * @return This builder for chaining.
       */
      public Builder setNameBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        name_ = value;
        bitField0_ |= 0x00000002;
        onChanged();
        return this;
      }

      private java.lang.Object type_ = "";
      /**
       *
       *
       * <pre>
       * The type of the resource. The syntax is platform-specific because
       * different platforms define their resources differently.
       *
       * For Google APIs, the type format must be "{service}/{kind}", such as
       * "pubsub.googleapis.com/Topic".
       * </pre>
       *
       * <code>string type = 3;</code>
       *
       * @return The type.
       */
      public java.lang.String getType() {
        java.lang.Object ref = type_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          type_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The type of the resource. The syntax is platform-specific because
       * different platforms define their resources differently.
       *
       * For Google APIs, the type format must be "{service}/{kind}", such as
       * "pubsub.googleapis.com/Topic".
       * </pre>
       *
       * <code>string type = 3;</code>
       *
       * @return The bytes for type.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getTypeBytes() {
        java.lang.Object ref = type_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          type_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The type of the resource. The syntax is platform-specific because
       * different platforms define their resources differently.
       *
       * For Google APIs, the type format must be "{service}/{kind}", such as
       * "pubsub.googleapis.com/Topic".
       * </pre>
       *
       * <code>string type = 3;</code>
       *
       * @param value The type to set.
       * @return This builder for chaining.
       */
      public Builder setType(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        type_ = value;
        bitField0_ |= 0x00000004;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The type of the resource. The syntax is platform-specific because
       * different platforms define their resources differently.
       *
       * For Google APIs, the type format must be "{service}/{kind}", such as
       * "pubsub.googleapis.com/Topic".
       * </pre>
       *
       * <code>string type = 3;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearType() {
        type_ = getDefaultInstance().getType();
        bitField0_ = (bitField0_ & ~0x00000004);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The type of the resource. The syntax is platform-specific because
       * different platforms define their resources differently.
       *
       * For Google APIs, the type format must be "{service}/{kind}", such as
       * "pubsub.googleapis.com/Topic".
       * </pre>
       *
       * <code>string type = 3;</code>
       *
       * @param value The bytes for type to set.
       * @return This builder for chaining.
       */
      public Builder setTypeBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        type_ = value;
        bitField0_ |= 0x00000004;
        onChanged();
        return this;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String> labels_;

      private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String> internalGetLabels() {
        if (labels_ == null) {
          return com.google.protobuf.MapField.emptyMapField(LabelsDefaultEntryHolder.defaultEntry);
        }
        return labels_;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String>
          internalGetMutableLabels() {
        if (labels_ == null) {
          labels_ = com.google.protobuf.MapField.newMapField(LabelsDefaultEntryHolder.defaultEntry);
        }
        if (!labels_.isMutable()) {
          labels_ = labels_.copy();
        }
        bitField0_ |= 0x00000008;
        onChanged();
        return labels_;
      }

      public int getLabelsCount() {
        return internalGetLabels().getMap().size();
      }
      /**
       *
       *
       * <pre>
       * The labels or tags on the resource, such as AWS resource tags and
       * Kubernetes resource labels.
       * </pre>
       *
       * <code>map&lt;string, string&gt; labels = 4;</code>
       */
      @java.lang.Override
      public boolean containsLabels(java.lang.String key) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        return internalGetLabels().getMap().containsKey(key);
      }
      /** Use {@link #getLabelsMap()} instead. */
      @java.lang.Override
      @java.lang.Deprecated
      public java.util.Map<java.lang.String, java.lang.String> getLabels() {
        return getLabelsMap();
      }
      /**
       *
       *
       * <pre>
       * The labels or tags on the resource, such as AWS resource tags and
       * Kubernetes resource labels.
       * </pre>
       *
       * <code>map&lt;string, string&gt; labels = 4;</code>
       */
      @java.lang.Override
      public java.util.Map<java.lang.String, java.lang.String> getLabelsMap() {
        return internalGetLabels().getMap();
      }
      /**
       *
       *
       * <pre>
       * The labels or tags on the resource, such as AWS resource tags and
       * Kubernetes resource labels.
       * </pre>
       *
       * <code>map&lt;string, string&gt; labels = 4;</code>
       */
      @java.lang.Override
      public /* nullable */ java.lang.String getLabelsOrDefault(
          java.lang.String key,
          /* nullable */
          java.lang.String defaultValue) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        java.util.Map<java.lang.String, java.lang.String> map = internalGetLabels().getMap();
        return map.containsKey(key) ? map.get(key) : defaultValue;
      }
      /**
       *
       *
       * <pre>
       * The labels or tags on the resource, such as AWS resource tags and
       * Kubernetes resource labels.
       * </pre>
       *
       * <code>map&lt;string, string&gt; labels = 4;</code>
       */
      @java.lang.Override
      public java.lang.String getLabelsOrThrow(java.lang.String key) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        java.util.Map<java.lang.String, java.lang.String> map = internalGetLabels().getMap();
        if (!map.containsKey(key)) {
          throw new java.lang.IllegalArgumentException();
        }
        return map.get(key);
      }

      public Builder clearLabels() {
        bitField0_ = (bitField0_ & ~0x00000008);
        internalGetMutableLabels().getMutableMap().clear();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The labels or tags on the resource, such as AWS resource tags and
       * Kubernetes resource labels.
       * </pre>
       *
       * <code>map&lt;string, string&gt; labels = 4;</code>
       */
      public Builder removeLabels(java.lang.String key) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        internalGetMutableLabels().getMutableMap().remove(key);
        return this;
      }
      /** Use alternate mutation accessors instead. */
      @java.lang.Deprecated
      public java.util.Map<java.lang.String, java.lang.String> getMutableLabels() {
        bitField0_ |= 0x00000008;
        return internalGetMutableLabels().getMutableMap();
      }
      /**
       *
       *
       * <pre>
       * The labels or tags on the resource, such as AWS resource tags and
       * Kubernetes resource labels.
       * </pre>
       *
       * <code>map&lt;string, string&gt; labels = 4;</code>
       */
      public Builder putLabels(java.lang.String key, java.lang.String value) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        if (value == null) {
          throw new NullPointerException("map value");
        }
        internalGetMutableLabels().getMutableMap().put(key, value);
        bitField0_ |= 0x00000008;
        return this;
      }
      /**
       *
       *
       * <pre>
       * The labels or tags on the resource, such as AWS resource tags and
       * Kubernetes resource labels.
       * </pre>
       *
       * <code>map&lt;string, string&gt; labels = 4;</code>
       */
      public Builder putAllLabels(java.util.Map<java.lang.String, java.lang.String> values) {
        internalGetMutableLabels().getMutableMap().putAll(values);
        bitField0_ |= 0x00000008;
        return this;
      }

      private java.lang.Object uid_ = "";
      /**
       *
       *
       * <pre>
       * The unique identifier of the resource. UID is unique in the time
       * and space for this resource within the scope of the service. It is
       * typically generated by the server on successful creation of a resource
       * and must not be changed. UID is used to uniquely identify resources
       * with resource name reuses. This should be a UUID4.
       * </pre>
       *
       * <code>string uid = 5;</code>
       *
       * @return The uid.
       */
      public java.lang.String getUid() {
        java.lang.Object ref = uid_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          uid_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The unique identifier of the resource. UID is unique in the time
       * and space for this resource within the scope of the service. It is
       * typically generated by the server on successful creation of a resource
       * and must not be changed. UID is used to uniquely identify resources
       * with resource name reuses. This should be a UUID4.
       * </pre>
       *
       * <code>string uid = 5;</code>
       *
       * @return The bytes for uid.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getUidBytes() {
        java.lang.Object ref = uid_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          uid_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * The unique identifier of the resource. UID is unique in the time
       * and space for this resource within the scope of the service. It is
       * typically generated by the server on successful creation of a resource
       * and must not be changed. UID is used to uniquely identify resources
       * with resource name reuses. This should be a UUID4.
       * </pre>
       *
       * <code>string uid = 5;</code>
       *
       * @param value The uid to set.
       * @return This builder for chaining.
       */
      public Builder setUid(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        uid_ = value;
        bitField0_ |= 0x00000010;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The unique identifier of the resource. UID is unique in the time
       * and space for this resource within the scope of the service. It is
       * typically generated by the server on successful creation of a resource
       * and must not be changed. UID is used to uniquely identify resources
       * with resource name reuses. This should be a UUID4.
       * </pre>
       *
       * <code>string uid = 5;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearUid() {
        uid_ = getDefaultInstance().getUid();
        bitField0_ = (bitField0_ & ~0x00000010);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * The unique identifier of the resource. UID is unique in the time
       * and space for this resource within the scope of the service. It is
       * typically generated by the server on successful creation of a resource
       * and must not be changed. UID is used to uniquely identify resources
       * with resource name reuses. This should be a UUID4.
       * </pre>
       *
       * <code>string uid = 5;</code>
       *
       * @param value The bytes for uid to set.
       * @return This builder for chaining.
       */
      public Builder setUidBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        uid_ = value;
        bitField0_ |= 0x00000010;
        onChanged();
        return this;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String> annotations_;

      private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String>
          internalGetAnnotations() {
        if (annotations_ == null) {
          return com.google.protobuf.MapField.emptyMapField(
              AnnotationsDefaultEntryHolder.defaultEntry);
        }
        return annotations_;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.MapField<java.lang.String, java.lang.String>
          internalGetMutableAnnotations() {
        if (annotations_ == null) {
          annotations_ =
              com.google.protobuf.MapField.newMapField(AnnotationsDefaultEntryHolder.defaultEntry);
        }
        if (!annotations_.isMutable()) {
          annotations_ = annotations_.copy();
        }
        bitField0_ |= 0x00000020;
        onChanged();
        return annotations_;
      }

      public int getAnnotationsCount() {
        return internalGetAnnotations().getMap().size();
      }
      /**
       *
       *
       * <pre>
       * Annotations is an unstructured key-value map stored with a resource that
       * may be set by external tools to store and retrieve arbitrary metadata.
       * They are not queryable and should be preserved when modifying objects.
       *
       * More info: https://kubernetes.io/docs/user-guide/annotations
       * </pre>
       *
       * <code>map&lt;string, string&gt; annotations = 6;</code>
       */
      @java.lang.Override
      public boolean containsAnnotations(java.lang.String key) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        return internalGetAnnotations().getMap().containsKey(key);
      }
      /** Use {@link #getAnnotationsMap()} instead. */
      @java.lang.Override
      @java.lang.Deprecated
      public java.util.Map<java.lang.String, java.lang.String> getAnnotations() {
        return getAnnotationsMap();
      }
      /**
       *
       *
       * <pre>
       * Annotations is an unstructured key-value map stored with a resource that
       * may be set by external tools to store and retrieve arbitrary metadata.
       * They are not queryable and should be preserved when modifying objects.
       *
       * More info: https://kubernetes.io/docs/user-guide/annotations
       * </pre>
       *
       * <code>map&lt;string, string&gt; annotations = 6;</code>
       */
      @java.lang.Override
      public java.util.Map<java.lang.String, java.lang.String> getAnnotationsMap() {
        return internalGetAnnotations().getMap();
      }
      /**
       *
       *
       * <pre>
       * Annotations is an unstructured key-value map stored with a resource that
       * may be set by external tools to store and retrieve arbitrary metadata.
       * They are not queryable and should be preserved when modifying objects.
       *
       * More info: https://kubernetes.io/docs/user-guide/annotations
       * </pre>
       *
       * <code>map&lt;string, string&gt; annotations = 6;</code>
       */
      @java.lang.Override
      public /* nullable */ java.lang.String getAnnotationsOrDefault(
          java.lang.String key,
          /* nullable */
          java.lang.String defaultValue) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        java.util.Map<java.lang.String, java.lang.String> map = internalGetAnnotations().getMap();
        return map.containsKey(key) ? map.get(key) : defaultValue;
      }
      /**
       *
       *
       * <pre>
       * Annotations is an unstructured key-value map stored with a resource that
       * may be set by external tools to store and retrieve arbitrary metadata.
       * They are not queryable and should be preserved when modifying objects.
       *
       * More info: https://kubernetes.io/docs/user-guide/annotations
       * </pre>
       *
       * <code>map&lt;string, string&gt; annotations = 6;</code>
       */
      @java.lang.Override
      public java.lang.String getAnnotationsOrThrow(java.lang.String key) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        java.util.Map<java.lang.String, java.lang.String> map = internalGetAnnotations().getMap();
        if (!map.containsKey(key)) {
          throw new java.lang.IllegalArgumentException();
        }
        return map.get(key);
      }

      public Builder clearAnnotations() {
        bitField0_ = (bitField0_ & ~0x00000020);
        internalGetMutableAnnotations().getMutableMap().clear();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Annotations is an unstructured key-value map stored with a resource that
       * may be set by external tools to store and retrieve arbitrary metadata.
       * They are not queryable and should be preserved when modifying objects.
       *
       * More info: https://kubernetes.io/docs/user-guide/annotations
       * </pre>
       *
       * <code>map&lt;string, string&gt; annotations = 6;</code>
       */
      public Builder removeAnnotations(java.lang.String key) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        internalGetMutableAnnotations().getMutableMap().remove(key);
        return this;
      }
      /** Use alternate mutation accessors instead. */
      @java.lang.Deprecated
      public java.util.Map<java.lang.String, java.lang.String> getMutableAnnotations() {
        bitField0_ |= 0x00000020;
        return internalGetMutableAnnotations().getMutableMap();
      }
      /**
       *
       *
       * <pre>
       * Annotations is an unstructured key-value map stored with a resource that
       * may be set by external tools to store and retrieve arbitrary metadata.
       * They are not queryable and should be preserved when modifying objects.
       *
       * More info: https://kubernetes.io/docs/user-guide/annotations
       * </pre>
       *
       * <code>map&lt;string, string&gt; annotations = 6;</code>
       */
      public Builder putAnnotations(java.lang.String key, java.lang.String value) {
        if (key == null) {
          throw new NullPointerException("map key");
        }
        if (value == null) {
          throw new NullPointerException("map value");
        }
        internalGetMutableAnnotations().getMutableMap().put(key, value);
        bitField0_ |= 0x00000020;
        return this;
      }
      /**
       *
       *
       * <pre>
       * Annotations is an unstructured key-value map stored with a resource that
       * may be set by external tools to store and retrieve arbitrary metadata.
       * They are not queryable and should be preserved when modifying objects.
       *
       * More info: https://kubernetes.io/docs/user-guide/annotations
       * </pre>
       *
       * <code>map&lt;string, string&gt; annotations = 6;</code>
       */
      public Builder putAllAnnotations(java.util.Map<java.lang.String, java.lang.String> values) {
        internalGetMutableAnnotations().getMutableMap().putAll(values);
        bitField0_ |= 0x00000020;
        return this;
      }

      private java.lang.Object displayName_ = "";
      /**
       *
       *
       * <pre>
       * Mutable. The display name set by clients. Must be &lt;= 63 characters.
       * </pre>
       *
       * <code>string display_name = 7;</code>
       *
       * @return The displayName.
       */
      public java.lang.String getDisplayName() {
        java.lang.Object ref = displayName_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          displayName_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * Mutable. The display name set by clients. Must be &lt;= 63 characters.
       * </pre>
       *
       * <code>string display_name = 7;</code>
       *
       * @return The bytes for displayName.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getDisplayNameBytes() {
        java.lang.Object ref = displayName_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          displayName_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * Mutable. The display name set by clients. Must be &lt;= 63 characters.
       * </pre>
       *
       * <code>string display_name = 7;</code>
       *
       * @param value The displayName to set.
       * @return This builder for chaining.
       */
      public Builder setDisplayName(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        displayName_ = value;
        bitField0_ |= 0x00000040;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Mutable. The display name set by clients. Must be &lt;= 63 characters.
       * </pre>
       *
       * <code>string display_name = 7;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearDisplayName() {
        displayName_ = getDefaultInstance().getDisplayName();
        bitField0_ = (bitField0_ & ~0x00000040);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Mutable. The display name set by clients. Must be &lt;= 63 characters.
       * </pre>
       *
       * <code>string display_name = 7;</code>
       *
       * @param value The bytes for displayName to set.
       * @return This builder for chaining.
       */
      public Builder setDisplayNameBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        displayName_ = value;
        bitField0_ |= 0x00000040;
        onChanged();
        return this;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.Timestamp createTime_;
      private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
              com.google.protobuf.Timestamp,
              com.google.protobuf.Timestamp.Builder,
              com.google.protobuf.TimestampOrBuilder>
          createTimeBuilder_;
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was created. This may
       * be either the time creation was initiated or when it was completed.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp create_time = 8;</code>
       *
       * @return Whether the createTime field is set.
       */
      public boolean hasCreateTime() {
        return ((bitField0_ & 0x00000080) != 0);
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was created. This may
       * be either the time creation was initiated or when it was completed.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp create_time = 8;</code>
       *
       * @return The createTime.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.Timestamp getCreateTime() {
        if (createTimeBuilder_ == null) {
          return createTime_ == null
              ? com.google.protobuf.Timestamp.getDefaultInstance()
              : createTime_;
        } else {
          return createTimeBuilder_.getMessage();
        }
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was created. This may
       * be either the time creation was initiated or when it was completed.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp create_time = 8;</code>
       */
      public Builder setCreateTime(com.couchbase.client.core.deps.com.google.protobuf.Timestamp value) {
        if (createTimeBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          createTime_ = value;
        } else {
          createTimeBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000080;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was created. This may
       * be either the time creation was initiated or when it was completed.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp create_time = 8;</code>
       */
      public Builder setCreateTime(com.couchbase.client.core.deps.com.google.protobuf.Timestamp.Builder builderForValue) {
        if (createTimeBuilder_ == null) {
          createTime_ = builderForValue.build();
        } else {
          createTimeBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000080;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was created. This may
       * be either the time creation was initiated or when it was completed.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp create_time = 8;</code>
       */
      public Builder mergeCreateTime(com.couchbase.client.core.deps.com.google.protobuf.Timestamp value) {
        if (createTimeBuilder_ == null) {
          if (((bitField0_ & 0x00000080) != 0)
              && createTime_ != null
              && createTime_ != com.google.protobuf.Timestamp.getDefaultInstance()) {
            getCreateTimeBuilder().mergeFrom(value);
          } else {
            createTime_ = value;
          }
        } else {
          createTimeBuilder_.mergeFrom(value);
        }
        if (createTime_ != null) {
          bitField0_ |= 0x00000080;
          onChanged();
        }
        return this;
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was created. This may
       * be either the time creation was initiated or when it was completed.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp create_time = 8;</code>
       */
      public Builder clearCreateTime() {
        bitField0_ = (bitField0_ & ~0x00000080);
        createTime_ = null;
        if (createTimeBuilder_ != null) {
          createTimeBuilder_.dispose();
          createTimeBuilder_ = null;
        }
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was created. This may
       * be either the time creation was initiated or when it was completed.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp create_time = 8;</code>
       */
      public com.couchbase.client.core.deps.com.google.protobuf.Timestamp.Builder getCreateTimeBuilder() {
        bitField0_ |= 0x00000080;
        onChanged();
        return getCreateTimeFieldBuilder().getBuilder();
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was created. This may
       * be either the time creation was initiated or when it was completed.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp create_time = 8;</code>
       */
      public com.couchbase.client.core.deps.com.google.protobuf.TimestampOrBuilder getCreateTimeOrBuilder() {
        if (createTimeBuilder_ != null) {
          return createTimeBuilder_.getMessageOrBuilder();
        } else {
          return createTime_ == null
              ? com.google.protobuf.Timestamp.getDefaultInstance()
              : createTime_;
        }
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was created. This may
       * be either the time creation was initiated or when it was completed.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp create_time = 8;</code>
       */
      private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
              com.google.protobuf.Timestamp,
              com.google.protobuf.Timestamp.Builder,
              com.google.protobuf.TimestampOrBuilder>
          getCreateTimeFieldBuilder() {
        if (createTimeBuilder_ == null) {
          createTimeBuilder_ =
              new com.google.protobuf.SingleFieldBuilderV3<
                  com.google.protobuf.Timestamp,
                  com.google.protobuf.Timestamp.Builder,
                  com.google.protobuf.TimestampOrBuilder>(
                  getCreateTime(), getParentForChildren(), isClean());
          createTime_ = null;
        }
        return createTimeBuilder_;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.Timestamp updateTime_;
      private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
              com.google.protobuf.Timestamp,
              com.google.protobuf.Timestamp.Builder,
              com.google.protobuf.TimestampOrBuilder>
          updateTimeBuilder_;
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was last updated. Any
       * change to the resource made by users must refresh this value.
       * Changes to a resource made by the service should refresh this value.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp update_time = 9;</code>
       *
       * @return Whether the updateTime field is set.
       */
      public boolean hasUpdateTime() {
        return ((bitField0_ & 0x00000100) != 0);
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was last updated. Any
       * change to the resource made by users must refresh this value.
       * Changes to a resource made by the service should refresh this value.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp update_time = 9;</code>
       *
       * @return The updateTime.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.Timestamp getUpdateTime() {
        if (updateTimeBuilder_ == null) {
          return updateTime_ == null
              ? com.google.protobuf.Timestamp.getDefaultInstance()
              : updateTime_;
        } else {
          return updateTimeBuilder_.getMessage();
        }
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was last updated. Any
       * change to the resource made by users must refresh this value.
       * Changes to a resource made by the service should refresh this value.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp update_time = 9;</code>
       */
      public Builder setUpdateTime(com.couchbase.client.core.deps.com.google.protobuf.Timestamp value) {
        if (updateTimeBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          updateTime_ = value;
        } else {
          updateTimeBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000100;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was last updated. Any
       * change to the resource made by users must refresh this value.
       * Changes to a resource made by the service should refresh this value.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp update_time = 9;</code>
       */
      public Builder setUpdateTime(com.couchbase.client.core.deps.com.google.protobuf.Timestamp.Builder builderForValue) {
        if (updateTimeBuilder_ == null) {
          updateTime_ = builderForValue.build();
        } else {
          updateTimeBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000100;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was last updated. Any
       * change to the resource made by users must refresh this value.
       * Changes to a resource made by the service should refresh this value.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp update_time = 9;</code>
       */
      public Builder mergeUpdateTime(com.couchbase.client.core.deps.com.google.protobuf.Timestamp value) {
        if (updateTimeBuilder_ == null) {
          if (((bitField0_ & 0x00000100) != 0)
              && updateTime_ != null
              && updateTime_ != com.google.protobuf.Timestamp.getDefaultInstance()) {
            getUpdateTimeBuilder().mergeFrom(value);
          } else {
            updateTime_ = value;
          }
        } else {
          updateTimeBuilder_.mergeFrom(value);
        }
        if (updateTime_ != null) {
          bitField0_ |= 0x00000100;
          onChanged();
        }
        return this;
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was last updated. Any
       * change to the resource made by users must refresh this value.
       * Changes to a resource made by the service should refresh this value.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp update_time = 9;</code>
       */
      public Builder clearUpdateTime() {
        bitField0_ = (bitField0_ & ~0x00000100);
        updateTime_ = null;
        if (updateTimeBuilder_ != null) {
          updateTimeBuilder_.dispose();
          updateTimeBuilder_ = null;
        }
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was last updated. Any
       * change to the resource made by users must refresh this value.
       * Changes to a resource made by the service should refresh this value.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp update_time = 9;</code>
       */
      public com.couchbase.client.core.deps.com.google.protobuf.Timestamp.Builder getUpdateTimeBuilder() {
        bitField0_ |= 0x00000100;
        onChanged();
        return getUpdateTimeFieldBuilder().getBuilder();
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was last updated. Any
       * change to the resource made by users must refresh this value.
       * Changes to a resource made by the service should refresh this value.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp update_time = 9;</code>
       */
      public com.couchbase.client.core.deps.com.google.protobuf.TimestampOrBuilder getUpdateTimeOrBuilder() {
        if (updateTimeBuilder_ != null) {
          return updateTimeBuilder_.getMessageOrBuilder();
        } else {
          return updateTime_ == null
              ? com.google.protobuf.Timestamp.getDefaultInstance()
              : updateTime_;
        }
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was last updated. Any
       * change to the resource made by users must refresh this value.
       * Changes to a resource made by the service should refresh this value.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp update_time = 9;</code>
       */
      private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
              com.google.protobuf.Timestamp,
              com.google.protobuf.Timestamp.Builder,
              com.google.protobuf.TimestampOrBuilder>
          getUpdateTimeFieldBuilder() {
        if (updateTimeBuilder_ == null) {
          updateTimeBuilder_ =
              new com.google.protobuf.SingleFieldBuilderV3<
                  com.google.protobuf.Timestamp,
                  com.google.protobuf.Timestamp.Builder,
                  com.google.protobuf.TimestampOrBuilder>(
                  getUpdateTime(), getParentForChildren(), isClean());
          updateTime_ = null;
        }
        return updateTimeBuilder_;
      }

      private com.couchbase.client.core.deps.com.google.protobuf.Timestamp deleteTime_;
      private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
              com.google.protobuf.Timestamp,
              com.google.protobuf.Timestamp.Builder,
              com.google.protobuf.TimestampOrBuilder>
          deleteTimeBuilder_;
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was deleted.
       * If the resource is not deleted, this must be empty.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp delete_time = 10;</code>
       *
       * @return Whether the deleteTime field is set.
       */
      public boolean hasDeleteTime() {
        return ((bitField0_ & 0x00000200) != 0);
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was deleted.
       * If the resource is not deleted, this must be empty.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp delete_time = 10;</code>
       *
       * @return The deleteTime.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.Timestamp getDeleteTime() {
        if (deleteTimeBuilder_ == null) {
          return deleteTime_ == null
              ? com.google.protobuf.Timestamp.getDefaultInstance()
              : deleteTime_;
        } else {
          return deleteTimeBuilder_.getMessage();
        }
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was deleted.
       * If the resource is not deleted, this must be empty.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp delete_time = 10;</code>
       */
      public Builder setDeleteTime(com.couchbase.client.core.deps.com.google.protobuf.Timestamp value) {
        if (deleteTimeBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          deleteTime_ = value;
        } else {
          deleteTimeBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000200;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was deleted.
       * If the resource is not deleted, this must be empty.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp delete_time = 10;</code>
       */
      public Builder setDeleteTime(com.couchbase.client.core.deps.com.google.protobuf.Timestamp.Builder builderForValue) {
        if (deleteTimeBuilder_ == null) {
          deleteTime_ = builderForValue.build();
        } else {
          deleteTimeBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000200;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was deleted.
       * If the resource is not deleted, this must be empty.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp delete_time = 10;</code>
       */
      public Builder mergeDeleteTime(com.couchbase.client.core.deps.com.google.protobuf.Timestamp value) {
        if (deleteTimeBuilder_ == null) {
          if (((bitField0_ & 0x00000200) != 0)
              && deleteTime_ != null
              && deleteTime_ != com.google.protobuf.Timestamp.getDefaultInstance()) {
            getDeleteTimeBuilder().mergeFrom(value);
          } else {
            deleteTime_ = value;
          }
        } else {
          deleteTimeBuilder_.mergeFrom(value);
        }
        if (deleteTime_ != null) {
          bitField0_ |= 0x00000200;
          onChanged();
        }
        return this;
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was deleted.
       * If the resource is not deleted, this must be empty.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp delete_time = 10;</code>
       */
      public Builder clearDeleteTime() {
        bitField0_ = (bitField0_ & ~0x00000200);
        deleteTime_ = null;
        if (deleteTimeBuilder_ != null) {
          deleteTimeBuilder_.dispose();
          deleteTimeBuilder_ = null;
        }
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was deleted.
       * If the resource is not deleted, this must be empty.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp delete_time = 10;</code>
       */
      public com.couchbase.client.core.deps.com.google.protobuf.Timestamp.Builder getDeleteTimeBuilder() {
        bitField0_ |= 0x00000200;
        onChanged();
        return getDeleteTimeFieldBuilder().getBuilder();
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was deleted.
       * If the resource is not deleted, this must be empty.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp delete_time = 10;</code>
       */
      public com.couchbase.client.core.deps.com.google.protobuf.TimestampOrBuilder getDeleteTimeOrBuilder() {
        if (deleteTimeBuilder_ != null) {
          return deleteTimeBuilder_.getMessageOrBuilder();
        } else {
          return deleteTime_ == null
              ? com.google.protobuf.Timestamp.getDefaultInstance()
              : deleteTime_;
        }
      }
      /**
       *
       *
       * <pre>
       * Output only. The timestamp when the resource was deleted.
       * If the resource is not deleted, this must be empty.
       * </pre>
       *
       * <code>.google.protobuf.Timestamp delete_time = 10;</code>
       */
      private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
              com.google.protobuf.Timestamp,
              com.google.protobuf.Timestamp.Builder,
              com.google.protobuf.TimestampOrBuilder>
          getDeleteTimeFieldBuilder() {
        if (deleteTimeBuilder_ == null) {
          deleteTimeBuilder_ =
              new com.google.protobuf.SingleFieldBuilderV3<
                  com.google.protobuf.Timestamp,
                  com.google.protobuf.Timestamp.Builder,
                  com.google.protobuf.TimestampOrBuilder>(
                  getDeleteTime(), getParentForChildren(), isClean());
          deleteTime_ = null;
        }
        return deleteTimeBuilder_;
      }

      private java.lang.Object etag_ = "";
      /**
       *
       *
       * <pre>
       * Output only. An opaque value that uniquely identifies a version or
       * generation of a resource. It can be used to confirm that the client
       * and server agree on the ordering of a resource being written.
       * </pre>
       *
       * <code>string etag = 11;</code>
       *
       * @return The etag.
       */
      public java.lang.String getEtag() {
        java.lang.Object ref = etag_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          etag_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * Output only. An opaque value that uniquely identifies a version or
       * generation of a resource. It can be used to confirm that the client
       * and server agree on the ordering of a resource being written.
       * </pre>
       *
       * <code>string etag = 11;</code>
       *
       * @return The bytes for etag.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getEtagBytes() {
        java.lang.Object ref = etag_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          etag_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * Output only. An opaque value that uniquely identifies a version or
       * generation of a resource. It can be used to confirm that the client
       * and server agree on the ordering of a resource being written.
       * </pre>
       *
       * <code>string etag = 11;</code>
       *
       * @param value The etag to set.
       * @return This builder for chaining.
       */
      public Builder setEtag(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        etag_ = value;
        bitField0_ |= 0x00000400;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Output only. An opaque value that uniquely identifies a version or
       * generation of a resource. It can be used to confirm that the client
       * and server agree on the ordering of a resource being written.
       * </pre>
       *
       * <code>string etag = 11;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearEtag() {
        etag_ = getDefaultInstance().getEtag();
        bitField0_ = (bitField0_ & ~0x00000400);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Output only. An opaque value that uniquely identifies a version or
       * generation of a resource. It can be used to confirm that the client
       * and server agree on the ordering of a resource being written.
       * </pre>
       *
       * <code>string etag = 11;</code>
       *
       * @param value The bytes for etag to set.
       * @return This builder for chaining.
       */
      public Builder setEtagBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        etag_ = value;
        bitField0_ |= 0x00000400;
        onChanged();
        return this;
      }

      private java.lang.Object location_ = "";
      /**
       *
       *
       * <pre>
       * Immutable. The location of the resource. The location encoding is
       * specific to the service provider, and new encoding may be introduced
       * as the service evolves.
       *
       * For Google Cloud products, the encoding is what is used by Google Cloud
       * APIs, such as `us-east1`, `aws-us-east-1`, and `azure-eastus2`. The
       * semantics of `location` is identical to the
       * `cloud.googleapis.com/location` label used by some Google Cloud APIs.
       * </pre>
       *
       * <code>string location = 12;</code>
       *
       * @return The location.
       */
      public java.lang.String getLocation() {
        java.lang.Object ref = location_;
        if (!(ref instanceof java.lang.String)) {
          com.google.protobuf.ByteString bs = (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          location_ = s;
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * Immutable. The location of the resource. The location encoding is
       * specific to the service provider, and new encoding may be introduced
       * as the service evolves.
       *
       * For Google Cloud products, the encoding is what is used by Google Cloud
       * APIs, such as `us-east1`, `aws-us-east-1`, and `azure-eastus2`. The
       * semantics of `location` is identical to the
       * `cloud.googleapis.com/location` label used by some Google Cloud APIs.
       * </pre>
       *
       * <code>string location = 12;</code>
       *
       * @return The bytes for location.
       */
      public com.couchbase.client.core.deps.com.google.protobuf.ByteString getLocationBytes() {
        java.lang.Object ref = location_;
        if (ref instanceof String) {
          com.google.protobuf.ByteString b =
              com.google.protobuf.ByteString.copyFromUtf8((java.lang.String) ref);
          location_ = b;
          return b;
        } else {
          return (com.couchbase.client.core.deps.com.google.protobuf.ByteString) ref;
        }
      }
      /**
       *
       *
       * <pre>
       * Immutable. The location of the resource. The location encoding is
       * specific to the service provider, and new encoding may be introduced
       * as the service evolves.
       *
       * For Google Cloud products, the encoding is what is used by Google Cloud
       * APIs, such as `us-east1`, `aws-us-east-1`, and `azure-eastus2`. The
       * semantics of `location` is identical to the
       * `cloud.googleapis.com/location` label used by some Google Cloud APIs.
       * </pre>
       *
       * <code>string location = 12;</code>
       *
       * @param value The location to set.
       * @return This builder for chaining.
       */
      public Builder setLocation(java.lang.String value) {
        if (value == null) {
          throw new NullPointerException();
        }
        location_ = value;
        bitField0_ |= 0x00000800;
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Immutable. The location of the resource. The location encoding is
       * specific to the service provider, and new encoding may be introduced
       * as the service evolves.
       *
       * For Google Cloud products, the encoding is what is used by Google Cloud
       * APIs, such as `us-east1`, `aws-us-east-1`, and `azure-eastus2`. The
       * semantics of `location` is identical to the
       * `cloud.googleapis.com/location` label used by some Google Cloud APIs.
       * </pre>
       *
       * <code>string location = 12;</code>
       *
       * @return This builder for chaining.
       */
      public Builder clearLocation() {
        location_ = getDefaultInstance().getLocation();
        bitField0_ = (bitField0_ & ~0x00000800);
        onChanged();
        return this;
      }
      /**
       *
       *
       * <pre>
       * Immutable. The location of the resource. The location encoding is
       * specific to the service provider, and new encoding may be introduced
       * as the service evolves.
       *
       * For Google Cloud products, the encoding is what is used by Google Cloud
       * APIs, such as `us-east1`, `aws-us-east-1`, and `azure-eastus2`. The
       * semantics of `location` is identical to the
       * `cloud.googleapis.com/location` label used by some Google Cloud APIs.
       * </pre>
       *
       * <code>string location = 12;</code>
       *
       * @param value The bytes for location to set.
       * @return This builder for chaining.
       */
      public Builder setLocationBytes(com.couchbase.client.core.deps.com.google.protobuf.ByteString value) {
        if (value == null) {
          throw new NullPointerException();
        }
        checkByteStringIsUtf8(value);
        location_ = value;
        bitField0_ |= 0x00000800;
        onChanged();
        return this;
      }

      @java.lang.Override
      public final Builder setUnknownFields(
          final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }

      // @@protoc_insertion_point(builder_scope:google.rpc.context.AttributeContext.Resource)
    }

    // @@protoc_insertion_point(class_scope:google.rpc.context.AttributeContext.Resource)
    private static final com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource DEFAULT_INSTANCE;

    static {
      DEFAULT_INSTANCE = new com.google.rpc.context.AttributeContext.Resource();
    }

    public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.couchbase.client.core.deps.com.google.protobuf.Parser<Resource> PARSER =
        new com.google.protobuf.AbstractParser<Resource>() {
          @java.lang.Override
          public Resource parsePartialFrom(
              com.google.protobuf.CodedInputStream input,
              com.google.protobuf.ExtensionRegistryLite extensionRegistry)
              throws com.google.protobuf.InvalidProtocolBufferException {
            Builder builder = newBuilder();
            try {
              builder.mergeFrom(input, extensionRegistry);
            } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
              throw e.setUnfinishedMessage(builder.buildPartial());
            } catch (com.couchbase.client.core.deps.com.google.protobuf.UninitializedMessageException e) {
              throw e.asInvalidProtocolBufferException()
                  .setUnfinishedMessage(builder.buildPartial());
            } catch (java.io.IOException e) {
              throw new com.google.protobuf.InvalidProtocolBufferException(e)
                  .setUnfinishedMessage(builder.buildPartial());
            }
            return builder.buildPartial();
          }
        };

    public static com.couchbase.client.core.deps.com.google.protobuf.Parser<Resource> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Parser<Resource> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }
  }

  private int bitField0_;
  public static final int ORIGIN_FIELD_NUMBER = 7;
  private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer origin_;
  /**
   *
   *
   * <pre>
   * The origin of a network activity. In a multi hop network activity,
   * the origin represents the sender of the first hop. For the first hop,
   * the `source` and the `origin` must have the same content.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Peer origin = 7;</code>
   *
   * @return Whether the origin field is set.
   */
  @java.lang.Override
  public boolean hasOrigin() {
    return ((bitField0_ & 0x00000001) != 0);
  }
  /**
   *
   *
   * <pre>
   * The origin of a network activity. In a multi hop network activity,
   * the origin represents the sender of the first hop. For the first hop,
   * the `source` and the `origin` must have the same content.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Peer origin = 7;</code>
   *
   * @return The origin.
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer getOrigin() {
    return origin_ == null
        ? com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()
        : origin_;
  }
  /**
   *
   *
   * <pre>
   * The origin of a network activity. In a multi hop network activity,
   * the origin represents the sender of the first hop. For the first hop,
   * the `source` and the `origin` must have the same content.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Peer origin = 7;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.PeerOrBuilder getOriginOrBuilder() {
    return origin_ == null
        ? com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()
        : origin_;
  }

  public static final int SOURCE_FIELD_NUMBER = 1;
  private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer source_;
  /**
   *
   *
   * <pre>
   * The source of a network activity, such as starting a TCP connection.
   * In a multi hop network activity, the source represents the sender of the
   * last hop.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Peer source = 1;</code>
   *
   * @return Whether the source field is set.
   */
  @java.lang.Override
  public boolean hasSource() {
    return ((bitField0_ & 0x00000002) != 0);
  }
  /**
   *
   *
   * <pre>
   * The source of a network activity, such as starting a TCP connection.
   * In a multi hop network activity, the source represents the sender of the
   * last hop.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Peer source = 1;</code>
   *
   * @return The source.
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer getSource() {
    return source_ == null
        ? com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()
        : source_;
  }
  /**
   *
   *
   * <pre>
   * The source of a network activity, such as starting a TCP connection.
   * In a multi hop network activity, the source represents the sender of the
   * last hop.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Peer source = 1;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.PeerOrBuilder getSourceOrBuilder() {
    return source_ == null
        ? com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()
        : source_;
  }

  public static final int DESTINATION_FIELD_NUMBER = 2;
  private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer destination_;
  /**
   *
   *
   * <pre>
   * The destination of a network activity, such as accepting a TCP connection.
   * In a multi hop network activity, the destination represents the receiver of
   * the last hop.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Peer destination = 2;</code>
   *
   * @return Whether the destination field is set.
   */
  @java.lang.Override
  public boolean hasDestination() {
    return ((bitField0_ & 0x00000004) != 0);
  }
  /**
   *
   *
   * <pre>
   * The destination of a network activity, such as accepting a TCP connection.
   * In a multi hop network activity, the destination represents the receiver of
   * the last hop.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Peer destination = 2;</code>
   *
   * @return The destination.
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer getDestination() {
    return destination_ == null
        ? com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()
        : destination_;
  }
  /**
   *
   *
   * <pre>
   * The destination of a network activity, such as accepting a TCP connection.
   * In a multi hop network activity, the destination represents the receiver of
   * the last hop.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Peer destination = 2;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.PeerOrBuilder getDestinationOrBuilder() {
    return destination_ == null
        ? com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()
        : destination_;
  }

  public static final int REQUEST_FIELD_NUMBER = 3;
  private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request request_;
  /**
   *
   *
   * <pre>
   * Represents a network request, such as an HTTP request.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Request request = 3;</code>
   *
   * @return Whether the request field is set.
   */
  @java.lang.Override
  public boolean hasRequest() {
    return ((bitField0_ & 0x00000008) != 0);
  }
  /**
   *
   *
   * <pre>
   * Represents a network request, such as an HTTP request.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Request request = 3;</code>
   *
   * @return The request.
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request getRequest() {
    return request_ == null
        ? com.google.rpc.context.AttributeContext.Request.getDefaultInstance()
        : request_;
  }
  /**
   *
   *
   * <pre>
   * Represents a network request, such as an HTTP request.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Request request = 3;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.RequestOrBuilder getRequestOrBuilder() {
    return request_ == null
        ? com.google.rpc.context.AttributeContext.Request.getDefaultInstance()
        : request_;
  }

  public static final int RESPONSE_FIELD_NUMBER = 4;
  private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response response_;
  /**
   *
   *
   * <pre>
   * Represents a network response, such as an HTTP response.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Response response = 4;</code>
   *
   * @return Whether the response field is set.
   */
  @java.lang.Override
  public boolean hasResponse() {
    return ((bitField0_ & 0x00000010) != 0);
  }
  /**
   *
   *
   * <pre>
   * Represents a network response, such as an HTTP response.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Response response = 4;</code>
   *
   * @return The response.
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response getResponse() {
    return response_ == null
        ? com.google.rpc.context.AttributeContext.Response.getDefaultInstance()
        : response_;
  }
  /**
   *
   *
   * <pre>
   * Represents a network response, such as an HTTP response.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Response response = 4;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.ResponseOrBuilder getResponseOrBuilder() {
    return response_ == null
        ? com.google.rpc.context.AttributeContext.Response.getDefaultInstance()
        : response_;
  }

  public static final int RESOURCE_FIELD_NUMBER = 5;
  private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource resource_;
  /**
   *
   *
   * <pre>
   * Represents a target resource that is involved with a network activity.
   * If multiple resources are involved with an activity, this must be the
   * primary one.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Resource resource = 5;</code>
   *
   * @return Whether the resource field is set.
   */
  @java.lang.Override
  public boolean hasResource() {
    return ((bitField0_ & 0x00000020) != 0);
  }
  /**
   *
   *
   * <pre>
   * Represents a target resource that is involved with a network activity.
   * If multiple resources are involved with an activity, this must be the
   * primary one.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Resource resource = 5;</code>
   *
   * @return The resource.
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource getResource() {
    return resource_ == null
        ? com.google.rpc.context.AttributeContext.Resource.getDefaultInstance()
        : resource_;
  }
  /**
   *
   *
   * <pre>
   * Represents a target resource that is involved with a network activity.
   * If multiple resources are involved with an activity, this must be the
   * primary one.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Resource resource = 5;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.ResourceOrBuilder getResourceOrBuilder() {
    return resource_ == null
        ? com.google.rpc.context.AttributeContext.Resource.getDefaultInstance()
        : resource_;
  }

  public static final int API_FIELD_NUMBER = 6;
  private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api api_;
  /**
   *
   *
   * <pre>
   * Represents an API operation that is involved to a network activity.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Api api = 6;</code>
   *
   * @return Whether the api field is set.
   */
  @java.lang.Override
  public boolean hasApi() {
    return ((bitField0_ & 0x00000040) != 0);
  }
  /**
   *
   *
   * <pre>
   * Represents an API operation that is involved to a network activity.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Api api = 6;</code>
   *
   * @return The api.
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api getApi() {
    return api_ == null ? com.google.rpc.context.AttributeContext.Api.getDefaultInstance() : api_;
  }
  /**
   *
   *
   * <pre>
   * Represents an API operation that is involved to a network activity.
   * </pre>
   *
   * <code>.google.rpc.context.AttributeContext.Api api = 6;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.ApiOrBuilder getApiOrBuilder() {
    return api_ == null ? com.google.rpc.context.AttributeContext.Api.getDefaultInstance() : api_;
  }

  public static final int EXTENSIONS_FIELD_NUMBER = 8;

  @SuppressWarnings("serial")
  private java.util.List<com.couchbase.client.core.deps.com.google.protobuf.Any> extensions_;
  /**
   *
   *
   * <pre>
   * Supports extensions for advanced use cases, such as logs and metrics.
   * </pre>
   *
   * <code>repeated .google.protobuf.Any extensions = 8;</code>
   */
  @java.lang.Override
  public java.util.List<com.couchbase.client.core.deps.com.google.protobuf.Any> getExtensionsList() {
    return extensions_;
  }
  /**
   *
   *
   * <pre>
   * Supports extensions for advanced use cases, such as logs and metrics.
   * </pre>
   *
   * <code>repeated .google.protobuf.Any extensions = 8;</code>
   */
  @java.lang.Override
  public java.util.List<? extends com.google.protobuf.AnyOrBuilder> getExtensionsOrBuilderList() {
    return extensions_;
  }
  /**
   *
   *
   * <pre>
   * Supports extensions for advanced use cases, such as logs and metrics.
   * </pre>
   *
   * <code>repeated .google.protobuf.Any extensions = 8;</code>
   */
  @java.lang.Override
  public int getExtensionsCount() {
    return extensions_.size();
  }
  /**
   *
   *
   * <pre>
   * Supports extensions for advanced use cases, such as logs and metrics.
   * </pre>
   *
   * <code>repeated .google.protobuf.Any extensions = 8;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.protobuf.Any getExtensions(int index) {
    return extensions_.get(index);
  }
  /**
   *
   *
   * <pre>
   * Supports extensions for advanced use cases, such as logs and metrics.
   * </pre>
   *
   * <code>repeated .google.protobuf.Any extensions = 8;</code>
   */
  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.protobuf.AnyOrBuilder getExtensionsOrBuilder(int index) {
    return extensions_.get(index);
  }

  private byte memoizedIsInitialized = -1;

  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.couchbase.client.core.deps.com.google.protobuf.CodedOutputStream output) throws java.io.IOException {
    if (((bitField0_ & 0x00000002) != 0)) {
      output.writeMessage(1, getSource());
    }
    if (((bitField0_ & 0x00000004) != 0)) {
      output.writeMessage(2, getDestination());
    }
    if (((bitField0_ & 0x00000008) != 0)) {
      output.writeMessage(3, getRequest());
    }
    if (((bitField0_ & 0x00000010) != 0)) {
      output.writeMessage(4, getResponse());
    }
    if (((bitField0_ & 0x00000020) != 0)) {
      output.writeMessage(5, getResource());
    }
    if (((bitField0_ & 0x00000040) != 0)) {
      output.writeMessage(6, getApi());
    }
    if (((bitField0_ & 0x00000001) != 0)) {
      output.writeMessage(7, getOrigin());
    }
    for (int i = 0; i < extensions_.size(); i++) {
      output.writeMessage(8, extensions_.get(i));
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (((bitField0_ & 0x00000002) != 0)) {
      size += com.google.protobuf.CodedOutputStream.computeMessageSize(1, getSource());
    }
    if (((bitField0_ & 0x00000004) != 0)) {
      size += com.google.protobuf.CodedOutputStream.computeMessageSize(2, getDestination());
    }
    if (((bitField0_ & 0x00000008) != 0)) {
      size += com.google.protobuf.CodedOutputStream.computeMessageSize(3, getRequest());
    }
    if (((bitField0_ & 0x00000010) != 0)) {
      size += com.google.protobuf.CodedOutputStream.computeMessageSize(4, getResponse());
    }
    if (((bitField0_ & 0x00000020) != 0)) {
      size += com.google.protobuf.CodedOutputStream.computeMessageSize(5, getResource());
    }
    if (((bitField0_ & 0x00000040) != 0)) {
      size += com.google.protobuf.CodedOutputStream.computeMessageSize(6, getApi());
    }
    if (((bitField0_ & 0x00000001) != 0)) {
      size += com.google.protobuf.CodedOutputStream.computeMessageSize(7, getOrigin());
    }
    for (int i = 0; i < extensions_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream.computeMessageSize(8, extensions_.get(i));
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
      return true;
    }
    if (!(obj instanceof com.google.rpc.context.AttributeContext)) {
      return super.equals(obj);
    }
    com.google.rpc.context.AttributeContext other = (com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext) obj;

    if (hasOrigin() != other.hasOrigin()) return false;
    if (hasOrigin()) {
      if (!getOrigin().equals(other.getOrigin())) return false;
    }
    if (hasSource() != other.hasSource()) return false;
    if (hasSource()) {
      if (!getSource().equals(other.getSource())) return false;
    }
    if (hasDestination() != other.hasDestination()) return false;
    if (hasDestination()) {
      if (!getDestination().equals(other.getDestination())) return false;
    }
    if (hasRequest() != other.hasRequest()) return false;
    if (hasRequest()) {
      if (!getRequest().equals(other.getRequest())) return false;
    }
    if (hasResponse() != other.hasResponse()) return false;
    if (hasResponse()) {
      if (!getResponse().equals(other.getResponse())) return false;
    }
    if (hasResource() != other.hasResource()) return false;
    if (hasResource()) {
      if (!getResource().equals(other.getResource())) return false;
    }
    if (hasApi() != other.hasApi()) return false;
    if (hasApi()) {
      if (!getApi().equals(other.getApi())) return false;
    }
    if (!getExtensionsList().equals(other.getExtensionsList())) return false;
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasOrigin()) {
      hash = (37 * hash) + ORIGIN_FIELD_NUMBER;
      hash = (53 * hash) + getOrigin().hashCode();
    }
    if (hasSource()) {
      hash = (37 * hash) + SOURCE_FIELD_NUMBER;
      hash = (53 * hash) + getSource().hashCode();
    }
    if (hasDestination()) {
      hash = (37 * hash) + DESTINATION_FIELD_NUMBER;
      hash = (53 * hash) + getDestination().hashCode();
    }
    if (hasRequest()) {
      hash = (37 * hash) + REQUEST_FIELD_NUMBER;
      hash = (53 * hash) + getRequest().hashCode();
    }
    if (hasResponse()) {
      hash = (37 * hash) + RESPONSE_FIELD_NUMBER;
      hash = (53 * hash) + getResponse().hashCode();
    }
    if (hasResource()) {
      hash = (37 * hash) + RESOURCE_FIELD_NUMBER;
      hash = (53 * hash) + getResource().hashCode();
    }
    if (hasApi()) {
      hash = (37 * hash) + API_FIELD_NUMBER;
      hash = (53 * hash) + getApi().hashCode();
    }
    if (getExtensionsCount() > 0) {
      hash = (37 * hash) + EXTENSIONS_FIELD_NUMBER;
      hash = (53 * hash) + getExtensionsList().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext parseFrom(java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext parseFrom(
      java.nio.ByteBuffer data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }

  public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext parseFrom(
      byte[] data, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext parseFrom(
      java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext parseDelimitedFrom(
      java.io.InputStream input) throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext parseDelimitedFrom(
      java.io.InputStream input, com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseDelimitedWithIOException(
        PARSER, input, extensionRegistry);
  }

  public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext parseFrom(
      com.google.protobuf.CodedInputStream input) throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(PARSER, input);
  }

  public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3.parseWithIOException(
        PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() {
    return newBuilder();
  }

  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }

  public static Builder newBuilder(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }

  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   *
   *
   * <pre>
   * This message defines the standard attribute vocabulary for Google APIs.
   *
   * An attribute is a piece of metadata that describes an activity on a network
   * service. For example, the size of an HTTP request, or the status code of
   * an HTTP response.
   *
   * Each attribute has a type and a name, which is logically defined as
   * a proto message field in `AttributeContext`. The field type becomes the
   * attribute type, and the field path becomes the attribute name. For example,
   * the attribute `source.ip` maps to field `AttributeContext.source.ip`.
   *
   * This message definition is guaranteed not to have any wire breaking change.
   * So you can use it directly for passing attributes across different systems.
   *
   * NOTE: Different system may generate different subset of attributes. Please
   * verify the system specification before relying on an attribute generated
   * a system.
   * </pre>
   *
   * Protobuf type {@code google.rpc.context.AttributeContext}
   */
  public static final class Builder extends com.google.protobuf.GeneratedMessageV3.Builder<Builder>
      implements
      // @@protoc_insertion_point(builder_implements:google.rpc.context.AttributeContext)
      com.google.rpc.context.AttributeContextOrBuilder {
    public static final com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptor() {
      return com.google.rpc.context.AttributeContextProto
          .internal_static_google_rpc_context_AttributeContext_descriptor;
    }

    @java.lang.Override
    protected com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.google.rpc.context.AttributeContextProto
          .internal_static_google_rpc_context_AttributeContext_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.google.rpc.context.AttributeContext.class,
              com.google.rpc.context.AttributeContext.Builder.class);
    }

    // Construct using com.google.rpc.context.AttributeContext.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }

    private void maybeForceBuilderInitialization() {
      if (com.couchbase.client.core.deps.com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders) {
        getOriginFieldBuilder();
        getSourceFieldBuilder();
        getDestinationFieldBuilder();
        getRequestFieldBuilder();
        getResponseFieldBuilder();
        getResourceFieldBuilder();
        getApiFieldBuilder();
        getExtensionsFieldBuilder();
      }
    }

    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      origin_ = null;
      if (originBuilder_ != null) {
        originBuilder_.dispose();
        originBuilder_ = null;
      }
      source_ = null;
      if (sourceBuilder_ != null) {
        sourceBuilder_.dispose();
        sourceBuilder_ = null;
      }
      destination_ = null;
      if (destinationBuilder_ != null) {
        destinationBuilder_.dispose();
        destinationBuilder_ = null;
      }
      request_ = null;
      if (requestBuilder_ != null) {
        requestBuilder_.dispose();
        requestBuilder_ = null;
      }
      response_ = null;
      if (responseBuilder_ != null) {
        responseBuilder_.dispose();
        responseBuilder_ = null;
      }
      resource_ = null;
      if (resourceBuilder_ != null) {
        resourceBuilder_.dispose();
        resourceBuilder_ = null;
      }
      api_ = null;
      if (apiBuilder_ != null) {
        apiBuilder_.dispose();
        apiBuilder_ = null;
      }
      if (extensionsBuilder_ == null) {
        extensions_ = java.util.Collections.emptyList();
      } else {
        extensions_ = null;
        extensionsBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000080);
      return this;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.protobuf.Descriptors.Descriptor getDescriptorForType() {
      return com.google.rpc.context.AttributeContextProto
          .internal_static_google_rpc_context_AttributeContext_descriptor;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext getDefaultInstanceForType() {
      return com.google.rpc.context.AttributeContext.getDefaultInstance();
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext build() {
      com.google.rpc.context.AttributeContext result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext buildPartial() {
      com.google.rpc.context.AttributeContext result =
          new com.google.rpc.context.AttributeContext(this);
      buildPartialRepeatedFields(result);
      if (bitField0_ != 0) {
        buildPartial0(result);
      }
      onBuilt();
      return result;
    }

    private void buildPartialRepeatedFields(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext result) {
      if (extensionsBuilder_ == null) {
        if (((bitField0_ & 0x00000080) != 0)) {
          extensions_ = java.util.Collections.unmodifiableList(extensions_);
          bitField0_ = (bitField0_ & ~0x00000080);
        }
        result.extensions_ = extensions_;
      } else {
        result.extensions_ = extensionsBuilder_.build();
      }
    }

    private void buildPartial0(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext result) {
      int from_bitField0_ = bitField0_;
      int to_bitField0_ = 0;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.origin_ = originBuilder_ == null ? origin_ : originBuilder_.build();
        to_bitField0_ |= 0x00000001;
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.source_ = sourceBuilder_ == null ? source_ : sourceBuilder_.build();
        to_bitField0_ |= 0x00000002;
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.destination_ =
            destinationBuilder_ == null ? destination_ : destinationBuilder_.build();
        to_bitField0_ |= 0x00000004;
      }
      if (((from_bitField0_ & 0x00000008) != 0)) {
        result.request_ = requestBuilder_ == null ? request_ : requestBuilder_.build();
        to_bitField0_ |= 0x00000008;
      }
      if (((from_bitField0_ & 0x00000010) != 0)) {
        result.response_ = responseBuilder_ == null ? response_ : responseBuilder_.build();
        to_bitField0_ |= 0x00000010;
      }
      if (((from_bitField0_ & 0x00000020) != 0)) {
        result.resource_ = resourceBuilder_ == null ? resource_ : resourceBuilder_.build();
        to_bitField0_ |= 0x00000020;
      }
      if (((from_bitField0_ & 0x00000040) != 0)) {
        result.api_ = apiBuilder_ == null ? api_ : apiBuilder_.build();
        to_bitField0_ |= 0x00000040;
      }
      result.bitField0_ |= to_bitField0_;
    }

    @java.lang.Override
    public Builder clone() {
      return super.clone();
    }

    @java.lang.Override
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.setField(field, value);
    }

    @java.lang.Override
    public Builder clearField(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.FieldDescriptor field) {
      return super.clearField(field);
    }

    @java.lang.Override
    public Builder clearOneof(com.couchbase.client.core.deps.com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return super.clearOneof(oneof);
    }

    @java.lang.Override
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field, int index, java.lang.Object value) {
      return super.setRepeatedField(field, index, value);
    }

    @java.lang.Override
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field, java.lang.Object value) {
      return super.addRepeatedField(field, value);
    }

    @java.lang.Override
    public Builder mergeFrom(com.couchbase.client.core.deps.com.google.protobuf.Message other) {
      if (other instanceof com.google.rpc.context.AttributeContext) {
        return mergeFrom((com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext) other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext other) {
      if (other == com.google.rpc.context.AttributeContext.getDefaultInstance()) return this;
      if (other.hasOrigin()) {
        mergeOrigin(other.getOrigin());
      }
      if (other.hasSource()) {
        mergeSource(other.getSource());
      }
      if (other.hasDestination()) {
        mergeDestination(other.getDestination());
      }
      if (other.hasRequest()) {
        mergeRequest(other.getRequest());
      }
      if (other.hasResponse()) {
        mergeResponse(other.getResponse());
      }
      if (other.hasResource()) {
        mergeResource(other.getResource());
      }
      if (other.hasApi()) {
        mergeApi(other.getApi());
      }
      if (extensionsBuilder_ == null) {
        if (!other.extensions_.isEmpty()) {
          if (extensions_.isEmpty()) {
            extensions_ = other.extensions_;
            bitField0_ = (bitField0_ & ~0x00000080);
          } else {
            ensureExtensionsIsMutable();
            extensions_.addAll(other.extensions_);
          }
          onChanged();
        }
      } else {
        if (!other.extensions_.isEmpty()) {
          if (extensionsBuilder_.isEmpty()) {
            extensionsBuilder_.dispose();
            extensionsBuilder_ = null;
            extensions_ = other.extensions_;
            bitField0_ = (bitField0_ & ~0x00000080);
            extensionsBuilder_ =
                com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders
                    ? getExtensionsFieldBuilder()
                    : null;
          } else {
            extensionsBuilder_.addAllMessages(other.extensions_);
          }
        }
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10:
              {
                input.readMessage(getSourceFieldBuilder().getBuilder(), extensionRegistry);
                bitField0_ |= 0x00000002;
                break;
              } // case 10
            case 18:
              {
                input.readMessage(getDestinationFieldBuilder().getBuilder(), extensionRegistry);
                bitField0_ |= 0x00000004;
                break;
              } // case 18
            case 26:
              {
                input.readMessage(getRequestFieldBuilder().getBuilder(), extensionRegistry);
                bitField0_ |= 0x00000008;
                break;
              } // case 26
            case 34:
              {
                input.readMessage(getResponseFieldBuilder().getBuilder(), extensionRegistry);
                bitField0_ |= 0x00000010;
                break;
              } // case 34
            case 42:
              {
                input.readMessage(getResourceFieldBuilder().getBuilder(), extensionRegistry);
                bitField0_ |= 0x00000020;
                break;
              } // case 42
            case 50:
              {
                input.readMessage(getApiFieldBuilder().getBuilder(), extensionRegistry);
                bitField0_ |= 0x00000040;
                break;
              } // case 50
            case 58:
              {
                input.readMessage(getOriginFieldBuilder().getBuilder(), extensionRegistry);
                bitField0_ |= 0x00000001;
                break;
              } // case 58
            case 66:
              {
                com.google.protobuf.Any m =
                    input.readMessage(com.couchbase.client.core.deps.com.google.protobuf.Any.parser(), extensionRegistry);
                if (extensionsBuilder_ == null) {
                  ensureExtensionsIsMutable();
                  extensions_.add(m);
                } else {
                  extensionsBuilder_.addMessage(m);
                }
                break;
              } // case 66
            default:
              {
                if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                  done = true; // was an endgroup tag
                }
                break;
              } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }

    private int bitField0_;

    private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer origin_;
    private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
            com.google.rpc.context.AttributeContext.Peer,
            com.google.rpc.context.AttributeContext.Peer.Builder,
            com.google.rpc.context.AttributeContext.PeerOrBuilder>
        originBuilder_;
    /**
     *
     *
     * <pre>
     * The origin of a network activity. In a multi hop network activity,
     * the origin represents the sender of the first hop. For the first hop,
     * the `source` and the `origin` must have the same content.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer origin = 7;</code>
     *
     * @return Whether the origin field is set.
     */
    public boolean hasOrigin() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     *
     *
     * <pre>
     * The origin of a network activity. In a multi hop network activity,
     * the origin represents the sender of the first hop. For the first hop,
     * the `source` and the `origin` must have the same content.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer origin = 7;</code>
     *
     * @return The origin.
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer getOrigin() {
      if (originBuilder_ == null) {
        return origin_ == null
            ? com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()
            : origin_;
      } else {
        return originBuilder_.getMessage();
      }
    }
    /**
     *
     *
     * <pre>
     * The origin of a network activity. In a multi hop network activity,
     * the origin represents the sender of the first hop. For the first hop,
     * the `source` and the `origin` must have the same content.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer origin = 7;</code>
     */
    public Builder setOrigin(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer value) {
      if (originBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        origin_ = value;
      } else {
        originBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The origin of a network activity. In a multi hop network activity,
     * the origin represents the sender of the first hop. For the first hop,
     * the `source` and the `origin` must have the same content.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer origin = 7;</code>
     */
    public Builder setOrigin(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer.Builder builderForValue) {
      if (originBuilder_ == null) {
        origin_ = builderForValue.build();
      } else {
        originBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The origin of a network activity. In a multi hop network activity,
     * the origin represents the sender of the first hop. For the first hop,
     * the `source` and the `origin` must have the same content.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer origin = 7;</code>
     */
    public Builder mergeOrigin(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer value) {
      if (originBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0)
            && origin_ != null
            && origin_ != com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()) {
          getOriginBuilder().mergeFrom(value);
        } else {
          origin_ = value;
        }
      } else {
        originBuilder_.mergeFrom(value);
      }
      if (origin_ != null) {
        bitField0_ |= 0x00000001;
        onChanged();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * The origin of a network activity. In a multi hop network activity,
     * the origin represents the sender of the first hop. For the first hop,
     * the `source` and the `origin` must have the same content.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer origin = 7;</code>
     */
    public Builder clearOrigin() {
      bitField0_ = (bitField0_ & ~0x00000001);
      origin_ = null;
      if (originBuilder_ != null) {
        originBuilder_.dispose();
        originBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The origin of a network activity. In a multi hop network activity,
     * the origin represents the sender of the first hop. For the first hop,
     * the `source` and the `origin` must have the same content.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer origin = 7;</code>
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer.Builder getOriginBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getOriginFieldBuilder().getBuilder();
    }
    /**
     *
     *
     * <pre>
     * The origin of a network activity. In a multi hop network activity,
     * the origin represents the sender of the first hop. For the first hop,
     * the `source` and the `origin` must have the same content.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer origin = 7;</code>
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.PeerOrBuilder getOriginOrBuilder() {
      if (originBuilder_ != null) {
        return originBuilder_.getMessageOrBuilder();
      } else {
        return origin_ == null
            ? com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()
            : origin_;
      }
    }
    /**
     *
     *
     * <pre>
     * The origin of a network activity. In a multi hop network activity,
     * the origin represents the sender of the first hop. For the first hop,
     * the `source` and the `origin` must have the same content.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer origin = 7;</code>
     */
    private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
            com.google.rpc.context.AttributeContext.Peer,
            com.google.rpc.context.AttributeContext.Peer.Builder,
            com.google.rpc.context.AttributeContext.PeerOrBuilder>
        getOriginFieldBuilder() {
      if (originBuilder_ == null) {
        originBuilder_ =
            new com.google.protobuf.SingleFieldBuilderV3<
                com.google.rpc.context.AttributeContext.Peer,
                com.google.rpc.context.AttributeContext.Peer.Builder,
                com.google.rpc.context.AttributeContext.PeerOrBuilder>(
                getOrigin(), getParentForChildren(), isClean());
        origin_ = null;
      }
      return originBuilder_;
    }

    private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer source_;
    private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
            com.google.rpc.context.AttributeContext.Peer,
            com.google.rpc.context.AttributeContext.Peer.Builder,
            com.google.rpc.context.AttributeContext.PeerOrBuilder>
        sourceBuilder_;
    /**
     *
     *
     * <pre>
     * The source of a network activity, such as starting a TCP connection.
     * In a multi hop network activity, the source represents the sender of the
     * last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer source = 1;</code>
     *
     * @return Whether the source field is set.
     */
    public boolean hasSource() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     *
     *
     * <pre>
     * The source of a network activity, such as starting a TCP connection.
     * In a multi hop network activity, the source represents the sender of the
     * last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer source = 1;</code>
     *
     * @return The source.
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer getSource() {
      if (sourceBuilder_ == null) {
        return source_ == null
            ? com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()
            : source_;
      } else {
        return sourceBuilder_.getMessage();
      }
    }
    /**
     *
     *
     * <pre>
     * The source of a network activity, such as starting a TCP connection.
     * In a multi hop network activity, the source represents the sender of the
     * last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer source = 1;</code>
     */
    public Builder setSource(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer value) {
      if (sourceBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        source_ = value;
      } else {
        sourceBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The source of a network activity, such as starting a TCP connection.
     * In a multi hop network activity, the source represents the sender of the
     * last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer source = 1;</code>
     */
    public Builder setSource(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer.Builder builderForValue) {
      if (sourceBuilder_ == null) {
        source_ = builderForValue.build();
      } else {
        sourceBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The source of a network activity, such as starting a TCP connection.
     * In a multi hop network activity, the source represents the sender of the
     * last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer source = 1;</code>
     */
    public Builder mergeSource(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer value) {
      if (sourceBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0)
            && source_ != null
            && source_ != com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()) {
          getSourceBuilder().mergeFrom(value);
        } else {
          source_ = value;
        }
      } else {
        sourceBuilder_.mergeFrom(value);
      }
      if (source_ != null) {
        bitField0_ |= 0x00000002;
        onChanged();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * The source of a network activity, such as starting a TCP connection.
     * In a multi hop network activity, the source represents the sender of the
     * last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer source = 1;</code>
     */
    public Builder clearSource() {
      bitField0_ = (bitField0_ & ~0x00000002);
      source_ = null;
      if (sourceBuilder_ != null) {
        sourceBuilder_.dispose();
        sourceBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The source of a network activity, such as starting a TCP connection.
     * In a multi hop network activity, the source represents the sender of the
     * last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer source = 1;</code>
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer.Builder getSourceBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getSourceFieldBuilder().getBuilder();
    }
    /**
     *
     *
     * <pre>
     * The source of a network activity, such as starting a TCP connection.
     * In a multi hop network activity, the source represents the sender of the
     * last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer source = 1;</code>
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.PeerOrBuilder getSourceOrBuilder() {
      if (sourceBuilder_ != null) {
        return sourceBuilder_.getMessageOrBuilder();
      } else {
        return source_ == null
            ? com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()
            : source_;
      }
    }
    /**
     *
     *
     * <pre>
     * The source of a network activity, such as starting a TCP connection.
     * In a multi hop network activity, the source represents the sender of the
     * last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer source = 1;</code>
     */
    private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
            com.google.rpc.context.AttributeContext.Peer,
            com.google.rpc.context.AttributeContext.Peer.Builder,
            com.google.rpc.context.AttributeContext.PeerOrBuilder>
        getSourceFieldBuilder() {
      if (sourceBuilder_ == null) {
        sourceBuilder_ =
            new com.google.protobuf.SingleFieldBuilderV3<
                com.google.rpc.context.AttributeContext.Peer,
                com.google.rpc.context.AttributeContext.Peer.Builder,
                com.google.rpc.context.AttributeContext.PeerOrBuilder>(
                getSource(), getParentForChildren(), isClean());
        source_ = null;
      }
      return sourceBuilder_;
    }

    private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer destination_;
    private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
            com.google.rpc.context.AttributeContext.Peer,
            com.google.rpc.context.AttributeContext.Peer.Builder,
            com.google.rpc.context.AttributeContext.PeerOrBuilder>
        destinationBuilder_;
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination = 2;</code>
     *
     * @return Whether the destination field is set.
     */
    public boolean hasDestination() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination = 2;</code>
     *
     * @return The destination.
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer getDestination() {
      if (destinationBuilder_ == null) {
        return destination_ == null
            ? com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()
            : destination_;
      } else {
        return destinationBuilder_.getMessage();
      }
    }
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination = 2;</code>
     */
    public Builder setDestination(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer value) {
      if (destinationBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        destination_ = value;
      } else {
        destinationBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination = 2;</code>
     */
    public Builder setDestination(
        com.google.rpc.context.AttributeContext.Peer.Builder builderForValue) {
      if (destinationBuilder_ == null) {
        destination_ = builderForValue.build();
      } else {
        destinationBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination = 2;</code>
     */
    public Builder mergeDestination(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer value) {
      if (destinationBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0)
            && destination_ != null
            && destination_ != com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()) {
          getDestinationBuilder().mergeFrom(value);
        } else {
          destination_ = value;
        }
      } else {
        destinationBuilder_.mergeFrom(value);
      }
      if (destination_ != null) {
        bitField0_ |= 0x00000004;
        onChanged();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination = 2;</code>
     */
    public Builder clearDestination() {
      bitField0_ = (bitField0_ & ~0x00000004);
      destination_ = null;
      if (destinationBuilder_ != null) {
        destinationBuilder_.dispose();
        destinationBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination = 2;</code>
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Peer.Builder getDestinationBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getDestinationFieldBuilder().getBuilder();
    }
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination = 2;</code>
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.PeerOrBuilder getDestinationOrBuilder() {
      if (destinationBuilder_ != null) {
        return destinationBuilder_.getMessageOrBuilder();
      } else {
        return destination_ == null
            ? com.google.rpc.context.AttributeContext.Peer.getDefaultInstance()
            : destination_;
      }
    }
    /**
     *
     *
     * <pre>
     * The destination of a network activity, such as accepting a TCP connection.
     * In a multi hop network activity, the destination represents the receiver of
     * the last hop.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Peer destination = 2;</code>
     */
    private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
            com.google.rpc.context.AttributeContext.Peer,
            com.google.rpc.context.AttributeContext.Peer.Builder,
            com.google.rpc.context.AttributeContext.PeerOrBuilder>
        getDestinationFieldBuilder() {
      if (destinationBuilder_ == null) {
        destinationBuilder_ =
            new com.google.protobuf.SingleFieldBuilderV3<
                com.google.rpc.context.AttributeContext.Peer,
                com.google.rpc.context.AttributeContext.Peer.Builder,
                com.google.rpc.context.AttributeContext.PeerOrBuilder>(
                getDestination(), getParentForChildren(), isClean());
        destination_ = null;
      }
      return destinationBuilder_;
    }

    private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request request_;
    private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
            com.google.rpc.context.AttributeContext.Request,
            com.google.rpc.context.AttributeContext.Request.Builder,
            com.google.rpc.context.AttributeContext.RequestOrBuilder>
        requestBuilder_;
    /**
     *
     *
     * <pre>
     * Represents a network request, such as an HTTP request.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request = 3;</code>
     *
     * @return Whether the request field is set.
     */
    public boolean hasRequest() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     *
     *
     * <pre>
     * Represents a network request, such as an HTTP request.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request = 3;</code>
     *
     * @return The request.
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request getRequest() {
      if (requestBuilder_ == null) {
        return request_ == null
            ? com.google.rpc.context.AttributeContext.Request.getDefaultInstance()
            : request_;
      } else {
        return requestBuilder_.getMessage();
      }
    }
    /**
     *
     *
     * <pre>
     * Represents a network request, such as an HTTP request.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request = 3;</code>
     */
    public Builder setRequest(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request value) {
      if (requestBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        request_ = value;
      } else {
        requestBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Represents a network request, such as an HTTP request.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request = 3;</code>
     */
    public Builder setRequest(
        com.google.rpc.context.AttributeContext.Request.Builder builderForValue) {
      if (requestBuilder_ == null) {
        request_ = builderForValue.build();
      } else {
        requestBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000008;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Represents a network request, such as an HTTP request.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request = 3;</code>
     */
    public Builder mergeRequest(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request value) {
      if (requestBuilder_ == null) {
        if (((bitField0_ & 0x00000008) != 0)
            && request_ != null
            && request_ != com.google.rpc.context.AttributeContext.Request.getDefaultInstance()) {
          getRequestBuilder().mergeFrom(value);
        } else {
          request_ = value;
        }
      } else {
        requestBuilder_.mergeFrom(value);
      }
      if (request_ != null) {
        bitField0_ |= 0x00000008;
        onChanged();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Represents a network request, such as an HTTP request.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request = 3;</code>
     */
    public Builder clearRequest() {
      bitField0_ = (bitField0_ & ~0x00000008);
      request_ = null;
      if (requestBuilder_ != null) {
        requestBuilder_.dispose();
        requestBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Represents a network request, such as an HTTP request.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request = 3;</code>
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Request.Builder getRequestBuilder() {
      bitField0_ |= 0x00000008;
      onChanged();
      return getRequestFieldBuilder().getBuilder();
    }
    /**
     *
     *
     * <pre>
     * Represents a network request, such as an HTTP request.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request = 3;</code>
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.RequestOrBuilder getRequestOrBuilder() {
      if (requestBuilder_ != null) {
        return requestBuilder_.getMessageOrBuilder();
      } else {
        return request_ == null
            ? com.google.rpc.context.AttributeContext.Request.getDefaultInstance()
            : request_;
      }
    }
    /**
     *
     *
     * <pre>
     * Represents a network request, such as an HTTP request.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Request request = 3;</code>
     */
    private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
            com.google.rpc.context.AttributeContext.Request,
            com.google.rpc.context.AttributeContext.Request.Builder,
            com.google.rpc.context.AttributeContext.RequestOrBuilder>
        getRequestFieldBuilder() {
      if (requestBuilder_ == null) {
        requestBuilder_ =
            new com.google.protobuf.SingleFieldBuilderV3<
                com.google.rpc.context.AttributeContext.Request,
                com.google.rpc.context.AttributeContext.Request.Builder,
                com.google.rpc.context.AttributeContext.RequestOrBuilder>(
                getRequest(), getParentForChildren(), isClean());
        request_ = null;
      }
      return requestBuilder_;
    }

    private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response response_;
    private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
            com.google.rpc.context.AttributeContext.Response,
            com.google.rpc.context.AttributeContext.Response.Builder,
            com.google.rpc.context.AttributeContext.ResponseOrBuilder>
        responseBuilder_;
    /**
     *
     *
     * <pre>
     * Represents a network response, such as an HTTP response.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Response response = 4;</code>
     *
     * @return Whether the response field is set.
     */
    public boolean hasResponse() {
      return ((bitField0_ & 0x00000010) != 0);
    }
    /**
     *
     *
     * <pre>
     * Represents a network response, such as an HTTP response.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Response response = 4;</code>
     *
     * @return The response.
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response getResponse() {
      if (responseBuilder_ == null) {
        return response_ == null
            ? com.google.rpc.context.AttributeContext.Response.getDefaultInstance()
            : response_;
      } else {
        return responseBuilder_.getMessage();
      }
    }
    /**
     *
     *
     * <pre>
     * Represents a network response, such as an HTTP response.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Response response = 4;</code>
     */
    public Builder setResponse(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response value) {
      if (responseBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        response_ = value;
      } else {
        responseBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Represents a network response, such as an HTTP response.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Response response = 4;</code>
     */
    public Builder setResponse(
        com.google.rpc.context.AttributeContext.Response.Builder builderForValue) {
      if (responseBuilder_ == null) {
        response_ = builderForValue.build();
      } else {
        responseBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000010;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Represents a network response, such as an HTTP response.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Response response = 4;</code>
     */
    public Builder mergeResponse(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response value) {
      if (responseBuilder_ == null) {
        if (((bitField0_ & 0x00000010) != 0)
            && response_ != null
            && response_ != com.google.rpc.context.AttributeContext.Response.getDefaultInstance()) {
          getResponseBuilder().mergeFrom(value);
        } else {
          response_ = value;
        }
      } else {
        responseBuilder_.mergeFrom(value);
      }
      if (response_ != null) {
        bitField0_ |= 0x00000010;
        onChanged();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Represents a network response, such as an HTTP response.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Response response = 4;</code>
     */
    public Builder clearResponse() {
      bitField0_ = (bitField0_ & ~0x00000010);
      response_ = null;
      if (responseBuilder_ != null) {
        responseBuilder_.dispose();
        responseBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Represents a network response, such as an HTTP response.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Response response = 4;</code>
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Response.Builder getResponseBuilder() {
      bitField0_ |= 0x00000010;
      onChanged();
      return getResponseFieldBuilder().getBuilder();
    }
    /**
     *
     *
     * <pre>
     * Represents a network response, such as an HTTP response.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Response response = 4;</code>
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.ResponseOrBuilder getResponseOrBuilder() {
      if (responseBuilder_ != null) {
        return responseBuilder_.getMessageOrBuilder();
      } else {
        return response_ == null
            ? com.google.rpc.context.AttributeContext.Response.getDefaultInstance()
            : response_;
      }
    }
    /**
     *
     *
     * <pre>
     * Represents a network response, such as an HTTP response.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Response response = 4;</code>
     */
    private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
            com.google.rpc.context.AttributeContext.Response,
            com.google.rpc.context.AttributeContext.Response.Builder,
            com.google.rpc.context.AttributeContext.ResponseOrBuilder>
        getResponseFieldBuilder() {
      if (responseBuilder_ == null) {
        responseBuilder_ =
            new com.google.protobuf.SingleFieldBuilderV3<
                com.google.rpc.context.AttributeContext.Response,
                com.google.rpc.context.AttributeContext.Response.Builder,
                com.google.rpc.context.AttributeContext.ResponseOrBuilder>(
                getResponse(), getParentForChildren(), isClean());
        response_ = null;
      }
      return responseBuilder_;
    }

    private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource resource_;
    private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
            com.google.rpc.context.AttributeContext.Resource,
            com.google.rpc.context.AttributeContext.Resource.Builder,
            com.google.rpc.context.AttributeContext.ResourceOrBuilder>
        resourceBuilder_;
    /**
     *
     *
     * <pre>
     * Represents a target resource that is involved with a network activity.
     * If multiple resources are involved with an activity, this must be the
     * primary one.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource = 5;</code>
     *
     * @return Whether the resource field is set.
     */
    public boolean hasResource() {
      return ((bitField0_ & 0x00000020) != 0);
    }
    /**
     *
     *
     * <pre>
     * Represents a target resource that is involved with a network activity.
     * If multiple resources are involved with an activity, this must be the
     * primary one.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource = 5;</code>
     *
     * @return The resource.
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource getResource() {
      if (resourceBuilder_ == null) {
        return resource_ == null
            ? com.google.rpc.context.AttributeContext.Resource.getDefaultInstance()
            : resource_;
      } else {
        return resourceBuilder_.getMessage();
      }
    }
    /**
     *
     *
     * <pre>
     * Represents a target resource that is involved with a network activity.
     * If multiple resources are involved with an activity, this must be the
     * primary one.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource = 5;</code>
     */
    public Builder setResource(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource value) {
      if (resourceBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        resource_ = value;
      } else {
        resourceBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Represents a target resource that is involved with a network activity.
     * If multiple resources are involved with an activity, this must be the
     * primary one.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource = 5;</code>
     */
    public Builder setResource(
        com.google.rpc.context.AttributeContext.Resource.Builder builderForValue) {
      if (resourceBuilder_ == null) {
        resource_ = builderForValue.build();
      } else {
        resourceBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000020;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Represents a target resource that is involved with a network activity.
     * If multiple resources are involved with an activity, this must be the
     * primary one.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource = 5;</code>
     */
    public Builder mergeResource(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource value) {
      if (resourceBuilder_ == null) {
        if (((bitField0_ & 0x00000020) != 0)
            && resource_ != null
            && resource_ != com.google.rpc.context.AttributeContext.Resource.getDefaultInstance()) {
          getResourceBuilder().mergeFrom(value);
        } else {
          resource_ = value;
        }
      } else {
        resourceBuilder_.mergeFrom(value);
      }
      if (resource_ != null) {
        bitField0_ |= 0x00000020;
        onChanged();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Represents a target resource that is involved with a network activity.
     * If multiple resources are involved with an activity, this must be the
     * primary one.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource = 5;</code>
     */
    public Builder clearResource() {
      bitField0_ = (bitField0_ & ~0x00000020);
      resource_ = null;
      if (resourceBuilder_ != null) {
        resourceBuilder_.dispose();
        resourceBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Represents a target resource that is involved with a network activity.
     * If multiple resources are involved with an activity, this must be the
     * primary one.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource = 5;</code>
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Resource.Builder getResourceBuilder() {
      bitField0_ |= 0x00000020;
      onChanged();
      return getResourceFieldBuilder().getBuilder();
    }
    /**
     *
     *
     * <pre>
     * Represents a target resource that is involved with a network activity.
     * If multiple resources are involved with an activity, this must be the
     * primary one.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource = 5;</code>
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.ResourceOrBuilder getResourceOrBuilder() {
      if (resourceBuilder_ != null) {
        return resourceBuilder_.getMessageOrBuilder();
      } else {
        return resource_ == null
            ? com.google.rpc.context.AttributeContext.Resource.getDefaultInstance()
            : resource_;
      }
    }
    /**
     *
     *
     * <pre>
     * Represents a target resource that is involved with a network activity.
     * If multiple resources are involved with an activity, this must be the
     * primary one.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Resource resource = 5;</code>
     */
    private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
            com.google.rpc.context.AttributeContext.Resource,
            com.google.rpc.context.AttributeContext.Resource.Builder,
            com.google.rpc.context.AttributeContext.ResourceOrBuilder>
        getResourceFieldBuilder() {
      if (resourceBuilder_ == null) {
        resourceBuilder_ =
            new com.google.protobuf.SingleFieldBuilderV3<
                com.google.rpc.context.AttributeContext.Resource,
                com.google.rpc.context.AttributeContext.Resource.Builder,
                com.google.rpc.context.AttributeContext.ResourceOrBuilder>(
                getResource(), getParentForChildren(), isClean());
        resource_ = null;
      }
      return resourceBuilder_;
    }

    private com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api api_;
    private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
            com.google.rpc.context.AttributeContext.Api,
            com.google.rpc.context.AttributeContext.Api.Builder,
            com.google.rpc.context.AttributeContext.ApiOrBuilder>
        apiBuilder_;
    /**
     *
     *
     * <pre>
     * Represents an API operation that is involved to a network activity.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Api api = 6;</code>
     *
     * @return Whether the api field is set.
     */
    public boolean hasApi() {
      return ((bitField0_ & 0x00000040) != 0);
    }
    /**
     *
     *
     * <pre>
     * Represents an API operation that is involved to a network activity.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Api api = 6;</code>
     *
     * @return The api.
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api getApi() {
      if (apiBuilder_ == null) {
        return api_ == null
            ? com.google.rpc.context.AttributeContext.Api.getDefaultInstance()
            : api_;
      } else {
        return apiBuilder_.getMessage();
      }
    }
    /**
     *
     *
     * <pre>
     * Represents an API operation that is involved to a network activity.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Api api = 6;</code>
     */
    public Builder setApi(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api value) {
      if (apiBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        api_ = value;
      } else {
        apiBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Represents an API operation that is involved to a network activity.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Api api = 6;</code>
     */
    public Builder setApi(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api.Builder builderForValue) {
      if (apiBuilder_ == null) {
        api_ = builderForValue.build();
      } else {
        apiBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000040;
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Represents an API operation that is involved to a network activity.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Api api = 6;</code>
     */
    public Builder mergeApi(com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api value) {
      if (apiBuilder_ == null) {
        if (((bitField0_ & 0x00000040) != 0)
            && api_ != null
            && api_ != com.google.rpc.context.AttributeContext.Api.getDefaultInstance()) {
          getApiBuilder().mergeFrom(value);
        } else {
          api_ = value;
        }
      } else {
        apiBuilder_.mergeFrom(value);
      }
      if (api_ != null) {
        bitField0_ |= 0x00000040;
        onChanged();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Represents an API operation that is involved to a network activity.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Api api = 6;</code>
     */
    public Builder clearApi() {
      bitField0_ = (bitField0_ & ~0x00000040);
      api_ = null;
      if (apiBuilder_ != null) {
        apiBuilder_.dispose();
        apiBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     *
     *
     * <pre>
     * Represents an API operation that is involved to a network activity.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Api api = 6;</code>
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.Api.Builder getApiBuilder() {
      bitField0_ |= 0x00000040;
      onChanged();
      return getApiFieldBuilder().getBuilder();
    }
    /**
     *
     *
     * <pre>
     * Represents an API operation that is involved to a network activity.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Api api = 6;</code>
     */
    public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext.ApiOrBuilder getApiOrBuilder() {
      if (apiBuilder_ != null) {
        return apiBuilder_.getMessageOrBuilder();
      } else {
        return api_ == null
            ? com.google.rpc.context.AttributeContext.Api.getDefaultInstance()
            : api_;
      }
    }
    /**
     *
     *
     * <pre>
     * Represents an API operation that is involved to a network activity.
     * </pre>
     *
     * <code>.google.rpc.context.AttributeContext.Api api = 6;</code>
     */
    private com.couchbase.client.core.deps.com.google.protobuf.SingleFieldBuilderV3<
            com.google.rpc.context.AttributeContext.Api,
            com.google.rpc.context.AttributeContext.Api.Builder,
            com.google.rpc.context.AttributeContext.ApiOrBuilder>
        getApiFieldBuilder() {
      if (apiBuilder_ == null) {
        apiBuilder_ =
            new com.google.protobuf.SingleFieldBuilderV3<
                com.google.rpc.context.AttributeContext.Api,
                com.google.rpc.context.AttributeContext.Api.Builder,
                com.google.rpc.context.AttributeContext.ApiOrBuilder>(
                getApi(), getParentForChildren(), isClean());
        api_ = null;
      }
      return apiBuilder_;
    }

    private java.util.List<com.couchbase.client.core.deps.com.google.protobuf.Any> extensions_ = java.util.Collections.emptyList();

    private void ensureExtensionsIsMutable() {
      if (!((bitField0_ & 0x00000080) != 0)) {
        extensions_ = new java.util.ArrayList<com.couchbase.client.core.deps.com.google.protobuf.Any>(extensions_);
        bitField0_ |= 0x00000080;
      }
    }

    private com.couchbase.client.core.deps.com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.protobuf.Any,
            com.google.protobuf.Any.Builder,
            com.google.protobuf.AnyOrBuilder>
        extensionsBuilder_;

    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public java.util.List<com.couchbase.client.core.deps.com.google.protobuf.Any> getExtensionsList() {
      if (extensionsBuilder_ == null) {
        return java.util.Collections.unmodifiableList(extensions_);
      } else {
        return extensionsBuilder_.getMessageList();
      }
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public int getExtensionsCount() {
      if (extensionsBuilder_ == null) {
        return extensions_.size();
      } else {
        return extensionsBuilder_.getCount();
      }
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public com.couchbase.client.core.deps.com.google.protobuf.Any getExtensions(int index) {
      if (extensionsBuilder_ == null) {
        return extensions_.get(index);
      } else {
        return extensionsBuilder_.getMessage(index);
      }
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public Builder setExtensions(int index, com.google.protobuf.Any value) {
      if (extensionsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureExtensionsIsMutable();
        extensions_.set(index, value);
        onChanged();
      } else {
        extensionsBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public Builder setExtensions(int index, com.google.protobuf.Any.Builder builderForValue) {
      if (extensionsBuilder_ == null) {
        ensureExtensionsIsMutable();
        extensions_.set(index, builderForValue.build());
        onChanged();
      } else {
        extensionsBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public Builder addExtensions(com.couchbase.client.core.deps.com.google.protobuf.Any value) {
      if (extensionsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureExtensionsIsMutable();
        extensions_.add(value);
        onChanged();
      } else {
        extensionsBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public Builder addExtensions(int index, com.google.protobuf.Any value) {
      if (extensionsBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureExtensionsIsMutable();
        extensions_.add(index, value);
        onChanged();
      } else {
        extensionsBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public Builder addExtensions(com.couchbase.client.core.deps.com.google.protobuf.Any.Builder builderForValue) {
      if (extensionsBuilder_ == null) {
        ensureExtensionsIsMutable();
        extensions_.add(builderForValue.build());
        onChanged();
      } else {
        extensionsBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public Builder addExtensions(int index, com.google.protobuf.Any.Builder builderForValue) {
      if (extensionsBuilder_ == null) {
        ensureExtensionsIsMutable();
        extensions_.add(index, builderForValue.build());
        onChanged();
      } else {
        extensionsBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public Builder addAllExtensions(java.lang.Iterable<? extends com.google.protobuf.Any> values) {
      if (extensionsBuilder_ == null) {
        ensureExtensionsIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(values, extensions_);
        onChanged();
      } else {
        extensionsBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public Builder clearExtensions() {
      if (extensionsBuilder_ == null) {
        extensions_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000080);
        onChanged();
      } else {
        extensionsBuilder_.clear();
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public Builder removeExtensions(int index) {
      if (extensionsBuilder_ == null) {
        ensureExtensionsIsMutable();
        extensions_.remove(index);
        onChanged();
      } else {
        extensionsBuilder_.remove(index);
      }
      return this;
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public com.couchbase.client.core.deps.com.google.protobuf.Any.Builder getExtensionsBuilder(int index) {
      return getExtensionsFieldBuilder().getBuilder(index);
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public com.couchbase.client.core.deps.com.google.protobuf.AnyOrBuilder getExtensionsOrBuilder(int index) {
      if (extensionsBuilder_ == null) {
        return extensions_.get(index);
      } else {
        return extensionsBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public java.util.List<? extends com.google.protobuf.AnyOrBuilder> getExtensionsOrBuilderList() {
      if (extensionsBuilder_ != null) {
        return extensionsBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(extensions_);
      }
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public com.couchbase.client.core.deps.com.google.protobuf.Any.Builder addExtensionsBuilder() {
      return getExtensionsFieldBuilder().addBuilder(com.couchbase.client.core.deps.com.google.protobuf.Any.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public com.couchbase.client.core.deps.com.google.protobuf.Any.Builder addExtensionsBuilder(int index) {
      return getExtensionsFieldBuilder()
          .addBuilder(index, com.google.protobuf.Any.getDefaultInstance());
    }
    /**
     *
     *
     * <pre>
     * Supports extensions for advanced use cases, such as logs and metrics.
     * </pre>
     *
     * <code>repeated .google.protobuf.Any extensions = 8;</code>
     */
    public java.util.List<com.couchbase.client.core.deps.com.google.protobuf.Any.Builder> getExtensionsBuilderList() {
      return getExtensionsFieldBuilder().getBuilderList();
    }

    private com.couchbase.client.core.deps.com.google.protobuf.RepeatedFieldBuilderV3<
            com.google.protobuf.Any,
            com.google.protobuf.Any.Builder,
            com.google.protobuf.AnyOrBuilder>
        getExtensionsFieldBuilder() {
      if (extensionsBuilder_ == null) {
        extensionsBuilder_ =
            new com.google.protobuf.RepeatedFieldBuilderV3<
                com.google.protobuf.Any,
                com.google.protobuf.Any.Builder,
                com.google.protobuf.AnyOrBuilder>(
                extensions_, ((bitField0_ & 0x00000080) != 0), getParentForChildren(), isClean());
        extensions_ = null;
      }
      return extensionsBuilder_;
    }

    @java.lang.Override
    public final Builder setUnknownFields(final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.couchbase.client.core.deps.com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }

    // @@protoc_insertion_point(builder_scope:google.rpc.context.AttributeContext)
  }

  // @@protoc_insertion_point(class_scope:google.rpc.context.AttributeContext)
  private static final com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext DEFAULT_INSTANCE;

  static {
    DEFAULT_INSTANCE = new com.google.rpc.context.AttributeContext();
  }

  public static com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.couchbase.client.core.deps.com.google.protobuf.Parser<AttributeContext> PARSER =
      new com.google.protobuf.AbstractParser<AttributeContext>() {
        @java.lang.Override
        public AttributeContext parsePartialFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws com.google.protobuf.InvalidProtocolBufferException {
          Builder builder = newBuilder();
          try {
            builder.mergeFrom(input, extensionRegistry);
          } catch (com.couchbase.client.core.deps.com.google.protobuf.InvalidProtocolBufferException e) {
            throw e.setUnfinishedMessage(builder.buildPartial());
          } catch (com.couchbase.client.core.deps.com.google.protobuf.UninitializedMessageException e) {
            throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
          } catch (java.io.IOException e) {
            throw new com.google.protobuf.InvalidProtocolBufferException(e)
                .setUnfinishedMessage(builder.buildPartial());
          }
          return builder.buildPartial();
        }
      };

  public static com.couchbase.client.core.deps.com.google.protobuf.Parser<AttributeContext> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.protobuf.Parser<AttributeContext> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public com.couchbase.client.core.deps.com.google.rpc.context.AttributeContext getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }
}
